package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;

public class Mempl_leave_yearsummary extends Memployee {
	
	MyHashMap hmLeave = new MyHashMap();
	MyHashMap hmDataMonth = new MyHashMap();
	private DbInquiry inqEvent = null;
	private DbInquiry inqEmp =null; 
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			this.initLeaveColumn();
			this.initDataColunm(this.hmDataMonth);
			this.setData();
						
			MyLog.debug(this, "HEAD DATA==="+this.hmLeave);
			MyLog.debug(this, "MONTH DATA==="+this.hmDataMonth);
		}
		return temp;
    }
	
	/*
	 * ӡá˹ջѹúҧ
	 * ´֧Ҩҡ¹ѹ (MEVENTGRP)
	 */
	private void setDayEventType(String id, String code) {
		try {
			if (this.inqEvent==null) {
				this.inqEvent = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqEvent.setSchemaName(this.userPro.getSchemaName());						
				this.inqEvent.initMyTable("Meventgrp", "", "");
				this.inqEvent.setColumn("*");
			}
			this.inqEvent.setFilter("eventgrpid='"+code+"'");
			this.inqEvent.refresh();
			if (this.inqEvent.next()) {
				this.hmLeave.put(id+"_code", this.inqEvent.getString("eventgrpid"));
				this.hmLeave.put(id+"_name", this.inqEvent.getString("tdesc"));
				if (this.inqEvent.getString("daytype").equals("7")) {					
					this.hmLeave.put(id+"_limit", this.getString("vacation_total"));
				} else this.hmLeave.put(id+"_limit", this.inqEvent.getString("limit"));
				this.hmLeave.put(this.inqEvent.getString("eventgrpid"), id);
			} else {
				this.hmLeave.put(id+"_code", ""); //ʻѹ
				this.hmLeave.put(id+"_name", ""); //ͻѹ
				this.hmLeave.put(id+"_limit", ""); //ӹǹ
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	/*
	 * ӡá˹§ҹ Ф鹤ͻ
	 * ´٨ҡʡҷҨ˹Ҩ
	 */
	private void  initLeaveColumn() {
		if (this.param.containsKey("LEAVECOLUMN")) { //ҡʡ Ҩҡ˹Ҩ
			String columnCode = (String) this.param.get("LEAVECOLUMN");
			try {
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
				inq.setSchemaName(this.userPro.getSchemaName());						
				inq.initMyTable("Mleave_report", "codeid='"+columnCode+"'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					DbRecord rec = inq.getCurrentDbRecord();
					for (int i=1;i<=10;i++) {
						String id = "col"+String.valueOf(i);
						if (i<=9) {
							id = "col0"+i;	
						}						
						this.setDayEventType(id, rec.getString(id));						
					}
				}
			} catch (Exception e) {
				MyLog.error(this, e);
			}
		 }
	}
	
	/*
	 * ˹Ф
	 */
	private void initDataColunm(MyHashMap hm) {
		for (int i=1;i<=10;i++) {
			String id = "col"+String.valueOf(i);
			if (i<=9) {
				id = "col0"+i;	
			}		
			
			int j=1;
			while (j<=12) {
				String mm = String.valueOf(j);
				if (j<=9) {
					mm = "0"+j;
				}	
									
				hm.put(id+"_"+mm, new Float(0));
				j++;
			}
			hm.put(id+"_total", new Float(0));
		}		
	}
	
	private void setData() {
		try {
			CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
			CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
			//CscCalendar cscStart = new CscCalendar("2005-01-01");
			//CscCalendar cscEnd = new CscCalendar("2005-12-31");
											
			String filter = "employeeid='"+this.getString("employeeid")+"'" +
				" and ((monthid>="+Integer.parseInt(cscStart.getMM())+" " +
				" and yearid>="+cscStart.getYear()+") " +
				" or (monthid<="+Integer.parseInt(cscEnd.getMM())+" " +
				" and yearid<="+cscEnd.getYear()+"))";
			if (this.inqEmp==null) {
				this.inqEmp = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqEmp.setSchemaName(this.userPro.getSchemaName());						
				this.inqEmp.initMyTable("Mempl_leave_total", "", "MONTHID,DAY_TYPE");
				this.inqEmp.setColumn("*");
			}
			this.inqEmp.setFilter(filter);
			this.inqEmp.refresh();
			while (this.inqEmp.next()) {
				DbRecord rec = this.inqEmp.getCurrentDbRecord();
				
				if (this.hmLeave.containsKey(rec.getString("DAY_TYPE"))) { //һҵçѺҷ㹡ҷѺҨҡ˹Ҩ
					String col = this.hmLeave.getString(rec.getString("DAY_TYPE"));
					String m = "";
					if (rec.getInt("MONTH")<=9) {
						m = "0"+ rec.getString("MONTHID");
					} else m = rec.getString("MONTHID");
					float lv = this.hmDataMonth.getFloat(col+"_"+m); //֧Ңͧҷºǡ͡
					CscTime ct = new CscTime(lv);
					ct.add(rec.getFloat("DAY_USED")); //ӡúǡҤ駹 ºǡ繰ҹ 60
					this.hmDataMonth.put(col+"_"+m, new Float(ct.getFloat()));
					
					
					float lv_total = this.hmDataMonth.getFloat(col+"_total"); //֧Ңͧҷºǡ͡
					CscTime ct_total = new CscTime(lv_total);
					ct_total.add(rec.getFloat("DAY_USED")); //ӡúǡҤ駹 ºǡ繰ҹ 60
					this.hmDataMonth.put(col+"_total", new Float(ct_total.getFloat()));
				}				
			}			
			
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") > 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmDataMonth.get(fName) != null) {
				return this.hmDataMonth.getString(fName);
			} else if (this.hmLeave.get(fName) != null) {
				return this.hmLeave.getString(fName);
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
}
