package com.csc.library.databean;

import java.text.DecimalFormat;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;

public class Memployee_workinghour extends Memployee {
	
	MyHashMap hmDataMonth = null;
	boolean flag = false;
	DbInquiry inqTimeC = null;
	DbInquiry inqTimeH = null;
	MyHashMap hmEvent = null;
	DbInquiry inqEvent = null;
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			if (this.flag==false) {				
				this.hmEvent = new MyHashMap();
				this.initEvent();
				this.hmDataMonth = new MyHashMap();				
				this.flag=true;
			}
			this.initDataColunm(this.hmDataMonth);
			this.setWorkingData();
			System.out.println("hmDataMonth="+this.hmDataMonth);
		}		
		return temp;
	}
	
	private void initEvent() {
		try {
			if (this.inqEvent==null) {
				this.inqEvent = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqEvent.setSchemaName(this.userPro.getSchemaName());						
				this.inqEvent.initMyTable("Meventgrp", "", "");
				this.inqEvent.setColumn("*");
			}
			this.inqEvent.refresh();
			while (this.inqEvent.next()) {
				DbRecord rec = this.inqEvent.getCurrentDbRecord();
				this.hmEvent.put(rec.getString("eventgrpid"), rec.getString("daytype"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private boolean chkSumRec(String event, String daytype) {
		if (this.hmEvent.containsKey(event) && (daytype.equals("6") || daytype.equals("7"))) {
			return false;
		}
		return true;
	}
	
	private void initDataColunm(MyHashMap hm) {
		int j=1;
		while (j<=12) {
			String mm = String.valueOf(j);
			if (j<=9) {
				mm = "0"+j;
			}	
								
			hm.put("col_d_"+mm, new Float(0));
			hm.put("col_w_"+mm, new Float(0));
			hm.put("col_name_"+mm, new Float(0));
			j++;
		}
		hm.put("col_d_total", new Float(0));
		hm.put("col_w_total", new Float(0));
	}
	
	private void setWorkingData() {
		DecimalFormat df = new DecimalFormat("00");
		//this.param.put("STARTDATE","2007-03-01");			
		//this.param.put("ENDDATE","2008-03-30");		
		CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		
		double i=1;
		CscCalendar c1 = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar c2 = new CscCalendar((String) this.param.get("ENDDATE"));
		MyHashMap hm = new MyHashMap();
		while (c1.beforeDate(c2)) {
			hm.put(c1.getMM()+"_"+c1.getYear(), df.format(i));
			if (this.userPro.get("lang").equalsIgnoreCase("THA")) {
				this.hmDataMonth.put("col_name_"+df.format(i), c1.getThaiShortMonth()+" "+c1.getYear());
			} else this.hmDataMonth.put("col_name_"+df.format(i), c1.getEngShortMonth()+" "+c1.getYear());	
			c1.incMonth(1);
			i++;
		}
		System.out.println("hm=========="+hm);
		
		try {
			String date = "";
			if (this.inqTimeC==null) {
				this.inqTimeC = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqTimeC.setSchemaName(this.userPro.getSchemaName());						
				this.inqTimeC.initMyTable("Ttime_current1", "", "employeeid, dateid, sequence");
				this.inqTimeC.setColumn("*");
			}
			this.inqTimeC.setFilter("employeeid='"+this.getString("employeeid")+"' and (dateid between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"')");
			//this.inqTimeC.setFilter("employeeid='"+this.getString("employeeid")+"' and (dateid between '2007-08-01' and '2007-08-30')");
			this.inqTimeC.refresh();
			while (this.inqTimeC.next()) {
				DbRecord rec = this.inqTimeC.getCurrentDbRecord();
				
				//System.out.println("Date : "+rec.getString("dateid")+" : "+rec.getString("eventgrp")+
				//		" : "+rec.getString("hour_s")+" : "+rec.getString("hour_d"));
				
				CscCalendar cDate = new CscCalendar(rec.getString("dateid"));
				
				String col = hm.getString(cDate.getMM()+"_"+cDate.getYear());
				
				if (col!=null && !col.equals("null") && Integer.parseInt(col)<=12) {
					CscTime c_d = new CscTime(this.hmDataMonth.getFloat("col_d_"+col));
					CscTime c_w = new CscTime(this.hmDataMonth.getFloat("col_w_"+col));
					
					CscTime col_d_total = new CscTime(this.hmDataMonth.getFloat("col_d_total"));
					CscTime col_w_total = new CscTime(this.hmDataMonth.getFloat("col_w_total"));
					
					if (this.chkSumRec(rec.getString("eventgrp") , rec.getString("daytype"))) {  					
						if (c_d.getFloat()==0) {
							if ((!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O")) || rec.getString("eventgrp").equals("L14")) {
								date = rec.getString("dateid");
								//workday++;
								c_d.add(rec.getFloat("hour_s"));
								col_d_total.add(rec.getFloat("hour_s"));								
								System.out.println("plus : "+rec.getString("dateid")+" : "+rec.getString("eventgrp"));
							} else System.out.println("not : "+rec.getString("dateid")+" : "+rec.getString("eventgrp"));
							
							c_w.add(rec.getFloat("hour_d"));
							col_w_total.add(rec.getFloat("hour_d"));
							if (rec.getString("eventgrp").equals("L14") && rec.getFloat("m_tm_bg")==0 && rec.getFloat("m_tm_en")==0) {
								c_w.add(rec.getFloat("m_lv"));
								col_w_total.add(rec.getFloat("m_lv"));
							}							
						} else {					
							if (!date.equals(rec.getString("dateid")) &&
									((!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O")) || rec.getString("eventgrp").equals("L14"))) {
								//workday++;
								c_d.add(rec.getFloat("hour_s"));
								col_d_total.add(rec.getFloat("hour_s"));								
								System.out.println("plus : "+rec.getString("dateid")+" : "+rec.getString("eventgrp"));
							} else System.out.println("not : "+rec.getString("dateid")+" : "+rec.getString("eventgrp"));
							
							c_w.add(rec.getFloat("hour_d"));
							col_w_total.add(rec.getFloat("hour_d"));
							if (rec.getString("eventgrp").equals("L14") && rec.getFloat("m_tm_bg")==0 && rec.getFloat("m_tm_en")==0) {
								c_w.add(rec.getFloat("m_lv"));
								col_w_total.add(rec.getFloat("m_lv"));
							}							
						}
					}
					
					date = rec.getString("dateid");		
					
					//System.out.println("mm="+cDate.getMM()+" d>"+c_d.getFloat());
					//System.out.println("mm="+cDate.getMM()+" w>"+c_w.getFloat());
					this.hmDataMonth.put("col_d_"+col, new Float(c_d.getFloat()));
					this.hmDataMonth.put("col_w_"+col, new Float(c_w.getFloat()));				
					
					this.hmDataMonth.put("col_d_total", new Float(col_d_total.getFloat()));
					this.hmDataMonth.put("col_w_total", new Float(col_w_total.getFloat()));
					System.out.println("current ==> "+c_w.getFloat());
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		try {
			String date = "";
			if (this.inqTimeH==null) {
				this.inqTimeH = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqTimeH.setSchemaName(this.userPro.getSchemaName());						
				this.inqTimeH.initMyTable("Ttime_history1", "", "employeeid, dateid, sequence");
				this.inqTimeH.setColumn("*");
			}
			this.inqTimeH.setFilter("employeeid='"+this.getString("employeeid")+"' and (dateid between '"+cscStart+"' and '"+cscEnd+"')");
			this.inqTimeH.refresh();
			while (this.inqTimeH.next()) {
				DbRecord rec = this.inqTimeH.getCurrentDbRecord();
				
				//System.out.println("Date : "+rec.getString("dateid")+" : "+rec.getString("eventgrp")+
				//		" : "+rec.getString("hour_s")+" : "+rec.getString("hour_d"));
				
				CscCalendar cDate = new CscCalendar(rec.getString("dateid"));
				
				String col = hm.getString(cDate.getMM()+"_"+cDate.getYear());
				
				if (col!=null && !col.equals("null") && Integer.parseInt(col)<=12) {				
					CscTime c_d = new CscTime(this.hmDataMonth.getFloat("col_d_"+col));
					CscTime c_w = new CscTime(this.hmDataMonth.getFloat("col_w_"+col));
					
					CscTime col_d_total = new CscTime(this.hmDataMonth.getFloat("col_d_total"));
					CscTime col_w_total = new CscTime(this.hmDataMonth.getFloat("col_w_total"));
					
					if (c_d.getFloat()==0) {
						if ((!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O")) || rec.getString("eventgrp").equals("L14")) {
							date = rec.getString("dateid");
							//workday++;
							c_d.add(rec.getFloat("hour_s"));
							col_d_total.add(rec.getFloat("hour_s"));
						} 
						
						c_w.add(rec.getFloat("hour_d"));
						col_w_total.add(rec.getFloat("hour_d"));
						if (rec.getString("eventgrp").equals("L14") && rec.getFloat("m_tm_bg")==0 && rec.getFloat("m_tm_en")==0) {
							c_w.add(rec.getFloat("m_lv"));
							col_w_total.add(rec.getFloat("m_lv"));
						}
					} else {	
						if (!date.equals(rec.getString("dateid")) &&
								((!rec.getString("eventgrp").equals("H") && !rec.getString("eventgrp").equals("I") && !rec.getString("eventgrp").equals("O")) || rec.getString("eventgrp").equals("L14"))) {
							//workday++;
							c_d.add(rec.getFloat("hour_s"));
							col_d_total.add(rec.getFloat("hour_s"));
						} 
						
						c_w.add(rec.getFloat("hour_d"));
						col_w_total.add(rec.getFloat("hour_d"));
						if (rec.getString("eventgrp").equals("L14") && rec.getFloat("m_tm_bg")==0 && rec.getFloat("m_tm_en")==0) {
							c_w.add(rec.getFloat("m_lv"));
							col_w_total.add(rec.getFloat("m_lv"));
						}
					}
					date = rec.getString("dateid");		
					
					//System.out.println("mm="+cDate.getMM()+" d>"+c_d.getFloat());
					//System.out.println("mm="+cDate.getMM()+" w>"+c_w.getFloat());
					this.hmDataMonth.put("col_d_"+col, new Float(c_d.getFloat()));
					this.hmDataMonth.put("col_w_"+col, new Float(c_w.getFloat()));				
					
					this.hmDataMonth.put("col_d_total", new Float(col_d_total.getFloat()));
					this.hmDataMonth.put("col_w_total", new Float(col_w_total.getFloat()));
					System.out.println("history ==> "+c_w.getFloat());
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") >= 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmDataMonth.containsKey(fName)) {			
				return this.hmDataMonth.getString(fName);
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
}
