package com.csc.library.databean;

import java.text.DecimalFormat;
import java.util.StringTokenizer;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;

public class Memployee_workingtime extends Memployee_ta {

	private boolean flag = false;
	private MyHashMap hmWorkingTime = null;
	private DbInquiry inqTimeC = null;
	private DbInquiry inqTimeH = null;
	private DecimalFormat df = new DecimalFormat("0.00");
	private FormulaString fs = new FormulaString();
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (this.hmWorkingTime!=null) {
			this.hmWorkingTime.clear();
		}
		try {
			if (this.inqTimeC==null) {
				this.inqTimeC = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqTimeC.setSchemaName(this.userPro.getSchemaName());						
				this.inqTimeC.initMyTable("Ttime_current1", "", "employeeid, dateid, sequence");
				this.inqTimeC.setColumn("*");
			}
			
			if (this.inqTimeH==null) {
				this.inqTimeH = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqTimeH.setSchemaName(this.userPro.getSchemaName());						
				this.inqTimeH.initMyTable("Ttime_history1", "", "employeeid, dateid, sequence");
				this.inqTimeH.setColumn("*");
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			if (this.flag==false) {
				this.hmWorkingTime = new MyHashMap();				
				this.flag=true;
			}			
			this.initDataColunm();
			this.setWorkingData();
			MyLog.debug("===>"+this.hmWorkingTime);
		}		
		return temp;
	}
	
	/*
	 * ˹ default Ф
	 */
	private void initDataColunm() {		
		this.hmWorkingTime.clear();
		this.hmWorkingTime.put("LATE_COUNT", 0); //ӹǹ駷
		this.hmWorkingTime.put("LATE_TIMES", 0); //ҷ
		this.hmWorkingTime.put("OUTBEFORE_COUNT", 0); //ӹǹ駷͡͹
		this.hmWorkingTime.put("OUTBEFORE_TIMES", 0); //ҷ͡͹
		this.hmWorkingTime.put("COL1_TIMES", 0); //ҡ 1
		this.hmWorkingTime.put("COL2_TIMES", 0); //ҡ 2
		this.hmWorkingTime.put("COL3_TIMES", 0); //ҡ 3
		this.hmWorkingTime.put("COL4_TIMES", 0); //ҡ 4
		this.hmWorkingTime.put("COL5_TIMES", 0); //ҡ 5
		this.hmWorkingTime.put("ABSENT_TIMES", 0); //ҷҴҹ
		this.hmWorkingTime.put("ABSENT_DATE", ""); //ѹҴҹ
		this.hmWorkingTime.put("FORGETIN_COUNT", 0); //ӹǹ駷ٴ
		this.hmWorkingTime.put("FORGETIN_DATE", ""); //ѹٴ͡
		this.hmWorkingTime.put("FORGETOUT_COUNT", 0); //ӹǹ駷ٴٴ͡
		this.hmWorkingTime.put("FORGETOUT_DATE", ""); //ѹٴ
		this.hmWorkingTime.put("OT1", 0); //ͷ 1 
		this.hmWorkingTime.put("OT15", 0);//ͷ 1.5 
		this.hmWorkingTime.put("OT2", 0); //ͷ 2 
		this.hmWorkingTime.put("OT3", 0); //ͷ 3 
		this.hmWorkingTime.put("UNUSED", 0); //ҡ
		
		//L01,L02,L03,L04,L05
		//ҹҨҡ prarameter ҡ˹Ҩ
		this.hmWorkingTime.put("COL1_TYPE", (String) this.param.get("LEAVE1_CODE")); //A,A1,A2
		this.hmWorkingTime.put("COL2_TYPE", (String) this.param.get("LEAVE2_CODE")); //B,B1
		this.hmWorkingTime.put("COL3_TYPE", (String) this.param.get("LEAVE3_CODE"));
		this.hmWorkingTime.put("COL4_TYPE", (String) this.param.get("LEAVE4_CODE"));
		this.hmWorkingTime.put("COL5_TYPE", (String) this.param.get("LEAVE5_CODE"));
		this.hmWorkingTime.put("ABSENT_TYPE", (String) this.param.get("ABSENT_CODE"));
		this.hmWorkingTime.put("UNUSED_CODE", (String) this.param.get("UNUSED_CODE")); //ͤ UNUSED
	}
	
	private void setWorkingData() {
		String sDate = (String) this.param.get("STARTDATE");
		String eDate = (String) this.param.get("ENDDATE");
		//String sDate = "2007-01-01";
		//String eDate = "2007-12-31";
		try {
			CscCalendar startDate = new CscCalendar(sDate);
			CscCalendar endDate = new CscCalendar(eDate);
			this.inqTimeC.setFilter("employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+startDate.getYYYYMMDD()+"' and '"+endDate.getYYYYMMDD()+"')");
			this.inqTimeC.refresh();
			this.setEmpWorkingData(this.inqTimeC);
			
			this.inqTimeH.setFilter("employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+startDate.getYYYYMMDD()+"' and '"+endDate.getYYYYMMDD()+"')");
			this.inqTimeH.refresh();
			this.setEmpWorkingData(this.inqTimeH);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private void setEmpWorkingData(DbInquiry inq) {
		try {
			String UNUSED_CODE = this.hmWorkingTime.getString("UNUSED_CODE");
			String COL1_TYPE = this.hmWorkingTime.getString("COL1_TYPE");
			String COL2_TYPE = this.hmWorkingTime.getString("COL2_TYPE");
			String COL3_TYPE = this.hmWorkingTime.getString("COL3_TYPE");
			String COL4_TYPE = this.hmWorkingTime.getString("COL4_TYPE");
			String COL5_TYPE = this.hmWorkingTime.getString("COL5_TYPE");
			String ABSENT_TYPE = this.hmWorkingTime.getString("ABSENT_TYPE");
			int LATE_COUNT = 0; //ӹǹ駷
			CscTime LATE_TIMES = new CscTime(0); //ҷ			
			int OUTBEFORE_COUNT = 0; //ӹǹ駷͡͹
			CscTime OUTBEFORE_TIMES = new CscTime(0); //ҷ͡͹
			CscTime COL1_TIMES = new CscTime(0); //ҡ 1
			CscTime COL2_TIMES = new CscTime(0); //ҡ 2
			CscTime COL3_TIMES = new CscTime(0); //ҡ 3
			CscTime COL4_TIMES = new CscTime(0); //ҡ 4
			CscTime COL5_TIMES = new CscTime(0); //ҡ 5
			CscTime ABSENT_TIMES = new CscTime(0);  //ҷҴҹ
			String ABSENT_DATE = ""; //ѹҴҹ
			int FORGETIN_COUNT= 0; //ӹǹ駷ٴ
			String FORGETIN_DATE = ""; //ѹٴ͡
			int FORGETOUT_COUNT = 0; //ӹǹ駷ٴٴ͡
			String FORGETOUT_DATE = ""; //ѹٴ
			CscTime OT1 = new CscTime(0); //ͷ 1 
			CscTime OT15 = new CscTime(0); //ͷ 1.5 
			CscTime OT2 = new CscTime(0); //ͷ 2 
			CscTime OT3 = new CscTime(0); //ͷ 3 
			double UNUSED = 0; //ҡ
			
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				CscCalendar cDate = new CscCalendar(rec.getString("dateid"));
				//System.out.println("----> "+cDate+" ==>"+rec.getDouble("ot5")+" ==>"+rec.getDouble("ot3"));
				if (rec.getDouble("LT")>0) { //Ҩӹǹ ҷ
					LATE_COUNT++;
					LATE_TIMES.add(rec.getDouble("LT"));
				}
				
				if (!rec.getString("outbefore").equals("") && Double.parseDouble(rec.getString("outbefore"))>0 && rec.getString("eventgrp").equals("T")) { //Ҩӹǹ ҷ͡͹
					OUTBEFORE_COUNT++;
					OUTBEFORE_TIMES.add(Double.parseDouble(rec.getString("outbefore")));
				}
				
				if (rec.getString("forget_in").equals("1") && rec.getString("forget_out").equals("1") && !rec.getString("eventgrp").equals("O")) { //Ҩӹǹ ѹٴ͡ Ѻͷ
					ABSENT_DATE += cDate.getDate() + ",";
				} else if (rec.getString("forget_in").equals("1") && !rec.getString("eventgrp").equals("O")) { //Ҩӹǹ ѹٴ Ѻͷ
					FORGETIN_COUNT++;
					FORGETIN_DATE += cDate.getDate() + ",";
				} else if (rec.getString("forget_out").equals("1") && !rec.getString("eventgrp").equals("O")) { //Ҩӹǹ ѹٴ͡ Ѻͷ
					FORGETOUT_COUNT++;
					FORGETOUT_DATE += cDate.getDate() + ",";
				}
				
				if (rec.getDouble("ot1")>0) { //ͷ 1 
					OT1.add(rec.getDouble("ot1"));
				} 
				if (rec.getDouble("ot5")>0) { //ͷ 1.5 
					OT15.add(rec.getDouble("ot5"));
				} 
				if (rec.getDouble("ot2")>0) { //ͷ 2 
					OT2.add(rec.getDouble("ot2"));
				}                     
				if (rec.getDouble("ot3")>0) { //ͷ 3 
					OT3.add(rec.getDouble("ot3"));
				}
				
				if (rec.getDouble(UNUSED_CODE)>0) {
					UNUSED += rec.getDouble(UNUSED_CODE);
				}
				
				if (COL1_TYPE.indexOf(rec.getString("eventgrp"))>-1) { //Ҫͧ 1
					COL1_TIMES.add(rec.getDouble("m_lv"));
				} else if (COL2_TYPE.indexOf(rec.getString("eventgrp"))>-1) { //Ҫͧ 2
					COL2_TIMES.add(rec.getDouble("m_lv"));
				} else if (COL3_TYPE.indexOf(rec.getString("eventgrp"))>-1) { //Ҫͧ 3
					COL3_TIMES.add(rec.getDouble("m_lv"));
				} else if (COL4_TYPE.indexOf(rec.getString("eventgrp"))>-1) { //Ҫͧ 4
					COL4_TIMES.add(rec.getDouble("m_lv"));
				} else if (COL5_TYPE.indexOf(rec.getString("eventgrp"))>-1) { //Ҫͧ 5
					COL5_TIMES.add(rec.getDouble("m_lv"));
				} else if (ABSENT_TYPE.indexOf(rec.getString("eventgrp"))>-1) { //Ҵҹ
					if (rec.getDouble("m_lv")>rec.getDouble("hour_s")) {
						ABSENT_TIMES.add(rec.getDouble("hour_s"));
					} else {
						ABSENT_TIMES.add(rec.getDouble("m_lv"));
					}
				} 
				
			} //end while
			
			if (!this.hmWorkingTime.getString("ABSENT_DATE").equals("")) {
				ABSENT_DATE = this.hmWorkingTime.getString("ABSENT_DATE")+","+ABSENT_DATE;
			} 
			if (ABSENT_DATE.length()>0) {
				ABSENT_DATE = ABSENT_DATE.substring(0, ABSENT_DATE.length()-1);
			}
			
			if (!this.hmWorkingTime.getString("FORGETIN_DATE").equals("")) {
				FORGETIN_DATE = this.hmWorkingTime.getString("FORGETIN_DATE")+","+FORGETIN_DATE;
			} 
			if (FORGETIN_DATE.length()>0) {
				FORGETIN_DATE = FORGETIN_DATE.substring(0, FORGETIN_DATE.length()-1);
			}
			
			if (!this.hmWorkingTime.getString("FORGETOUT_DATE").equals("")) {
				FORGETOUT_DATE = this.hmWorkingTime.getString("FORGETOUT_DATE")+","+FORGETOUT_DATE;
			}
			if (FORGETOUT_DATE.length()>0) {
				FORGETOUT_DATE = FORGETOUT_DATE.substring(0, FORGETOUT_DATE.length()-1);
			}
			
			LATE_COUNT = LATE_COUNT + this.hmWorkingTime.getInt("LATE_COUNT");
			this.hmWorkingTime.put("LATE_COUNT", LATE_COUNT); //ӹǹ駷
			
			LATE_TIMES.add(this.hmWorkingTime.getDouble("LATE_TIMES"));
			this.hmWorkingTime.put("LATE_TIMES", this.df.format(LATE_TIMES.getDouble())); //ҷ
						
			OUTBEFORE_COUNT = OUTBEFORE_COUNT + this.hmWorkingTime.getInt("OUTBEFORE_COUNT");
			this.hmWorkingTime.put("OUTBEFORE_COUNT", OUTBEFORE_COUNT); //ӹǹ駷͡͹
			
			OUTBEFORE_TIMES.add(this.hmWorkingTime.getDouble("OUTBEFORE_TIMES"));
			this.hmWorkingTime.put("OUTBEFORE_TIMES", this.df.format(OUTBEFORE_TIMES.getDouble())); //ҷ͡͹
			
			int m1 = this.fs.DhmToM(this.hmWorkingTime.getString("COL1_TIMES")) + this.fs.Tm_To_Min(COL1_TIMES.getDouble());
			this.hmWorkingTime.put("COL1_TIMES", this.fs.MTODhm(m1)); //ҡ 1
			
			int m2 = this.fs.DhmToM(this.hmWorkingTime.getString("COL2_TIMES")) + this.fs.Tm_To_Min(COL2_TIMES.getDouble());
			this.hmWorkingTime.put("COL2_TIMES", this.fs.MTODhm(m2)); //ҡ 2
			
			int m3 = this.fs.DhmToM(this.hmWorkingTime.getString("COL3_TIMES")) + this.fs.Tm_To_Min(COL3_TIMES.getDouble());
			this.hmWorkingTime.put("COL3_TIMES", this.fs.MTODhm(m3)); //ҡ 3
			
			int m4 = this.fs.DhmToM(this.hmWorkingTime.getString("COL4_TIMES")) + this.fs.Tm_To_Min(COL4_TIMES.getDouble());
			this.hmWorkingTime.put("COL4_TIMES", this.fs.MTODhm(m4)); //ҡ 4
			
			int m5 = this.fs.DhmToM(this.hmWorkingTime.getString("COL5_TIMES")) + this.fs.Tm_To_Min(COL5_TIMES.getDouble());
			this.hmWorkingTime.put("COL5_TIMES", this.fs.MTODhm(m5)); //ҡ 5
			
			int m6 = this.fs.DhmToM(this.hmWorkingTime.getString("ABSENT_TIMES")) + this.fs.Tm_To_Min(ABSENT_TIMES.getDouble());
			this.hmWorkingTime.put("ABSENT_TIMES", this.fs.MTODhm(m6)); //ҷҴҹ
						
			this.hmWorkingTime.put("ABSENT_DATE", ABSENT_DATE); //ѹҴҹ
			
			FORGETIN_COUNT = FORGETIN_COUNT + this.hmWorkingTime.getInt("FORGETIN_COUNT");
			this.hmWorkingTime.put("FORGETIN_COUNT", FORGETIN_COUNT); //ӹǹ駷ٴ
			
			this.hmWorkingTime.put("FORGETIN_DATE", FORGETIN_DATE); //ѹٴ͡
			
			FORGETOUT_COUNT = FORGETOUT_COUNT + this.hmWorkingTime.getInt("FORGETOUT_COUNT");
			this.hmWorkingTime.put("FORGETOUT_COUNT", FORGETOUT_COUNT); //ӹǹ駷ٴ͡
			
			this.hmWorkingTime.put("FORGETOUT_DATE", FORGETOUT_DATE); //ѹٴ
			
			OT1.add(this.hmWorkingTime.getDouble("OT1"));
			this.hmWorkingTime.put("OT1", this.df.format(OT1.getDouble())); //ͷ 1 
			
			OT15.add(this.hmWorkingTime.getDouble("OT15"));
			this.hmWorkingTime.put("OT15", this.df.format(OT15.getDouble()));//ͷ 1.5 
			
			OT2.add(this.hmWorkingTime.getDouble("OT2"));
			this.hmWorkingTime.put("OT2", this.df.format(OT2.getDouble())); //ͷ 2 
			
			OT3.add(this.hmWorkingTime.getDouble("OT3"));
			this.hmWorkingTime.put("OT3", this.df.format(OT3.getDouble())); //ͷ 3 
			
			UNUSED = UNUSED+this.hmWorkingTime.getDouble("UNUSED");
			this.hmWorkingTime.put("UNUSED", this.df.format(UNUSED)); //ҡ
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	public String getString(String fieldName) {
		if (fieldName.indexOf("$") > -1) {
			return this.getStringChild(fieldName);
		} else if (this.hmWorkingTime!=null && this.hmWorkingTime.containsKey(fieldName.toUpperCase())) {
			return this.hmWorkingTime.getString(fieldName.toUpperCase());
		} else {
			return super.getString(fieldName);
		}
	}

	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmWorkingTime.containsKey(fName.toUpperCase())) {
				return this.hmWorkingTime.getString(fName.toUpperCase());
			}
		}
		return super.getString(fieldName);
	}
	
}
