package com.csc.library.databean;

import java.text.DecimalFormat;
import java.util.HashMap;
 
import com.csc.library.database.DataSet;
import com.csc.library.process.ReportData;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime; 
import com.csc.library.utilities.MyLog;
import com.csc.library.utility.NUtils;

public class Memployeecpnworktime extends Memployee{
	private DecimalFormat dc = new DecimalFormat("#,##0.00");
	private String reportHeader = "";
	private ReportData rpt = null;
	
	CscCalendar cscStart = null;
	CscCalendar cscEnd= null;
	String table_list = "";
	
	public int assignField(DataSet rs) {				
		int temp = super.assignField(rs);
		
		String stDayOfMonth= (String) this.param.get("STDOM");
		String stMonth = (String) this.param.get("STMONTH");
		String stYear = (String) this.param.get("STYEAR");
		String endDayOfMonth= (String) this.param.get("ENDDOM");
		String endMonth = (String) this.param.get("ENDMONTH");
		String endYear = (String) this.param.get("ENDYEAR");
		String reportType = (String) this.param.get("REPORTTYPE");
		
	 	cscStart = new CscCalendar(stDayOfMonth+"-"+stMonth+"-"+stYear);
		cscEnd= new CscCalendar(endDayOfMonth+"-"+endMonth+"-"+endYear);
		
		if(reportType.equals("1")){
			table_list ="ttime_current1";
			//§ҹ
			if (this.reportHeader.equals("")) {
				if (((String) this.userPro.get("lang")).equalsIgnoreCase("ENG")) {
					this.reportHeader ="Work Time Result Date "+cscStart.getDayOfMonth()+" "+cscStart.getEngLongMonth()+" "+cscStart.getEngYYYY()
					+" - "+cscEnd.getDayOfMonth()+" "+cscEnd.getEngLongMonth()+" "+cscEnd.getEngYYYY();
				} else{
					this.reportHeader ="§ҹҡ÷ӧҹ Ш͹ "+cscStart.getThaiLongMonth()+" .."+cscStart.getThaiYYYY();
				}//end if 
			}//end if 
		}else{
			table_list="ttime_history1";
			//§ҹ
			if (this.reportHeader.equals("")) {
				if (((String) this.userPro.get("lang")).equalsIgnoreCase("ENG")) {
					this.reportHeader ="Work Time History Result Date "+cscStart.getDayOfMonth()+" "+cscStart.getEngLongMonth()+" "+cscStart.getEngYYYY()
					+" - "+cscEnd.getDayOfMonth()+" "+cscEnd.getEngLongMonth()+" "+cscEnd.getEngYYYY();
				} else{
					this.reportHeader ="§ҹѵҡ÷ӧҹШ͹ "+cscStart.getThaiLongMonth()+" .."+cscStart.getThaiYYYY();
				}//end if 
			}//end if  
		}//end if 
		
		sumWokTimeData(cscStart,cscEnd,table_list);
		
		return temp;
	}//end method assignField
	
	private void sumWokTimeData(CscCalendar startDate, CscCalendar endDate, String tablename) {
		try {
			rpt = new ReportData();
			rpt.setReportColumns(getInputColumns());
			rpt.setUProfile(this.userPro);
			rpt.setEmployeeCode(this.getString("employeeid"));
			rpt.setStartDate(cscStart.getYYYYMMDD());
			rpt.setEndDate(cscEnd.getYYYYMMDD());
			rpt.setTableName(tablename);
			rpt.fetchData();
			rpt.calWorkTime();
			rpt.setColumnDetail();
		} catch (Exception e) {
			MyLog.error("!! Error at MemployeeWorkResult.sumWokTimeData() employeeid is: "+this.getString("employeeid"));
		}//end try
	}//end method sumWokTimeData
	
	/* */
	private String[] getInputColumns(){
		CheckNull chk = new CheckNull();
		String col[] = {"","","","","","","","",""};
		try {
			col[0] = (String) this.getParam().get("__COL01");
			col[1] = (String) this.getParam().get("__COL02");
			col[2] = (String) this.getParam().get("__COL03");
			col[3] = (String) this.getParam().get("__COL04");
			col[4] = (String) this.getParam().get("__COL05");
			col[5] = (String) this.getParam().get("__COL06");
			col[6] = (String) this.getParam().get("__COL07");
			col[7] = (String) this.getParam().get("__COL08");
			col[8] = (String) this.getParam().get("__COL_MISC");	/* misc column */
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return col;
	}
	
	public String getString(String fieldName) {
		if (fieldName.equalsIgnoreCase("workgrade")) {
			return rpt.grade;
		} else if (fieldName.equalsIgnoreCase("sumwork")) {
     		return dc.format(rpt.csWork.getFloat());
		} else if (fieldName.equalsIgnoreCase("countwork")) {
     		return Integer.toString(rpt.work);     		
		} else if (fieldName.equalsIgnoreCase("countlate")) {
     		return Integer.toString(rpt.late);
		} else if (fieldName.equalsIgnoreCase("sumlate")) {
     		return dc.format(rpt.csLate.getFloat());
     	} else if (fieldName.equalsIgnoreCase("countabsent")) {
     		return Integer.toString(rpt.absent);
     	} else if (fieldName.equalsIgnoreCase("sumAbsent")) {
     		return dc.format(rpt.csAbsent.getFloat());
     	} else if (fieldName.equalsIgnoreCase("count_col01")) {
     		return Integer.toString(rpt.count_col[0]);
     	} else if (fieldName.equalsIgnoreCase("sum_col01")) {
     		return dc.format(rpt.csCol[0].getFloat());
     	} else if (fieldName.equalsIgnoreCase("count_col02")) {
     		return Integer.toString(rpt.count_col[1]);
     	} else if (fieldName.equalsIgnoreCase("sum_col02")) {
     		return dc.format(rpt.csCol[1].getFloat());
     	} else if (fieldName.equalsIgnoreCase("count_col03")) {
     		return Integer.toString(rpt.count_col[2]);
     	} else if (fieldName.equalsIgnoreCase("sum_col03")) {
     		return dc.format(rpt.csCol[2].getFloat());
     	} else if (fieldName.equalsIgnoreCase("count_col04")) {
     		return Integer.toString(rpt.count_col[3]);
     	} else if (fieldName.equalsIgnoreCase("sum_col04")) {
     		return dc.format(rpt.csCol[3].getFloat());
     	} else if (fieldName.equalsIgnoreCase("count_col05")) {
     		return Integer.toString(rpt.count_col[4]);
     	} else if (fieldName.equalsIgnoreCase("sum_col05")) {
     		return dc.format(rpt.csCol[4].getFloat());
     	} else if (fieldName.equalsIgnoreCase("count_col06")) {
     		return Integer.toString(rpt.count_col[5]);
    	} else if (fieldName.equalsIgnoreCase("sum_col06")) {
     		return dc.format(rpt.csCol[5].getFloat());
    	} else if (fieldName.equalsIgnoreCase("count_col07")) {
     		return Integer.toString(rpt.count_col[6]);
      	} else if (fieldName.equalsIgnoreCase("sum_col07")) {
     		return dc.format(rpt.csCol[6].getFloat());
    	} else if (fieldName.equalsIgnoreCase("count_col08")) {
     		return Integer.toString(rpt.count_col[7]);
       	} else if (fieldName.equalsIgnoreCase("sum_col08")) {
     		return dc.format(rpt.csCol[7].getFloat());
      	} else if (fieldName.equalsIgnoreCase("countmisc")) {
     		return Integer.toString(rpt.count_col[8]);
     	} else if (fieldName.equalsIgnoreCase("summisc")) {
     		return dc.format(rpt.csCol[8].getFloat());
     	} else if (fieldName.equalsIgnoreCase("ot1")) {
     		return dc.format(rpt.csOt1.getFloat());
       	} else if (fieldName.equalsIgnoreCase("ot5")) {
     		return dc.format(rpt.csOt5.getFloat());
    	} else if (fieldName.equalsIgnoreCase("ot2")) {
     		return dc.format(rpt.csOt2.getFloat());  
    	} else if (fieldName.equalsIgnoreCase("ot3")) {
     		return dc.format(rpt.csOt3.getFloat());     		
     	} else if (fieldName.equalsIgnoreCase("header")) {
     		return String.valueOf(this.reportHeader);
     	} else if (fieldName.equalsIgnoreCase("periodstart")) {
     		return cscStart.getDDMMYYYY().replace("-", "/");     
     	} else if (fieldName.equalsIgnoreCase("periodend")) {
     		return cscEnd.getDDMMYYYY().replace("-", "/");       
     	} else if (fieldName.equalsIgnoreCase("col01_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[0]);  
     	} else if (fieldName.equalsIgnoreCase("col02_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[1]);       
     	} else if (fieldName.equalsIgnoreCase("col03_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[2]);    
     	} else if (fieldName.equalsIgnoreCase("col04_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[3]);       
     	} else if (fieldName.equalsIgnoreCase("col05_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[4]);       
     	} else if (fieldName.equalsIgnoreCase("col06_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[5]);        
     	} else if (fieldName.equalsIgnoreCase("col07_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[6]);     
     	} else if (fieldName.equalsIgnoreCase("col08_thaname")) {
     		return rpt.getColHeaderThai(rpt.REPORT_COLUMNS[7]);        
     	} else if (fieldName.equalsIgnoreCase("col01_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[0]);  
     	} else if (fieldName.equalsIgnoreCase("col02_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[1]);       
     	} else if (fieldName.equalsIgnoreCase("col03_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[2]);    
     	} else if (fieldName.equalsIgnoreCase("col04_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[3]);       
     	} else if (fieldName.equalsIgnoreCase("col05_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[4]);       
     	} else if (fieldName.equalsIgnoreCase("col06_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[5]);        
     	} else if (fieldName.equalsIgnoreCase("col07_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[6]);     
     	} else if (fieldName.equalsIgnoreCase("col08_engname")) {
     		return rpt.getColHeaderEng(rpt.REPORT_COLUMNS[7]);    
     	}else{
     		return super.getString(fieldName);
     	}//end if 
	}//end method getString
	
	private DbInquiry getInq(String tableName,CscCalendar startDate) {
		DbInquiry inq = null;
		try {
			if (inq==null) {	
				inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable(tableName, "", "");
				inq.setColumn("*");				
			}//end if 
		} catch (Exception e) {
			MyLog.error("!! Error at MemployeeWorkResult.getInq()!!");
		}//end try
		return inq;
	}//end method getInq
	
}//end class TimeWorkResult


