package com.csc.library.databean;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

import java.util.HashMap;

import com.csc.library.database.StaticConfig;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;

import com.csc.library.timeattendance.TimeUtility;
import com.csc.library.timeinterface.GenDayShift;
import com.csc.library.utilities.CscCalendar;

public class Mtime1 extends RecordCmp implements GenDayShift, DbRecord {
	
	Shift lastShift=null;
	MyTreeMap trEmpSwipe = null;
	
	CscCalendar pstart = null ; /* start period */
	CscCalendar pend = null ;	/* end period */
    private HashMap hmTime0List = null ;
    
	public Mtime1() {
		super("Mtime1", "Mtime1 Table");
	}
	
	public void setMtime0List(HashMap mlist){
		this.hmTime0List = mlist ;
	}
	
	//Overide to check this shift : last shift
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, Shift lastShift, String type, HashMap hmData1, 
			String workarea, CscCalendar sDate, CscCalendar eDate) {		
		this.lastShift = lastShift;
		return this.generateDayShift(time0id, date, holidayHM, type, hmData1,workarea, sDate, eDate);
	}

	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, String type, HashMap hmData1, 
		String workarea, CscCalendar sDate, CscCalendar eDate) {
		DayShift dShift = new DayShift(date);
		TimeUtility tu = new TimeUtility();
		
		try {
			initGenWorkShiftPeriod(sDate, eDate);
			
			if ((type.equalsIgnoreCase("true")) || (!holidayHM.containsKey(date.getYYYYMMDD()) && this.getType(date, holidayHM, type).equals("T")) || this.getType(date, holidayHM, type).equals("A")) {
				if (this.getString("dayweekid").equals(String.valueOf(date.getCSCDOW()))
						&& (this.getString("time0id").equalsIgnoreCase(time0id))) {				
					if (this.getString("amtperiod").equalsIgnoreCase("1")) { //ٴѵ 2 駵ѹ
						Shift sh = new Shift();					
						sh.setEventGroup(this.getType(date, holidayHM, type));
						sh.setTR_Type(dShift.getNextRuningCode(this.getType(date, holidayHM, type)));
						this.setBreakTimeToShift(sh, date); //˹ҾѡѺ
						this.setTimeToShift(sh, date); //˹-͡Ѻ					
						if (sh.get_c_dt_out().beforeDate(sh.get_c_dt_in())) {
							sh.get_c_dt_out().incDate();
						}
						sh.setShiftDate(sh.get_c_dt_in()); //˹ѹͧ
						sh.setHour_s(this.getFloat("hour_d")); //˹ .ӧҹѹ
						if (sh.getEventGroup().equals("I") || sh.getEventGroup().equals("H")) {
							sh.setHour_d(0f);
						} else sh.setHour_d(this.getFloat("hour_d"));
						sh.setWorkarea(workarea);
						
						//dShift.put(sh);
						//dShift.setShiftDate(sh.get_c_dt_in());
						if (sDate!=null && eDate!=null) { 
							if (sDate.getCSCTime()!=0.0 && eDate.getCSCTime()!=0.0) {
								if (sh.get_c_dt_in().after(sDate) && sh.get_c_dt_out().before(eDate)) {
									dShift.put(sh);
									dShift.setShiftDate(sh.get_c_dt_in());
								}
							} else {
								dShift.put(sh);
								dShift.setShiftDate(sh.get_c_dt_in());
							}
						} else {
							dShift.put(sh);
							dShift.setShiftDate(sh.get_c_dt_in());
						}
						
					} else if (this.getString("amtperiod").equalsIgnoreCase("2")) { //ٴѵ 4 駵ѹ
						Shift sh = new Shift(); //зͧٴѵêǧá
						sh.setTR_Type(dShift.getNextRuningCode(this.getType(date, holidayHM, type)));
						this.setBreakTimeToShift(sh, date);
						this.setTimeToShift(sh, date, "1");					
						if (sh.get_c_dt_out().beforeDate(sh.get_c_dt_in())) {
							sh.get_c_dt_out().incDate();
						}
						sh.setEventGroup(this.getType(date, holidayHM, type));
						sh.setShiftDate(sh.get_c_dt_in());
						sh.setHour_s(this.getFloat("hour_d"));
						if (sh.getEventGroup().equals("I") || sh.getEventGroup().equals("H")) {
							sh.setHour_d(0f);
						} else sh.setHour_d(this.getFloat("hour_d"));			
						sh.setWorkarea(workarea);
						//dShift.put(sh);
						//dShift.setShiftDate(sh.get_c_dt_in());
						
						if (sDate!=null && eDate!=null) { 
							if (sDate.getCSCTime()!=0.0 && eDate.getCSCTime()!=0.0) {
								if (sh.get_c_dt_in().after(sDate) && sh.get_c_dt_out().before(eDate)) {
									dShift.put(sh);
									dShift.setShiftDate(sh.get_c_dt_in());
								}
							} else {
								dShift.put(sh);
								dShift.setShiftDate(sh.get_c_dt_in());
							}
						} else {
							dShift.put(sh);
							dShift.setShiftDate(sh.get_c_dt_in());
						}
						
	
						Shift sh1 = new Shift(); //зͧٴѵêǧѧ
						sh1.setEventGroup(this.getType(date, holidayHM, type));
						sh1.setTR_Type(dShift.getNextRuningCode(this.getType(date, holidayHM, type)));
						this.setTimeToShift(sh1, sh.get_c_dt_out(), "2");
						if (sh1.get_c_dt_in().beforeDate(sh.get_c_dt_out()))
							sh1.get_c_dt_in().incDate();
						if (sh1.get_c_dt_out().beforeDate(sh1.get_c_dt_in()))
							sh1.get_c_dt_out().incDate();
						sh1.setShiftDate(sh1.get_c_dt_in());
						sh1.setHour_s(this.getFloat("hour_d"));
						if (sh1.getEventGroup().equals("I") || sh1.getEventGroup().equals("H")) {
							sh1.setHour_d(0f);
						} else sh1.setHour_d(this.getFloat("hour_d"));			
						sh1.setWorkarea(workarea);
						
						//dShift.put(sh1);
						if (sDate!=null && eDate!=null) { 
							if (sDate.getCSCTime()!=0.0 && eDate.getCSCTime()!=0.0) {
								if (sh1.get_c_dt_in().after(sDate) && sh1.get_c_dt_out().before(eDate)) {
									dShift.put(sh1);
								}
							} else {
								dShift.put(sh1);
							}
						} else {
							dShift.put(sh1);
						}
						
					}
				}else{
					MyLog.error("[MTIME1.GENERATEDAYSHIFT] could not found time0id : " + this.getString("dayweekid") + " match with input date : " +  String.valueOf(date.getCSCDOW()));
				}
	        }
			//} else {
			//	if (holidayHM.containsKey(date.getYYYYMMDD())) MyLog.debug(this, "IS IN HOLIDAY");
			//	if (!this.getType(date, holidayHM).equals("T")) MyLog.debug(this, "IS STOP DAY >>> "+this.getString("stopday")+" TYPE="+this.getType(date, holidayHM));		
			//MyLog.debug(this, "---->dShift in Mtime1=" + dShift.keySet());	
		}catch(Exception e){
			MyLog.error("[MTIME1.GENERATEDAYSHIFT] WorkingShift might be incorrect ");
			MyLog.error(this,e);
		}
		return dShift;
	}
	
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, String type, HashMap hmData1, 
			String workarea, CscCalendar sDate, CscCalendar eDate, MyTreeMap trSwipe) {
		this.trEmpSwipe = trSwipe;
		return this.generateDayShift(time0id, date, holidayHM, type, hmData1, workarea, sDate, eDate);
	}
	public DayShift generateDayShift(String time0id, CscCalendar date, HashMap holidayHM, Shift lastShift, String type, HashMap hmData1, 
			String workarea, CscCalendar sDate, CscCalendar eDate, MyTreeMap trSwipe) {		
		this.lastShift = lastShift;
		this.trEmpSwipe = trSwipe;
		return this.generateDayShift(time0id, date, holidayHM, type, hmData1,workarea, sDate, eDate);
	}
	
	/*
	 * ˹ǧҾѡѺ
	 */
	private void setBreakTimeToShift(Shift sh, CscCalendar date) { 
		try {				
			CscCalendar breakIN = new CscCalendar(date.getDDMMYYYY());
			breakIN.setCSCTime(this.getFloat("timeout1"));
			if ((this.getFloat("timeout1") < this.getFloat("timein1")) || this.getFloat("timein1") == 0) {
				breakIN.incDate();
			}
			CscCalendar breakOUT = new CscCalendar(date.getDDMMYYYY());
			breakOUT.setCSCTime(this.getFloat("timein2"));			
			if ((this.getFloat("timein2") < this.getFloat("timein1")) || this.getFloat("timein1") == 0) {
				breakOUT.incDate();
			}
			
			/*if (breakIN.getCSCTime()>breakOUT.getCSCTime()) {				
				breakOUT.incDate();
			}
			if (this.lastShift!=null) {
				if (this.lastShift.get_c_dt_out().getCSCTime()>breakIN.getCSCTime()) {
					breakIN.incDate();
					breakOUT.incDate();
				}
			}*/
			
			sh.setMidDayStop(new TimeZone(breakIN, breakOUT));
			//MyLog.debug(this, ">>>>>>>> BREAK START="+breakIN.getTimestamp()+" END="+breakOUT.getTimestamp());
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	/*
	 * ˹ҵҧ Ѻ
	 * sh = 
	 * date = ѹͧ
	 * id1 = 
	 * id2 = ͡
	 */
	private void setTimeToShift(Shift sh, CscCalendar date, String id1, String id2) {
		try {			
			CscCalendar cscTmp = new CscCalendar(date.getDDMMYYYY());
			cscTmp.incDate();
			cscTmp.setCSCTime(0f);
			
			CscCalendar csIN = new CscCalendar(date.getDDMMYYYY());
			csIN.setCSCTime(this.getFloat("timein" + id1));
			/*if (this.getFloat("timein"+id1)==0.0) {				
				csIN.decMinute();
				csIN.incDate();
			}*/
			
			CscCalendar csOUT = new CscCalendar(date.getDDMMYYYY());
			csOUT.setCSCTime(this.getFloat("timeout" + id2));
			if (csIN.getCSCTime()>csOUT.getCSCTime()) {				
				csOUT.incDate();
			}
			
			//-------------------------------- Start FlexTime NSTDA --------------------------//
			String isCalFlexTime = "";
			try {
				isCalFlexTime = (String) StaticConfig.getConfigCompany(this.userPro, "ta1012");
			} catch (Exception e) {
				//MyLog.error("ERROR !!! Find Config TA1012 not found : is use for calculate flex time NSTDA");
			}
			//繡Ẻ͹ͧ Ƿ  зӡ͹ ŧ
			if (isCalFlexTime.equals("1") && this.trEmpSwipe!=null && !this.trEmpSwipe.isEmpty()) { 
				if (this.trEmpSwipe.containsKey(date.getDDMMYYYY())) {
					MyTreeMap timeSwipe = (MyTreeMap) this.trEmpSwipe.get(date.getDDMMYYYY());
					double times = ((Double) timeSwipe.get(timeSwipe.keySet().iterator().next())).doubleValue();
					
					double times_leave = 0;
					if (this.trEmpSwipe.containsKey(date.getDDMMYYYY()+"_FIX")) {
						MyTreeMap timeFix = (MyTreeMap) this.trEmpSwipe.get(date.getDDMMYYYY()+"_FIX");
						times_leave = ((Double) timeFix.get(timeFix.keySet().iterator().next())).doubleValue();
					}
					
					CscCalendar b1 = sh.getMidDayStop().getBeginZone();
					CscCalendar b2 = sh.getMidDayStop().getEndZone();					
					if (times_leave>=7.30 && times_leave<=9.00) {
						//Ҫǧ ŧ 8.30 Ҩ 7.30 
						if (times<times_leave && times>7.30) { //ٴѵù¡ҷ
							CscTime c = new CscTime(0f);
							c.add(times);
							c.add(this.getFloat("hour_d"));
							c.add(b2.subForHour(b1));
							csIN.setCSCTime(times);
							csOUT.setCSCTime(c.getFloat());
						} else {
							CscTime c = new CscTime(0f);
							c.add(times_leave);
							c.add(this.getFloat("hour_d"));
							c.add(b2.subForHour(b1));
							csIN.setCSCTime(times_leave);
							csOUT.setCSCTime(c.getFloat());
						}
					} else {
						if (times>7.30 && times<=9.00) {					
							CscTime c = new CscTime(0f);
							c.add(times);
							c.add(this.getFloat("hour_d"));
							c.add(b2.subForHour(b1));
							csIN.setCSCTime(times);
							csOUT.setCSCTime(c.getFloat());
						} else if (times>9.00) {
							CscTime c = new CscTime(0f);
							c.add(9f);
							c.add(this.getFloat("hour_d"));
							c.add(b2.subForHour(b1));
							csIN.setCSCTime(9);
							csOUT.setCSCTime(c.getFloat());
						}
					}
				} else if (this.trEmpSwipe.containsKey(date.getDDMMYYYY()+"_FIX")) { // ҡŧ
					MyTreeMap timeFix = (MyTreeMap) this.trEmpSwipe.get(date.getDDMMYYYY()+"_FIX");
					double times_leave = ((Double) timeFix.get(timeFix.keySet().iterator().next())).doubleValue();
					if (times_leave>=7.30 && times_leave<=9.00) {
						CscCalendar b1 = sh.getMidDayStop().getBeginZone();
						CscCalendar b2 = sh.getMidDayStop().getEndZone();		
						CscTime c = new CscTime(0f);
						c.add(times_leave);
						c.add(this.getFloat("hour_d"));
						c.add(b2.subForHour(b1));
						csIN.setCSCTime(times_leave);
						csOUT.setCSCTime(c.getFloat());
					}
				}
			} 
			//-------------------------------- Start FlexTime NSTDA --------------------------//
			
			if (this.lastShift!=null) {
				if (this.lastShift.get_c_dt_out().getCSCTime()>csIN.getCSCTime()) {
					csIN.incDate();
					csOUT.incDate();
				}
			}
			
			sh.set_c_dt_in(csIN); //ѹҧҹͧѷ
			sh.set_c_dt_out(csOUT); //ѹ͡ҹͧѷ
			
			CscCalendar o_in = new CscCalendar(csIN.getYYYYMMDD());
			o_in.setCSCTime(csIN.getCSCTime());
			CscCalendar o_out = new CscCalendar(csOUT.getYYYYMMDD());
			o_out.setCSCTime(csOUT.getCSCTime());
			sh.set_o_dt_in(o_in); 
			sh.set_o_dt_out(o_out);
			
			sh.set_sh_dt_in(o_in); //ѹҧҹ
			sh.set_sh_dt_out(o_out); //ѹ͡ҹ
			
			sh.setTimeCode(this.getString("time0id"));
			//MyLog.debug(this, ">>>>>>>> TIMEWORK START="+csIN.getTimestamp()+" END="+csOUT.getTimestamp());			
		} catch (Exception e) {
			//MyLog.error(this, e);			
		}
	}

	private void setTimeToShift(Shift sh, CscCalendar date, String id) {
		this.setTimeToShift(sh, date, id, id);		
	}

	private void setTimeToShift(Shift sh, CscCalendar date) {
		this.setTimeToShift(sh, date, "1", "2");
	}

	/*
	 * һѹ ѹ ѹش 
	 */
	public String getType(CscCalendar date, HashMap hm, String type) {
		String result = "T";
		if (this.getString("stopday").equalsIgnoreCase("1")) {
			result = "H";
		} else {
			if(isPublicHoliday(date, hm)){
				result = "I";
			}
			/*
			if (date.getYYYYMMDD().equalsIgnoreCase((String) hm.get(date.getYYYYMMDD()))) {
				result = "I";
			}*/
		}
		
		if (type.equals("3")) {
			result = "A";
		}
		return result;
	}

	public void setEmpSwipeTime(MyTreeMap tr) {
		this.trEmpSwipe = tr;
	}
	
	private void initGenWorkShiftPeriod(CscCalendar s, CscCalendar e){
		this.pstart = s ;
		this.pend = e ;
	}
	
	private boolean isPublicHoliday(CscCalendar sdate, HashMap hol){
		HashMap holidayHM = new HashMap();
		try {
			/* init public holiday */
			String holc = getHolidayCode() ;
			if(hol.containsKey(holc)){
				holidayHM = (HashMap) hol.get(holc);
			}else{
				try {
					DbInquiry inqHoliday = new InitialInquiry(this.userPro).getDbInquiry();
					inqHoliday.setParam(this.param);
					inqHoliday.setSchemaName(this.userPro.getSchemaName());
					inqHoliday.initMyTable("Mholiday1", "", "");
					inqHoliday.setColumn("hdate, companyid");
					inqHoliday.setFilter("holidayid='"	+ holc + "' and hdate between '" + pstart.getYYYYMMDD() + "' and '" + pend.getYYYYMMDD() + "'");
					inqHoliday.refresh();

					while (inqHoliday.next()) {
						CscCalendar csc = new CscCalendar(inqHoliday.getString("hdate"));
						holidayHM.put(csc.getYYYYMMDD(), csc.getYYYYMMDD());
					}
					
					hol.put(key, holidayHM);
				} catch (Exception e) {
					MyLog.error(this, e);			
				}
			}
			
			if(holidayHM.containsKey(sdate.getYYYYMMDD())){
				return true ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	private String getHolidayCode(){
		String hc = "";
		DbRecord db = null ;
		try {
			if(this.hmTime0List.containsKey(this.getString("time0id"))){
				db = (DbRecord) hmTime0List.get(this.getString("time0id"));
			}else{
				db = new InitialRecord(this.userPro).getDbRecord("Mtime0");
				db.set("time0id", this.getString("time0id"));
				db.set("companyid", this.getUProfile().getCompanyid());
				if(db.search() == 1){
					hmTime0List.put(this.getString("time0id"), db);
				}
			}
			
			if(db != null) hc = db.getString("holidaycode");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return hc ;
	}
}