package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.formula.FormulaString;
import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Simmemployee_tadjtime0_Eastwater extends Memployee {

	private String employeeid="";
	MyHashMap hm_Col = new MyHashMap();
	MyHashMap hm_mevent = new MyHashMap();
	MyHashMap hm_hour_d = new MyHashMap();
	double hr_mtime0 = 0;

	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		this.hm_Col.clear();
        MyLog.debug(this, "<<<<<<<<<<<<<<-- Simmemployee_tadjtime0 -->>>>>>>>>>>>>>");
        
		if(!this.getString("employeeid").equals("")){
		if (this.param.containsKey("__runno")	&& this.param.containsKey("wf_id")) {
            MyLog.debug(this, "<-----------workflow-------------->");
			try {
				String table = (String) this.param.get("wf_id");
				String runno = (String) this.param.get("__runno");
				if (table.equals("5"))
					table = "TABSENTDATE0";
				else if (table.equals("6"))
					table = "TABSENT_M_DATE";
				DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
				inq.initMyTable(table, "runno=" + runno, "");
				inq.setColumn("employeeid,companyid,runno");
				inq.refresh();
				if (inq.next())
					this.employeeid = inq.getString("employeeid");
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
		} else this.employeeid = (String) this.param.get("__employeeid");
		
		this.selectEvent();
		this.sumTime();
		}
		//MyLog.debug(this, "-->hm_Col="+hm_Col);
		//MyLog.debug(this, "-->hm_mevent="+hm_mevent);
		//MyLog.debug(this, "-->hm_hour_d="+hm_hour_d);
		return temp;
	}

	private void selectEvent() {
		try {
			String limit = "";
			FormulaString fs = new FormulaString();
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.setSchemaName(this.getUProfile().getSchemaName());
			inq.initMyTable(	"meventgrp","daytype!='1' and daytype !='5' and daytype !='6' and daytype !='9' ","");
			inq.setColumn("eventgrpid,companyid,edesc,tdesc,daytype,limit");
			inq.refresh();
			this.getHour_Day();
			while (inq.next()) {
				if (inq.getString("daytype").equalsIgnoreCase("7")) {
					//MyLog.debug(this, "<------------vacation------------>");
					DbInquiry inqEmp = new InitialInquiry(this.getUProfile()).getDbInquiry();
					inqEmp.initMyTable("memployee", "", "");
					inqEmp.setColumn("memployeeid,companyid,vacation0,vacation1");
					inqEmp.setFilter("employeeid='" + this.employeeid + "'");
					inqEmp.refresh();
					int i=0;
					if (inqEmp.next()) 			
					//	MyLog.debug(this, " >>>>>>>>>> vacation0="+inqEmp.getString("vacation0"));
					//	MyLog.debug(this, " >>>>>>>>>> vacation1="+inqEmp.getString("vacation1"));
						i = fs.DhmToM(inqEmp.getString("vacation0")) + fs.DhmToM(inqEmp.getString("vacation1"));
					limit = fs.MTODhm(i);
				} else {
					//MyLog.debug(this, "<------------limit------------>");
					limit = inq.getString("limit")+":0:0";
				}
				//MyLog.debug(this, "code----------->>>> " +
				// inq.getString("eventgrpid") + " >>> limit=" + limit);
				//MyLog.debug(this, "<----eventgrpid---->" +
				// inq.getString("eventgrpid"));
				this.hm_Col.put(inq.getString("eventgrpid"), inq.getString("eventgrpid"));
				//this.hm_Col.put(inq.getString("eventgrpid") + "1", this.lToL(limit));//limit leave
                this.hm_Col.put(inq.getString("eventgrpid") + "1", limit);//limit leave
				this.hm_Col.put(inq.getString("eventgrpid") + "4", inq.getString("edesc"));//desc leave
				this.hm_Col.put(inq.getString("eventgrpid") + "2", "0:0:0");//time leave
				this.hm_Col.put(inq.getString("eventgrpid") + "3", limit);//ans of leave
				//MyLog.debug(this, "<----eventgrpidH---->" +
				// this.hm_Col.get(inq.getString("eventgrpid")));
				//MyLog.debug(this, "<----eventgrpidL---->" +
				// this.hm_Col.get(inq.getString("eventgrpid") + "1"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void sumTime() {
		try {
			// ### comment by pae 8-2-2005 ####
			 
			CscCalendar cs = new CscCalendar(); 
			String DateS = "", DateE = "",Date=cs.getYYYYMMDD(); 
			String pDateStart = ""; String pDateEnd = "";
         //   MyLog.debug(this, "StartDate -->> "+this.param.get("__date_start"));
         //   MyLog.debug(this, "EndDate -->> "+this.param.get("__date_end"));
						 
			if (this.param.containsKey("__date_start") && this.param.containsKey("__date_end")) { 
				pDateStart = (String) this.param.get("__date_start"); 
				pDateEnd = (String) this.param.get("__date_end");
				//MyLog.debug(this, "param__date--->" + pDateStart + " <->" + pDateEnd);
			 
				 if (!pDateEnd.trim().equals("")) { 
				 	DateE = pDateEnd; 
				 } 
				 if (!pDateStart.trim().equals("")) { 
				 	DateS = pDateStart; 				 	
				 } 
                 if(pDateStart.trim().equals("")&&pDateEnd.trim().equals("")){
                    MyLog.debug(this, "<-------------Mbudget getDate-------------->");
                     CscCalendar csBudget = new CscCalendar();
                     int yearStart = csBudget.getYear();
                     csBudget.incYear(1);
                     int yearEnd = csBudget.getYear();
                     DbInquiry inqM = new InitialInquiry(this.getUProfile()).getDbInquiry();
                     inqM.initMyTable("Mbudget", "", "");                    
                     inqM.setColumn("budid,companyid,years,startdate,enddate");
                     inqM.setFilter("startdate<='"+yearStart+"-10-01' and enddate >='"+yearEnd+"-09-30' and companyid='"+this.getString("companyid")+"'");
                     inqM.refresh();  
                     inqM.next();
                     //MyLog.debug(this, " budid -->> "+inqM.getString("budid"));
                     //MyLog.debug(this, " dateS -->> "+inqM.getString("startdate") +" dateE -->> "+inqM.getString("enddate"));
                     DateS=inqM.getString("startdate");
                     DateE=inqM.getString("enddate");                    
                     CscCalendar cs1=new CscCalendar(DateS);
                     CscCalendar cs2=new CscCalendar(DateE);
                     DateS=cs1.getYYYYMMDD();
                     DateE=cs2.getYYYYMMDD();
                    // MyLog.debug(this, " dateS -->> "+DateS +" dateE -->> "+DateE);
                    this.hm_Col.put("DateStart",cs1.getDDMMYYYY());
                    this.hm_Col.put("DateEnd",cs2.getDDMMYYYY());
                 }				
			} else{
                MyLog.debug(this, "<-------------Mbudget else-------------->");
                DbInquiry inqM = new InitialInquiry(this.getUProfile()).getDbInquiry();
                CscCalendar csBudget = new CscCalendar();
                MyLog.debug(this, "<-------------csBudget-------------->"+csBudget);
                MyLog.debug(this, "<-------------csBudget Month-------------->"+csBudget.getMonth());
                if ((csBudget.getMonth()+1)==10||(csBudget.getMonth()+1)==11||(csBudget.getMonth()+1)==12) {
                	MyLog.debug(this, "<-------------Month=10,11,12-------------->"+(csBudget.getMonth()+1));
                	//csBudget.incYear(1);
                } else if ((csBudget.getMonth()+1)<10) {
                	MyLog.debug(this, "<-------------Month=1-9-------------->"+csBudget.getMonth()+1);
                	csBudget.decYear(1);
                }                
                int yearStart = csBudget.getYear();
                csBudget.incYear(1);
                int yearEnd = csBudget.getYear();
                inqM.initMyTable("Mbudget", "", "");                    
                inqM.setColumn("budid,companyid,years,startdate,enddate");
                //inqM.setFilter("startdate<='"+Date+"' and enddate >='"+Date+"' and companyid='"+this.getString("companyid")+"'");
                inqM.setFilter("startdate<='"+yearStart+"-10-01' and enddate >='"+yearEnd+"-09-30' and companyid='"+this.getString("companyid")+"'");
                inqM.refresh();  
                inqM.next();
                //MyLog.debug(this, " budid -->> "+inqM.getString("budid"));
                //MyLog.debug(this, " dateS -->> "+inqM.getString("startdate") +" dateE -->> "+inqM.getString("enddate"));
                DateS=inqM.getString("startdate");
                DateE=inqM.getString("enddate");                    
                CscCalendar cs1=new CscCalendar(DateS);
                CscCalendar cs2=new CscCalendar(DateE);
                DateS=cs1.getYYYYMMDD();
                DateE=cs2.getYYYYMMDD();
               // MyLog.debug(this, " dateS -->> "+DateS +" dateE -->> "+DateE);
               this.hm_Col.put("DateStart",cs1.getDDMMYYYY());
               this.hm_Col.put("DateEnd",cs2.getDDMMYYYY());
            }
			
			String sql = "employeeid= '" + employeeid + "'";
			if (!DateS.equals("")&&!DateE.equals("")) {
				sql = sql +  " and (m_dt_bg between'" + DateS + "' and '" + DateE + " ')" ;
			}
			MyLog.debug(this, "SQL >>>>>>>>>>>>>" + sql);
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.initMyTable("ttime_current1", "", "");
			inq.setColumn("employeeid,companyid,dateid,doctype,lv_ty,m_lv,tr_type,eventgrp");
			inq.setFilter(sql);
			inq.refresh();
			FormulaString fs = new FormulaString();
			while (inq.next()) {
				int a = 0;
				String d = "", e = "";
				//MyLog.debug(this, "--------------eventgrp-------------> "+inq.getString("eventgrp")+" *****");
				if (inq.getString("eventgrp").equals(this.hm_Col.get(inq.getString("eventgrp")))) {
					//MyLog.debug(this, "eventgrp---->>>>>>" + this.hm_Col.get(inq.getString("eventgrp")) + "doctype---> " + inq.getString("doctype"));
					//if ((inq.getString("doctype").trim().equals("A") || inq.getString("doctype").trim().equals("S"))) {
						//MyLog.debug(this, "doctype---->"+ inq.getString("doctype"));
						double s1 = 0f;
						double h = 0f;
						//s1 = Double.valueOf(inq.getString("m_lv"))	.doubleValue();
						s1 = inq.getCurrentDbRecord().getDouble("m_lv");
						//MyLog.debug(this, "eventgrp2-->" + this.hm_Col.get(inq.getString("eventgrp")	+ "2"));
						//MyLog.debug(this, "tr_type<>updtype-->" 	+ inq.getString("tr_type") + "<->"	+ inq.getString("updtype"));
						if (this.hm_Col.containsKey(inq.getString("eventgrp") + "2")) {
							e = this.hm_Col.get(inq.getString("eventgrp") + "2").toString();
							//MyLog.debug(this, "befor SUM------->>>" + fs.DhmToM(e) + " + " + fs.times(s1));
							a = fs.DhmToM(e) + fs.Tm_To_Min(s1);
						} else {
							a = fs.Tm_To_Min(s1);
						}
						d = fs.MTODhm(a,this.hr_mtime0);
						this.hm_Col.put(inq.getString("eventgrp") + "2", d);
						//MyLog.debug(this, "sum-------->" + this.hm_Col.get(inq.getString("eventgrp") + "2"));
						this.subTime(inq.getString("eventgrp"));
					//}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void subTime(String a) {
		FormulaString fs = new FormulaString();
		String x = this.hm_Col.get(a + "1").toString();
		String y = this.hm_Col.get(a + "2").toString();
		int b = fs.DhmToM(x) - fs.DhmToM(y);
		//MyLog.debug(this, "Ans-->" + x + "-" + y + "<---Limit_LV---->" + b);
		String z = fs.MTODhm(b,this.hr_mtime0);
		//MyLog.debug(this, "MMM--->" + z);
		this.hm_Col.put(a + "3", z);
	}

	private String lToL(String a) {
		FormulaString fs = new FormulaString();
		return fs.MTODhm(fs.DhmToM(a, this.hr_mtime0), this.hr_mtime0);
	}

	private void getHour_Day() {
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");
			//inq1.refresh();
			
            this.putChild(inq1);
            this.refreshChild();
            /*
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.initMyTable("memployee", "", "");
			inq.setColumn("memployeeid,companyid,time0");
			inq.setFilter("employeeid='" + this.employeeid + "'");
			inq.putChild(inq1);
			inq.refresh();
			inq.next();			
            */
			this.hr_mtime0 = Double.valueOf(inq1.getString("hour_d")).doubleValue();
			MyLog.debug(this, "hour_d------->>>" + this.hr_mtime0);
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	public String getString(String fieldName) {
		//MyLog.debug(this, "fieldName ----------> " + fieldName);
		if (fieldName.indexOf("$") > 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}

	private String getStringChild(String fieldName) {
		//MyLog.debug(this, "fieldNameChild ----------> " + fieldName);
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hm_Col.get(fName) != null) {
				return String.valueOf(this.hm_Col.get(fName));
			}
		}
		return super.getString(fieldName);
	}
}