package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.text.DecimalFormat;

import com.csc.library.formula.FormulaString;
import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Simmemployee_tadjtime0_Pea extends Memployee {

	private String employeeid = "";
	MyHashMap hm_Col = new MyHashMap();
	MyHashMap hm_mevent = new MyHashMap();
	MyHashMap hm_hour_d = new MyHashMap();
	double hr_mtime0 = 0;

	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (temp!=0) {
			this.hm_Col.clear();
	
			if (!this.getString("employeeid").equals("")) {
				if (this.param.containsKey("__runno") 	&& this.param.containsKey("wf_id")) {
					try {
						String table = (String) this.param.get("wf_id");
						String runno = (String) this.param.get("__runno");
						if (table.equals("5")) {
							table = "TABSENTDATE0";
						} else if (table.equals("6")) {
							table = "TABSENT_M_DATE";
						}						
						DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
						inq.initMyTable(table, "runno=" + runno, "");
						inq.setColumn("employeeid,companyid,runno");
						inq.refresh();
						if (inq.next())
							this.employeeid = inq.getString("employeeid");
					} catch (Exception e) {
						MyLog.error(this, e);

						
					}
				} else {
					this.employeeid = (String) this.param.get("__employeeid");
				}
				
				if (this.param.containsKey("SCREEN")) {
					if (((String)this.param.get("SCREEN")).equalsIgnoreCase("EXPORTSUMLEAVE")) {
						this.employeeid = this.getString("employeeid");
					}
				}
	
				this.selectEvent();
				this.sumTime();
			}
			this.displayLeave();
		}
		return temp;
	}
	
	private void displayLeave() {
		try {
			MyLog.debug(this, "EmployeeID ::: "+this.employeeid);
			DbInquiry inqDay = new InitialInquiry(this.userPro).getDbInquiry();
			inqDay.setSchemaName(this.userPro.getSchemaName());
			inqDay.initMyTable("meventgrp","daytype!='1' and daytype !='5' and daytype !='6' and daytype !='9' ","");
			inqDay.setColumn("eventgrpid,companyid,edesc,tdesc,daytype,limit");
			inqDay.refresh();				
			while (inqDay.next()) {
				String a="simmemployee_tadjtime0$"+ inqDay.getString("eventgrpid");
				String b= inqDay.getString("eventgrpid");
				MyLog.debug(this, b+" \t\t "+this.getString(a+"1")+" \t\t "+this.getString(a+"2")+" \t\t "
						+this.getString(a+"3")+" \t\t "+this.getString(a+"4")+" \t\t\t "
						+"5:"+this.getString(a+"5"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			// TODO Auto-generated catch block
			
		}
	}

	private void selectEvent() {
		try {
			String limit="";
			FormulaString fs = new FormulaString();
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.setSchemaName(this.getUProfile().getSchemaName());
			inq.initMyTable("meventgrp","daytype!='1' and daytype !='5' and daytype !='6' and daytype !='9' ","");
			inq.setColumn("eventgrpid,companyid,edesc,tdesc,daytype,limit");
			inq.refresh();
			this.getHour_Day();
			while (inq.next()) {
				if (inq.getString("daytype").equalsIgnoreCase("7")) {
					//MyLog.debug(this, "<------------vacation------------>");
					DbInquiry inqEmp = new InitialInquiry(this.getUProfile()).getDbInquiry();
					inqEmp.initMyTable("memployee", "", "");
					inqEmp	.setColumn("memployeeid,companyid,vacation0,vacation1");
					inqEmp.setFilter("employeeid='" + this.employeeid + "'");
					inqEmp.refresh();
					int i = 0;
					if (inqEmp.next()) {
						i = fs.DhmToM(inqEmp.getString("vacation0")) 	+ fs.DhmToM(inqEmp.getString("vacation1"));
					}
					limit = fs.MTODhm(i);
				} else {					
					limit = inq.getString("limit") + ":0:0";
				}
				this.hm_Col.put(inq.getString("eventgrpid"), inq.getString("eventgrpid"));
				this.hm_Col.put(inq.getString("eventgrpid") + "1", limit);//limit leave
				this.hm_Col.put(inq.getString("eventgrpid") + "4", inq	.getString("edesc"));//desc leave
				this.hm_Col.put(inq.getString("eventgrpid") + "2", "0:0:0");//uses leave
				this.hm_Col.put(inq.getString("eventgrpid") + "3", limit);//leave [limit-uses]				
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void sumTime() {
		try {
			CscCalendar cs = new CscCalendar();
			String DateS = "", DateE = "", Date = cs.getYYYYMMDD();
			String pDateStart = "";
			String pDateEnd = "";
			this.hm_Col.put("year", cs.getYear()); // default
			if ((this.param.containsKey("__date_start") && this.param.containsKey("__date_end")) ||
					(this.param.containsKey("date_start") && this.param.containsKey("date_end")) ||
					(this.param.containsKey("__DATE_START") && this.param.containsKey("__DATE_END")) ||
					(this.param.containsKey("DATE_START") && this.param.containsKey("DATE_END"))) {
				
				if (this.param.containsKey("__date_start") && this.param.containsKey("__date_end")) {
					pDateStart = (String) this.param.get("__date_start");
					pDateEnd = (String) this.param.get("__date_end");
				} else if (this.param.containsKey("date_start") && this.param.containsKey("date_end")) {
					pDateStart = (String) this.param.get("date_start");
					pDateEnd = (String) this.param.get("date_end");
				} else if (this.param.containsKey("__DATE_START") && this.param.containsKey("__DATE_END")) {
					pDateStart = (String) this.param.get("__DATE_START");
					pDateEnd = (String) this.param.get("__DATE_END");
				} else if (this.param.containsKey("DATE_START") && this.param.containsKey("DATE_END")) {
					pDateStart = (String) this.param.get("DATE_START");
					pDateEnd = (String) this.param.get("DATE_END");
				}
				
				if (!pDateEnd.trim().equals("")) {
					CscCalendar csEnd = new CscCalendar(pDateEnd);
					DateE = csEnd.getYYYYMMDD();
					//DateE = pDateEnd;
				}
				if (!pDateStart.trim().equals("")) {					
					CscCalendar csStart = new CscCalendar(pDateStart);
					DateS = csStart.getYYYYMMDD();
					this.hm_Col.put("year", csStart.getYear());
					//DateS = pDateStart;
				}
				if (pDateStart.trim().equals("") && pDateEnd.trim().equals("")) {
					CscCalendar csBudget = new CscCalendar();
					int yearStart = csBudget.getYear();
					csBudget.incYear(1);
					int yearEnd = csBudget.getYear();
					CscCalendar date = new CscCalendar();
					DateS = date.getYear() + "-01-01";
					DateE = date.getYear() + "-12-31";
					CscCalendar cs1 = new CscCalendar(DateS);
					CscCalendar cs2 = new CscCalendar(DateE);
					DateS = cs1.getYYYYMMDD();
					DateE = cs2.getYYYYMMDD();
					this.hm_Col.put("DateStart", cs1.getDDMMYYYY());
					this.hm_Col.put("DateEnd", cs2.getDDMMYYYY());
					this.hm_Col.put("year", yearStart);
				} 
			} else {				
				CscCalendar csBudget = new CscCalendar();
				int yearStart = csBudget.getYear();
				csBudget.incYear(1);
				int yearEnd = csBudget.getYear();
				CscCalendar date = new CscCalendar();
				DateS = date.getYear() + "-01-01";
				DateE = date.getYear() + "-12-31";
				CscCalendar cs1 = new CscCalendar(DateS);
				CscCalendar cs2 = new CscCalendar(DateE);
				DateS = cs1.getYYYYMMDD();
				DateE = cs2.getYYYYMMDD();
				this.hm_Col.put("DateStart", cs1.getDDMMYYYY());
				this.hm_Col.put("DateEnd", cs2.getDDMMYYYY());
				this.hm_Col.put("year", yearStart);
			}
			
			String sql = "employeeid= '" + employeeid + "'";
			if (!DateS.equals("") && !DateE.equals("")) {
				sql = sql + " and (dt_bg between '" + DateS + "' and '" + DateE + " ')";
			}
			sql += " and updtype='A'";
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq.initMyTable("tadjtime0", "", "");
			inq.setColumn("*");
			inq.setFilter(sql);
			inq.refresh();
			FormulaString fs = new FormulaString();
			String lv_ty="";
			while (inq.next()) {
				int a = 0;
				String d = "", e = "";
				lv_ty = inq.getString("eventgrp");
				if (lv_ty.equals(this.hm_Col.get(lv_ty))) {
					double s1 = 0f;
					double h = 0f;
					s1 = inq.getCurrentDbRecord().getDouble("lv");
					if (this.hm_Col.containsKey(lv_ty + "2")) {
						e = this.hm_Col.get(lv_ty + "2").toString();
						a = fs.DhmToM(e) + fs.Tm_To_Min(s1);
					} else {
						a = fs.Tm_To_Min(s1);
					}
					d = fs.MTODhm(a, this.hr_mtime0);
					this.hm_Col.put(lv_ty + "2", d);
					this.subTime(lv_ty);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void subTime(String a) {
		FormulaString fs = new FormulaString();
		String x = this.hm_Col.get(a + "1").toString();
		String y = this.hm_Col.get(a + "2").toString();
		int b = fs.DhmToM(x) - fs.DhmToM(y);
		String z = fs.MTODhm(b, this.hr_mtime0);
		this.hm_Col.put(a + "3", z);
	}

	private String lToL(String a) {
		FormulaString fs = new FormulaString();
		return fs.MTODhm(fs.DhmToM(a, this.hr_mtime0), this.hr_mtime0);
	}

	private void getHour_Day() {
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");
			this.putChild(inq1);
			this.refreshChild();
			this.hr_mtime0 = Double.valueOf(inq1.getString("hour_d")).doubleValue();
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") > 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}

	private String getStringChild(String fieldName) {
		FormulaString fs = new FormulaString();
		DecimalFormat df = new DecimalFormat("0.0");
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1,	fieldName.length());
			if (fName.charAt(fName.length()-1)=='5') {
				String tmp = fName.substring(0, fName.length()-1);
				tmp += "3";
				String data = String.valueOf(this.hm_Col.get(tmp));
				int b = fs.DhmToM(data); //String Time ---> Minute
				String hour = fs.Min_to_tm(b); //Minute ----> Hour
				String value = df.format(Double.parseDouble(hour));
				return value;
			}			
			if (this.hm_Col.get(fName) != null) {
				return String.valueOf(this.hm_Col.get(fName));
			}
			
		}
		return super.getString(fieldName);
	}
}