package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.DataSet;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.formula.FormulaString;

public class Simttime_current extends Memployee {
	MyHashMap hm_data = new MyHashMap();
	int count = 0;
	double hr = 0;
	String employeeid;

	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		this.hm_data.clear();
		employeeid = this.getString("employeeid");

		if (!this.getString("employeeid").trim().equals("")) {
			this.getHour_Day();
			this.setEventgrp();
			this.setDaytype();
			this.setSumData();
			this.setSubData();
		}
		return temp;
	}

	public void setEventgrp() {
		try {
			String limit = "";
			FormulaString fs = new FormulaString();

			String lang = "ENG";
			if (this.param.containsKey("LANGUAGE")) {
				String codeL = (String) this.param.get("LANGUAGE");
				if (!codeL.trim().equals("")) {
					lang = codeL;
				}
			}
			//MyLog.debug(this, "param_lang---> "+this.param.get("LANGUAGE"));
			//MyLog.debug(this, "lang---> "+lang);
			DbInquiry in2 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			in2.initMyTable("Meventgrp",	"(daytype!='1' or eventgrpid = 'LT') and daytype !='5' and daytype !='6' and daytype !='9' " +
					"and companyid='" + this.getString("companyid") + "'", "");
			in2.setColumn("eventgrpid,limit,edesc,tdesc,daytype,companyid");
			in2.refresh();
			while (in2.next()) {
				if (in2.getString("daytype").equalsIgnoreCase("7")) {
					//MyLog.debug(this, "<------------vacation------------>");
					DbInquiry inqEmp = new InitialInquiry(this.getUProfile()).getDbInquiry();
					inqEmp.initMyTable("memployee", "employeeid='" + this.employeeid + "'", "");
					inqEmp.setColumn("memployeeid,companyid,vacation0,vacation1");
					inqEmp.refresh();
					int i = 0;
					if (inqEmp.next()){
						// MyLog.debug(this, " >>>>>>>>>> vacation0="+inqEmp.getString("vacation0"));
						//  MyLog.debug(this, " >>>>>>>>>> vacation1="+inqEmp.getString("vacation1"));
						i = fs.DhmToM(inqEmp.getString("vacation0")) + fs.DhmToM(inqEmp.getString("vacation1"));
						limit = fs.MTODhm(i, hr);
					}//end if		
				} else {
					limit = in2.getString("limit") + ":00:00";
				}

				if (lang.equals("ENG")) {
					this.hm_data.put(in2.getString("eventgrpid"), in2.getString("edesc"));
				} else {
					this.hm_data.put(in2.getString("eventgrpid"), in2.getString("tdesc"));
				}
				this.hm_data.put("id_" + in2.getString("eventgrpid"), in2.getString("eventgrpid"));
				this.hm_data.put("limit_" + in2.getString("eventgrpid"), limit);
			}
		} catch (Exception e) { 
			MyLog.error(this, e);
		}
	}

	public void setDaytype() {
		//  MyLog.debug(this, "<-------------------setdayType------------------->");
		try {
			count = 0;
			String codecol = "";
			String data = "0:0:0";

			codecol = "01";
			if (this.param.containsKey("CODEID")) {
				String code = (String) this.param.get("CODEID");
				if (!code.trim().equals("")) {
					
					codecol = code;
				}
			}
			DbInquiry in1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			in1.initMyTable("Mleave_report", "codeid = '" + codecol + "'", "");
			in1.setColumn("*");
			in1.refresh();
			in1.next();
			
			for (int i = 1; i <= 15; i++) {
				if (i == 15) {
					this.hm_data.put("id_col15", in1.getString("col15"));
					this.hm_data.put("col15", this.hm_data.get(in1.getString("col15")).toString());
					this.hm_data.put("limit_col15", this.hm_data.get("limit_" + in1.getString("col15")).toString());
					this.hm_data.put("lv_col15", data);
					this.hm_data.put("total_col15", data);
					continue;
				}
				//=====================Nuiss Code==================
				/**
				 * Author : Nuiss
				 * Date : 22/05/2552
				 */
				String colName = "";
				String idCol = "";
				String limitCol="";
				String lvCol="";
				String totalCol="";
				if(i<10){
					colName ="col0" + i;
					idCol ="id_col0"+i;
					limitCol="limit_col0"+i;
					lvCol="lv_col0"+i;
					totalCol="total_col0"+i;
				}else{
					colName ="col" + i;
					idCol ="id_col"+i;
					limitCol="limit_col"+i;
					lvCol="lv_col"+i;
					totalCol="total_col"+i;
				}
				//=====================Nuiss Code==================
				if (in1.getString(colName).trim().equals("")) {
					continue;
				}else{
					count++;
				}

				MyLog.debug(this, "Data Inq0" + i + "-->"+ in1.getString(colName));
				this.hm_data.put(idCol, in1.getString(colName));
				this.hm_data.put(colName, this.hm_data.get(in1.getString(colName)).toString());
				this.hm_data.put(limitCol, this.hm_data.get("limit_" + in1.getString(colName)).toString());
				this.hm_data.put(lvCol, data);
				this.hm_data.put(totalCol, data);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	public void setSumData() {
		//  MyLog.debug(this, "<-------------------setSumData------------------->");
		try {
			int lt = 0;
			String tlv = "";
			int rec = 0, lv = 0, lv1 = 0, lvSum = 0;
			String startD = "", endD = "";
			StringBuffer sql = new StringBuffer();
			CscCalendar cs = new CscCalendar();
			FormulaString fs = new FormulaString();
			startD = String.valueOf(cs.getYear()) + "-01-01";
			endD = cs.getYYYYMMDD();
			if (this.param.containsKey("STARTD")) {
				String st = (String) this.param.get("STARTD");
				if (!st.trim().equals("")) {
					CscCalendar csS = new CscCalendar(st);
					startD = csS.getYYYYMMDD();
				}
			}

			if (this.param.containsKey("ENDD")) {
				String en = (String) this.param.get("ENDD");
				if (!en.trim().equals("")) {
					CscCalendar csE = new CscCalendar(en);
					endD = csE.getYYYYMMDD();
				}
			}

			CscCalendar cs1 = new CscCalendar(startD);
			CscCalendar cs2 = new CscCalendar(endD);		
			sql.append("employeeid='").append(this.getString("employeeid")).append("' ");
			sql.append("and (dateid between '").append(startD).append("' and '").append(endD).append("') ");
			sql.append("and (doctype = 'LT' or doctype='A' or doctype='S' or doctype='ABSENT')");
			DbInquiry in1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			in1.initMyTable("tleave_summary", sql.toString(), "employeeid,dateid");

			in1.refresh();
			while (in1.next()) {

				for (int i = 1; i <= 15; i++) {
					lv = 0;
					lv1 = 0;
					lvSum = 0;
					//=====================Nuiss Code==================
					/**
					 * Author : Nuiss
					 * Date : 22/05/2552
					 */
					String colName = "";
					String idCol = "";
					String limitCol="";
					String lvCol="";
					String totalCol="";
					if(i<10){
						colName ="col0" + i;
						idCol ="id_col0"+i;
						limitCol="limit_col0"+i;
						lvCol="lv_col0"+i;
						totalCol="total_col0"+i;
					}else{
						colName ="col" + i;
						idCol ="id_col"+i;
						limitCol="limit_col"+i;
						lvCol="lv_col"+i;
						totalCol="total_col"+i;
					}
					//=====================Nuiss Code==================

					if (i == 15) {
						if (in1.getString("lv_type").equals(this.hm_data.get("id_col15"))) {
							lv = fs.DhmToM(this.hm_data.get("lv_col15" + i).toString());
							lv1 = fs.Tm_To_Min(Double.valueOf(in1.getString("m_lv")).doubleValue());
							lvSum = lv + lv1;
							tlv = fs.MTODhm(lvSum, hr);
							this.hm_data.put("lv_col15", tlv);
						}
						continue;
					}
					if (in1.getString("lv_type").equals(this.hm_data.get(idCol))) {
						
						lv = fs.DhmToM(this.hm_data.get(lvCol).toString());
						lv1 = fs.Tm_To_Min(Double.valueOf(in1.getString("m_lv")).doubleValue());
						lvSum = lv + lv1;
						tlv = fs.MTODhm(lvSum, hr);
						this.hm_data.put(lvCol, tlv);
						rec += 1;
					}
				}
				lv = 0;
			}
			startD = cs1.getDD() + "/" + cs1.getMM() + "/"	+ String.valueOf(cs1.getYear());
			endD = cs2.getDD() + "/" + cs2.getMM() + "/" + String.valueOf(cs2.getYear());
			this.hm_data.put("lt_col", lt);
			this.hm_data.put("rec_col", new Integer(rec));
			this.hm_data.put("startd", startD);
			this.hm_data.put("endd", endD);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	public void setSubData() {
		try {
			int sub = 0;
			String dhm;
			FormulaString fs = new FormulaString();
			for (int i = 1; i <= count; i++) {
				//=====================Nuiss Code==================
				/**
				 * Author : Nuiss
				 * Date : 22/05/2552
				 */
				String colName = "";
				String idCol = "";
				String limitCol="";
				String lvCol="";
				String totalCol="";
				if(i<10){
					colName ="col0" + i;
					idCol ="id_col0"+i;
					limitCol="limit_col0"+i;
					lvCol="lv_col0"+i;
					totalCol="total_col0"+i;
				}else{
					colName ="col" + i;
					idCol ="id_col"+i;
					limitCol="limit_col"+i;
					lvCol="lv_col"+i;
					totalCol="total_col"+i;
				}
				//=====================Nuiss Code==================
				if (i == 15) {
					dhm = fs.subDhm(this.hm_data.get("limit_col15").toString(),this.hm_data.get("lv_col15").toString(), this.hr);
					this.hm_data.put("total_col15", dhm);
					continue;
				}else{
					dhm = fs.subDhm(this.hm_data.get(limitCol).toString(),this.hm_data.get(lvCol).toString(), this.hr);
					this.hm_data.put(totalCol, dhm);   
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	private void getHour_Day() {
		try {
			DbInquiry inq1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inq1.initMyTable("mtime0", "", "");
			inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");
			this.putChild(inq1);
			this.refreshChild();
			this.hr = Double.valueOf(inq1.getString("hour_d")).doubleValue();
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	private String lToL(String a) {
		//MyLog.debug(this, "limit method -->> "+a);
		String dt = "";
		FormulaString fs = new FormulaString();
		if (a.indexOf(":") > -1) {
			dt = fs.MTODhm(fs.DhmToM(a, hr), hr);
		} else {
			//dt = a + ":00:00";
			dt = a;
		}
		return dt;
	}

	public String getString(String field) {
		if (this.hm_data.containsKey(field)) {
			return this.lToL(this.hm_data.get(field).toString());
		} else {
			return super.getString(field);
		}
	}

}
