package com.csc.library.databean;

import java.io.File;
import java.rmi.RemoteException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import std.library.TimeSpan;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.formula.FormulaString;
import com.csc.library.mail.SendMail;
import com.csc.library.service.GenProcessQuque;
import com.csc.library.service.ServiceTimeWorking;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.ChkTimeOverLap;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.ManageAdjustChangeHoliday;
import com.csc.library.timeattendance.ManageAdjustLeave;
import com.csc.library.timeattendance.ManageAdjustOT;
import com.csc.library.timeattendance.ManageEmpLeaveStat;
import com.csc.library.timeattendance.MyTimeZone;
import com.csc.library.timeattendance.ReAdjustAlignment;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.TimeResult;
import com.csc.library.util.download.Downloadfile;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utility.DHMConvert;

public class Tabsent_nstda extends RecordCmp {
       
	private final int DAYREQ = 0 ;		/* ѹ */ 
	private final int HOURREQ = 1 ;		/*  . */ 
	private final int FTPARTREQ = 2 ;	/* Ҥá */ 
	private final int NDPARTREQ = 3 ;	/* Ҥѧ */ 
	private final int SPREQ = 4 ; /* ӹǳẺ () ˹ҨẺ */
	
    private AdjustResult result=null;   
    private float hour_s=0;
    private DecimalFormat df = new DecimalFormat("0.00");
    private String used = "";
    private String old_start_date="";
    private String old_end_date="";
    private float old_start_time =0;
    private float old_end_time =0;
    private String old_startdate=""; //for aGa Print at EditMail 
    private String old_enddate="";	 //for aGa Print at EditMail
    private String sendmail = "";
    private boolean leaveAllDay = false;
	private InitialEnvironment env = new InitialEnvironment("GLOBAL");
	private Hashtable meventDesc= null;
    private String allowType =null;
    private boolean isBefore = false;
    
    public String exc_absentid = ""; /* ͡÷ͧ令ӹǳʹ ШѴἹ */
    public String del_absentid = ""; /* Ţ͡÷ͧ١ź͡ҡк ͹кѹ֡ */
    public String exc_mode = ""; /* U Ѿഷ¡ԡ wf_status = 9 , D ź */
    
    public Tabsent_nstda() {
        super("Tabsent_nstda", "Tabsent_nstda Table");
    }   
    
    @Override
    public boolean set(String fieldName, String data) {
    	if(fieldName.equalsIgnoreCase("EXC_ABSENTID")){	/* Ţ͡÷¡ Ҥӹǳʹ */
    		this.exc_absentid = data ;
    	}else if(fieldName.equalsIgnoreCase("DEL_ABSENTID")){
    		this.del_absentid = data ; 					/* Ţ͡÷ͧ١ź͡ҡк ͹кѹ֡ */
    	}else if(fieldName.equalsIgnoreCase("EXC_MODE")){
    		this.exc_mode = data ; 					/* ʶҹзź  EXC_ABSENTID ͹кѹ֡ */    		
    	}else{
    		return super.set(fieldName, data);
    	}
    	return true;
    }
    
    protected void postInsertTrigger() throws Exception {
        super.postInsertTrigger();  
        
        if (this.getString("wf_status").equalsIgnoreCase("1")||this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
        	MyLog.debug("[TAbsent_nstda.PostInsert] wf_status is 1 or 4 or 6 this doc ["+this.getString("absendid")+"] will be adjusted]");
        	saveTleave(this);	/* ѹ֡ʹ Tleave_summary */
        	//saveAutoAssignWF();	/* ѹ֡ͺ§ҹѵѵ */
        } else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
        	MyLog.debug("[TAbsent_nstda.PostInsert] wf_status is 8 or 9 this doc ["+this.getString("absendid")+"] will be remove from adjust]");
            delDataTleaveSummary(this);	/* źʹ */
            //delAutoAssignWF();	/* źͺ§ҹѵѵ */
        }//end if 
        
        if(sendmail.equals("1")){
            this.sendMail();
        }        
        
        this.param.put("wf_docno", this.getString("absentid"));
	        
        if (this.param.containsKey("__temp") && (this.param.containsKey("__temp_file"))) {
        	if (!this.param.get("__temp_file").equals("")) {
        		this.transferFile();
        	}
        } 
        CreateQuque();	/* 觻żҷӧҹ ੾з*/
    }//end method postInsertTrigger

    protected void postUpdateTrigger() throws Exception {
        super.postUpdateTrigger();
        delDataTleaveSummary(this);
        
        if (this.getString("wf_status").equalsIgnoreCase("1")||this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {     
        	saveTleave(this);	/* ѹ֡ʹ Tleave_summary */
        	//saveAutoAssignWF();	/* ѹ֡ͺ§ҹѵѵ */
        } else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
        	MyLog.debug("[TAbsent_nstda.PostUpdate] wf_status is 8 or 9 this doc ["+this.getString("absendid")+"] will be remove from adjust]");
            //delAutoAssignWF();	/* źͺ§ҹѵѵ */
        }//end if 
        
        if(sendmail.equals("1")){
            this.sendMail();
        }
        CreateQuque();	/* 觻żҷӧҹ ੾з*/
    }//end method postUpdateTrigger
    
    protected boolean preDeleteTrigger() throws Exception {
    	boolean result = super.preDeleteTrigger();
        delDataTleaveSummary(this); /* źʹ */
        
        return result;
    }
    
    protected void postDeleteTrigger() throws Exception {       
        super.postDeleteTrigger();
        CreateQuque();
    }//end method postDeleteTrigger
    
    /* źšҷҧ  TLEAVE_SUMMARY */
    private void delDataTleaveSummary(DbRecord absent) {
    	CscConnection conn = null;
    	Statement stmt = null;
    	boolean autoCommit=true;
    	
        try {
        	StringBuffer filter = new StringBuffer();
        	filter.append("delete tleave_summary where ");
        	filter.append("docid='").append(absent.getString("absentid")).append("' and doctype = 'A'");
        	
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			autoCommit = conn.getAutoCommit();
			conn.setAutoCommit(false);
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);

			stmt = conn.createStatement();
			stmt.executeUpdate(filter.toString());

			conn.commit();
			
        } catch (Exception e) {
            MyLog.error("!! Error in Tabsent_nstda.delDataTleave_summary !!", e);           
        } finally {
    		try{
    			if(stmt != null) stmt.close();
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in Tabsent_nstda.deleteDataTleave!!",e);
    		}
        }
    }
    
    public MyTreeMap getDWRData() {
        return this.genRecord(false);
    }

    /*
     *  Day Type 繡ҷѺ - 
     */
    private String getDayType() {
        String result="";
        try {          
        	ManageEmpLeaveStat mels = new ManageEmpLeaveStat(userPro, this.getString("employeeid"), this.getString("type_absent"));
        	return mels.getEventDayType();
        	/*
            DbRecord dbEVENTGRP = new InitialRecord(this.userPro).getDbRecord("Meventgrp");
            dbEVENTGRP.setColumn("eventgrpid, companyid, daytype");
            dbEVENTGRP.set("EVENTGRPID", this.getString("TYPE_ABSENT"));
            dbEVENTGRP.set("COMPANYID", this.userPro.get("companyid"));
            if (dbEVENTGRP.search() == 1){
            	result = dbEVENTGRP.getString("DAYTYPE");
            }*/
            
        } catch (Exception e) {
            MyLog.error(this, e);                       
        }
        return result;
    }
    
    /*
     * ӡá˹ҷѺ TimeZone
     */
    private TimeZone getDocTimeZone() {
        TimeZone tz = new TimeZone();
        CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
        CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
        try {
            cs1.setCSCTime(this.getFloat("start_time"));
            cs2.setCSCTime(this.getFloat("end_time"));
            if (cs2.getDDMMYYYY().equals(cs1.getDDMMYYYY()) && this.getFloat("end_time")==0) {
            	cs2.incDate();
            }
        } catch (Exception e) {
            MyLog.error(this, e);            
        }
        tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
        tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
        MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
        return tz;
    }

    /*
     * ҧš
     * param isSave = false ҧŧ Hashmap ͹
     * param isSave = true ҧ й save ŧ TADJTIME0
     */
    public MyTreeMap genRecord(boolean isSave) {
    	MyTreeMap hm = new MyTreeMap();
        Vector vAdjust = new Vector();
        MyTreeMap trEmpSwipe = new MyTreeMap();
        int i=1;
        try {
        	MyLog.debug("!!!! PROCESS ADJUSTTIME START FROM HERE !!!!");
        	
            DbRecord dbEMP = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
            dbEMP.setColumn("*");
            dbEMP.set("EMPLOYEEID", this.getString("employeeid"));
            
            if(dbEMP.search() == 1) { // search found
                Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
                rec.setColumn("*");
                rec.set("time0id", dbEMP.getString("time0"));
                rec.set("companyid", this.userPro.get("companyid"));
                
                if(rec.search() == 1) { // ʡԧ MTIME0 ֧ Process 
	                CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
	                cs1.decDate();
	                CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
	                cs2.incDate();
	                
	                rec.setEmpRec(dbEMP);
	                rec.setEmpSwipeTime(trEmpSwipe);
	                
	                //ҧἹ ǧѹѺҨҡ˹Ҩ
	                String getDayType = this.getDayType();
	                WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
	                        new CscCalendar(cs2.getYYYYMMDD()), getDayType); 
	                ws.setUProfile(this.userPro);
	                ws.meargeWithShiftTrans(dbEMP, new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()));
	                if (!ws.isEmpty()) {
	                    ws.setUProfile(this.userPro);
	                    ws.setEmployeeid(dbEMP.getString("employeeid"));
	                    ws.setEmprec(dbEMP);
	                    ws.adjust();	/* ἹѺ੾¹ š  */
	                    
	                    /* ¹ѹشһѺἹ  */
		                ManageAdjustChangeHoliday mac = new ManageAdjustChangeHoliday(userPro);
		                ws.adjustChangeHoliday(mac.getAdjustChangeHolidayData(ws, this),userPro);
	                    
	                    /* ѺἹѺ  */
		                ManageAdjustLeave mal = new ManageAdjustLeave(userPro);
		                ws.adjustDocument(mal.getAdjustLeaveData(ws, this, rec, "approve != 'W'"),userPro);
	                    
	                    if (!getDayType.equals("3")) { //Ѻѹش  -
	                    	ws.removeStopShift(); //ѹشҧ ͡
	                    }
	                    
	                    ws.overlapChecking();
	                    ws.createLink();  
	                    
	                    try {
	                    	CscCalendar c = new CscCalendar(this.getString("start_date"));
	                    	if (this.leaveAllDay==true && this.getString("start_date").equals(this.getString("end_date"))) {//繡ѹ
	                    		TimeZone tz = new TimeZone();       
	                    		Iterator it = (Iterator) ws.keySet().iterator(); 
	    	                    if (it.hasNext()) {
	    	                    	DayShift ds = (DayShift) ws.get(c.getYYYYMMDD());
	    	                        Iterator it_ds = (Iterator) ds.keySet().iterator();
	    	                        if (it_ds.hasNext()) {
	    	                        	Shift sh = (Shift) ds.get(it_ds.next());
	    	                        	tz.setTimeZone(sh.get_c_dt_in(), sh.get_c_dt_out()); //ѹ ͡ ŧ
	    	                        }
	    	                    }
	    	                    vAdjust = ws.genSubShiftTrans(tz);
	                    	} else {
	                    		vAdjust = ws.genSubShiftTrans(getDocTimeZone());
	                    	}
	                    	
	                    	int count = 0;
	                    	CscCalendar dateChk = null;
	                    	CscCalendar dateOut = null;
	                    	Iterator it = vAdjust.iterator();    
	                    	
	                    	/* For error checking */
	                    	if(vAdjust.size() == 0){
	                    		MyLog.error("!!! Process AdjustTime terminated here coz no data in vAdjust from genSubShiftTrans["+getDocTimeZone()+"]");
	                    	}
	                    	
	                    	String[] strLeaveDay = this.getString("leave_day").split("\\.");
	                    	int dayLeaveReq = Integer.valueOf(strLeaveDay[0]);
	                    	int dayLeave_DType = 0 ;
	                    	int dayLeave_AType = 0 ;
	                    	
	                    	while (it.hasNext()) {                   		              		
		                	   result = (AdjustResult) it.next();
		                	   
		                	   /* ҷж١ process ¡鹡âͷ (EventGroup = 'O')*/
		                	   if (!result.getEventGroup().substring(0, 1).equalsIgnoreCase("O")) {
	                			   MyLog.debug("[NOT SAVE or ADJUST] THIS process is invoked by press calculate button from JSP");
	                			   if (result.getType().equalsIgnoreCase("A")) { // Type  2  "A" ѺاŧἹ  "D" ѺźἹѹ  ǧҷ˹
	                					   if (this.getString("LEAVE_FORMAT").equals("0") && count>=this.getFloat("LEAVE_DAY")) { //ӹǹѹҡѹ	                				   
			                				   if (dateChk!=null && dateOut!=null && result.getAdjDate().afterEquals(dateChk)) {
				                				   this.set("end_time", dateOut.getCSCTime());
				                				   break;
			                				   }
	                					   }
		                				   
		                				   MyHashMap hmData = new MyHashMap();
		                				   hmData.put("DOCID", this.getString("absentid"));
		                				   hmData.put("DOCTYPE", "A");
		                				   hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
		                				   hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
		                				   hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
		                				   hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
		                				   hmData.put("UPDTYPE", result.getType());
		                				   hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
		                				   hmData.put("EMPLOYEEID", this.getString("employeeid"));
		                				   hmData.put("TIME0ID", result.getTimeCode());
		                				   hmData.put("OLDTIME0ID", "");
		                				   hmData.put("OLDEVENTGRP", "");
		                				   if (result.getType().equals("T")) {
		                					   hmData.put("LV_TY", "T");
		                					   hmData.put("EVENTGRP", "T");
		                				   } else {
		                					   hmData.put("LV_TY", this.getString("type_absent"));
		                					   hmData.put("EVENTGRP", this.getString("type_absent"));
		                				   }
		                				   hmData.put("TR_TYPE", result.getEventGroup());
		                				   
	                					 //===================== Nuiss ͧ Structure ͹ ========
	                					   /**
		                           		 	* Author : Nuiss
		                           		 	* Date : 18/06/2552
		                           		 	* Logic :  fields flag 2 fields [lvFixType,lvFixHour]
		                           		 	* Ѻ fix . ѹ Фӹǳǧ  ˹ͧ
		                           		 	*  SKI á
		                           		 	*/
		                				   if (this.getString("LEAVE_FORMAT").equals("0")){	/* ѹ ˹ . ӧҹѹ */
		                					   hmData.put("LV", ws.getShiftProperty().get("HOUR_D"));  
		                				   } else if ((this.getString("LEAVE_FORMAT").equals("2") || this.getString("LEAVE_FORMAT").equals("3")) && !result.getType().equals("D")){
				                           		String time0Id =result.getTime0();
				                           		Object[] lvFixData = this.getLvFix(time0Id); 
				                            	if(Integer.parseInt(String.valueOf(lvFixData[0]))==0){
				                            		hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), 
					                						   result.get_DT_BG().getYYYYMMDD(), 
					                						   result.get_DT_EN().getYYYYMMDD(), 
					                						   result.get_DT_BG().getCSCTime(), 
					                						   result.get_DT_EN().getCSCTime()));     
				                           		}else{ 
				                           			hmData.put("LV",Float.parseFloat(String.valueOf(lvFixData[1])));     
				                           		}//end if 
		                				   }else{
		                					   //ͧ
		                					   hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), 
			                						   result.get_DT_BG().getYYYYMMDD(), 
			                						   result.get_DT_EN().getYYYYMMDD(), 
			                						   result.get_DT_BG().getCSCTime(), 
			                						   result.get_DT_EN().getCSCTime()));  
		                				   }//end if			 			
		                				 //===================== Nuiss ͧ Structure ͹ ========
	
			                			   hmData.put("STATUS", this.getString("status"));
		                				   hmData.put("PRIORITY", "1");
		                				   hmData.put("HOUR_S", ws.getShiftProperty().get("HOUR_D"));
		                				   hmData.put("WF_STATUS", this.getString("wf_status"));
		                				   hmData.put("ACTUAL_DATE", result.getActualDate());
		                				   hm.put(Integer.valueOf(i), hmData);
		                				   i++;	                				   	                				   
			                			   
			                			   if (result.getType().equalsIgnoreCase("A")) {
			                				   count++;
			                				   dateChk = result.getAdjDate();
			                				   dateOut = result.get_DT_EN();
			                			   }
		                			   }
		                		   }
	                    	}//end while     
	                    } catch (Exception e) {
	                    	MyLog.error(this,e);
	                    }
	                } else {
	                	MyLog.error("!!!! Process AdjustTime terminated here coz can't create workshift ["+ this.getString("absentid")+","+getDayType+","+cs1+","+cs2+"]");
	                }
            	} else {// end if can't fine TIME0id
            		MyLog.error("!! Error : Time0ID not found in MTIME0 process will be terminated here (Tabsent_nstda:Calculate leave) !! id:" + this.getString("absentid"));
            	}
            } else {//while (inqEmp.next())
            	MyLog.error("!!!! Process AdjustTime Terminated here coz of can't find employeeid " + this.getString("employeeid") + "!!!! id :" + this.getString("absentid"));
            }
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return hm;
    }
    
    private Shift getWorkShift(WorkingShift ws, String key){
    	Shift sh = null;
    	try {
    		DayShift df = (DayShift) ws.get(key);
    		Iterator it = (Iterator) df.keySet().iterator() ;
    		while(it.hasNext()){
    			sh = (Shift) df.get((String) it.next());
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return sh ;
    }
    
    /*
     * ҧš
     * param isSave = false ҧŧ Hashmap ͹
     * param isSave = true ҧ й save ŧ TADJTIME0
     * Mode  : 0 ѹ
     * 			: 1  
     * 			: 2  觺 
     */
    public MyTreeMap genRecordEx(boolean isSave) {
    	MyTreeMap hm = new MyTreeMap();
    	WorkingShift ws = null;
        try {
        	ws = genWorkShift();
        	Vector vWorktime = cloneWorkdayShift(ws);
        	Vector vLeavePeriod = genLeavePeriod();
        	Vector vAdjust = new Vector();
        	
        	for(int i=0; i < vLeavePeriod.size(); i++){
        		String tmp[] = (String[])vLeavePeriod.get(i);
        		if(ws.containsKey(tmp[0]) && !((DayShift) ws.get(tmp[0])).isEmpty() ){	/* ӹǳ੾ѹѹӧҹ */
        			TimeZone tz = createLeaveTimeZone(getWorkShift(ws, tmp[0]), tmp);
            		
            		vAdjust = ws.genSubShiftTrans(tz);
            		Iterator it = vAdjust.iterator(); 
            		
	            		while (it.hasNext()) {                   		              		
	                 	   result = (AdjustResult) it.next();
	                 	   
	           			   if (result.getType().equalsIgnoreCase("A")) { // Type  2  "A" ѺاŧἹ  "D" ѺźἹѹ  ǧҷ˹
	           				   MyHashMap hmData = new MyHashMap();
	           				   hmData.put("DOCID", this.getString("absentid"));
	           				   hmData.put("DOCTYPE", "A");
	           				   hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
	           				   hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
	           				   hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
	           				   hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
	           				   hmData.put("UPDTYPE", result.getType());
	           				   hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
	           				   hmData.put("EMPLOYEEID", this.getString("employeeid"));
	           				   hmData.put("TIME0ID", result.getTimeCode());
	           				   hmData.put("OLDTIME0ID", "");
	           				   hmData.put("OLDEVENTGRP", "");
	           				   hmData.put("LV_TY", this.getString("type_absent"));
	    					   hmData.put("EVENTGRP", this.getString("type_absent"));
	    					   hmData.put("TR_TYPE", result.getEventGroup());
	    					   
	    					   /* ӹǳ. Ẻ fix ͤӹǳἹ */
	    					   	Object[] lvFixData = this.getLvFix(result.getTimeCode()); 
	    					   	
                           		if(tmp[1].equals("0")){	/* ѹ ӹǳẺ */
                           			hmData.put("LV_FORMAT", "0");	/* ѹ */
	                           		hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), 
		                						   result.get_DT_BG().getYYYYMMDD(), 
		                						   result.get_DT_EN().getYYYYMMDD(), 
		                						   result.get_DT_BG().getCSCTime(), 
		                						   result.get_DT_EN().getCSCTime()));     
                          		}else{ 	/* Ҥѹ  */
                          			hmData.put("LV_FORMAT", "2");	/* Ҥѹ */
                          			
                          			if(Integer.parseInt(String.valueOf(lvFixData[0])) == 0){	/* Ẻ fix . ӹǳἹ */
                          				hmData.put("LV", this.getHourDAdjust(result.getTimeCode(), 
		                						   result.get_DT_BG().getYYYYMMDD(), 
		                						   result.get_DT_EN().getYYYYMMDD(), 
		                						   result.get_DT_BG().getCSCTime(), 
		                						   result.get_DT_EN().getCSCTime()));
                          			}else{	/* ҤѹẺ fix .  */
                          				hmData.put("LV",Float.parseFloat(String.valueOf(lvFixData[1])));  
                          			}
                          		}//end if             				   
	             					 
	    					   hmData.put("STATUS", this.getString("status"));
	    					   hmData.put("PRIORITY", "1");
	    					   hmData.put("HOUR_S", ws.getShiftProperty().get("HOUR_D"));
	    					   hmData.put("WF_STATUS", this.getString("wf_status"));
	    					   
	    					   hm.put(Integer.valueOf(i), hmData);
	           			   }
	        		} //end while
             	}
        	}
        }catch(Exception e){
        	MyLog.error(this,e);
        }
        return hm ;
    }
    
    private TimeZone createLeaveTimeZone(Shift sh, String[] per){
    	TimeZone tz = new TimeZone(); 
    	try {
    		if(per[1].equals("0")){	/* ѹ */
    			tz.setTimeZone(sh.get_c_dt_in(), sh.get_c_dt_out());
    		}else if(per[1].equals("1")){	/* Ҥ */
    			tz.setTimeZone(sh.get_c_dt_in(), sh.getMidDayStop().getBeginZone());
    		}else if(per[1].equals("2")){	/* Ҥ觺 */
    			tz.setTimeZone(sh.getMidDayStop().getEndZone(), sh.get_c_dt_out());
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return tz;
    }
    
    private Vector genLeavePeriod(){
    	Vector vLeave = new Vector();
    	try {
    		if(this.getCscCalendar("start_date").equalsDate(this.getCscCalendar("end_date"))){ /* ѹ */
    			String req[] = {"",""};
    			req[0] = this.getString("start_date");

    			if(this.getString("st_period").equals("0") && this.getString("en_period").equals("0")){	/*  */
    				req[1] = "1";
    			}else if(this.getString("st_period").equals("1") && this.getString("en_period").equals("1")){ /* 觺 */
    				req[1] = "2";
    			}else if(this.getString("st_period").equals("0") && this.getString("en_period").equals("1")){ /* ѹ */
    				req[1] = "0";
    			}
				vLeave.add(req);
    		}else{
    			CscCalendar cst = this.getCscCalendar("start_date");
    			CscCalendar cen = this.getCscCalendar("end_date");
    			
    			for(int loop = 0; cst.beforeEqualsDate(cen); loop++, cst.incDate()){
    				String req[] = {"",""};
        			req[0] = cst.getYYYYMMDD();
        			
        			if(loop == 0){	/* ѹá */
        				if(this.getString("st_period").equals("0")){	/* ҵ */
        					req[1] = "0";	/* ѹ ѹ繪ǧ ʴѹáТҷѹ */
        				}else{
        					req[1] = "2";	/*  */
        				}
        			}else if(cst.beforeDate(cen)){ /* ѹѴ */
        				req[1] = "0";	
        			}else{	/* ѹش */
        				if(this.getString("en_period").equals("0")){	/*  */
        					req[1] = "1";
        				}else{
        					req[1] = "0";	/* ҷѹ */
        				}
        			}
    				vLeave.add(req);
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	
    	return vLeave ;
    }
    
    /* ҧἹ÷ӧҹͺǧҢ */
    private Vector cloneWorkdayShift(WorkingShift ws){
    	Vector vWorkshift = new Vector();
    	
    	try {
    		/* Ἱ÷ӧҹŧ vector */
            String key = "";
            String dkey = "";
            Iterator it = (Iterator) ws.keySet().iterator() ;
            for(; it.hasNext(); ){
            	key = (String) it.next();
            	
            	DayShift df = (DayShift) ws.get(key);
            	Iterator dit = (Iterator) df.keySet().iterator() ;
                for(; dit.hasNext(); ){
                	dkey = (String) dit.next();
                	Shift sh = (Shift) df.get(dkey);
                	
                	if(sh.getEventGroup().equals("T")){	/* ੾Сзӧҹ */
                		vWorkshift.add(sh);
                	}
                }
            }
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	
    	return vWorkshift ;
    }
    
    /* ҧἹ÷ӧҹͺǧҢ */
    private WorkingShift genWorkShift(){
    	WorkingShift ws = null ; 
    	
    	try {
    		DbRecord dbEMP = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
            dbEMP.setColumn("employeeid,time0,companyid,status,startdate,resigndate");
            dbEMP.setParam("rsc_skip","true");
            dbEMP.set("EMPLOYEEID", this.getString("employeeid"));
            
            if(dbEMP.search() == 1) { // search found
                Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
                rec.setColumn("*");
                rec.set("time0id", dbEMP.getString("time0"));
                rec.set("companyid", this.userPro.get("companyid"));
                
                if(rec.search() == 1) { // ʡԧ MTIME0 ֧ Process 
	                CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
	                CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
	                
	                /* ҧѹѺѡѹش͡ҡἹ Դӹǹѹкǡ 20% ͧӹǹѹҨҡ˹Ҩ ǡա 3 ѹ (óբҹѹ ӹǹǡй¨֧ͧ 3 ѹ default */
	                cs2.incDate(Math.round((cs2.subForDay(cs1) + 1) + ((cs2.subForDay(cs1) + 1) * (20f/100))) + 3);	
	                
	                rec.setEmpRec(dbEMP);
	                //rec.setEmpSwipeTime(trEmpSwipe);
	                
	                //ҧἹ ǧѹѺҨҡ˹Ҩ
	                String getDayType = this.getDayType();
	                ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()), getDayType);
	                ws.setUProfile(this.userPro);
	                
	                /* ѺἹ */
	                ws.meargeWithShiftTrans(dbEMP, new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()));
	                
	                if (!ws.isEmpty()) {
	                    ws.setUProfile(this.userPro);
	                    ws.setEmployeeid(dbEMP.getString("employeeid"));
	                    ws.adjust();	/* ἹѺ੾¹ š  */
	                    
	                    /* ¹ѹشһѺἹ  */
	                    ManageAdjustChangeHoliday mac = new ManageAdjustChangeHoliday(this.userPro);
	                    ws.adjustChangeHoliday(mac.getAdjustChangeHolidayData(ws, dbEMP),this.userPro);
	                    
	                    /* ѺἹѺ  */
	                    ManageAdjustLeave mal = new ManageAdjustLeave(this.userPro);
	                    ws.adjustDocument(mal.getAdjustLeaveData(ws, dbEMP, rec, "approve = ''"),this.userPro);
	                    
	                    if (!getDayType.equals("3")) { //Ѻѹش  -
	                    	ws.removeStopShift(); //ѹشҧ ͡
	                    }
	                    
	                    ws.overlapChecking();
	                    ws.createLink();  
	                }
                }
            }
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	
    	return ws ;
    }
    
    
    
    private float getHourDAdjust(String timeCode, String date1, String date2, float time1, float time2) {
        float hour = 0; 
        DbInquiry inqTime1 =  null;
        try {           
            float break_hour = 0;
            CscCalendar cs1=null, cs2=null;
            CscCalendar cs = new CscCalendar(date1);
            String filter = "time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'";
            inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
            inqTime1.setParam(this.param);
            inqTime1.setSchemaName(this.userPro.getSchemaName());
            inqTime1.initMyTable("Mtime1", filter, "");
            inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
            inqTime1.refresh();
            if (inqTime1.next()) {
                DbRecord rec = inqTime1.getCurrentDbRecord();                
                this.hour_s = rec.getFloat("hour_d");
                
                // Break Hour
                cs1 = new CscCalendar(date1);
                cs1.setCSCTime(rec.getFloat("timeout1"));
                if (rec.getFloat("timeout1")==0) {
                	cs1.incDate();
                }
                cs2 = new CscCalendar(date2);
                cs2.setCSCTime(rec.getFloat("timein2"));
                if ((rec.getFloat("timein2") < rec.getFloat("timeout1")) && date1.equals(date2)) {
                    cs2.incDate();
                }
                break_hour = cs2.subForHour(cs1);
                if (break_hour>24)
                	break_hour = break_hour-24;
                
                // Working Hour
                CscCalendar cs3 = new CscCalendar(date1);
                cs3.setCSCTime(rec.getFloat("timein1"));
                CscCalendar cs4 = new CscCalendar(date2);
                cs4.setCSCTime(rec.getFloat("timeout2"));
                if ((rec.getFloat("timeout2") < rec.getFloat("timein1")) && date1.equals(date2)) {
                    cs4.incDate();
                }
                /**================================================
                 * Author : Nuiss
                 * Date : 19/01/2553
                 * Logic : ͧ  źѹ ѹͧત͹ѹѹǡѹ ѹѹѹ
                 * ѹеԴ ź
                 */
                TimeSpan ts = new TimeSpan();
                TimeSpan tsStDate = new TimeSpan();
                tsStDate.setSignSeperateOfDate("-");
                tsStDate.setSignSeperateOfTime(":");
                tsStDate.cnvrtToTimeSpan(cs3.getYYYYMMDD(), cs3.getHHMM());
                TimeSpan tsEndDate = new TimeSpan();
                tsEndDate.setSignSeperateOfDate("-");
                tsEndDate.setSignSeperateOfTime(":");
                tsEndDate.cnvrtToTimeSpan(cs4.getYYYYMMDD(), cs4.getHHMM());
                double hourLeave= ts.timeDiff(tsStDate, tsEndDate);
                /**================================================*/
                if(!cs3.equalsDate(cs4)){
                	hour = (float) hourLeave;
                }else{
                	//ͧ
                	CscTime c = new CscTime(cs4.subForHour(cs3));
                    c.sub(break_hour);
                    hour = c.getFloat(); 
                }  
                
                /* ó軡ԶҪ. Թ . ӧҹѹѺҡѺ . ӧҹѹ */
                if(hour > this.hour_s){
                	hour = this.hour_s;
                }
            }
            
            CscCalendar c_dt_in = new CscCalendar(date1);
            c_dt_in.setCSCTime(time1);
            CscCalendar c_dt_out = new CscCalendar(date2);
            c_dt_out.setCSCTime(time2);
            float hourCom = c_dt_out.subForHour(c_dt_in);
            
            if (cs1!=null&&cs2!=null) {
                if (cs1.afterEquals(c_dt_in)&&cs2.beforeEquals(c_dt_out)) {
                    CscTime c = new CscTime(hourCom);
                    if (break_hour>0) {
                    	c.sub(break_hour);
                    }                    
                    hourCom = c.getFloat();
                }
            }       
            
            if (hourCom<hour) {
                hour=hourCom;
            }
            
        } catch (Exception e) {
            MyLog.error(this, e);
        }finally{
        	inqTime1.closeConnection();
        	
            return hour;
        }
    }
    
    public String calulateLeaveRemain(float dayForRequest, int lv_format, float hour, String used,String allowType) {
    	this.used = (used == null)?"0":used;
    	this.set("LEAVE_FORMAT", lv_format);
    	this.set("LEAVE_DAY", dayForRequest);
    	this.set("LEAVE_HOUR", hour);
    	this.allowType =allowType; 
    	return this.calulateLeaveRemain(dayForRequest, lv_format, hour);
    }
    
     
    public String calulateLeaveRemain(float dayForRequest, int lv_format, float hour, String used) {
    	this.used = used;
    	this.set("LEAVE_FORMAT", lv_format);
    	this.set("LEAVE_DAY", dayForRequest);
    	this.set("LEAVE_HOUR", hour);
    	return this.calulateLeaveRemain(dayForRequest, lv_format, hour);
    }
    
    /*
     * ӹǳöҵǧѹ
     * param	dayForRequest = ӹǹѹ
     * 				lv_format = ٻẺ (ѹ, Ҥѹ, Ҥѹ, 繪)
     * 				hour = ӹǹ .  (੾Сó繪)
     */
    public String calulateLeaveRemain(float dayForRequest, int lv_format, float hour) {
        MyTreeMap hm = new MyTreeMap();
        
        String result = "0";  
        String desc_leave = "";    
    	String vacation1_limit = "";
        String dayType= "";
        String strForHTML = "###";//¡繢ͧ  ǹ   result  return ͡
		String tmpEndDate = this.getString("end_date");
		String tmpStartDate = this.getString("start_date");		
		
		float tmpStartTime = Float.parseFloat(this.getString("start_time"));
		float tmpEndTime = Float.parseFloat(this.getString("end_time"));
        float hour_leave = 0;

       	int leaveCountForWF = 0;
        int day_leave = 0;

        double hour_d = 0;
        
        FormulaString fs = new FormulaString();
        DHMConvert dhm = new DHMConvert();
        
    	/** Logic :  step wokflow ҹ step 1  ͧ Ǩͺ͡ùա */
    	if (this.getString("wf_status").equals("4") || this.getString("wf_status").equalsIgnoreCase("6")){ return "0"; }

		try {
            String limit = "";
            String before_type = "";
            String emp_status = "";
            
            int limit_times = 0;
            int service_year = 0;
            int before_request = 0;
            int clear_leave = 1;     
                
            CscCalendar startWorkingDate = null;

            if (lv_format == 0 || lv_format==2 || lv_format==3) { //ѹ  ҪǧѺstart_time Ἱ
             	this.set("start_time", 0);
            	this.set("end_time", 0);
            }
            
            /* Ǩͺ͹䢵ҧ  㹡Ҥ駹 */
            ManageEmpLeaveStat mels = new ManageEmpLeaveStat(userPro, this.getString("employeeid"), this.getString("type_absent"));
            mels.setAbsentProp(this);
            mels.setExceptAbsentID(this.exc_absentid); /* ˹Ţ͡÷ͧ令ӹǳʹ ШѴἹ */
            
            limit = mels.getLimitLeave();
            limit_times = mels.getLimitAmount();
            
            hour_d = this.getHour_Day(mels.empRec.getString("time0"));	/*  . ӧҹѹ */
            this.hour_s = Float.parseFloat(String.valueOf(hour_d));
            
            /* Һѹ֡ҡ˹Ҩѧҹ ͧ͹ѧ ǧ˹ */
            if (!(this.param.containsKey("chkdaterequest") || this.param.containsKey("CHKDATEREQUEST") 
                    || this.param.containsKey("__chkdaterequest") || this.param.containsKey("__CHKDATEREQUEST"))) {
            	
            	boolean isPastLimit = mels.isPastLimit(new CscCalendar(this.getString("start_date")), this.getString("leave_day"));
                boolean isBeyondLimit = mels.isBeyondLimit(new CscCalendar(this.getString("start_date")), this.getString("leave_day"));
                boolean isInAdvPeriod = mels.isInAdvPeriod(new CscCalendar(this.getString("start_date")));
                
                //͹ѧԹ˹
                if(isPastLimit){ return "P#"+mels.getLvPastLimit(); }
                //ǧ˹Թ˹
            	if(isBeyondLimit){ return "F#"+mels.getBeyondLimit(); }
            	//ǧ˹ҧ ç͹
            	if(isInAdvPeriod){ return "I#"+mels.getLvAdvPeriod(); }
            	// Ǩͺâǧ˹ 
            	//if(mels.isRequireBeforeRequest(this.getString("start_date"), this.getString("start_time"))){return "9";}; 
            	// Ǩاҹö
            	if(mels.isAllowForRequest()) { return "2"; }
            }
            
            if(mels.isSexValid()) { return "8"; }	/* ǨͺȢͧ */
            
            if(!mels.isRequireEvent()){ return "5 : سԷԡ "+mels.getPrvEventDesc()+" ͹"; }	/* ǨͺԷԡһ 繵ͧ͹ */
            
            if(mels.isCountLeaveFormatOverLimit(this)) { return "O : " + this.getString("leave_format") + "#" + mels.getFormatLimit(this.getInt("leave_format")); }
          
            CscTime ct= new CscTime();
            CscTime ct_lv = new CscTime();
            CscTime cal_ct_lv = new CscTime();
            CscTime next_ct_lv = new CscTime();
            CscTime now_ct_lv = new CscTime();
            CscCalendar c1 = new CscCalendar(this.getString("start_date"));
            CscCalendar c2 = new CscCalendar(this.getString("end_date"));
            
            /*
             * 0 = ѹ
             * 1 =  
             * 2 = Ҥѹ
             * 3 = Ҥѹ
             * */
            WorkingShift ws = null;

        	if(mels.empRec != null){	/* ʾѡҹ㹷¹ ֧зӧҹ */
            	Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
                rec.set("time0id", mels.empRec.getString("time0"));
                rec.set("companyid", this.userPro.get("companyid"));
                if (rec.search()==0) { return "A"; }

                CscCalendar csLeave = new CscCalendar(this.getString("start_date"));
                CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
                //cs1.decDate();
                CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
                cs2.incDate();
                
                CscCalendar cc1 = new CscCalendar(this.getString("start_date"));
            	CscCalendar cc2 = new CscCalendar(this.getString("end_date"));
            	
            	int leaveDayCount = cc2.subForDay(cc1)+1;
                
            	if (lv_format==0 && dayForRequest>1 && leaveDayCount<dayForRequest) { //ѹ ҡ 1 ѹ
                	cc2.incDate(((int) (dayForRequest - leaveDayCount)));  //ǡѹشŧ
                	cc2.incDate(7);	// ǡѹشա 7 ѹ
                	this.set("END_DATE", cc2.getDDMMYYYY());
                	cs2.incDate(((int) (dayForRequest - leaveDayCount)));	        	
                }
                
                MyTreeMap trEmpSwipe = new MyTreeMap();	
                rec.setEmpRec(mels.empRec);
                rec.setEmpSwipeTime(trEmpSwipe);
                
                //ҧἹ÷ӧҹͧѡҹ
                ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()), mels.getEventDayType());
                ws.setUProfile(this.getUProfile());
                ws.meargeWithShiftTrans(mels.empRec, new CscCalendar(cs1.getTimestamp()), new CscCalendar(cs2.getTimestamp()));
                
                if (!ws.isEmpty()) {
                	ws.setUProfile(this.userPro);
                    ws.setEmployeeid(mels.empRec.getString("employeeid"));
                    ws.setEmprec(mels.empRec);
                    ws.adjust();	/* ἹѺ੾¹ š  */
                    
                    ws.overlapChecking();
                    ws.createLink();
                    
                    /* ¹ѹشһѺἹ  */
                    ManageAdjustChangeHoliday mac = new ManageAdjustChangeHoliday(this.userPro);
                    ws.adjustChangeHoliday(mac.getAdjustChangeHolidayData(ws, mels.empRec), this.userPro);
                    
	                for (Iterator<?> IT = ws.keySet().iterator(); IT.hasNext();) {  
	           			 String key = (String) IT.next();
	                     DayShift dShift = (DayShift) ws.get(key);
	           	         for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {                    	
	           	        	 String key1 = (String) IT1.next();
	           	             TimeResult tr = (TimeResult) dShift.get(key1);
	           	                 
	           	             CscCalendar curDateItemInws = new CscCalendar(key);
	           	             CscCalendar stDate = new CscCalendar(tmpStartDate);
	           	             CscCalendar endDate = new CscCalendar(tmpEndDate);
	           	             if((curDateItemInws.equalsDate(stDate)||curDateItemInws.afterDate(stDate)) &&
	           	                	(curDateItemInws.equalsDate(endDate)||curDateItemInws.beforeDate(endDate))){
	           	                	leaveCountForWF++;
	           	             }
	           	         }
	           		}//end for 
                    
                    int i= 0;
                    Iterator it = (Iterator) ws.keySet().iterator(); 
                    if (it.hasNext()) {
                    	i++;
                    	DayShift ds = (DayShift) ws.get(csLeave.getYYYYMMDD());
                        int ds_size = ds.size();
                        Iterator it_ds = (Iterator) ds.keySet().iterator();
                        if (it_ds.hasNext()) {
                        	Shift sh = (Shift) ds.get(it_ds.next());
                            if (sh!=null && (!sh.getEventGroup().equals("H") && !sh.getEventGroup().equals("I")) ) { //ͧѹش
                            	TimeZone tz = sh.getMidDayStop(); 	//Ҿѡͧ
                            	if (lv_format == 0) { //ѹ 繪ǧ
                            		if (i==1) { //ѹ
                            			this.set("START_TIME", sh.get_c_dt_in().getCSCTime());
                            		}
                            		if (i==ds_size) { //ѹ ѹش
                            			if (this.getFloat("end_time")>sh.get_c_dt_out().getCSCTime() || this.getFloat("end_time")==0) {
                            				this.set("END_TIME", sh.get_c_dt_out().getCSCTime());
                            			}
                            		} else { 
                            			//ѹش ѹشŧ 
                            			//µǨͺл ѧաеա 
                            			//ҡжѴ繡ش¢ͧ
                            			while (!sh.getEventGroup().equals("T") && it_ds.hasNext()) {
                            				sh = (Shift) ds.get(it_ds.next());
                            				if (sh.getEventGroup().equals("T")) {
                            					this.set("END_TIME", sh.get_c_dt_out().getCSCTime());
 	                            		    	break;
 	                            		    }
                            		    }	                            		   
                            		}
                            	} else if (lv_format == 1) { // 
                            		if (hour>0) {
                            			hour = mels.getRoudingValue(hour);	/* ҡ˹Ѵ .  ͧѴɡ͹令ӹǳ */
                            			
                            			CscCalendar time_in = new CscCalendar(this.getString("start_date"));
                    	            	time_in.setCSCTime(this.getFloat("start_time"));	                    	            		
                    	            	CscCalendar time_out = new CscCalendar(this.getString("end_date"));
                    	            	time_out.setCSCTime(this.getFloat("end_time"));
                    	            	
                    	            	CscCalendar break_in = sh.getMidDayStop().getBeginZone(); //鹾ѡ
                    	            	CscCalendar break_out = sh.getMidDayStop().getEndZone(); //شѡ
                    	            	
                    	            	CscTime ct_time = new CscTime(this.getFloat("START_TIME"));
                    	            	ct_time.add(hour); //ӡúǡա ӹǹ.	                    	            		 
                    	            	
                    	            	if (ct_time.getFloat()>=24) { //Թ§׹ Թǡա 1 ѹ
                    	            		ct_time.sub(24);
                    	            		time_out.incDate(1);
                    	            		time_out.setCSCTime(ct_time.getFloat());
                    	            		this.set("END_DATE", time_out.getDDMMYYYY());
                    	            		this.set("END_TIME", ct_time.getFloat());	                    	            			
                    	            	} else {
                    	            		time_out.setCSCTime(ct_time.getFloat());
                    	            		this.set("END_DATE", time_out.getDDMMYYYY());
                    	            		this.set("END_TIME", ct_time.getFloat());
                    	            	}
                    	            		
                    	            	//ش 㹪ǧѡ§
                    	            	if (time_in.beforeEquals(break_in) && time_out.afterEquals(break_out)) { //8.xx-17.xx
                    	        			ct_time.add(break_out.subForHour(break_in));	 
                    	        			this.set("END_TIME", ct_time.getFloat());
                    	        		} else if (time_in.before(break_in) && time_out.before(break_out) && time_out.afterEquals(break_in)) { //8.xx-12.xx
                    	        			if (!time_out.equals(break_in)) {
                    	        				ct_time.add(break_out.subForHour(break_in));
                    	        			}
                    	        			this.set("END_TIME", ct_time.getFloat());
                    	        		} else if (time_out.after(break_out) && time_in.afterEquals(break_in) && time_in.before(break_out)) { //12.xx-14.xx
                    	        			if (time_in.before(break_out)) {
                    	        				this.set("START_TIME", break_out.getCSCTime());
                    	        				ct_time = new CscTime(this.getFloat("START_TIME"));
                    	        				ct_time.add(hour);	                    	        				
                    	        			} else if (!time_in.equals(break_out)) {
                    	        				ct_time.add(break_out.subForHour(break_in));	 
                    	        			} 
                    	        			this.set("END_TIME", ct_time.getFloat());
                    	        		} 
                    	            }
                            	} else if (lv_format == 2) { //Ҥѹ 鹡þѡͧش
                            		CscCalendar cs = tz.getBeginZone();
                            		this.set("START_DATE", sh.get_c_dt_in().getDDMMYYYY());
                            		this.set("START_TIME", sh.get_c_dt_in().getCSCTime());
                            		this.set("END_DATE", cs.getDDMMYYYY());
                            		this.set("END_TIME", cs.getCSCTime());
                            	} else if (lv_format == 3) { //Ҥѹ شþѡ鹡
                            		CscCalendar cs = tz.getEndZone();
                            		this.set("START_DATE", cs.getDDMMYYYY());
                            		this.set("START_TIME", cs.getCSCTime());
                            		if (cs.after(sh.get_c_dt_out())) {
                            			if (it_ds.hasNext()) {
                            				sh = (Shift) ds.get(it_ds.next());
                            				while (!sh.getEventGroup().equals("T") && it_ds.hasNext()) {	            	                        		
	                            				if (sh.getEventGroup().equals("T")) {
	                            					break;
	 	                            		    }
	                            				sh = (Shift) ds.get(it_ds.next());
            	                        	}
                            			} else {
	                            			ds = (DayShift) ws.get(cs.getYYYYMMDD());
	                            			Iterator it_ds2 = (Iterator) ds.keySet().iterator();
	            	                        if (it_ds2.hasNext()) {
	            	                        	sh = (Shift) ds.get(it_ds2.next());     
	            	                        	while (!sh.getEventGroup().equals("T") && it_ds2.hasNext()) {	            	                        		
		                            				if (sh.getEventGroup().equals("T")) {
		                            					break;
		 	                            		    }
		                            				sh = (Shift) ds.get(it_ds2.next());
	            	                        	}
	            	                        }	        
                            			}
                            		}
                            		this.set("END_DATE", sh.get_c_dt_out().getDDMMYYYY());
                            		
                            		/**
                            		 * Author : Nuiss
                            		 * Date : ѹ 1/2 ѹ  ͧ ش
                            		 *  ѹͧ 13.00-16.30 ѹ 13.00-13.00 
                            		 */
                            		if(cs.getCSCTime()==sh.get_c_dt_out().getCSCTime()){
                            			this.set("END_TIME",tmpEndTime);
                            		}else{
                            			//ͧ
                            			this.set("END_TIME", sh.get_c_dt_out().getCSCTime());
                            		}//end if                  
                            	} else if(lv_format == SPREQ){ /* óդӹǳ˹Ҩ; */
                            		if(this.getInt("st_period") == 0){
                            			this.set("START_TIME", sh.get_c_dt_in().getCSCTime());
                            		}else{
                            			this.set("START_TIME", sh.getMidDayStop().getBeginZone().getCSCTime());
                            		}
                            		
                            		if(this.getInt("en_period") == 0){
                            			this.set("END_TIME", sh.getMidDayStop().getBeginZone().getCSCTime());
                            		}else{
                            			this.set("END_TIME", sh.get_c_dt_out().getCSCTime());
                            		}
                            		
                            	}
                            } else {
                            	return "6";//ѹش eventgrp=H  eventgrp=I
                            }
                        } else {
                        	return "6";//ѹش eventgrp=H  eventgrp=I
                        }
                    } //if (it.hasNext())
                } else { //if (!ws.isEmpty())
           			return "A";
                }
            }
            
            if (lv_format == 0) {
            	this.leaveAllDay = true; //ѹ  leaveAllDay = true
            }else{
            	this.leaveAllDay = false; //ѹ  leaveAllDay = false
            }
            
            if(this.getString("leave_format").equals("4")){
            	hm = this.genRecordEx(false);
            }else{
            	hm = this.genRecord(false); // öѹ             
            }
  
            //ǨͺҷҡѺӹǹҨҡ˹Ҩѧ
            int loop = 1;
            if (hm.size()>0 && lv_format==0) { 
            	//condition && loop <=100 protect loop die
	            while (hm.size() < dayForRequest && loop <=100) {         
	            	int hm_size = hm.size();
	            		                
	            	CscCalendar l1 =null;CscCalendar l2 =null;
	            	if(loop==1){
	            		MyHashMap lastLeave = (MyHashMap)hm.get(Integer.valueOf(hm_size));
		            	String startDate =lastLeave.get("DT_BG").toString();
	            		l1 = new CscCalendar(startDate);	                
	               	    l2 = new CscCalendar(startDate);
	            	}else{
	            		l1 =new CscCalendar(this.getString("start_date"));	                
	               	    l2 =new CscCalendar(this.getString("start_date"));
	            	}
	                l1.incDate();
	                l2.incDate();
	                
	                this.set("START_DATE", l1.getDDMMYYYY());
	                this.set("END_DATE", l2.getDDMMYYYY());
	                this.leaveAllDay = true;
	                MyTreeMap hm_tmp = this.genRecord(false); //ӹǳ ѹ
	                Iterator it_tmp = hm_tmp.keySet().iterator();
	                while (it_tmp.hasNext()&&hm.size()<dayForRequest) {
	                	hm_size++;	          
	                	Integer key_tmp = (Integer) it_tmp.next();
	                	hm.put(Integer.valueOf(hm_size), (MyHashMap) hm_tmp.get(key_tmp));                	
	                }
	                loop++;
	            }
            }
            boolean isOverYear = false;
            if (hm.size()==0) { //ӹǳբšԴ
                return "6";
            } else {
            	int count = 1;
            	String s_date="", e_date=""; 
            	float s_time = 0f, e_time = 23.59f; 
                day_leave = hm.size();
                Iterator it = hm.keySet().iterator();
                CscCalendar dHisLeave = new CscCalendar(), endLeaveYear = null;
                if( dayType.equalsIgnoreCase("10") ){
                	endLeaveYear = new CscCalendar((String) StaticConfig.getConfigCompany(this.getUProfile(), "TA1004"));
                }else{
                	endLeaveYear = new CscCalendar((String) StaticConfig.getConfigCompany(this.getUProfile(), "TA1002"));
                }
                while (it.hasNext()) {
                	Integer key = (Integer) it.next();
                    MyHashMap hmDetail = (MyHashMap) hm.get(key);
                    if (hmDetail.get("UPDTYPE").equals("A")) {
                    	if (hour_d>0 && (hour_d<hmDetail.getFloat("LV") || hmDetail.getFloat("LV")==hmDetail.getFloat("HOUR_S"))) {
                    		ct_lv.add(this.hour_s);
                    		cal_ct_lv.add(this.hour_s);
                    	} else {
                    		//===================== Nuiss ͧ Structure ͹ ========
                    		/**
                    		 * Author : Nuiss
                    		 * Date : 18/06/2552
                    		 * Logic :  fields flag 2 fields [lvFixType,lvFixHour]
                    		 * Ѻ fix . ѹ Фӹǳǧ  ˹ͧ
                    		*/
                    		String time0Id = hmDetail.getString("time0Id");
                    		Object[] lvFixData = this.getLvFix(time0Id); 
                     		if(Integer.parseInt(String.valueOf(lvFixData[0]))==0){
                     			//ͧ
                     			ct_lv.add(hmDetail.getFloat("LV")); 
                     			cal_ct_lv.add(hmDetail.getFloat("LV"));
                    		}else{ 
                    			ct_lv.add(Float.parseFloat(String.valueOf(lvFixData[1]))); 
                    			cal_ct_lv.add(Float.parseFloat(String.valueOf(lvFixData[1])));
                    		}//end if
                     		//===================== Nuiss ͧ Structure ͹ ========
                    	}//end if 
                    	
                    	dHisLeave.setCalendar(hmDetail.getString("docdate"));
                    	if(dHisLeave.afterDate(endLeaveYear)){
                    		//next_ct_lv.add(ct_lv);
                    		next_ct_lv.add(cal_ct_lv);
                    		isOverYear = true;
                    	}else{
                    		//now_ct_lv.add(ct_lv);
                    		now_ct_lv.add(cal_ct_lv);
                    	}
                    }
                    
                    if (count==1) {
                    	s_date = hmDetail.getString("DT_BG");
                    	s_time = hmDetail.getFloat("TM_BG");
                    }
                    e_date = hmDetail.getString("DT_EN");
                    e_time = hmDetail.getFloat("TM_EN");
                    count++;
                    cal_ct_lv.resetTime();
                } 
                hour_leave = ct_lv.getFloat();
                
                this.set("START_DATE", s_date);
                this.set("END_DATE", e_date);
           	 	this.set("START_TIME", s_time);
           	 	this.set("END_TIME", e_time);
            }
            
            if(this.getInt("leave_format") == SPREQ ){	/* ӹǳẺ ͧ觤 ѹ  . ҷ */
            	ct_lv = new CscTime();
            	ct_lv.add(Double.parseDouble(calLeaveHour(hm)));
            }
            
            int chkTypeYear = 1;	//1 = չ	,	2 = չлնѴ
            
            /**
             * Author : Nuiss
             * Date : 20/05/2552
             * Logic :  wf_status == ź½ºؤ
             * ͧત ѹԷԾ  ѹź data ͡ҡ 
             * table tleave_summary лѺ data ׹ table tadjtim0
             *  data ͧ ͡   table tabsent_nstda ѧ
             */
            if (!this.getString("wf_status").equalsIgnoreCase("8")&&!this.getString("wf_status").equalsIgnoreCase("9")) {
               	//ǨͺԷԡ§͵͡Ҥ駹
            	int used = dhm.DHMToMin(mels.getLeaveUsed(this.getString("type_absent"),this),Double.toString(hour_d));
            	int nextUsed = dhm.DHMToMin(mels.getLeaveNextUsed(this.getString("type_absent"),this),Double.toString(hour_d));
            	String nextRemain = mels.getRemainNextLeave(this.getString("type_absent"));
            	String rm = mels.getRemainLeave(this.getString("type_absent"));
            	int remainMin = dhm.DHMToMin(rm,Double.toString(hour_d));	/* ʹͷ ˹¹ҷ */
            	if(rm.startsWith("-")){ remainMin = remainMin * -1 ;}
            	int used_count = mels.getAmountLeaveUsed(this.getString("type_absent"),this) ;	
            	/* ԷǶԹ limit ѹ繡Ң 繡Ң Է礢ͧûѹ */
            	boolean isOverLimit = (used + fs.time2min(ct_lv.getFloat())) > fs.DhmToM(limit, hour_d);
            	/* ԷǶԹ limit ѹ繡Ң 繡Ң Է礢ͧûѹ */
            	if( isOverYear ){
            		/* 礡Ңͧչ ѺԷͧչ ö */
            		isOverLimit = (used+(fs.time2min(now_ct_lv.getFloat())))>fs.DhmToM(limit, this.hour_s);
            		chkTypeYear = 2;
            		/* 礡â㹻ջѨغѹѺԷԷ㹻ջѨغѹ ö ҡҢͧնѴ Է§ */
            		if(!isOverLimit){
            			/* ԷͧջѨغѹ ҹ ö ԷͧնѴ仵 */
            			isOverLimit = (nextUsed+(fs.time2min(next_ct_lv.getFloat()))) > (fs.DhmToM(limit, this.hour_s));
            		}
            	}
            	//|| (used + fs.time2min(ct_lv.getFloat())) > fs.DhmToM(limit, hour_d)
    			
            	if((isOverLimit  || (used_count + 1) > limit_times) && chkTypeYear == 1){
            		int count = limit_times - (used_count + 1);	/* Ҥ駹 (+1) */
            		if(count < 0) { count = 0; }
            		
      	        	if (this.userPro.get("lang").equalsIgnoreCase("tha")) {    		                		 
                		 String leaveAlert = "سö "+desc_leave +" "+day_leave + " ѹ ͧҡ"
                		 +"\nԷԡ § " + rm
                		 +" ѹ "
                		 +"\n\n[***˵***]"
                		 +"\nسԷԡ  "+limit+" ѹ"
                		 +"\nسԷԡ "+dhm.MinToDHM(used, hour_d)+" ѹ";
                		 return "7 : "+leaveAlert;
                		 //ͧ
                     } else {
                		 String leaveAlert = "You can not take leave for "+day_leave + " day(s) because"
                		 +"\nyour leave privillege remain "+fs.MTODhm(remainMin)+" day(s)"
                		 +"\n\n[***Remark***]"
                		 +"\nyour leave privillege "+limit+" day."
                		 +"\nyou have took leave for "+dhm.MinToDHM(used, hour_d)+" day.";
                		 return "7 : "+leaveAlert;
                    	//ͧ
                     }
    	         }else if((isOverLimit  || (used_count + 1) > limit_times) && chkTypeYear == 2){
    	        	int count = limit_times - (used_count + 1);	/* Ҥ駹 (+1) */
             		if(count < 0) { count = 0; }
             		
       	        	if (this.userPro.get("lang").equalsIgnoreCase("tha")) {    		                		 
                 		 String leaveAlert = "سö "+desc_leave +" "+day_leave + " ѹ ͧҡ"
                 		 +"\nԷԡ § " + rm +" ѹ "
                 		 +"\n Էԡ㹻նѴ  " + nextRemain +" ѹ "
                 		 +"\n\n[***˵***]"
                 		 +"\nسԷԡ  "+limit+" ѹ"
                 		 +"\nسԷԡ "+dhm.MinToDHM(used, hour_d)+" ѹ"
                 		 +"\n سԷԡ㹻նѴ "+dhm.MinToDHM(nextUsed, hour_d)+" ѹ";
                 		 return "7 : "+leaveAlert;
                 		 //ͧ
                      } else {
                 		 String leaveAlert = "You can not take leave for "+day_leave + " day(s) because"
                 		 +"\nyour leave privillege remain "+fs.MTODhm(remainMin)+" day(s)"
                 		 +"\nand your leave privillege remain next year "+nextRemain+" day(s)"
                 		 +"\n\n[***Remark***]"
                 		 +"\nyour leave privillege "+limit+" day."
                 		 +"\nyou have took leave for "+dhm.MinToDHM(used, hour_d)+" day."
                 		 +"\nand you have took leave next year for "+dhm.MinToDHM(nextUsed, hour_d)+" day.";
                 		 return "7 : "+leaveAlert;
                     	//ͧ
                      }
    	         }
            }//end if       
                   
            
        } catch (Exception e) {
            MyLog.error(this, e);           
        }       
        
        String d_limit="";
        try {
	    	int x = fs.DhmToM(this.used);
	    	int l = fs.Tm_To_Min(Double.parseDouble(String.valueOf(hour_leave)));
	    	d_limit = fs.MTODhm(x+l, hour_d);	    	
    	} catch (Exception e) {
    		MyLog.debug(this, e);
    	}    	
    	
    	try {
        	CscCalendar csBegin = new CscCalendar(this.getString("start_date"));
        	csBegin.setCSCTime(this.getFloat("start_time"));
        	CscCalendar csEnd = new CscCalendar(this.getString("end_date"));
        	csEnd.setCSCTime(this.getFloat("end_time"));
        	if (csEnd.before(csBegin)) {   
        	    csEnd.incDate();
        	    this.set("END_DATE", csEnd.getDDMMYYYY());
        	}
    	} catch (Exception e) {
            MyLog.debug(this, e);
        }       
    	
        if (this.chkLeaveSameDay(hm)) {
            return "1";
        }
    	
        CscCalendar startDateReturn = new CscCalendar(this.getString("START_DATE"));
        CscCalendar endDateReturn = new CscCalendar(this.getString("END_DATE"));
      
        if(this.getInt("leave_format") == SPREQ ){	/* ӹǳẺ ͧ觤 ѹ  . ҷ */
        	String time[] = dhm.MinToDHM(fs.Tm_To_Min(Double.parseDouble(calLeaveHour(hm))), hour_d).split(":");
        	
        	return result+"_"+day_leave+"_"+d_limit
    		+"#"+startDateReturn.getDDMMYYYY()
    		+"#"+endDateReturn.getDDMMYYYY()
    		+"#"+df.format(this.getDouble("START_TIME"))
    		+"#"+df.format(this.getDouble("END_TIME"))
    		+"#"+ Integer.parseInt(time[0])
    		+"#"+ Float.parseFloat(time[1] + "." + time[2])
    		+strForHTML;
        }else{
        	return result+"_"+day_leave+"_"+d_limit
        		+"#"+startDateReturn.getDDMMYYYY()
        		+"#"+endDateReturn.getDDMMYYYY()
        		+"#"+df.format(this.getDouble("START_TIME"))
        		+"#"+df.format(this.getDouble("END_TIME"))
        		+"#"+hour
        		+strForHTML;
        }
        
        /*
         * ERROR LIST
         * 0 = 
         * 1 = աѹ
         * 2 = اҹ֧
         * 3 = 駷Թ
         * 4 = кö͹ѧ سҵԴͧҹçҹؤ
         * 5 = سҡ͹˹ҹ͹
         * 6 = öѹ >>>   1. ¹ҹ͡ҡ÷ӧҹ 
         * 7 = Էԡ
         * 8 = 㹡١ͧ
         * 9 = ǧ˹ҵͧҡ͹ 13.00
         * 10 = 鹡١ͧ
         * A = յҧҡ÷ӧҹ
         * B = ʾѡҹ١ͧ
         * C = һ öǧ˹
         * */       
    }
    
    /* óդӹǳ ѹ . ˹Ҩ; */
    private String calLeaveHour(MyTreeMap hm){
    	DecimalFormat df = new DecimalFormat("#0.00");
    	CscTime cs = new CscTime();
    	try {
    		for(Iterator it = (Iterator) hm.keySet().iterator(); it.hasNext();){
    			Integer key = (Integer) it.next();
    			HashMap dat = (HashMap) hm.get(key);
    			
    			cs.add((Double)dat.get("LV"));
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return df.format(cs.getDouble());
    }
    
    private String getLeaveErrorResult(String error) {
    	String result = "";
    	if (error!=null && error.length()>0) {
	    	String[] THA_ERROR = {"",
	    			"աѹ",
	    			"اҹ֧",
	    			"駷Թ",
	    			//"ǧ˹",
	    			"кö͹ѧ سҵԴͧҹçҹؤ",
	    			"سҷǢͧ͹˹ҹ͹",
	    			"öѹ",
	    			"Էԡ",
	    			"㹡١ͧ",
	    			"ǧ˹ҵͧҡ͹ 13.00",
	    			"һ öǧ˹"};
	    	String[] ENG_ERROR = {"",
	    			"Alreadly took leave for today",
	    			"Has no right to request",
	    			"Time of leave are excess the limit",
	    			//"Inform leave less than advance limit days",
	    			"This system not request to be past. Please contact HR",
	    			"Please finish all preriquisite leave first",
	    			"Can't take leave for this ",
	    			"Insufficient remaining leave",
	    			"Sex is not match with leave type",
	    			"Please Request Before 13.00",
	    			"Can't take this leave in advance for this type"};
	    	String[] ERROR_LIST = {};
	    	if (this.getUProfile().get("lang").equalsIgnoreCase("THA")) {
	    		ERROR_LIST = THA_ERROR;
	    	} else {
	    		ERROR_LIST = ENG_ERROR;
	    	}
	    	
	    	if (error.substring(0,1).equals("1")) {
	    		result = ERROR_LIST[1];
	    	} else if (error.substring(0,1).equals("2")) {
	    		result = ERROR_LIST[2];
	    	} else if (error.substring(0,1).equals("3")) {
	    		result = ERROR_LIST[3];
	    	} else if (error.substring(0,1).equals("4")) {
	    		result = ERROR_LIST[4];
	    	} else if (error.substring(0,1).equals("5")) {
	    		result = ERROR_LIST[5];
	    	} else if (error.substring(0,1).equals("6")) {
	    		result = ERROR_LIST[6];
	    	} else if (error.substring(0,1).equals("7")) {
	    		result = ERROR_LIST[7];
	    	} else if (error.substring(0,1).equals("8")) {
	    		result = ERROR_LIST[8];
	    	} else if (error.substring(0,1).equals("C")) {
	    		result = ERROR_LIST[11];
	    	} 
    	}
    	return result;
    }
    
    /** ֧ .ӧҹѹ */
    private double getHour_Day(String timeCode) {
        double value = 8;
        try {
            DbRecord inq1 = new InitialRecord(this.getUProfile()).getDbRecord("MTIME0");
            inq1.setColumn("time0id,companyid,edesc,tdesc,hour_d");    
            inq1.set("time0id", timeCode);
            inq1.set("companyid", this.userPro.get("companyid"));
            if (inq1.search()==1) {
                value = inq1.getDouble("hour_d");            
            } 
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return value;
    }
    
    /*
     *  ѹ ա
     */
    private boolean chkLeaveSameDay(MyTreeMap hm) {
        boolean result = false;
        try {
            CscCalendar csc1 = new CscCalendar(this.getString("start_date"));
            csc1.setCSCTime(this.getFloat("start_time"));
            CscCalendar csc2 = new CscCalendar(this.getString("end_date"));   
            csc2.setCSCTime(this.getFloat("end_time"));
            
            String filter = "employeeid='"+this.getString("employeeid")+"' and doctype='A' and " +
            "(dateid between '"+csc1.getYYYYMMDD()+"' and '"+csc2.getYYYYMMDD()+"') and docid<>'"+this.getString("absentid")+"'" ;
            
			if(!this.exc_absentid.equals("")){ /* Ţ͡÷˹͡¡ Ҥӹǳʹ  */
				filter += " and absentid != '" + this.exc_absentid + "'";
			}
			MyTimeZone tzNewLv = null , tzOldLv = null;
            
            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
            inq.setParam(this.param);
            inq.setSchemaName(this.userPro.getSchemaName());
            inq.initMyTable("TLEAVE_SUMMARY", filter, "");
            inq.setColumn("*");
            inq.refresh();
            while (inq.next()) {
            	DbRecord rec = inq.getCurrentDbRecord();
            	
            	Iterator it = hm.keySet().iterator();
            	while (it.hasNext()) {
            		Integer key = (Integer) it.next();
            		MyHashMap hmData = (MyHashMap) hm.get(key);
            		
            		CscCalendar leave1 = new CscCalendar(rec.getString("lv_bg_date"));
                	leave1.setCSCTime(rec.getFloat("lv_bg_time"));
                	CscCalendar leave2 = new CscCalendar(rec.getString("lv_en_date"));
                	leave2.setCSCTime(rec.getFloat("lv_en_time"));
                	
                	csc1 = new CscCalendar(hmData.getString("DT_BG"));
                    csc1.setCSCTime(hmData.getFloat("TM_BG"));
                    csc2 = new CscCalendar(hmData.getString("DT_EN"));   
                    csc2.setCSCTime(hmData.getFloat("TM_EN"));
                    
                    if( tzNewLv == null ){
                    	tzNewLv = new MyTimeZone(csc1,csc2);
                    }else{
                    	tzNewLv.setBeginZone(csc1);
                    	tzNewLv.setEndZone(csc2);
                    }
                    if( tzOldLv == null ){
                    	tzOldLv = new MyTimeZone(leave1,leave2);
                    }else{
                    	tzOldLv.setBeginZone(leave1);
                    	tzOldLv.setEndZone(leave2);
                    }
                    
                    float diffIntersec = tzNewLv.getDiffIntersectZone(tzOldLv);
                    if( diffIntersec > 0 ){
                    	return true;
                    }
                    /* if(csc1.beforeEqualsDateTime(leave1) && (csc2.afterEqualsDateTime(leave1) && csc2.beforeEqualsDateTime(leave2))){
                    	return true;
                    } else if(csc1.beforeEqualsDateTime(leave1) && csc2.afterEqualsDateTime(leave2)){ //  8.00 - 17.40 ӡѺ 8.00 - 12.20
                        return true;
                    } else if((csc1.afterEqualsDateTime(leave1) && csc1.beforeEqualsDateTime(leave2)) && csc2.afterEqualsDateTime(leave2)) {
                    	return true;
                    } else if((csc1.afterEqualsDateTime(leave1)&&csc1.beforeEqualsDateTime(leave2)) && (csc2.afterEqualsDateTime(leave1)&&csc2.beforeEqualsDateTime(leave2))) {
                    	return true;
                    } else if(csc1.beforeDateTime(leave1) && csc2.afterDateTime(leave2)) {
                    	return true;
                    }*/
            	}
            }
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return result;
    }
    
    /* ҢҤѹ ͧ૵ӹǹ .  leave_hour  ͹͹ʴ§ҹ */
    private void setLeaveHour(){
    	try{
    		if(this.getString("leave_format").equals("2") || this.getString("leave_format").equals("3")){
    			CscCalendar st = this.getCscCalendar("start_date");
    			st.setCSCTime(this.getFloat("start_time"));
    			
    			CscCalendar en = this.getCscCalendar("end_date");
    			en.setCSCTime(this.getFloat("end_time"));
    			
    			this.set("leave_hour", en.subForHour(st));
    		}
    	}catch(Exception e){
    		MyLog.error("!! Error : can't set leave hour !!", e);
    	}
    }
    
    protected boolean preInsertTrigger() throws Exception {
    	boolean result = super.preInsertTrigger();
        
        setEmployeeDetail();	/*  detail  ͧ employeeid   */

        if(!forceDeleteAbsent()) return false;	/* ź͡÷к ͹кѹ֡ŧ */
        
        /* IDS only : Ҩҡ import  ʶҹ͡ V ʴźšҷçѺǧҢͧ͡ù */
        if(this.getString("wf_status").equalsIgnoreCase("v") || this.getString("wf_status").equalsIgnoreCase("n")){
        	if(this.getString("wf_status").equalsIgnoreCase("n")){
        		updateStatusAbsent("4");
        	} else if(this.getString("wf_status").equalsIgnoreCase("v")){
        		deleteExistingAbsent();
        		updateStatusAbsent("8");
        		return false ;
        	}
        }
        
        /* if request leave period overlap with existing, this request will not be save */
        boolean chkOverLap = false;
        ChkTimeOverLap chkTOverLap = new ChkTimeOverLap();
        String[] absent = {"0",this.getString("employeeid"),this.getString("companyid"),this.getString("start_date"),this.getString("start_time"),this.getString("end_date"),this.getString("end_time")};
        chkTOverLap.setProp(absent, this.getUProfile());
    	chkOverLap = chkTOverLap.chkTimeOverlap();
    	
    	if(chkOverLap){
    		this.param.put("error_msg","Already took leave for today.");
    		return false;
    	}
        
    	/* send mail inform employee */
        if (this.param!=null && this.param.containsKey("__sendmail")) {
            if(((String) this.param.get("__sendmail")).equals("1")){
                sendmail = "1";
            }
        }
        
        return result;      
    }
    
    protected boolean preUpdateTrigger() throws Exception {

    	boolean result = super.preUpdateTrigger();  
    	
    	delDataTleaveSummary(this);	/* źʹ駡͹ Ѿഷкѹ֡ŧ */
        setEmployeeDetail();		/*  detail  ͧ employeeid   */
        setOldData(); 				//aGazin add for Retive data before edit

        if (this.param!=null && this.param.containsKey("__sendmail")) {
            if(((String) this.param.get("__sendmail")).equals("1")){
                sendmail = "1";
            }
        }
        
        return result;
    }  
    
    public int search() {
    	int result = super.search();
    	if (result==1) {
    		this.old_start_date = this.getString("start_date"); 
            this.old_end_date = this.getString("end_date");
    	}
    	return result;
    }
    
    /*
     * ӡѧѡҹ
     */
    private void sendMail() {
    	if(this.meventDesc==null){
    		this.getMeventgrp();
    	}
    	String isNSTDASite = "";
         try {
        	isNSTDASite = (String) StaticConfig.getConfigCompany(this.userPro, "ta1012"); 
 		} catch (Exception e) {
 			MyLog.error("ERROR !!! Find Config TA1012 not found : is use for calculate flex time NSTDA");
 		}
    	try {
    		DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
			inqEmp.setParam(this.param);
			inqEmp.setSchemaName(this.userPro.getSchemaName());
			inqEmp.initMyTable("Memployee", "employeeid='"+this.getString("employeeid")+"'", "");
			inqEmp.setColumn("employeeid, runno, companyid, email");			
			inqEmp.refresh();
			if (inqEmp.next()) {
				if (!inqEmp.getString("email").equals("")) {	
					String mail_content ="";
					
					if(this.getString("wf_status").equalsIgnoreCase("8") ||
					   this.getString("wf_status").equalsIgnoreCase("9")){
						/*Edit by aGazin on 11022010*/
						/* for mail NSTDA */
						if(isNSTDASite.equals("1")){ //is NSTDA?
							String LeaveFormat = this.getString("LEAVE_FORMAT");
							boolean isDay = (this.getString("LEAVE_FORMAT").equalsIgnoreCase("0") || this.getString("LEAVE_FORMAT").equalsIgnoreCase("4"));
							mail_content = "ҹ¡ԡ "+this.meventDesc.get(this.getString("type_absent"))+"\n"
									+"ѹ "+this.old_start_date+"  "+this.getString("start_time")+" ."
									+"֧ ѹ"+this.old_end_date+"  "+this.getString("end_time")+" ."
									+" ӹǹ "+((isDay)?this.getString("LEAVE_DAY"):"-")+" ѹ "+((!isDay)?this.getString("LEAVE_HOUR"):"-")+"  \n"
									+"Ѻ¡ԡ öǨͺ͡ http://ehr.nstda.or.th/hr";	
						}else{
							mail_content = "Ңͧҹ "+
							"ѹ "+this.old_start_date+" ֧ѹ "+this.old_end_date+" "+
							"Ѻ¡ԡ" ;
						}
						/*Edit by aGazin on 11022010*/
					} else{
						/*Edit by aGazin on 11022010*/
						/* for mail NSTDA */
						if(isNSTDASite.equals("1")){ //is NSTDA?
							String LeaveFormat = this.getString("LEAVE_FORMAT");
							boolean isDay = (this.getString("LEAVE_FORMAT").equalsIgnoreCase("0") || this.getString("LEAVE_FORMAT").equalsIgnoreCase("4"));
							mail_content = "ҹ "+this.meventDesc.get(this.getString("type_absent"))+"\n"
									+"ѹ "+this.old_startdate+"  "+this.old_start_time+" ."
									+"֧ ѹ "+this.old_enddate+"  "+this.old_end_time+" .\n"
									+"ӹǹ "+((isDay)?this.getString("LEAVE_DAY"):"-")+" ѹ "+((!isDay)?this.getString("LEAVE_HOUR"):"-")+"  "
									+"Ѻ䢴ѧ \n"
									+" "+this.meventDesc.get(this.getString("type_absent"))
									+"ѹ "+this.getString("start_date")+"  "+this.getString("start_time")+" ."
									+"֧ ѹ "+this.getString("start_date")+"  "+this.getString("end_time")+" .\n"
									+"ӹǹ "+((isDay)?this.getString("LEAVE_DAY"):"-")+" ѹ "+((!isDay)?this.getString("LEAVE_HOUR"):"-")+"  "
									+"öǨͺ͡ http://ehr.nstda.or.th/hr";	
						}else{
							mail_content = "ҢͧҹѺ "+
							"ҡѹ "+this.old_start_date+" ֧ "+this.old_end_date+" "+
							"ѹ "+this.getString("start_date")+" ֧ "+this.getString("end_date");
						}
					}//end if 
					
					SendMail sm = new SendMail("", 
					        new InitialEnvironment("GLOBAL").getValue("MAILAUTH-username"), 
							inqEmp.getString("email"),
							"", 
							"Mail From HR [Leave Edit]",
							mail_content);
					sm.send();
				}
			}	    	
    	} catch (Exception e) {
    		MyLog.error(this, e);
    	}
    }
    
    /**
     * @author PipoXP
     * @param empCode
     * @param startdate
     * @return START_TIME, END_DATE, END_TIME  Hashmap
     * get  ѹش ش㹡÷ӧҹ (зӧҹԧ)
     */
    public MyHashMap getWorkingDateTime(String empCode, String startdate){
        String start_time = "0";
        String end_date = "";
        String end_time = "";
        MyHashMap hm = new MyHashMap();
        String isCalFlexTime = "";
        MyTreeMap trEmpSwipe = new MyTreeMap();
        try{
            DbInquiry inqEmp = new InitialInquiry(this.getUProfile()).getDbInquiry();
            inqEmp.setSchemaName(this.getUProfile().getSchemaName());
            inqEmp.initMyTable("Memployee", "employeeid='"  + empCode + "'", "");
            inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
            inqEmp.setParam("rsc_skip","true");
            inqEmp.refresh();
            while (inqEmp.next()) {
                Mtime0 rec = (Mtime0) new InitialRecord(this.getUProfile()).getDbRecord("Mtime0");
                rec.set("time0id", inqEmp.getString("time0"));
                rec.set("companyid", this.getUProfile().get("companyid"));
                rec.search();
    
                CscCalendar cs1 = new CscCalendar(startdate);
                                    
                rec.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
                rec.setEmpSwipeTime(trEmpSwipe);
                
                WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
                        new CscCalendar(cs1.getYYYYMMDD()), "true");             
                if (!ws.isEmpty()) {
                    ws.setUProfile(this.getUProfile());
                    ws.setEmployeeid(inqEmp.getString("employeeid"));
                    //ws.adjustLeave();
                    ws.overlapChecking();
                    ws.createLink();
                    int i= 0;
                    
                    Iterator it = (Iterator) ws.keySet().iterator(); 
                    if (it.hasNext()) {
                        i++;
                        DayShift ds = (DayShift) ws.get(it.next());
                        int ds_size = ds.size();
                        Iterator it_ds = (Iterator) ds.keySet().iterator();
                        if (it_ds.hasNext()) {
                            Shift sh = (Shift) ds.get((String) it_ds.next());
                            if (sh!=null) {
                                TimeZone tz = sh.getMidDayStop();
                                CscCalendar cs = tz.getBeginZone();
                                start_time = df.format(sh.get_c_dt_in().getCSCTime());
                                end_date = sh.get_c_dt_out().getDDMMYYYY();
                                end_time = df.format(sh.get_c_dt_out().getCSCTime());
                                hm.put("START_TIME", start_time);
                                hm.put("END_DATE", end_date);
                                hm.put("END_TIME", end_time);
                            }
                        }
                    }      
                }
            } //End Check Leave Haft Day
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return hm;     
    }
    
    /** ҡ folder 0 ѧ folder  absentid */
    private void transferFile(){
		String absentid = this.getString("absentid");
		String companyid = this.getString("companyid");
    	String source = this.env.getValue((String) this.param.get("__temp")) + companyid + "/0";
    	String desctination = this.env.getValue((String) this.param.get("__temp")) + companyid + "/" + absentid;
    	String file_list = this.param.get("__temp_file").toString();
    	String fileName = "";
    	File sourceFile = null;
    	File desctFolder = new File(desctination);
    	Downloadfile download = null;
    	StringTokenizer strToken = new StringTokenizer(file_list, ",");
    	
    	try {
	    	download = new Downloadfile(source);
			HashMap attach_file_hm = download.listFile();
			ArrayList file_name = (ArrayList)attach_file_hm.get("file_name");
			//ArrayList file_size = (ArrayList)attach_file_hm.get("file_size"); 
			do {
				fileName = strToken.nextToken();
				if (file_name.indexOf(fileName) > -1) {
					sourceFile = new File(source + "/" + fileName);
					this.moveFile(sourceFile, desctFolder);
				}
			} while (strToken.hasMoreTokens());

    	} catch (Exception e) {
    		MyLog.error(this, e);
    	}
    }
    
    /**   */
    private boolean moveFile(File source, File desctFolder) {
    	boolean result = false;
    	if (source.exists()){
    		if (!desctFolder.exists()){
    			desctFolder.mkdirs();
    		}
			
    		if ( source.renameTo(new File(desctFolder.getAbsolutePath()+ "/" +source.getName())) ){
    			return this.deleteFile(source);
    		}
    	}
    	return result;
    }
    
	private boolean deleteFile(File file){
		boolean result = false;
		if (file.exists())
			return file.delete();
		return result;
	}
	
	private void setEmployeeDetail() {
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			rec.setColumn("employeeid, companyid, bu1, bu2, bu3, bu4, bu5, branch, "
							+ "job, emp_position, emp_group, bossid, salatype, workarea");
			rec.setParam("rsc_skip","true");
			rec.set("employeeid", this.getString("employeeid"));
			if (rec.search() ==  1) {
				this.set("bu1", rec.getString("bu1"));
				this.set("bu2", rec.getString("bu2"));
				this.set("bu3", rec.getString("bu3"));
				this.set("bu4", rec.getString("bu4"));
				this.set("bu5", rec.getString("bu5"));
				this.set("job", rec.getString("job"));
				this.set("emp_position", rec.getString("emp_position"));
				this.set("emp_group", rec.getString("emp_group"));
				this.set("branch", rec.getString("branch"));
				this.set("bossid", rec.getString("bossid"));
				this.set("salatype", rec.getString("salatype"));
				this.set("workarea", rec.getString("workarea"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	/**
	 * Author : Nuiss
     * Date : 18/06/2552
     * Logic :  fields flag 2 fields [lvFixType,lvFixHour]
     * Ѻ fix . ѹ Фӹǳǧ  ˹ͧ
	 * @param time0Id
	 * @return Object[]
	 */
	private Object[] getLvFix(String time0Id){
		Object[] dataReturn= new Object[2]; 
		try{
			DbRecord inqMtime0 = new InitialRecord(this.userPro).getDbRecord("Mtime0");
			inqMtime0.setColumn("TIME0ID,COMPANYID,TDESC,LVFIXTYPE,LVFIXHOUR");
			inqMtime0.set("time0id", time0Id);
			inqMtime0.set("companyid", (String) this.userPro.get("compnayid"));
			if(inqMtime0.search()==1){
				if(inqMtime0.getString("LVFIXTYPE") == null 
						||inqMtime0.getString("LVFIXTYPE").equals("")
						||inqMtime0.getString("LVFIXTYPE").equals("0")){
					dataReturn[0] ="0";
				}else{
					dataReturn[0] = inqMtime0.getString("LVFIXTYPE");
				}//end if 
				if(inqMtime0.getString("LVFIXHOUR") == null 
						|| inqMtime0.getString("LVFIXHOUR").equals("")){
					dataReturn[1] = "4.00";
				}else{
					dataReturn[1] = inqMtime0.getString("LVFIXHOUR");
				}//end if 
			}//end if 
		}catch(Exception ex){
			dataReturn[0] ="0";
			dataReturn[1] ="0.00";
			MyLog.error("Error on Tabsent_nstda.getLvFix() at Retrieve Mtime0...",ex);
		}//end try 
			
		return dataReturn;
	}//end method getLvFix
	
	private void getMeventgrp(){
		this.meventDesc = new Hashtable();
		try{
			DbInquiry inqEvent = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inqEvent = new InitialInquiry(this.getUProfile()).getDbInquiry();
	        inqEvent.setSchemaName(this.getUProfile().getSchemaName());
	        inqEvent.initMyTable("meventgrp","","");
	        inqEvent.setColumn("*");
	        inqEvent.refresh();
	        while (inqEvent.next()){
	        	this.meventDesc.put(inqEvent.getString("eventgrpid"),inqEvent.getString("TDESC"));
	        }
		}catch(Exception ex){
			MyLog.error("Error on Tabsent_nstda.getMeventgrp()",ex);
		} 
	}
	
	private void setOldData(){
		try{
			DbInquiry inqEvent = new InitialInquiry(this.getUProfile()).getDbInquiry();
			inqEvent = new InitialInquiry(this.getUProfile()).getDbInquiry();
	        inqEvent.setSchemaName(this.getUProfile().getSchemaName());
	        inqEvent.initMyTable("tabsent_nstda","ABSENTID = '"+this.getString("ABSENTID")+"'","");
	        inqEvent.setColumn("*");
	        inqEvent.refresh();
	        while (inqEvent.next()){
	        	this.old_startdate = inqEvent.getString("start_date");
	        	this.old_enddate = inqEvent.getString("end_date");
	        	this.old_start_time = Float.parseFloat(inqEvent.getString("start_time"));
	        	this.old_end_time = Float.parseFloat(inqEvent.getString("end_time"));
	        }
		}catch(Exception ex){
			MyLog.error("Error on Tabsent_nstda.setOldData()",ex);
		} 
	}
	
	/**
	 * @author aGazin
	 * @create_date : 2010-09-20
	 * @modify_date : 2010-09-20 
	 * @cuz : ͧʶԵԡҷءһ˹ѹ㹻
	 * @sol : ҡҷ tleave_summary 仨ṡ ҡ鹷ӡúǡл
	 * @param employeeid
	 * @param startDate
	 * @param endDate
	 * @param leaveType [öкػҷͧ  A1 , A1#B1 , A1#B1#B2]
	 * @return hashMap DBReccord ͧ Tabsent
	 */ 
	public HashMap getStatisticLeaveFromSummary(String employeeid,CscCalendar startDate,CscCalendar endDate){ 
		return this.getStatisticLeaveFromSummary(employeeid, startDate, endDate, "");
	}
	
	public HashMap getStatisticLeaveFromSummary(String employeeid,CscCalendar startDate,CscCalendar endDate,String leaveType){
		HashMap hashStatisticLeave = new HashMap();
        CscTime ct= new CscTime();
		DbInquiry inqAbsent = new InitialInquiry(this.getUProfile()).getDbInquiry();
		
		//init filter
		StringBuffer filter = new StringBuffer("employeeid like '"+employeeid+"' ");
		filter.append(" and (dateid between '"+startDate.getYYYYMMDD()+"' and '"+endDate.getYYYYMMDD()+"' ) ");
		filter.append(" and doctype like 'A' ");
		if(!leaveType.equals("")){
			filter.append(" and lv_type in ( ");
			String tempLeaveType[] = leaveType.split("#");
			for(int i=0;i<tempLeaveType.length;i++){
				filter.append("'"+tempLeaveType[i]+"'");
			}
			filter.append(" )");
		}
		
		//calculate static leave
		try{
			float tempHourLeave = 0.0f;
			
			inqAbsent.setSchemaName(this.getUProfile().getSchemaName());
			inqAbsent.initMyTable("Tleave_summary", filter.toString(), "dateid");
			inqAbsent.setColumn("*");
			inqAbsent.refresh();
			while(inqAbsent.next()){
				if(hashStatisticLeave.containsKey(inqAbsent.getString("lv_type"))){
					tempHourLeave = (Float) hashStatisticLeave.get(inqAbsent.getString("lv_type"));
					hashStatisticLeave.put(inqAbsent.getString("lv_type"), inqAbsent.getCurrentDbRecord().getFloat("m_lv")+tempHourLeave);
				}else{
					hashStatisticLeave.put(inqAbsent.getString("lv_type"), inqAbsent.getCurrentDbRecord().getFloat("m_lv"));
				}
			}
			
		}catch(Exception ex){
			MyLog.error("!! Error on Tabsent_nstda.getStatisticLeaveFromSummary !!"+ex);
		}
		return hashStatisticLeave;
	}

	/* Ҩӹǹѹ Ѻѹش ҧҡѹѨغѹѹ Ѻ礨ӹǹѹ͹ѧ ǧ˹   mode  (0 ͹ѧ, 1 ǧ˹)*/
	private int findLeaveDays(int mode){
		int days = 0;    /* ӹǹѹӹǳҧҡѹѨѺѹ */
		int _BEFORE = 0; /* 0 is before current date */
		int _AFTER = 1;  /* 1 is after current date  */
		int _ERROR = 99; /* óշ͹ѧ 繡ҤѹѨغѹ 繡͹ѧ ֧絤ö (૵ӹǹѹ 99)*/
		int idxType;	 /* ͡ǧ˹ ͹ѧ 礨ҡѹ ѹѨغѹ */
		
		Vector vDays = new Vector(); /* ѹ Ἱѹش */
		
        CscCalendar stGenWorkingSF = null; /* ѹἹҧ */
        CscCalendar enGenWorkingSF = null; /* ѹشἹҧ */
        WorkingShift wkShf = null;
		try {
			/* ˹ҵõҧ  ҧἹ÷ӧҹ */
			Memployee_ta emp = (Memployee_ta) new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE_TA");
			emp.set("employeeid", this.getString("employeeid"));
			emp.setColumn("*");
			emp.search();
			String time0 = emp.getDailyTime0id(new CscCalendar(this.getString("start_date")));
			
        	Mtime0 timeRec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("MTIME0");
            timeRec.set("time0id", time0); /* ʡ ͹Ҥ prop ͧ */
            timeRec.setColumn("*");
            timeRec.search();
            timeRec.setEmpRec(emp);            
                
            /* ѹش ҧἹ÷ӧҹ ѹѨѺѹ֧ѹѹش㹡ҧἹ  */
            /*   11-11-2010 ֧ 13-11-2010 ѹѨغѹ 15-11-2010 */
            /* ҧἹѹ 13-11-2010 - 15-11-2010 */
            CscCalendar stDate = new CscCalendar(this.getString("start_date"));
            CscCalendar curDate = new CscCalendar();

            /* ˹ѹ ش 
             * ͹ѧ ѹ鹨ѹ ѹشѹѨغѹ
             * ǧ˹ ѹ鹨ѹѨغѹ ѹشἹѹ鹷 */
            if(stDate.beforeDate(curDate)){
               	stGenWorkingSF = stDate;
               	enGenWorkingSF = curDate;
               	idxType = _BEFORE;
               	isBefore = true;
            } else {
               	stGenWorkingSF = curDate;
               	enGenWorkingSF = stDate;
               	idxType = _AFTER;
               	isBefore = false;
            }
			
            /* ҵçѺ mode  ͹䢡Ẻǡѹ  觤 mode 0 ͹ѧ 礨ҡѹ͹ѧԧ֧зӧҹ */
            if(idxType == mode){
	            /* ҧἹ */
	            wkShf = timeRec.genWorkingShift(new CscCalendar(stGenWorkingSF.getTimestamp()), new CscCalendar(enGenWorkingSF.getTimestamp())); //ѹش
	            wkShf.setUProfile(this.userPro);
	            wkShf.setEmployeeid(this.getString("employeeid"));
	            wkShf.setEmpTimeCode(time0);
	            wkShf.adjust();    
	            Iterator IT = wkShf.keySet().iterator();
	
	            /* ѹἹŧ Vector */
	            while(IT.hasNext()){
	            	String dayKey = (String) IT.next();
	                DayShift dShift = (DayShift) wkShf.get(dayKey);
	                if (!dShift.isEmpty() || dShift.size()==1) {
	                	vDays.add(dayKey);
	                }
	            }
	            
	            /* ӹǳҨӹǹѹ ֧ѹѨغѹ 
	             * ҧ͹ѧ  13-11-2010 - 15-11-2010 ѹѨغѹ 18-11-2010 ӹǹѹҧҡѹѨغѹ  3 ѹ
	             * ҧǧ˹  20-11-2010 - 22-11-2010 ѹѨغѹ 18-11-2010 ӹǹѹҧҡѹѨغѹ  2 ѹ*/
	            if(idxType == _BEFORE){ /* ó͹ѧ Фӹǳѹش ֧ѹѨغѹ ѧ鹨Ѻѹ͹ѹش */
	            	/*  ͹ѧԧ ѹش¡ҵͧ͹ѹѨغѹ 礨ӹǹѹ ѺӹǹѹҧҡҧἹ 
	            	 * ӹǹѹҧҡἹ ͧҡ 
	            	 *   18-11-2010 - 21-11-2010 ѹѨغѹ 20-11-2010 
	            	 * Ἱ÷ӧҹ ١ҧѹ 18-11-2010 - 20-11-2010  3 ѹ
	            	 * ӹǹѹ 4 ѹ ҡҨӹǹѹҧҡἹ ֧ö */		 
	            	
	            	int daysCount = (this.getString("leave_format").equals("0")?this.getInt("leave_day"):1); // ѹ (leave_format = 0) еͧ礨ӹǹѹ ҡ դ 1  ( . Ҥѹ )
	            	
	            	if(daysCount <= vDays.size()){ 
		            	for(int i = 0; i < daysCount ; i++){
			            	if(vDays.size() > 0) vDays.remove(0);
		            	}
			            days = vDays.size(); 
		            }else{ /* ӹǹѹ ҡҨӹǹѹҧἹ÷ӧҹ */
		            	days = _ERROR;
		            }
	            }else{ /* óǧ˹ͧ */
	            	/* ͹Ҥա¹͹ */
		            days = vDays.size();
	            }
            }else{
            	days = 0;
            }
		}catch(Exception e){
			MyLog.error("!! Error : Can't find leave days from tabsent_nstda !!",e);
		}
		return days;
	}
	
	/* ѹ֡͡ */
	private void saveTleave(DbRecord absent){
		int error = 0;
		CheckNull chknull = new CheckNull();
		try {
			MyTreeMap hm = new MyTreeMap();
			if(this.getInt("leave_format") ==  SPREQ){	/* 觨ҡ˹ҨẺ */
				hm = genRecordEx(false);	/* ҧá촡 */
			}else{
				hm = genRecord(false);	/* ҧá촡 */
			}
			
			Iterator it = hm.keySet().iterator();
            while (it.hasNext()) {
            	Integer key = (Integer) it.next();
                MyHashMap hmDetail = (MyHashMap) hm.get(key);
                if (hmDetail.get("UPDTYPE").equals("A")) {
					DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Tleave_summary");
					rec.set("DOCID", absent.getString("absentid"));
					rec.set("DOCTYPE", "A");
					rec.set("DATEID", (hmDetail.containsKey("ACTUAL_DATE"))?hmDetail.getString("ACTUAL_DATE"):hmDetail.getString("DT_BG"));
					rec.set("EMPLOYEEID", absent.getString("employeeid"));
					rec.set("TABLE_NAME", "TADJTIME0");
					rec.set("LV_TYPE", absent.getString("type_absent"));	/*  */
					rec.set("LV_BG_DATE", hmDetail.getString("DT_BG"));
					rec.set("LV_EN_DATE", hmDetail.getString("DT_EN"));
					rec.set("LV_BG_TIME", hmDetail.getString("TM_BG"));
					rec.set("LV_EN_TIME", hmDetail.getString("TM_EN"));
					rec.set("HOUR_S", getHour_Day(getTimeCode(this)));
					rec.set("BU1", absent.getString("bu1"));
					rec.set("BU2", absent.getString("bu2"));
					rec.set("BU3", absent.getString("bu3"));
					rec.set("BU4", absent.getString("bu4"));
					rec.set("BU5", absent.getString("bu5"));
					rec.set("BRANCH", absent.getString("branch"));
					rec.set("EMP_POSITION", absent.getString("emp_position"));
					rec.set("EMP_GROUP", absent.getString("emp_group"));
					rec.set("JOBCODE", absent.getString("jobcode"));
					rec.set("COSTCENTER", absent.getString("costcenter"));
					rec.set("SALATYPE", absent.getString("salatype"));
					rec.set("LEAVE_FORMAT", absent.getString("leave_format"));
					rec.set("APPROVE", chknull.chkNullString(absent.getString("approve"),"NULL"));
					
					/* ӹǹ .  */
					/*
					rec.set("M_LV", getHourDAdjust(getTimeCode(this), 
							hmDetail.getString("DT_BG"), 
							hmDetail.getString("DT_EN"), 
							hmDetail.getFloat("TM_BG"), 
							hmDetail.getFloat("TM_EN"))); 	*/
					rec.set("M_LV", hmDetail.getString("LV"));	/* ӹǹ . 㹵͹ genrec ͧӹǳա Ҥ */
					error = rec.save();
                }
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		} finally {
			
		}
	}
	
	/*  time0id ͧѹ  */
	private String getTimeCode(DbRecord absent){
		try {
			Memployee_ta ta = (Memployee_ta)new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE_TA");
			ta.setColumn("*");
			ta.setParam("rsc_skip","true");
			ta.set("employeeid", absent.getString("employeeid"));
			ta.set("companyid", this.userPro.get("companyid"));
			if(ta.search()==1){
				return ta.getDailyTime0id(new CscCalendar(absent.getString("start_date")));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	/* delete data in tleave_summary */
	private boolean deleteExistingAbsent(){
		boolean status = false;
		try {
			String sql = "delete tleave_summary where employeeid = '"+this.getString("employeeid")+"' and dateid between '" + this.getString("start_date") + "' and '" + this.getString("end_date")
				+ "' and lv_type = '" + this.getString("type_absent") + "'";
			
			if(exec(sql)) {
				status = true; 
			}else{
				MyLog.error("!! deleteExistingAbsent failed , query could be incorrect !!");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return status ;
	}
	
	/* update status from import data */
	private void updateStatusAbsent(String stat){
		try {
			this.set("wf_status", stat);
			this.set("remark", this.getString("remark") + "(imp process)");
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private boolean exec(String sql) {
		boolean status = false;
		CscConnection conn = null;
    	Statement stmt = null;
    	boolean autoCommit= true;
    	
    	try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			autoCommit = conn.getAutoCommit();
			conn.setAutoCommit(false);
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);

			stmt = conn.createStatement();
			stmt.execute(sql);
			
			conn.commit();
			
			status = true ;
			
        } catch (Exception e) {
            MyLog.error(this, e);           
        } finally {
    		try{
    			if(stmt != null) stmt.close();
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in executeQuery!!",e);
    		}
        }
        
        return status ;
	}
	
	/* ź͡÷к ͹кѹ֡ŧ */
	private boolean forceDeleteAbsent(){
		try {
			if(!this.del_absentid.equals("")){
				DbRecord db = new InitialRecord(this.userPro).getDbRecord("Tabsent_nstda");
				db.setColumn("*");
				db.set("absentid", this.del_absentid);
				db.set("companyid", this.userPro.get("companyid"));

				if(db.search() == 1){
					db.set("wf_status", "9");	/* 9 : ¡ԡ */
					db.save();
					
					if(this.exc_mode.equalsIgnoreCase("D")){	/* óź͡ Ѻʶҹ¡ԡ͡ ǡ return ͡ ͧѹ֡ҵ */
						return false ;
					}else{		/* óѾഷ лѺʶҹ¡ԡ͡ ǡ save   return true ͡ǹѹ֡һ */
						return true;
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return true ;
	}
	
	/* ѹ֡ͺ§ҹóкʾѡҹ е˹ */
	private boolean saveAutoAssignWF(){
		int stat = 2 ;
		try {
			if(!this.getString("AUTO_ASS_EMPID").equals("")){
				DbRecord db = new InitialRecord(this.userPro).getDbRecord("auto_assign_pos");
				db.setColumn("user_code,position_code,companyid,begin_date,end_date,auto_assign_pos_id,aaid,assign_user_code");
				db.set("user_code", this.getString("employeeid"));
				db.set("position_code", this.getString("emp_position"));
				db.set("companyid", this.getString("companyid"));
				db.set("begin_date", this.getString("start_date"));
				db.set("end_date", this.getString("end_date"));
				db.set("auto_assign_pos_id", "1");
				db.set("aaid", "0");
				db.set("assign_user_code", this.getString("auto_ass_empid"));
				db.set("wf_status", "A"); 	/* ˹ A óա˹ͺ§ҹ */
				stat = db.save() ;
				
				if(stat > -1){
					return true ;	/* save successful */
				}else{
					MyLog.error("Can not assign work for leave doc : " + this.getString("absentid"));
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* óźҵͧźͺ§ҹ */
	private boolean delAutoAssignWF(){
		try {
			if(!this.getString("ass_empid").equals("")){
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("auto_assign_pos");
				inq.setColumn("*");
				inq.setFilter("wf_ref_doc = '" + this.getString("absentid"));
				
				while(inq.next()){
					DbRecord db = inq.getCurrentDbRecord();
					db.delete();
				}
				
				return true;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	/* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		HashMap hmCon = new HashMap();
		hmCon.put("uprofile", this.userPro);
		hmCon.put("employeeid", "transfer");
		hmCon.put("companyid", "100");
		hmCon.put("schemaname", this.userPro.getSchemaName());
		hmCon.put("lang", "THA");
		hmCon.put("appname", "TA");
		//hmCon.put("dbname", this.userPro.get("dbname"));
		hmCon.put("startDate", this.getString("start_date"));
		hmCon.put("endDate", this.getString("end_date"));
		hmCon.put("cmdValue", "transfer");
		hmCon.put("delStatus", "true");
		hmCon.put("employeeBetween", "(employeeid between '"+this.getString("employeeid")+"' and '"+this.getString("employeeid")+"')");

		GenProcessQuque gpq = new GenProcessQuque();
		gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "Tabsent_nstda", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
	}
}//end class
