package com.csc.library.databean;

import com.csc.library.utilities.MyLog;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.service.GenProcessQuque;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.CreateChangeShift;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.ReAdjustAlignment;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;

public class Tchangeshift_nstda extends RecordCmp {
	
	public Tchangeshift_nstda() {
		super("Tchangeshift_nstda", "Tchangeshift_nstda Table");
	}	

	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();				
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			
			if(isCreateTime0Trans()){
				this.manageTime0Trans();	/* ҧἹ÷ӧҹŧ㹵ҧͧѡҹ  (Table Mempl_time0trans) GPF 繵Ẻ */
				saveNewTime0Tran();			/* ǧ¹е */
			}else{	/* standard */
				this.genRecord(true);
			}
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			delTchangeShiftAdjData();
		}	
		 CreateQuque();
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			
			if(isCreateTime0Trans()){
				this.manageTime0Trans();	/* ҧἹ÷ӧҹŧ㹵ҧͧѡҹ  (Table Mempl_time0trans) GPF 繵Ẻ */
				saveNewTime0Tran();			/* ǧ¹е */
			}else{	/* standard */
				this.genRecord(true);
			}
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			delTchangeShiftAdjData();
		}
		 CreateQuque();
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
	}
	
	public MyHashMap getDWRData() {
		return this.genRecord(false);
	}
	
	/* óź¹з źšѾഷἹ駴 */
	private void delTchangeShiftAdjData(){
		try {
			StringBuffer filter = new StringBuffer();
        	filter.append("delete tadjtime0 ");
        	filter.append(" where docid = '").append(this.getString("tchshiftid")).append("' and doctype = 'C'");
        	
        	this.executeQuery(filter.toString());
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* óշѹ֡¹ еͧźš¹Тͧ ͡͹ кִ¹ش (㺷բҡ͹˹Ҩж١źšѾഷἹ ѧ¹е鹩Ѻ */
	private void delDataAdjTime0(){
		try {
			StringBuffer filter = new StringBuffer();
			filter.append("delete tadjtime0 where employeeid = '").append(this.getString("employeeid")).append("' ");
        	filter.append(" and (docid = '").append(this.getString("tchshiftid"));
        	filter.append("' or docdate between '").append(this.getString("start_date")).append("' and '").append(this.getString("end_date")).append("') ");
        	filter.append(" and (doctype = 'C' or doctype = 'CB')");

        	this.executeQuery(filter.toString());
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* method ѹ sql */
	private void executeQuery(String sql) {
		CscConnection conn = null;
    	Statement stmt = null;
    	boolean autoCommit=true;
    	
        try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userPro.get("dbname"));
			autoCommit = conn.getAutoCommit();
			conn.setAutoCommit(false);
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);

			stmt = conn.createStatement();
			stmt.executeUpdate(sql);

			conn.commit();
			
        } catch (Exception e) {
            MyLog.error("!! Error in Tabsent_nstda.delDataTleave_summary !!", e);           
        } finally {
    		try{
    			if(stmt != null) stmt.close();
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in Tchangeshift_nstda.delDataAdjTime0 !!",e);
    		}
        }
	}
	
	private TimeZone getDocTimeZone() {
		TimeZone tz = new TimeZone();
		CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
		CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
		tz.setBeginZone(new CscCalendar(cs1.getYYYYMMDD() + " 00:00:00"));
		tz.setEndZone(new CscCalendar(cs2.getYYYYMMDD() + " 23:59:59"));
		return tz;
	}
	
	/*
	 * ҧš¹
	 */
	private MyHashMap genRecord(boolean isSave) {
		MyHashMap hm = new MyHashMap();
		MyHashMap hmSub = new MyHashMap();
		MyHashMap hmAdd = new MyHashMap();
		MyHashMap hmOldShift = new MyHashMap();
		Vector vAdjustSub = new Vector();
		Vector vAdjustAdd = new Vector();
		try {
            DbRecord dbEMP = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
            dbEMP.setColumn("employeeid,time0,companyid,status,startdate,resigndate");
            dbEMP.setParam("rsc_skip","true");
            dbEMP.set("EMPLOYEEID", this.getString("employeeid"));
            
            if(dbEMP.search() == 1) { // search found
				CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
				CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
				
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", dbEMP.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				if(rec.search() == 1){
					rec.setEmpRec(dbEMP);
					
					WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()), "true");
					if (!ws.isEmpty()) {
						ws.setUProfile(this.userPro);
						ws.adjust();
						ws.setEmployeeid(dbEMP.getString("employeeid"));
						ws.overlapChecking();
						ws.createLink();
						vAdjustSub = ws.genSubShiftTrans(this.getDocTimeZone());
						
						int i=1;
						Iterator it = vAdjustSub.iterator();
						while (it.hasNext()) {
							AdjustResult result = (AdjustResult) it.next();
							
							if  (result.getType().equals("D")) {
								if (isSave) {
									DbRecord recSub = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
									recSub.set("COMPANYID",this.getString("companyid"));
									recSub.set("DOCID",this.getString("tchshiftid"));
									recSub.set("DOCTYPE","C");
									recSub.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
									recSub.set("TM_BG",result.get_DT_BG().getCSCTime());
									recSub.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
									recSub.set("TM_EN",result.get_DT_EN().getCSCTime());
									recSub.set("UPDTYPE",result.getType());
									recSub.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
									recSub.set("EMPLOYEEID",this.getString("employeeid"));
									recSub.set("TIME0ID",result.getTimeCode());
									recSub.set("EVENTGRP", result.getEventGroup().substring(0,1));
									recSub.set("OLDTIME0ID", result.getOldTime0());
									recSub.set("OLDEVENTGRP", result.getOldEventGroup());
									recSub.set("LV_TY",result.get_LV_TY());
									recSub.set("LV","0");
									recSub.set("TR_TYPE",result.getEventGroup()); 
									recSub.set("HOUR_S", result.getHour_s());
									recSub.set("WF_STATUS", this.getString("wf_status"));
									recSub.save();
									
									hmOldShift.put(result.get_DT_BG().getYYYYMMDD(), result.getTimeCode());
								} else {
									MyHashMap hmData = new MyHashMap();
									hmData.put("COMPANYID",this.getString("companyid"));
									hmData.put("DOCID",this.getString("tchshiftid"));
									hmData.put("DOCTYPE","C");
									hmData.put("DT_BG",result.get_DT_BG().getYYYYMMDD());
									hmData.put("TM_BG",result.get_DT_BG().getCSCTime());
									hmData.put("DT_EN",result.get_DT_EN().getYYYYMMDD());
									hmData.put("TM_EN",result.get_DT_EN().getCSCTime());
									hmData.put("UPDTYPE",result.getType());
									hmData.put("DOCDATE",result.getAdjDate().getYYYYMMDD());
									hmData.put("EMPLOYEEID",this.getString("employeeid"));
									hmData.put("TIME0ID",result.getTimeCode());
									hmData.put("EVENTGRP", result.getEventGroup().substring(0,1));
									hmData.put("OLDTIME0ID", result.getOldTime0());
									hmData.put("OLDEVENTGRP", result.getOldEventGroup());
									hmData.put("LV_TY",result.get_LV_TY());
									hmData.put("LV","0");
									hmData.put("TR_TYPE",result.getEventGroup()); 
									hmData.put("HOUR_S", result.getHour_s());
									hmData.put("WF_STATUS", this.getString("wf_status"));
									hmData.put("HOUR_S", result.getHour_s());
									hmSub.put(String.valueOf(i),hmData);
									i++;
									
									hmOldShift.put(result.get_DT_BG().getYYYYMMDD(), result.getTimeCode());
								}
							}
						} //End While Save Sub Transaction 		
					} 
					
					//Start Add Transaction
					Mtime0 recAdd = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					recAdd.set("time0id", this.getString("new_shift"));
					recAdd.set("companyid", this.userPro.get("companyid"));
					recAdd.search();
					recAdd.setEmpRec(dbEMP);
					
					WorkingShift wsAdd = recAdd.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()), "true");
					if (!wsAdd.isEmpty()) {					
						MyLog.debug(this, "<<< WORKINGSHIFT ADD >>>");
						//cs1.incDate(); //cs2.decDate();
						int j=1;
						Iterator it = wsAdd.keySet().iterator();
						while (it.hasNext()) {
							DayShift ds = (DayShift) wsAdd.get(it.next());
							Iterator it2 = ds.keySet().iterator();
							while (it2.hasNext()) {
								Shift sh = (Shift) ds.get(it2.next());
								
								if (sh.getShiftDate().afterEqualsDate(cs1)&&sh.getShiftDate().beforeEqualsDate(cs2)) {							
									MyLog.debug(this, this.getUProfile(), sh.toString());
									if (isSave) {
										DbRecord recAddData = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
										recAddData.set("COMPANYID",this.getString("companyid"));
										recAddData.set("DOCID",this.getString("tchshiftid"));
										recAddData.set("DOCTYPE","C");
										recAddData.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
										recAddData.set("TM_BG", sh.get_c_dt_in().getCSCTime());
										recAddData.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
										recAddData.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
										recAddData.set("UPDTYPE","T");
										recAddData.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
										recAddData.set("EMPLOYEEID",this.getString("employeeid"));
										recAddData.set("TIME0ID", sh.getTimeCode());
										recAddData.set("EVENTGRP", sh.getEventGroup());
										recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
										if (hmOldShift.containsKey(sh.get_c_dt_in().getYYYYMMDD())) {
											recAddData.set("OLDTIME0ID", hmOldShift.getString(sh.get_c_dt_in().getYYYYMMDD()));
										} else recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
										recAddData.set("OLDEVENTGRP", sh.getOldEventGroup());
										recAddData.set("LV_TY",sh.getLV_Type());
										recAddData.set("LV","0");
										recAddData.set("TR_TYPE",sh.getTR_Type());
										recAddData.set("HOUR_S", sh.getHour_s());
										recAddData.set("WF_STATUS", this.getString("wf_status"));
										recAddData.save();
										
									} else {
										MyHashMap hmData = new MyHashMap();
										hmData.put("COMPANYID",this.getString("companyid"));
										hmData.put("DOCID",this.getString("tchshiftid"));
										hmData.put("DOCTYPE","C");
										hmData.put("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
										hmData.put("TM_BG", sh.get_c_dt_in().getCSCTime());
										hmData.put("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
										hmData.put("TM_EN", sh.get_c_dt_out().getCSCTime());								
										hmData.put("UPDTYPE","T");
										hmData.put("DOCDATE", sh.getShiftDate().getYYYYMMDD());
										hmData.put("EMPLOYEEID",this.getString("employeeid"));
										hmData.put("TIME0ID", sh.getTimeCode());
										hmData.put("EVENTGRP", sh.getEventGroup());
										hmData.put("OLDTIME0ID", sh.getOldTimeCode());
										if (hmOldShift.containsKey(sh.get_c_dt_in().getYYYYMMDD())) {
											hmData.put("OLDTIME0ID", hmOldShift.getString(sh.get_c_dt_in().getYYYYMMDD()));
										} else hmData.put("OLDTIME0ID", sh.getOldTimeCode());
										hmData.put("OLDEVENTGRP", sh.getOldEventGroup());
										hmData.put("LV_TY",sh.getLV_Type());
										hmData.put("LV","0");
										hmData.put("TR_TYPE",sh.getTR_Type());
										hmData.put("HOUR_S", sh.getHour_s());
										hmData.put("WF_STATUS", this.getString("wf_status"));
										hmAdd.put(String.valueOf(j),hmData);
										j++;
									}
								}
							}
						} //End WorkingShift Iterator
					} 
				}else{
					MyLog.debug("!! Time0id not found in Tchangeshift_nstda.genRecord() ,process teminate here !! ");
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}

		try {
			Iterator it = vAdjustSub.iterator();
			while (it.hasNext()) {
				AdjustResult result = (AdjustResult) it.next();
				MyLog.debug(this, result.toString());
				
				if (result.getType().equals("D")) {		
					if (isSave) {
						DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
						rec.set("COMPANYID",this.getString("companyid"));
						rec.set("DOCID",this.getString("tchshiftid"));
						rec.set("DOCTYPE","C");
						rec.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
						rec.set("TM_BG",result.get_DT_BG().getCSCTime());
						rec.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
						rec.set("TM_EN",result.get_DT_EN().getCSCTime());
						rec.set("UPDTYPE",result.getType());
						rec.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
						rec.set("EMPLOYEEID",this.getString("employeeid"));
						rec.set("TIME0ID",result.getTimeCode());
						rec.set("EVENTGRP", result.getEventGroup().substring(0,1));
						rec.set("OLDTIME0ID", result.getOldTime0());
						rec.set("OLDEVENTGRP", result.getOldEventGroup());
						rec.set("LV_TY",result.get_LV_TY());
						rec.set("LV","0");
						rec.set("TR_TYPE",result.getEventGroup()); 
						rec.set("HOUR_S", result.getHour_s());
						rec.set("WF_STATUS", this.getString("wf_status"));
						rec.save();
					}
				}
			}		
		} catch (Exception e1) {
			MyLog.error(this, e1);			
		}
		hm.put("HMADD", hmAdd);
		hm.put("HMSUB", hmSub);
		return hm;
	}
	
	private boolean chkForChangeShift() {
		boolean status = true;
		try {
			CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
			CscCalendar cs2 = new CscCalendar(this.getString("end_date"));

			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", " (dt_bg between '"
					+ cs1.getYYYYMMDD() + "' and '" + cs2.getYYYYMMDD()
					+ "') and employeeid='" + this.getString("employeeid") + "' and doctype<>'C'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				status = false;
				break;
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return status;
	}
	
	protected boolean preInsertTrigger() throws Exception {
		return super.preInsertTrigger();	
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result =  super.preUpdateTrigger();	
		
		/* óкҧ¹ ǵͧҧ㹵ҧ Mempl_time0trans 繵ͧź¡÷Ǣͧ͡ */
		if(isCreateTime0Trans()){
			deleteExistTime0Tran();
		}
		
		return result;
	}
	
	protected boolean preDeleteTrigger() throws Exception {
		boolean result =  super.preDeleteTrigger();
		delTchangeShiftAdjData();
		
		/* óкҧ¹ ǵͧҧ㹵ҧ Mempl_time0trans 繵ͧź¡÷Ǣͧ͡ */
		if(isCreateTime0Trans()){
			deleteExistTime0Tran();
		}
		
		return result;
	}
	
	/**
	 * @author PipoXP ҡз㹪ǧѹ˹
	 * @param empCode, start_date, end_date
	 * @return List Shift
	 */
	public String getListShift(String empCode, String start_date, String end_date){
        String shiftid = "";
        try{
            DbRecord inqEmp = new InitialRecord(this.getUProfile()).getDbRecord("MEMPLOYEE");
            inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
            inqEmp.setParam("rsc_skip","true");
            inqEmp.set("employeeid", empCode);
            
            if (inqEmp.search() == 1) {
                Mtime0 rec = (Mtime0) new InitialRecord(this.getUProfile()).getDbRecord("Mtime0");
                rec.set("time0id", inqEmp.getString("time0"));
                rec.set("companyid", this.getUProfile().get("companyid"));
                rec.search();
    
                CscCalendar cs1 = new CscCalendar(start_date);
                CscCalendar cs2 = new CscCalendar(end_date);
                                    
                rec.setEmpRec(inqEmp);
                
                WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
                        new CscCalendar(cs2.getYYYYMMDD()));             
                if (!ws.isEmpty()) {
                    ws.setUProfile(this.getUProfile());
                    ws.setEmployeeid(inqEmp.getString("employeeid"));
                    ws.adjust();
                    ws.overlapChecking();
                    ws.createLink();
                    int i= 0;
                    
                    Iterator it = (Iterator) ws.keySet().iterator(); 
                    if (it.hasNext()) {
                        i++;
                        DayShift ds = (DayShift) ws.get(it.next());
                        int ds_size = ds.size();
                        Iterator it_ds = (Iterator) ds.keySet().iterator();
                        if (it_ds.hasNext()) {
                            Shift sh = (Shift) ds.get((String) it_ds.next());
                            if(sh!=null){
                                shiftid += sh.getTimeCode() + ",";
                            }
                        }
                    }      
                }
            } 
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return shiftid;	    
	}
	
	   /**
     * @author PipoXP ҡз㹪ǧѹ˹
     * @param empCode, start_date, end_date
     * @return List Shift
     */
    public String getListShiftAll(String empCode, String start_date, String end_date){
        String shiftid = "";
        try{
            DbRecord inqEmp = new InitialRecord(this.getUProfile()).getDbRecord("MEMPLOYEE");
            inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
            inqEmp.setParam("rsc_skip","true");
            inqEmp.set("employeeid", empCode);
            
            if (inqEmp.search() == 1) {
                Mtime0 rec = (Mtime0) new InitialRecord(this.getUProfile()).getDbRecord("Mtime0");
                rec.set("time0id", inqEmp.getString("time0"));
                rec.set("companyid", this.getUProfile().get("companyid"));
                rec.search();
    
                CscCalendar cs1 = new CscCalendar(start_date);
                CscCalendar cs2 = new CscCalendar(end_date);
                                    
                rec.setEmpRec(inqEmp);
                
                WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()),"true");             
                if (!ws.isEmpty()) {
                    ws.setUProfile(this.getUProfile());
                    ws.setEmployeeid(inqEmp.getString("employeeid"));
                    ws.adjust();
                    ws.overlapChecking();
                    ws.createLink();
                    int i= 0;
                    
                    Iterator it = (Iterator) ws.keySet().iterator(); 
                    if (it.hasNext()) {
                        i++;
                        DayShift ds = (DayShift) ws.get(it.next());
                        int ds_size = ds.size();
                        Iterator it_ds = (Iterator) ds.keySet().iterator();
                        if (it_ds.hasNext()) {
                            Shift sh = (Shift) ds.get((String) it_ds.next());
                            if(sh!=null){
                                shiftid += sh.getTimeCode() + ",";
                            }
                        }
                    }      
                }
            } 
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return shiftid;     
    }
    
    /*
     * Ǩͺѹ¹ ѹش
     */
	public boolean chkIsHoliday(String empCode, String date){
        boolean isHoliday = true;
        try{
            DbRecord inqEmp = new InitialRecord(this.getUProfile()).getDbRecord("MEMPLOYEE");
            inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
            inqEmp.setParam("rsc_skip","true");
            inqEmp.set("employeeid", empCode);
            
            if (inqEmp.search() == 1) {
                Mtime0 rec = (Mtime0) new InitialRecord(this.getUProfile()).getDbRecord("Mtime0");
                rec.set("time0id", inqEmp.getString("time0"));
                rec.set("companyid", this.getUProfile().get("companyid"));
                
                if(rec.search()==1){
                    CscCalendar cs1 = new CscCalendar(date);
	                                    
	                rec.setEmpRec(inqEmp);
	                WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs1.getYYYYMMDD()));             
	                if (!ws.isEmpty()) {
	                    ws.setUProfile(this.getUProfile());
	                    ws.setEmployeeid(inqEmp.getString("employeeid"));
	                    ws.adjust();
	                    ws.overlapChecking();
	                    ws.createLink();
	                    int i= 0;
	                    
	                    Iterator it = (Iterator) ws.keySet().iterator(); 
	                    if (it.hasNext()) {
	                        i++;
	                        DayShift ds = (DayShift) ws.get(it.next());
	                        if(!ds.isEmpty()){
	                            isHoliday = false;
	                        }
	                    }      
	                }
                }else{
                	MyLog.debug("!! Error : time0id not found in Tchangeshift_nstda.chkIsHoliday !!");
                }
            }
        } catch (Exception e) {
            MyLog.error(this, e);           
        }
        return isHoliday;     
    }
	
	/* ҧŧ㹷¹ */
	private void manageTime0Trans(){
		try {
			CscCalendar st = this.getCscCalendar("start_date");
			CscCalendar en = this.getCscCalendar("end_date");
			
			String selectSQL = "(START_DATE BETWEEN '" + st.getYYYYMMDD() + "' and '" + en.getYYYYMMDD() + "' or ";
			selectSQL += "END_DATE BETWEEN '" + st.getYYYYMMDD() + "' and '" + en.getYYYYMMDD() + "')";
			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("Mempl_time0trans");
			inq.setColumn("*");
			inq.setFilter(selectSQL);
			inq.setOrderBy("start_date");
			inq.refresh();
			
			while(inq.next()){
				DbRecord db = inq.getCurrentDbRecord().cloneRecord(true);
				
				adjTime0TransData(db);	/* ҡ¹¡÷Ѻѹ ͧѴǧ */
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ѹ֡ǧ¹Ъǧش */
	private void saveNewTime0Tran(){
		try {
			DbRecord ndb = new InitialRecord(this.userPro).getDbRecord("Mempl_time0trans");
			ndb.setColumn("*");
			ndb.set("employeeid", this.getString("employeeid"));
			ndb.set("start_date", this.getString("start_date"));
			ndb.set("end_date", this.getString("end_date"));
			ndb.set("time0id", this.getString("new_shift"));
			ndb.set("wf_ref_doc", this.getString("tchshiftid"));
			ndb.save();
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* źǧ¹Сóź¹Шҡѧҹ */
	private void deleteExistTime0Tran(){
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("Mempl_time0trans");
			inq.setColumn("*");
			inq.setFilter("wf_ref_doc = '" + this.getString("tchshiftid") + "'");
			inq.refresh();
			
			while(inq.next()){
				DbRecord db = inq.getCurrentDbRecord().cloneRecord(true);
				db.delete();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ֧ǧҷ¹ЫӡѹҨѴ  */
	private void adjTime0TransData(DbRecord db){
		DbRecord newdb = null;
		try {
			newdb = db.cloneRecord(true);
			
			if(this.getCscCalendar("start_date").afterDate(db.getCscCalendar("start_date"))
					&& this.getCscCalendar("start_date").beforeDate(db.getCscCalendar("end_date")) 
					&& this.getCscCalendar("end_date").afterDate(db.getCscCalendar("end_date")) ){	/* 鹡 ҧ  شѧ */
				CscCalendar tmp = new CscCalendar(this.getCscCalendar("start_date").getYYYYMMDD());
				tmp.decDate();
				
				/*  */
				newdb.set("end_date", tmp.getYYYYMMDD());
				newdb.save();
				
				/* źͧ */
				db.delete();
			}else if(this.getCscCalendar("start_date").beforeDate(db.getCscCalendar("start_date"))
					&& this.getCscCalendar("end_date").afterDate(db.getCscCalendar("start_date"))
					&& this.getCscCalendar("end_date").beforeDate(db.getCscCalendar("end_date"))){	/* ͹ شҧ  */
				
				CscCalendar tmp = new CscCalendar(this.getCscCalendar("end_date").getYYYYMMDD());
				tmp.incDate();
				
				/*  */
				newdb.set("start_date", tmp.getYYYYMMDD());
				newdb.save();
				
				/* źͧ */
				db.delete();
			}else if(this.getCscCalendar("start_date").beforeEqualsDate(db.getCscCalendar("start_date"))
					&& this.getCscCalendar("end_date").afterEqualsDate(db.getCscCalendar("end_date"))){ /* ǧ¹شͧ źͧ */
				db.delete();
			}else if(this.getCscCalendar("start_date").afterDate(db.getCscCalendar("start_date"))
					&& this.getCscCalendar("end_date").beforeDate(db.getCscCalendar("end_date"))){	/* ǧ¹شҧ */
				CscCalendar tmp_st = new CscCalendar(this.getCscCalendar("start_date").getYYYYMMDD());
				tmp_st.decDate();
				
				CscCalendar tmp_en = new CscCalendar(this.getCscCalendar("end_date").getYYYYMMDD());
				tmp_en.incDate();
				
				DbRecord sec = db.cloneRecord(true);
				
				/* Ҫǧá */
				db.set("end_date", tmp_st.getYYYYMMDD());
				db.save();
				
				/* Ҫǧѧ (ա˹á ͨҡǧ¹лѨغѹ )*/
				sec.set("start_date", tmp_en.getYYYYMMDD());
				sec.save();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private boolean isCreateTime0Trans(){
		try {
			String status = (String) StaticConfig.getConfigCompany(this.userPro, "TATM0TRS");
			if(status.equals("Y")){
				return true ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	/* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		HashMap hmCon = new HashMap();
		hmCon.put("uprofile", this.userPro);
		hmCon.put("employeeid", "transfer");
		hmCon.put("companyid", "100");
		hmCon.put("schemaname", this.userPro.getSchemaName());
		hmCon.put("lang", "THA");
		hmCon.put("appname", "TA");
		//hmCon.put("dbname", this.userPro.get("dbname"));
		hmCon.put("startDate", this.getString("start_date"));
		hmCon.put("endDate", this.getString("end_date"));
		hmCon.put("cmdValue", "transfer");
		hmCon.put("delStatus", "true");
		hmCon.put("employeeBetween", "(employeeid between '"+this.getString("employeeid")+"' and '"+this.getString("employeeid")+"')");

		GenProcessQuque gpq = new GenProcessQuque();
		gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "Tabsent_nstda", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
	}	
}
