package com.csc.library.databean;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.service.GenProcessQuque;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.ManageAdjustLeave;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.SwipeData;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.TimeResult;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

public class Tchholiday extends RecordCmp {
	
	private DbInquiry inqEmp = null;
	private MyTreeMap hmResult_Add = new MyTreeMap();
	private MyTreeMap hmResult_Sub = new MyTreeMap();

	public Tchholiday() {
		super("Tchholiday", "Tchholiday Table");
	}
	
	private void setEmployeeDetail(){
		try {
            DbRecord dbEMP = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
            dbEMP.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, salatype, workarea,  emp_position, emp_group, companyid");	
            dbEMP.setParam("rsc_skip","true");
            dbEMP.set("employeeid", this.getString("employeeid"));
            
            if(dbEMP.search() == 1) { // search found
				this.set("bu1", dbEMP.getString("bu1"));
				this.set("bu2", dbEMP.getString("bu2"));
				this.set("bu3", dbEMP.getString("bu3"));
				this.set("bu4", dbEMP.getString("bu4"));
				this.set("bu5", dbEMP.getString("bu5"));
				this.set("job", dbEMP.getString("job"));
				this.set("emp_group", dbEMP.getString("emp_group"));
				this.set("emp_position", dbEMP.getString("emp_position"));
				this.set("branch", dbEMP.getString("branch"));
				this.set("bossid", dbEMP.getString("bossid"));
				this.set("salatype", dbEMP.getString("salatype"));
				this.set("workarea", dbEMP.getString("workarea"));			
			}else{
				MyLog.error("!! employee not found !!");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		if (chkForChangeHoliday() == false) {
			this.param.put("error_msg",	"error : can not swap working day and holiday on those request date");
			this.saveStatus = 99;
			return false;
		} 
		
		boolean result = super.preInsertTrigger();	
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}			
						
		return result;
	}

	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		this.param.put("error_msg", "No Error");	
 
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.setEmployeeDetail();
		} 
		return result;

	}

	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();		
		CreateQuque();
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();		
		CreateQuque();
	}	
	
	protected void postDeleteTrigger() throws Exception {
		super.postDeleteTrigger();
		CreateQuque();
	}

	/* Ǩͺѹͧ¹ѹش ѹӧҹ */
	public boolean chkForChangeHoliday() {
		try {
			if(isHoliday(this) && isWorking(this)){
				return true;
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return false;
	}
	
	/* Ǩͺ ѹ¹繷ӧҹ ѹش */
	private boolean isHoliday(DbRecord chholiday){
		try {
			DbRecord dbEmp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			dbEmp.setColumn("*");	
			dbEmp.setParam("rsc_skip","true");
			dbEmp.set("employeeid", this.getString("employeeid"));
            if(dbEmp.search() == 1){
           	
            	Mtime0 dbTime0 = (Mtime0) new InitialRecord(this.userPro).getDbRecord("MTIME0");
            	dbTime0.setColumn("*");	
            	dbTime0.set("time0id", dbEmp.getString("time0"));
            	dbTime0.set("companyid", dbEmp.getString("companyid"));
    			
    			if(dbTime0.search() == 1){
    				CscCalendar cs1 = new CscCalendar(chholiday.getString("change_date2"));	/* Ŵ change_date1 ѹͧӧҹ еͧâ¹ */
 	                
 	                //ҧἹ 
    				dbTime0.setEmpRec(dbEmp);
 	                WorkingShift ws = dbTime0.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs1.getYYYYMMDD()), "true");             
 	                if (!ws.isEmpty()) {
 	                    ws.setUProfile(this.userPro);
 	                    ws.setEmployeeid(dbEmp.getString("employeeid"));
 	                    ws.adjust();	/* ἹѺ੾¹ š  */
 	                    ws.overlapChecking();
 	                    ws.createLink();  
 	                    
 	                    /* ҧἹ ֧ѹش */
 	                    DayShift ds = (DayShift) ws.get(cs1.getYYYYMMDD());
 	                    Iterator it_ds = (Iterator) ds.keySet().iterator();
 	                    if (it_ds.hasNext()) {
 	                    	Shift sh = (Shift) ds.get(it_ds.next());
 	                    	if(sh.getEventGroup().equals("H") || sh.getEventGroup().equals("I")){
 	                    		return true;
 	                    	}
 	                    }
 	                }
    			}
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* Ǩͺѹ  ѹӧҹ */
	private boolean isWorking(DbRecord chholiday){
		try {
			DbRecord dbEmp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			dbEmp.setColumn("*");	
			dbEmp.setParam("rsc_skip","true");
			dbEmp.set("employeeid", this.getString("employeeid"));
            if(dbEmp.search() == 1){
           	
            	Mtime0 dbTime0 = (Mtime0) new InitialRecord(this.userPro).getDbRecord("MTIME0");
            	dbTime0.setColumn("*");	
            	dbTime0.set("time0id", dbEmp.getString("time0"));
            	dbTime0.set("companyid", dbEmp.getString("companyid"));
    			
    			if(dbTime0.search() == 1){
    				CscCalendar cs1 = new CscCalendar(chholiday.getString("change_date1")); /* Ŵ change_date2 ѹش ͧ¹ѹӧҹ */
 	                
 	                //ҧἹ 
    				dbTime0.setEmpRec(dbEmp);
 	                WorkingShift ws = dbTime0.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs1.getYYYYMMDD()), "true");             
 	                if (!ws.isEmpty()) {
 	                    ws.setUProfile(this.userPro);
 	                    ws.setEmployeeid(dbEmp.getString("employeeid"));
 	                    ws.adjust();	/* ἹѺ੾¹ š  */
 	                    ws.overlapChecking();
 	                    ws.createLink();  
 	                    
 	                    /* һѺἹ */
 	                    ManageAdjustLeave mal = new ManageAdjustLeave(this.userPro);
 	                    ws.adjustDocument(mal.getAdjustLeaveData(ws, dbEmp, dbTime0), this.userPro);
 	                    
 	                    /* ҧἹ ֧ѹӧҹ */
 	                    DayShift ds = (DayShift) ws.get(cs1.getYYYYMMDD());
 	                    Iterator it_ds = (Iterator) ds.keySet().iterator();
 	                    if (it_ds.hasNext()) {
 	                    	Shift sh = (Shift) ds.get(it_ds.next());
 	                    	if(sh.getEventGroup().equals("T") || sh.getEventGroup().equals("O")){
 	                    		return true;
 	                    	}
 	                    }
 	                }
    			}
            }
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	private TimeZone getDocTimeZone(Shift shCheck) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(shCheck.get_c_dt_in().getYYYYMMDD());
		CscCalendar cs2 = new CscCalendar(shCheck.get_c_dt_out().getYYYYMMDD());		
		try {
			cs1.setCSCTime(shCheck.get_c_dt_in().getCSCTime());
			cs2.setCSCTime(shCheck.get_c_dt_out().getCSCTime());
		} catch (Exception e) {
			e.printStackTrace();
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		System.out.println(">>> RESULT TIMEZONE="+tz);
		return tz;
	}
	/* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		HashMap hmCon = new HashMap();
		hmCon.put("uprofile", this.userPro);
		hmCon.put("employeeid", "transfer");
		hmCon.put("companyid", "100");
		hmCon.put("schemaname", this.userPro.getSchemaName());
		hmCon.put("lang", "THA");
		hmCon.put("appname", "TA");
		//hmCon.put("dbname", this.userPro.get("dbname"));
		hmCon.put("startDate", this.getString("change_date2"));
		hmCon.put("endDate", this.getString("change_date1"));
		hmCon.put("cmdValue", "transfer");
		hmCon.put("delStatus", "true");
		hmCon.put("employeeBetween", "(employeeid between '"+this.getString("employeeid")+"' and '"+this.getString("employeeid")+"')");

		GenProcessQuque gpq = new GenProcessQuque();
		gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "Tabsent_nstda", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
	}
	
	/*
	 * Time   adjust Ẻ ѧ dwr ҧǷ call  method  ͹  build library 
	 * ͧ仵Ǩͺ˹Ҩ˹ҹѹ ͧ任Ѻ  clear method 
	 * By Tong_Zuu 02-03-2015
	 * 
	 * */
	public boolean chkIsWorkingInHoliday(String empid,String date){
    	boolean result = false;
    	try{
	        DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
            inqEmp.setSchemaName(this.userPro.getSchemaName());
            inqEmp.initMyTable("Memployee", "employeeid='"  + empid + "'", "");
            inqEmp.setColumn("employeeid, time0,companyid, status, startdate, resigndate");
            inqEmp.refresh();
            while (inqEmp.next()) {
                Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
                rec.set("time0id", inqEmp.getString("time0"));
                rec.set("companyid", this.userPro.get("companyid"));
                rec.search();
                
                rec.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));

                CscCalendar cs1 = new CscCalendar(date);
                CscCalendar cs2 = new CscCalendar(date);

                WorkingShift wstmp = rec.genWorkingShift(new CscCalendar(cs1.getTimestamp()), new CscCalendar(cs2.getTimestamp()), "true");	//ѹش
                
                cs1.setCSCTime(0.0f);
                cs2.setCSCTime(23.59f);
                
                SwipeData SD = new SwipeData();
                SD.setUProfile(this.userPro);
                Vector v = SD.loadDataToVector(inqEmp.getString("employeeid"), cs1, cs2); 
                
                //Ἱ÷ӧҹͧǧҡ÷ӧҹ ( -)
            	if (!wstmp.isEmpty()) {      
            		wstmp.setUProfile(this.userPro);
                    wstmp.setEmployeeid(inqEmp.getString("employeeid"));
                    wstmp.setEmpTimeCode(inqEmp.getString("time0"));
                    wstmp.adjust();                
                    
                    wstmp.createLink();                
                    SwipeData SD1 = new SwipeData();
                    SD1.setUProfile(this.userPro);
                    SD1.setSwipeTime(v);
                    
                    wstmp.genTimeZone();
                    wstmp.setSwipeTrans(SD1);                
                    wstmp.findTime(cs1, cs2);
            	}
            	
            	for (Iterator<?> IT = wstmp.keySet().iterator(); IT.hasNext();) {    
                    String key = (String) IT.next();
                    DayShift dShift = (DayShift) wstmp.get(key);
                    dShift.findHolidaySwipe();
                    dShift.genProcessResult();
                	HashMap errorDayShiftResult = dShift.getErrorResult();
                    for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {   
                    	String key1 = (String) IT1.next();
                        TimeResult tr = (TimeResult) dShift.get(key1);
                    	
                        if (errorDayShiftResult!=null && !errorDayShiftResult.isEmpty() && errorDayShiftResult.containsKey("11")) {
    	                	if (tr.getResultTR_Type().indexOf("A")>-1 || tr.getResultTR_Type().indexOf("H")>-1 || tr.getResultTR_Type().indexOf("I")>-1) {
    	                		if (dShift.getSwipeHoliday().size()>0) {	                            			
    	                			for (int j=0;j<dShift.getSwipeHoliday().size();j++) {
    	                				result = true;
    	                			}
    	                		} 	                            		
    	            		}
    	                } //աٴѵѹش
                    }
            	}
            }
    	} catch (Exception e) {
			MyLog.error(this, e);		
		}
    	return result;
    }
}
