package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.database.ChildManager;
import java.util.Enumeration;
import com.csc.library.approve.Organization;


public class Tchshift0 extends RecordCmp {
	
	Vector vt = new Vector();
	DbTable dbChild=null;
	
	public Tchshift0() {
		super("Tchshift0", "Tchshift0 Table");
	}
	
	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TCHSHIFT0");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("shiftid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	private boolean chkForExchangeShift() {
		boolean status = true;
		try {
			DbTable dt;					
			if (this.getChild("Tchshift1")!=null) {
				dt = (DbTable) this.getChild("Tchshift1");			
			} else {
				DbTable db = new InitialTable(this.userPro).getDbTable("Tchshift1");
				db.setColumn("*");
				this.putChild(db);
				this.refreshChild();
				dt = (DbTable) this.getChild("Tchshift1");	
			}					
			dt.first();
			while (!dt.eof()) {
				DbRecord rec = dt.getCurrentRecordManager();
				CscCalendar cs1 = new CscCalendar(rec.getString("start_date"));
				CscCalendar cs2 = new CscCalendar(rec.getString("end_date"));
				String emp = rec.getString("employeeid");

				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tadjtime0", " (dt_bg between '"
						+ cs1.getYYYYMMDD() + "' and '" + cs2.getYYYYMMDD()
						+ "') and employeeid='" + emp + "'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					HashMap tmp = new HashMap();
					tmp.put("empid", emp);
					tmp.put("docid", inq.getString("docid"));
					tmp.put("dt_bg", inq.getString("dt_bg"));
					tmp.put("tm_bg", inq.getString("tm_bg"));
					tmp.put("tm_en", inq.getString("tm_en"));
					vt.addElement(tmp);
					status = false;
				}
				dt.next();
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return status;
	}

	protected boolean preInsertTrigger() throws Exception {
		MyLog.debug(this, "******** PRE INSERT TCHSHIFT0 ********");
		/*
		if (this.chkForExchangeShift() == false) {			
			this.param.put("error_msg",	"Error Because This Day is Request Leave or OT");
			MyLog.debug(this, "NOT CHANGESHIFT !!!");
			this.saveStatus = 99;
			return false;
		} else {
			
		}*/
		boolean result = super.preInsertTrigger();	
		removeExistChild();	/* delete exist child */
		
		this.param.put("error_msg", "No Error");	
		if (this.param.containsKey("__oldWF")) {
			if (((String) this.param.get("__oldWF")).equals("7")) {
				this.updateReturnDocument();
			}
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("") || this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}

	protected boolean preUpdateTrigger() throws Exception {
		MyLog.debug(this, "******** PRE UPDATE TCHSHIFT0 ********");
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6") || 
				this.getString("wf_status").equalsIgnoreCase("")) {
			this.delDataAdjTime0();
		}
		
		/*
		if (this.chkForExchangeShift() == false) {
			this.param.put("error_msg",	"Error Because This Day is Request Leave or OT");
			MyLog.debug(this, "NOT CHANGESHIFT !!!");
			this.saveStatus = 99;
			return false;
		} else {
			
		}*/
		boolean result = super.preUpdateTrigger();	
		removeExistChild(); /* delete exist child before save updated record */
		this.param.put("error_msg", "No Error");			
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
		if (this.getString("wf_status").equalsIgnoreCase("8") || 
				this.getString("wf_status").equalsIgnoreCase("7") || 
				this.getString("wf_status").equalsIgnoreCase("B")) {			
			this.setColumn(this.getListKey()+",wf_status");
		}		
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}

	public String getString(String field) {
		if (field.equalsIgnoreCase("error_msg")) {
			return this.param.get("error_msg").toString();
		} else {
			return super.getString(field);
		}
	}

	protected void postInsertTrigger() throws Exception {		
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
		
	}

	protected void postUpdateTrigger() throws Exception {		
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}	
	
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}

	private void delDataAdjTime0() {
		try {
			/*
			DbTable dt;					
			if (this.getChild("Tchshift1")!=null) {
				dt = (DbTable) this.getChild("Tchshift1");			
			} else {
				dt = new InitialTable(this.userPro).getDbTable("Tchshift1");
				dt.setColumn("*");
				this.putChild(dt);
				this.refreshChild();
			}			
			dt.first();
			while (!dt.eof()) {
				DbRecord rec = dt.getCurrentRecordManager();
				CscCalendar cs1 = new CscCalendar(rec.getString("start_date"));
				CscCalendar cs2 = new CscCalendar(rec.getString("end_date"));
				String emp = rec.getString("employeeid");

				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tadjtime0", "docid='" + this.getString("shiftid")
						+ "' and doctype='F' and (dt_bg between '"
						+ cs1.getYYYYMMDD() + "' and '" + cs2.getYYYYMMDD()
						+ "') and employeeid='" + emp + "'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					DbRecord recChild = inq.getCurrentDbRecord().cloneRecord(true);
					recChild.delete();
				}
				dt.next();
			}*/
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", "docid='" + this.getString("shiftid") + "' and doctype = 'CB'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord recChild = inq.getCurrentDbRecord().cloneRecord(true);
				recChild.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}

	private void genRecord() {
		try {
			Vector vAdjustSub = new Vector();
			Vector vAdjustAdd = new Vector();
			
			DbTable dt;					
			if (this.getChild("Tchshift1")!=null) {
				dt = (DbTable) this.getChild("Tchshift1");			
			} else {
				dt = new InitialTable(this.userPro).getDbTable("Tchshift1");
				dt.setColumn("*");
				this.putChild(dt);
				this.refreshChild();
			}			
			dt.first();
			while (!dt.eof()) {
				Tchshift1 db = (Tchshift1) dt.getCurrentRecordManager();
								
				DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				inqEmp.setParam(this.param);
				inqEmp.setSchemaName(this.userPro.getSchemaName());
				inqEmp.initMyTable("Memployee", "employeeid='" + db.getString("employeeid") + "'", "");
				inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
				inqEmp.refresh();
				while (inqEmp.next()) {
					
					CscCalendar cs1 = new CscCalendar(db.getString("start_date"));
					cs1.decDate();
					CscCalendar cs2 = new CscCalendar(db.getString("end_date"));
					cs2.incDate();
					
					//Start Sub Transaction
					Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					rec.set("time0id", inqEmp.getString("time0"));
					rec.set("companyid", this.userPro.get("companyid"));
					rec.search();
					
					rec.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
					MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
									+ cs1.getYYYYMMDD() + ", end_date=" + cs2.getYYYYMMDD());
					WorkingShift ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()),"true");
					if (!ws.isEmpty()) {
						MyLog.debug(this, "<<< WORKINGSHIFT OLD >>>");
						MyLog.debug(this, this.getUProfile(), ws.toString());					
						ws.setUProfile(this.userPro);
						ws.adjust();
						ws.setEmployeeid(inqEmp.getString("employeeid"));
						ws.overlapChecking();
						ws.createLink();
						Iterator itTime = db.getDocAllTimeZone().keySet().iterator();
						while (itTime.hasNext()) {
							String key = (String) itTime.next();
							TimeZone tz =  (TimeZone) db.getDocAllTimeZone().get(key);
														
							Vector vAdjust = ws.genSubShiftTrans(tz);

							MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
							Iterator it = vAdjust.iterator();
							MyLog.debug(this, "Transaction");
							while (it.hasNext()) {
								AdjustResult result = (AdjustResult) it.next();
								MyLog.debug(this, result.toString());
								if  (result.getType().equals("D")) {				
									DbRecord recSub = new InitialRecord(this.userPro).getDbRecord("Tadjtime0");								
									recSub.set("COMPANYID",this.getString("companyid"));
									recSub.set("DOCID",this.getString("shiftid"));
									recSub.set("DOCTYPE","CB");
									recSub.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
									recSub.set("TM_BG",result.get_DT_BG().getCSCTime());
									recSub.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
									recSub.set("TM_EN",result.get_DT_EN().getCSCTime());									
									recSub.set("UPDTYPE",result.getType());									
									recSub.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
									recSub.set("EMPLOYEEID", db.getString("employeeid"));
									recSub.set("TIME0ID", result.getTimeCode());
									recSub.set("EVENTGRP", result.getEventGroup().substring(0,1));
									recSub.set("OLDTIME0ID", result.getOldTime0());
									recSub.set("OLDEVENTGRP", result.getOldEventGroup());
									recSub.set("LV_TY",result.get_LV_TY());
									recSub.set("LV",result.get_LV());
									recSub.set("TR_TYPE",result.getEventGroup()); 
									recSub.set("HOUR_S", result.getHour_s());
									recSub.save();
								}
							}
						}
					}
					
					//Start Add Transaction
					Mtime0 recAdd = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					recAdd.set("time0id", db.getString("shift_new"));
					recAdd.set("companyid", this.userPro.get("companyid"));
					recAdd.search();
					recAdd.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
					MyLog.debug(this, ">>>>>> DATE TO PROCESS >>>>>> start_date="
									+ cs1.getYYYYMMDD() + ", end_date="	+ cs2.getYYYYMMDD());
					WorkingShift wsAdd = recAdd.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()),"true");
					MyLog.debug(this, "WORKINGSHIFT="+wsAdd);
					if (!wsAdd.isEmpty()) {					
						MyLog.debug(this, "<<< WORKINGSHIFT ADD >>>");
						cs1.incDate(); //cs2.decDate();
						Iterator it = wsAdd.keySet().iterator();
						while (it.hasNext()) {
							DayShift ds = (DayShift) wsAdd.get(it.next());
							Iterator it2 = ds.keySet().iterator();
							while (it2.hasNext()) {
								Shift sh = (Shift) ds.get(it2.next());
								if (sh.getShiftDate().afterEquals(cs1)&&sh.getShiftDate().beforeEquals(cs2)) {							
									MyLog.debug(this, this.getUProfile(),  sh.toString());
									DbRecord recAddData = new InitialRecord(this.userPro).getDbRecord("TadjTime0");								
									recAddData.set("COMPANYID",this.getString("companyid"));
									recAddData.set("DOCID",this.getString("shiftid"));
									recAddData.set("DOCTYPE","CB");
									recAddData.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									recAddData.set("TM_BG", sh.get_c_dt_in().getCSCTime());
									recAddData.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									recAddData.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
									recAddData.set("UPDTYPE","T");
									recAddData.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									recAddData.set("EMPLOYEEID",db.getString("employeeid"));
									recAddData.set("TIME0ID", sh.getTimeCode());
									recAddData.set("EVENTGRP", sh.getEventGroup());
									recAddData.set("OLDTIME0ID", sh.getOldTimeCode());
									recAddData.set("OLDEVENTGRP", sh.getOldEventGroup());
									recAddData.set("LV_TY",sh.getLV_Type());
									recAddData.set("LV",sh.getLv());
									recAddData.set("TR_TYPE",sh.getTR_Type());
									recAddData.set("HOUR_S", sh.getHour_s());
									recAddData.save();
								}
							}
						}
					}
					//this.genRecordDetail(db, inqEmp, "SUB");
					//this.genRecordDetail(db, inqEmp, "ADD");
				}
				dt.next();
			}
		} catch (Exception e) {
			MyLog.error(this, e);

						
		}	
	}

	public int putChild(ChildManager oChild) {
		int point = super.putChild(oChild);
		try {
			if ((oChild instanceof DbTable) && (oChild.getTableName().equalsIgnoreCase("TCHSHIFT1"))) {
				DbTable dbTable = (DbTable) oChild;
				String empid = (String) this.getUProfile().get("actor");
				Organization org = (Organization) new InitialRecord(this.userPro, this.param).getDbRecord("Masfactor");
				org.setDaTaResult("Torgani", "bossid,employeeid,companyid,runno");
				org.setSub("1", "employeeid", "bossid", empid);
				Vector subOrdi = org.getSub();
				long keyis = System.currentTimeMillis();
				for (Enumeration e = subOrdi.elements(); e.hasMoreElements();) {
					DbRecord rec = dbTable.getNewRecord();
					DbRecord subBean = (DbRecord) e.nextElement();
					rec.set("shiftid", "SH" + keyis);
					rec.set("employeeid", subBean.getString("employeeid"));
					rec.set("companyid", this.getUProfile().get("companyid"));
					rec.set("shift_old", subBean.getString("time0"));
					MyLog.debug(this, " ::::: CHANGE TIME TIME TO MTIME :::::"	+ subBean.getString("time0"));
					dbTable.putNewRecord(rec);
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);

			
		}
		return point;
	}

	private void updateWFChild(String wf) {
		try {
			if (this.getChild("Tchshift1")!=null) {
				DbTable db = (DbTable) this.getChild("Tchshift1");
				db.first();
				do{				
					DbRecord rec = (DbRecord) db.getCurrentRecordManager();				
					rec.set("WF_STATUS",wf);
					db.next();				
				} while (!db.eof());		
				//db.save();
			} else {			
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tchshift1","", "");
				inq.setColumn("SHIFTID, COMPANYID, EMPLOYEEID, WF_STATUS");			
				this.putChild(inq);
				this.refreshChild();
				DbInquiry inqChild = (DbInquiry) this.getChild("Tchshift1");
				while (inqChild.next()) {
					DbRecord rec = inqChild.getCurrentDbRecord().cloneRecord(true);
					rec.set("wf_status",wf);
					rec.save();
				}
				this.removeChild("Tchshift1");
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}
	
	/*private void genRecordDetail(Tchshift1 ch, DbInquiry inqEmp, String status) {
		try {
			Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
			if (status.equals("SUB")) {
				recTime.set("time0id", ch.getString("shift_old"));
			} else if (status.equals("ADD")) {
				recTime.set("time0id", ch.getString("shift_new"));
			}
			recTime.set("companyid", this.userPro.get("companyid"));
			recTime.search();
			CscCalendar cs1 = new CscCalendar(ch.getString("start_date"));
			cs1.decDate();
			CscCalendar cs2 = new CscCalendar(ch.getString("end_date"));
			cs2.incDate();
			recTime.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
			WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
					new CscCalendar(cs2.getYYYYMMDD()));
			if (!ws.isEmpty()) {						
				ws.setUProfile(this.userPro);
				ws.setEmployeeid(inqEmp.getString("employeeid"));
				ws.adjust();
				ws.overlapChecking();
				ws.createLink();
				Iterator itTime = ch.getDocAllTimeZone().keySet().iterator();
				while (itTime.hasNext()) {
					String key = (String) itTime.next();
					TimeZone tz =  (TimeZone) ch.getDocAllTimeZone().get(key);
												
					Vector vAdjust = ws.genSubShiftTrans(tz);

					MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
					Iterator it = vAdjust.iterator();
					MyLog.debug(this, "Transaction");
					while (it.hasNext()) {
						AdjustResult result = (AdjustResult) it.next();
						MyLog.debug(this, result.toString());
						if  (result.getType().equals("D")) {				
							DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Tadjtime0");								
							rec.set("COMPANYID",this.getString("companyid"));
							rec.set("DOCID",this.getString("shiftid"));
							rec.set("DOCTYPE","F");
							rec.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
							rec.set("TM_BG",result.get_DT_BG().getCSCTime());
							rec.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
							rec.set("TM_EN",result.get_DT_EN().getCSCTime());
							if (status.equals("SUB")) {
								rec.set("UPDTYPE",result.getType());
							} else if (status.equals("ADD")) {
								rec.set("UPDTYPE","T");
							}
							rec.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
							rec.set("EMPLOYEEID", ch.getString("employeeid"));
							rec.set("TIME0ID", result.getTimeCode());
							rec.set("EVENTGRP", result.getEventGroup().substring(0,1));
							rec.set("OLDTIME0ID", result.getOldTime0());
							rec.set("OLDEVENTGRP", result.getOldEventGroup());
							rec.set("LV_TY",result.get_LV_TY());
							rec.set("LV",result.get_LV());
							rec.set("TR_TYPE",result.getEventGroup()); 
							rec.save();
						}
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			// TODO Auto-generated catch block
			
		}
	}*/
	
	private void removeExistChild(){
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("Tchshift1");
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.setColumn("*");	
			inq.setFilter("shiftid = '" + this.getString("shiftid") + "'");
			inq.refresh();

			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
}