package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;

public class Texchangeshift extends RecordCmp {

	private Vector vt = new Vector();
	private DbRecord inqEmp = null;
	private DbRecord rec = null;
	
	public Texchangeshift() {
		super("Texchangeshift", "Texchangeshift Table");
	}

	private void chkEmpInq() {
		try {
			if (this.inqEmp == null) {
				this.inqEmp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
				this.inqEmp.setParam("rsc_skip","ture");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void setEmployeeDetail(){
		try {
			this.chkEmpInq();
			this.inqEmp.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, salatype, workarea,  emp_position, emp_group, companyid");	 
			this.inqEmp.set("employeeid", this.getString("employeeid"));
			if (this.inqEmp.search() == 1) {
				this.set("bu1", this.inqEmp.getString("bu1"));
				this.set("bu2", this.inqEmp.getString("bu2"));
				this.set("bu3", this.inqEmp.getString("bu3"));
				this.set("bu4", this.inqEmp.getString("bu4"));
				this.set("bu5", this.inqEmp.getString("bu5"));
				this.set("job", this.inqEmp.getString("job"));
				this.set("emp_group", this.inqEmp.getString("emp_group"));
				this.set("emp_position", this.inqEmp.getString("emp_position"));
				this.set("branch", this.inqEmp.getString("branch"));
				this.set("bossid", this.inqEmp.getString("bossid"));
				this.set("salatype", this.inqEmp.getString("salatype"));
				this.set("workarea", this.inqEmp.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();	
		if (!this.getString("employeeid").equals("")) {
			this.setEmployeeDetail();
		}
			
		return result;
	}

	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		
		if (this.getString("wf_status").equalsIgnoreCase("4")) {
			this.delDataAdjTime0();
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.setEmployeeDetail();
		} 
		return result;
	}

	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}
	
	protected boolean preDeleteTrigger() throws Exception {		
		boolean result = super.preDeleteTrigger();
		this.delDataAdjTime0();
		return result;
	}

	private void delDataAdjTime0() {
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0", "docid='"+this.getString("exshiftid")+"' and doctype='E'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}

	private void genRecord(){
		String timeCodeEmp = this.getTimeCode(this.getString("employeeid"));
		String timeCodeReceive = this.getTimeCode(this.getString("receiverid"));
		
		if (this.rec == null) {
			try {
				this.rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
				this.rec.setColumn("*");
			} catch (Exception e) {
				MyLog.debug(this, e);
			}
		}
		this.genSubRecordDetail(this.getString("employeeid"), timeCodeEmp);
		this.genAddRecordDetail(this.getString("employeeid"), timeCodeReceive);
		this.genSubRecordDetail(this.getString("receiverid"), timeCodeReceive);		
		this.genAddRecordDetail(this.getString("receiverid"), timeCodeEmp);		
	}
	
	private String getTimeCode(String employeeid){
		String timeCode="";
		try {
			this.chkEmpInq();
			this.inqEmp.set("employeeid='", employeeid);
			this.inqEmp.setColumn("employeeid, time0, companyid");
			if (this.inqEmp.search()==1) {
				timeCode = this.inqEmp.getString("time0");
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return timeCode;
	}
	
	private void genAddRecordDetail(String emp, String timeCode) {
		try {
			this.chkEmpInq();
			this.inqEmp.set("employeeid='", emp);
			this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			
			if (this.inqEmp.search() == 1) {
				Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recTime.set("time0id", timeCode);
				recTime.set("companyid", this.userPro.get("companyid"));
				
				
				if(recTime.search() == 1){
				
					CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
					cs1.decDate();
					CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
					cs2.incDate();
					
					recTime.setEmpRec(this.inqEmp);
					WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()));
					if (!ws.isEmpty()) {						
						cs1.incDate(); //cs2.decDate();
						Iterator it = ws.keySet().iterator();
						while (it.hasNext()) {
							DayShift ds = (DayShift) ws.get(it.next());
							Iterator it2 = ds.keySet().iterator();
							while (it2.hasNext()) {
								Shift sh = (Shift) ds.get(it2.next());
								
								MyLog.debug(this, "sh="+sh.getShiftDate()+" cs1="+cs1+" c2="+cs2);
								if (sh.getShiftDate().afterEquals(cs1)&&sh.getShiftDate().beforeEquals(cs2)) {							
									MyLog.debug(this, this.getUProfile(), sh.toString());			
									this.rec.clearField();
									this.rec.set("COMPANYID",this.getString("companyid"));
									this.rec.set("DOCID",this.getString("exshiftid"));
									this.rec.set("DOCTYPE","E");
									this.rec.set("DT_BG", sh.get_c_dt_in().getYYYYMMDD());
									this.rec.set("TM_BG", sh.get_c_dt_in().getCSCTime());
									this.rec.set("DT_EN", sh.get_c_dt_out().getYYYYMMDD());
									this.rec.set("TM_EN", sh.get_c_dt_out().getCSCTime());								
									this.rec.set("UPDTYPE","T");
									this.rec.set("DOCDATE", sh.getShiftDate().getYYYYMMDD());
									this.rec.set("EMPLOYEEID", emp);
									this.rec.set("TIME0ID", sh.getTimeCode());
									this.rec.set("EVENTGRP", sh.getEventGroup());
									this.rec.set("OLDTIME0ID", sh.getOldTimeCode());
									this.rec.set("OLDEVENTGRP", sh.getOldEventGroup());
									this.rec.set("LV_TY",sh.getLV_Type());
									this.rec.set("LV",sh.getLv());
									this.rec.set("TR_TYPE",sh.getTR_Type());
									this.rec.save();
								}
							}						
						}			
					}else{
						MyLog.debug("!! Error : time0id not found in Texchangeshift.genAddRecordDetail !! ["+emp+":"+timeCode+"]");
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	private void genSubRecordDetail(String emp, String timeCode) {
		try {
			this.chkEmpInq();
			this.inqEmp.set("employeeid='" ,emp);
			this.inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
			
			if (this.inqEmp.search() == 1) {
				Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				recTime.set("time0id", timeCode);
				recTime.set("companyid", this.userPro.get("companyid"));
				if(recTime.search()==1){
				
					CscCalendar cs1 = new CscCalendar(this.getString("start_date"));
					cs1.decDate();
					CscCalendar cs2 = new CscCalendar(this.getString("end_date"));
					cs2.incDate();
					
					recTime.setEmpRec(this.inqEmp);
					WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), new CscCalendar(cs2.getYYYYMMDD()));
					if (!ws.isEmpty()) {						
						ws.setUProfile(this.userPro);
						ws.setEmployeeid(this.inqEmp.getString("employeeid"));
						ws.adjust();
						ws.overlapChecking();
						ws.createLink();
						
						MyTreeMap tr = this.getDocAllTimeZone(ws);
						Iterator itTime = tr.keySet().iterator();
						while (itTime.hasNext()) {
							String key = (String) itTime.next();
							TimeZone tz =  (TimeZone) tr.get(key);
														
							Vector vAdjust = ws.genSubShiftTrans(tz);
	
							MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
							Iterator it = vAdjust.iterator();
							MyLog.debug(this, "Transaction");
							while (it.hasNext()) {
								AdjustResult result = (AdjustResult) it.next();
								MyLog.debug(this, result.toString());
								if  (result.getType().equals("D")) {		
									this.rec.clearField();
									this.rec.set("COMPANYID",this.getString("companyid"));
									this.rec.set("DOCID",this.getString("exshiftid"));
									this.rec.set("DOCTYPE","E");
									this.rec.set("DT_BG",result.get_DT_BG().getYYYYMMDD());
									this.rec.set("TM_BG",result.get_DT_BG().getCSCTime());
									this.rec.set("DT_EN",result.get_DT_EN().getYYYYMMDD());
									this.rec.set("TM_EN",result.get_DT_EN().getCSCTime());								
									this.rec.set("UPDTYPE",result.getType());
									this.rec.set("DOCDATE",result.getAdjDate().getYYYYMMDD());
									this.rec.set("EMPLOYEEID", emp);
									this.rec.set("TIME0ID", result.getTimeCode());
									this.rec.set("EVENTGRP", result.getEventGroup().substring(0,1));
									this.rec.set("OLDTIME0ID", result.getOldTime0());
									this.rec.set("OLDEVENTGRP", result.getOldEventGroup());
									this.rec.set("LV_TY",result.get_LV_TY());
									this.rec.set("LV",result.get_LV());
									this.rec.set("TR_TYPE",result.getEventGroup()); 
									this.rec.save();
								}
							}
						}
					}else{
						MyLog.debug("!! Error : time0 not found in Texchangeshift.genSubRecordDetail !! ["+emp+":"+timeCode+"]");
					}
				}				
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	public MyTreeMap getDocAllTimeZone(WorkingShift ws){
		MyTreeMap hm = new MyTreeMap();
		CscCalendar begDate = new CscCalendar(this.getString("start_date"));
		CscCalendar endDate = new CscCalendar(this.getString("end_date"));
		while (begDate.beforeEquals(endDate)) {	
			
			/*CscCalendar cs1 = new CscCalendar(begDate.getYYYYMMDD());
			CscCalendar cs2 = new CscCalendar(begDate.getYYYYMMDD());
			try {
				cs1.setCSCTime(0.00f);
				cs2.setCSCTime(23.59f);
			} catch (Exception e) {
				MyLog.error(this, e);				
			}*/
			TimeZone tz = new TimeZone();
			try {
				DayShift ds1 = (DayShift) ws.get(begDate.getYYYYMMDD());			
				Shift sh1 = (Shift) ds1.get((String) ds1.keySet().iterator().next());
							
				tz.setBeginZone(sh1.get_c_dt_in());
				tz.setEndZone(sh1.get_c_dt_out());
			} catch (Exception e) {
				CscCalendar cs1 = new CscCalendar(begDate.getYYYYMMDD());
				CscCalendar cs2 = new CscCalendar(begDate.getYYYYMMDD());
				try {
					cs1.setCSCTime(0.00f);
					cs2.setCSCTime(23.59f);
				} catch (Exception ex) {
					MyLog.error(this, ex);				
				}		
				tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
				tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
			}
			
			//TimeZone tz = new TimeZone();
			//tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
			//tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
			hm.put(begDate.getYYYYMMDD(), tz);
			begDate.incDate();			
		}
		return hm;
	}
}