package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.service.GenProcessQuque;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.database.ChildManager;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
import com.csc.library.approve.Organization;

public class Tot0 extends RecordCmp {

	private DbTable dbChild=null;
	private MyHashMap hmResult = new MyHashMap();
	private DbInquiry inqEmp = null;
	private DbInquiry inqTot1 = null;
	private DbTable dbTot1 = null; 
	boolean isDuplicateRequstOT = false ;
	private String grouplist = "";

	
	public Tot0() {
		super("Tot0", "Tot0 Table");
	}
	
	private void chkTot1Inq() {
		try {
			if (this.inqTot1 ==null) {
				this.inqTot1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTot1.setParam(this.param);
				this.inqTot1.setSchemaName(this.userPro.getSchemaName());
				this.inqTot1.initMyTable("Tot1", "", "");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}
	}
	
	private void chkTot1Db() {
		try {
			if (this.dbTot1 == null) {
				this.dbTot1 = new InitialTable(this.userPro).getDbTable("Tot1");
				this.dbTot1.setColumn("*");
			}
		} catch (Exception e) {
			MyLog.debug(this, e);
		}	
	}
	
	private void setEmployeeDetail(){
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			rec.setColumn("*");
			rec.setParam("rsc_skip","true");
			rec.set("employeeid", this.getString("employeeid"));
			rec.set("companyid", (String)this.userPro.get("companyid"));
			
			if (rec.search() == 1) {
				this.set("bu1", rec.getString("bu1"));
				this.set("bu2", rec.getString("bu2"));
				this.set("bu3", rec.getString("bu3"));
				this.set("bu4", rec.getString("bu4"));
				this.set("bu5", rec.getString("bu5"));
				this.set("job", rec.getString("job"));
				this.set("emp_group", rec.getString("emp_group"));
				this.set("emp_position", rec.getString("emp_position"));
				this.set("branch", rec.getString("branch"));
				this.set("bossid", rec.getString("bossid"));
				this.set("salatype", rec.getString("salatype"));
				this.set("workarea", rec.getString("workarea"));		
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}	
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();	
		setEmployeeDetail();
		
		if(this.getString("wf_status").equals("4") && !this.getString("grouplist").equals("")){
			genChild();
		}

		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		setEmployeeDetail();
		
		return result;
	}

	protected void postInsertTrigger() throws Exception {		
		super.postInsertTrigger();
		
		if(this.getString("wf_status").equals("4") && !this.getString("grouplist").equals("")){
			delEmpListTemp();
		}
		CreateQuque();
	}

	protected void postUpdateTrigger() throws Exception {		
		super.postUpdateTrigger();
		CreateQuque();
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		CreateQuque();
	}
	
	private MyHashMap genRecord(boolean isSave) {
		try {
			DbTable dt;			
			int count=1;
			WorkingShift wsNormal = null ;
			
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
			rec.setColumn("*");
			
			if (this.getChild("Tot1")!=null) {
				dt = (DbTable) this.getChild("Tot1");			
			} else {
				this.chkTot1Db();
				this.putChild(this.dbTot1);
				this.refreshChild("Tot1");
				dt = (DbTable) this.getChild("Tot1");
			}			
			dt.first();
			while (!dt.eof()) {
				Tot1 db = (Tot1) dt.getCurrentRecordManager();
				
				MyHashMap hmShiftTemp = new MyHashMap();
				DbRecord emp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
				emp.setColumn("*");
				emp.setParam("rsc_skip","true");
				emp.set("employeeid", this.getString("employeeid"));
				emp.set("companyid", (String)this.userPro.get("companyid"));
				
				if (emp.search() == 1) {

					Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					recTime.set("time0id", emp.getString("time0"));
					recTime.set("companyid", this.userPro.get("companyid"));
					recTime.search();

					CscCalendar cs1 = new CscCalendar(db.getString("start_date"));
					cs1.decDate(3);
					CscCalendar cs2 = new CscCalendar(db.getString("end_date"));
					cs2.incDate(3);
					
					recTime.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
										
					WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()));
					if (!ws.isEmpty()) {						
						ws.setUProfile(this.userPro);
						ws.setEmployeeid(this.inqEmp.getString("employeeid"));
						ws.adjust();
						ws.overlapChecking();
						ws.createLink();
						
						ws.removeStopShift();
						Iterator itTime = db.getDocAllTimeZone().keySet().iterator();
						while (itTime.hasNext()) {
							String key = (String) itTime.next();
										
							Vector vAdjust = new Vector();
							if (ws.chkAddShiftTrans(db.getDocTimeZone())) {
								MyLog.debug(this, "TIME NOT MATCH IN SHIFT !!!");
							} else vAdjust = ws.genAddShiftTrans(db.getDocTimeZone());
							
							MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
							Iterator it = vAdjust.iterator();
							MyLog.debug(this, "ADD Transaction");
							while (it.hasNext()) {
								AdjustResult result = (AdjustResult) it.next();
								MyLog.debug(this, result.toString());
								
								String tmp="";
								String flag="0";
								if (!result.get_DT_EN().getYYYYMMDD().equals(result.get_DT_BG().getYYYYMMDD())) {				
									WorkingShift wsOT = recTime.genWorkingShift(new CscCalendar(result.get_DT_EN().getYYYYMMDD()), 
											new CscCalendar(result.get_DT_EN().getYYYYMMDD()),"true");
									if (!wsOT.isEmpty()) {					
										wsOT.setUProfile(this.userPro);
										wsOT.setEmployeeid(this.inqEmp.getString("employeeid"));
										wsOT.adjust();
										MyLog.debug(this, "======== wsOT==========");
										MyLog.debug(this, this.getUProfile(), wsOT.toString());
										if (!wsOT.isEmpty()) {											
											DayShift ds = (DayShift) wsOT.get(result.get_DT_EN().getYYYYMMDD());
											Iterator dtt = ds.keySet().iterator();
											while (dtt.hasNext()) {
												String dKey = (String) dtt.next();
												Shift sh = (Shift) ds.get(dKey);
												if (sh.getType()=='T'||sh.getType()=='H') {
													if (result.get_DT_EN().afterEquals(sh.get_c_dt_in())) {
														flag="1";
														continue;
													}
												}
											}											
										}
									} else flag="1";
									
									if (flag.equals("1")) {
										MyLog.debug(this, "OT REQUEST OVER DAY!!!");
										tmp = this.getOTContinue(result, db.getString("employeeid"));
									}				
								}
								
								String timeCode = result.getTimeCode();
								
								//if (timeCode.equals("")) {
									wsNormal = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
											new CscCalendar(cs2.getYYYYMMDD()),"true");
									if (wsNormal!=null && !wsNormal.isEmpty()) {
										for (Iterator itNormal = wsNormal.keySet().iterator(); itNormal.hasNext();) {
											String keyNormal = (String) itNormal.next();
											DayShift dsNormal = (DayShift) wsNormal.get(keyNormal);
											for (Iterator it2 = dsNormal.keySet().iterator(); it2.hasNext();) {
												String key2 = (String) it2.next();
												Shift sh = (Shift) dsNormal.get(key2);
												hmShiftTemp.put(sh.getShiftDate().getYYYYMMDD(), sh.getTimeCode());
											}
										}
									}
									wsNormal.setUProfile(this.userPro);
									wsNormal.setEmployeeid(this.inqEmp.getString("employeeid"));
									wsNormal.adjust();
									MyLog.debug(this, " ====== WorkingShitf Normal ====== ");
									MyLog.debug(this, this.getUProfile(), wsNormal.toString());
								//}
								
								if (wsNormal!=null) {
									if (wsNormal.containsKey(result.get_DT_BG().getYYYYMMDD())) {
										DayShift d = (DayShift) wsNormal.get(result.get_DT_BG().getYYYYMMDD());
										Iterator i = d.keySet().iterator();
										while (i.hasNext()) {
											String dKey = (String) i.next();
											Shift s = (Shift) d.get(dKey);
											if (!s.getTimeCode().equals(result.getTimeCode())) {
												timeCode = s.getTimeCode();
												MyLog.debug(this, ">>>timeCode Change === "+timeCode);
											}
										}
									}
								}
								
								if (isSave) {
									rec.clearField();
									rec.set("COMPANYID", this.getString("companyid"));
									rec.set("DOCID", this.getString("otid"));
									rec.set("DOCTYPE", "O");
									rec.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
									rec.set("TM_BG", result.get_DT_BG().getCSCTime());
									rec.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
									rec.set("TM_EN", result.get_DT_EN().getCSCTime());
									rec.set("UPDTYPE", result.getType());
									rec.set("DOCDATE", result.getAdjDate().getYYYYMMDD());
									rec.set("EMPLOYEEID", db.getString("employeeid"));
									if (timeCode.equals("")) {
										if (hmShiftTemp.containsKey(result.getAdjDate().getYYYYMMDD())) {
											rec.set("TIME0ID", hmShiftTemp.getString(result.getAdjDate().getYYYYMMDD()));
										}
									} else rec.set("TIME0ID", timeCode);
									rec.set("EVENTGRP", "O");
									rec.set("OLDTIME0ID", "");
									rec.set("OLDEVENTGRP", "");
									rec.set("LV_TY", "");
									rec.set("LV", result.get_LV());
									rec.set("TR_TYPE", result.getEventGroup());
									rec.set("ADJUSTTEMP", tmp);
									rec.set("STATUS", dt.getString("status"));
									rec.set("PRIORITY", "2");	
									rec.set("OT_WORKAREA", dt.getString("ot_workarea"));
									rec.set("OT_SALATYPE", dt.getString("ot_salatype"));
									rec.set("OT_TYPE", dt.getString("ot_type"));
									rec.set("OT_TIME0", dt.getString("ot_time0"));
									rec.save();
								} else {
									MyHashMap hmData = new MyHashMap();
									hmData.put("COMPANYID", this.getString("companyid"));
									hmData.put("DOCID", this.getString("otid"));
									hmData.put("DOCTYPE", "O");
									hmData.put("DT_BG", result.get_DT_BG().getYYYYMMDD());
									hmData.put("TM_BG", result.get_DT_BG().getCSCTime());
									hmData.put("DT_EN", result.get_DT_EN().getYYYYMMDD());
									hmData.put("TM_EN", result.get_DT_EN().getCSCTime());
									hmData.put("UPDTYPE", result.getType());
									hmData.put("DOCDATE", result.getAdjDate().getYYYYMMDD());
									hmData.put("EMPLOYEEID", db.getString("employeeid"));
									if (timeCode.equals("")) {
										if (hmShiftTemp.containsKey(result.getAdjDate().getYYYYMMDD())) {
											hmData.put("TIME0ID", hmShiftTemp.getString(result.getAdjDate().getYYYYMMDD()));
										}
									} else hmData.put("TIME0ID", timeCode);
									hmData.put("EVENTGRP", "O");
									hmData.put("OLDTIME0ID", "");
									hmData.put("OLDEVENTGRP", "");
									hmData.put("LV_TY", "");
									hmData.put("LV", result.get_LV());
									hmData.put("TR_TYPE", result.getEventGroup());
									hmData.put("ADJUSTTEMP", tmp);
									hmData.put("STATUS", dt.getString("status"));
									hmData.put("PRIORITY", "2");	
									hmData.put("OT_WORKAREA", dt.getString("ot_workarea"));
									hmData.put("OT_SALATYPE", dt.getString("ot_salatype"));
									hmData.put("OT_TYPE", dt.getString("ot_type"));
									hmData.put("OT_TIME0", dt.getString("ot_time0"));
									this.hmResult.put(String.valueOf(count),hmData);
									count++;
								}
							}
						}
					}
				}
				dt.next();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return this.hmResult;
	}

	public int putChild(ChildManager oChild) {
		int point = super.putChild(oChild);
		try {
			if (this.param.containsKey("__screen")) {
				if (((String) (this.param.get("__screen"))).equalsIgnoreCase("BossRequestOT")) {
					if ((oChild instanceof DbTable) && (oChild.getTableName().equalsIgnoreCase("TOT1"))) {
						DbTable dbTable = (DbTable) oChild;
						
						String empid = (String) this.getUProfile().get("actor");
						Organization org = (Organization) new InitialRecord(this.userPro, this.param).getDbRecord("Masfactor");
						org.setDaTaResult("Torgani","bossid,employeeid,companyid,runno");
						org.setSub("1", "employeeid", "bossid", empid);
						Vector subOrdi = org.getSub();				
						long keyis = System.currentTimeMillis();
						for (int i = 0; i < subOrdi.size(); i++) {
							DbRecord rec = dbTable.getNewRecord();
							DbRecord subBean = (DbRecord) subOrdi.elementAt(i);
							rec.set("otid", keyis);					
							rec.set("employeeid", subBean.getString("employeeid"));
							rec.set("companyid", subBean.getString("companyid"));
							dbTable.putNewRecord(rec);
						}
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);			
		}
		return point;
	}

//	㹡 Genarate Adjtime0 㹡óբ OT ѹ
	private String getOTContinue(AdjustResult result, String empID) {
		String value=""; 
		try {
			WorkingShift ws = null;
			DbRecord emp = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
			emp.setColumn("*");
			emp.setParam("rsc_skip","true");
			emp.set("employeeid", this.getString("employeeid"));
			emp.set("companyid", (String)this.userPro.get("companyid"));
			
			if (emp.search() == 1) {
				Mtime0 rec = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
				rec.set("time0id", this.inqEmp.getString("time0"));
				rec.set("companyid", this.userPro.get("companyid"));
				rec.search();

				CscCalendar cs1 = new CscCalendar(result.get_DT_BG().getYYYYMMDD());
				cs1.decDate();
				CscCalendar cs2 = new CscCalendar(result.get_DT_EN().getYYYYMMDD());
				cs2.incDate();
				
				rec.setEmpRec(this.inqEmp.getCurrentDbRecord().cloneRecord(false));
				ws = rec.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
						new CscCalendar(cs2.getYYYYMMDD()), "true");
				
				if (ws!=null) {
					CscCalendar csStart = new CscCalendar(result.get_DT_BG().getYYYYMMDD());
					CscCalendar csEnd = new CscCalendar(result.get_DT_EN().getYYYYMMDD());
					String tmpData="";
					while (csStart.beforeEquals(csEnd)) {
						tmpData="";
						//͹ 1 ѹ ҢͧѹѴ
						CscCalendar tmp = new CscCalendar(csStart.getYYYYMMDD());
						tmp.incDate();
											
						DayShift dsOUT = (DayShift) ws.get(csStart.getYYYYMMDD());
						Shift shOUT = (Shift) dsOUT.get((String) dsOUT.firstKey());
						
						DayShift dsIN = (DayShift) ws.get(tmp.getYYYYMMDD());
						Shift shIN = (Shift) dsIN.get((String) dsIN.firstKey());
					
						if (result.get_DT_BG().getYYYYMMDD().equals(csStart.getYYYYMMDD())) {
							tmpData += "DT_BG="+result.get_DT_BG().getYYYYMMDD()+",";
							tmpData += "TM_BG="+result.get_DT_BG().getCSCTime()+",";
						} else {
							tmpData += "DT_BG="+shOUT.get_c_dt_in().getYYYYMMDD()+",";
							tmpData += "TM_BG="+shOUT.get_c_dt_in().getCSCTime()+",";
						}
						
						if (!result.get_DT_EN().getYYYYMMDD().equals(csStart.getYYYYMMDD())) {
							tmpData += "DT_EN="+shIN.get_c_dt_in().getYYYYMMDD()+",";
							tmpData += "TM_EN="+shIN.get_c_dt_in().getCSCTime()+",";
						} else {
							tmpData += "DT_EN="+result.get_DT_EN().getYYYYMMDD()+",";
							tmpData += "TM_EN="+result.get_DT_EN().getCSCTime()+",";
						}		
						
						tmpData += "TIMECODE="+shOUT.getTimeCode()+",";
						//MyLog.debug(this, tmpData);
						csStart.incDate();
						value += tmpData+"#";
					}
				}
			}
			
		} catch (Exception e) {
			MyLog.error(this, e);			
		}	
		MyLog.debug(this, ">>>>>>>>>> "+value);
		return value;
	}
	
	
	private String genCh() {
		String empSelect = (String) this.param.get("__selectData");
		int lineno = 1;
		
		try {
			ChildManager oChild = this.getChild("TOT1");
			if ((oChild != null) && (oChild instanceof DbTable)) {
				DbTable dbTable = (DbTable) oChild;
				dbTable.last();
				//dbTable.previous();
				lineno = dbTable.getInt(dbTable.getMinorKey());
				if (lineno==1) lineno=0;
				StringTokenizer str = new StringTokenizer(empSelect, ",");
				while (str.hasMoreTokens()) {
					String time0 = "";
					String workarea = "";
					String costcen = "";
					
					String emp = str.nextToken();
					DbRecord empRec = new InitialRecord(this.userPro).getDbRecord("MEMPLOYEE");
					empRec.setColumn("*");
					empRec.setParam("rsc_skip","true");
					empRec.set("employeeid", emp);
					empRec.set("companyid", (String)this.userPro.get("companyid"));
					
					if (empRec.search() == 1) {
						time0 = empRec.getString("time0");
						workarea = empRec.getString("workarea");
						costcen = empRec.getString("costcenter");
                    }
                    
                    DbRecord rec = dbTable.getNewRecord();
					rec.set("OTID", this.getString("otid"));
					rec.set("EMPLOYEEID", emp);
					rec.set("COMPANYID", this.getUProfile().get("companyid"));
					rec.set("OT_TIME0", time0);
					rec.set("OT_SALATYPE", costcen);
					rec.set("OT_WORKAREA", workarea);
					rec.set(dbTable.getMinorKey(), ++lineno);
					
					dbTable.putNewRecord(rec);
				}
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return String.valueOf(lineno);
	}

	public String getString(String field) {
		if (field.equalsIgnoreCase("gen")) {
			return this.genCh();
		} else {
			return super.getString(field);
		}
	}
	
	public MyHashMap getDWRData() {
        return this.genRecord(false);
    }
   
	@Override
	public boolean set(String fieldName, String data) {
		if(fieldName.equals("GROUPLIST")){
			this.grouplist = data;
			return true;
		}else{
			return super.set(fieldName, data);
		}
	}
	
	public FieldManager getField(String fieldName) {
		FieldManager fm = super.getField(fieldName);
		if (fieldName.equalsIgnoreCase("grouplist")) {
			fm = this.initField("String", "grouplist", 50, 0, "grouplist");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.set(this.grouplist);
		}
		return fm;
	}
	
	private void genChild(){
		try {
			if(this.getChild("tot1") != null){
				this.removeChild("tot1");
			}
			
			DbTable db = new InitialTable(this.userPro).getDbTable("tot1");
			db.first();
			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("EMP_CREATE_LIST");
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.setColumn("*");
			inq.setFilter("listid = '"+this.getString("grouplist")+"'");
			inq.refresh();
			int lineNo =0;
			DbRecord rec = null;
			while (inq.next()) {
				try{
					rec = db.getNewRecord();
					rec.set("COMPANYID", this.userPro.get("companyid"));
					rec.set("OTID", this.getString("OTID"));
					rec.set("EMPLOYEEID", inq.getString("employeeid"));
					rec.set("LINE_NO", lineNo);
					rec.set("START_DATE", inq.getString("START_DATE"));
					rec.set("END_DATE", inq.getString("END_DATE"));
					rec.set("START_TIME", inq.getString("START_TIME"));
					rec.set("END_TIME", inq.getString("END_TIME"));
					rec.set("TOTAL_TIME", inq.getString("TOTAL_TIME"));
					rec.set("PATHWAYID", inq.getString("PATHWAYID"));
					rec.set("WF_STATUS", this.getString("WF_STATUS"));
					rec.set("DOCREF", this.getString("DOCREF"));
					db.putNewRecord(rec);
					lineNo++;
				}catch(Exception e){
					MyLog.error(this,e);
				}
			}
			this.putChild(db);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void delEmpListTemp(){
		try {
			CscCalendar cscdate = new CscCalendar();
			cscdate.decDate(30);
			//ź list   list ١  30 ѹ ͤ㹡 load list ˹Ҩ
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("EMP_CREATE_LIST_TEMP");
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.setColumn("*");
			inq.setFilter("create_date < '"+cscdate.getYYYYMMDD()+"'");
			//inq.setFilter("listid = '"+this.getString("grouplist")+"' or create_date < '"+cscdate.getYYYYMMDD()+"'");
			inq.refresh();

			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	/* ҧ quque 觻żѹ͡ҡзѺἹ÷ӧҹ */
	private void CreateQuque() throws Exception{
		CscCalendar st = new CscCalendar(this.getString("docdate"));
		st.decDate();
		
		HashMap hmCon = new HashMap();
		hmCon.put("uprofile", this.userPro);
		hmCon.put("employeeid", "transfer");
		hmCon.put("companyid", "100");
		hmCon.put("schemaname", this.userPro.getSchemaName());
		hmCon.put("lang", "THA");
		hmCon.put("appname", "TA");
		//hmCon.put("dbname", this.userPro.get("dbname"));
		hmCon.put("startDate", this.getString("start_date"));
		hmCon.put("endDate", this.getString("end_date"));
		hmCon.put("cmdValue", "transfer");
		hmCon.put("delStatus", "true");
		hmCon.put("employeeBetween", "(employeeid between '"+this.getString("employeeid")+"' and '"+this.getString("employeeid")+"')");

		GenProcessQuque gpq = new GenProcessQuque();
		gpq.createQuque(this.userPro, "Auto TransferTime", "Auto TransferTime", "TransferTimeProcess", "TOT0", "ProcessWorkFlowTime", "9", hmCon, "EXPORT_TXT", "P", "N", "cond");
	}
}