package com.csc.library.databean;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;

import std.library.DataTable;

import com.csc.library.database.CscConnection;
import com.csc.library.database.FieldManager;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.RecordCmp0;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.FindingAddress;
import com.csc.library.utilities.UProfile;

public class Vw_time_trans extends RecordCmp0{
	private CscConnection conn = null;
	private Statement stmt =null; 
	private UProfile userProFile = this.userPro;
	private String c_dt_bg=null;
	private String c_tm_bg=null;
	private String c_dt_en=null;
	private String c_tm_en=null;
	
	public Vw_time_trans() {
		// TODO Auto-generated constructor stub
		super("Vw_time_trans","Vw_time_trans View");
	}
	
	public FieldManager getField(String fieldName) {		
		FieldManager fm = super.getField(fieldName);   
  
        if (fieldName.equalsIgnoreCase("reason")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            fm.set(retrieveData(this.getString("employeeid"),this.getString("dateid"),"","","reason"));
        }else if (fieldName.equalsIgnoreCase("outside_detail")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            fm.set(retrieveData(this.getString("employeeid"),this.getString("dateid"),"","","outside_detail"));
        }else if (fieldName.equalsIgnoreCase("accu")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
        }else if (fieldName.equalsIgnoreCase("ot_timein")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            String employeeid =(this.getString("employeeid")==null)?"":this.getString("employeeid");      
            String dateid = this.getString("dateid");          
            String doctype =this.getString("doctype");
            String docno =this.getString("docno") ;        
            if(!employeeid.equals("")&&!dateid.equals("")&&!doctype.equals("")&&!docno.equals("")){
               fm.set(this.retrieveData(employeeid, dateid, doctype, docno,"ot_timein"));
            }else{
            	fm.set("");
            }//end if 
         }else if (fieldName.equalsIgnoreCase("ot_timeout")) {
            fm = (FieldManager) this.initField("String", fieldName, 250, 0, "");
            fm.setWorking(true);
            String employeeid =(this.getString("employeeid")==null)?"":this.getString("employeeid");
            String dateid = this.getString("dateid");          
            String doctype =this.getString("doctype");
            String docno =this.getString("docno") ;            
            if(!employeeid.equals("")&&!dateid.equals("")&&!doctype.equals("")&&!docno.equals("")){
                fm.set(this.retrieveData(employeeid, dateid, doctype, docno,"ot_timeout"));
             }else{
             	fm.set("");
             }//end if
        }else{
        	 fm = super.getField(fieldName);
        }//end if 
        return fm;
	}
	public String retrieveData(String employeeid,String dateid
			,String c_dt_bg,String c_tm_bg,String c_dt_en,String c_tm_en
			,String doctype,String docno,String fieldName){
		this.c_dt_bg= c_dt_bg;
		this.c_tm_bg=c_tm_bg;
		this.c_dt_en=c_dt_en;
		this.c_tm_en=c_tm_en;
		return this.retrieveData( employeeid, dateid, doctype, docno, fieldName);
	}//end method retrieveData
	
	private String retrieveData(String employeeid,String dateid
			,String doctype,String docno,String fieldName){ 
		
		ResultSet resultSet = null;
		String strReturn ="";
		try{			
			if(this.userProFile.get("dbname")==null){
				this.userProFile = this.userPro;
			}//end if 
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userProFile.get("dbname"));
			stmt = conn.createStatement();
			
			if(fieldName.equalsIgnoreCase("reason")){
				resultSet = stmt.executeQuery(this.getSQLQuery(employeeid,new CscCalendar(dateid).getYYYYMMDD()));
				if (resultSet.next()) {	
					strReturn= resultSet.getString("reasonchangeid");
				}else{
					strReturn="";
				}//end if 
			}else if(fieldName.equalsIgnoreCase("outside_detail")){
				resultSet = stmt.executeQuery(this.getSQLQuery(employeeid,new CscCalendar(dateid).getYYYYMMDD()));
				if (resultSet.next()) {	
					strReturn= resultSet.getString("remark");
				}else{
					strReturn="";
				}//end if 
			}else if(fieldName.equalsIgnoreCase("ot_timein")){
				resultSet = stmt.executeQuery(this.getSQLQueryAdjDateTime(employeeid, new CscCalendar(dateid).getYYYYMMDD(), doctype, docno));
				
				CscCalendar stDateTimePlan =null;
				CscCalendar endDateTimePlan=null;
				if(this.c_dt_bg==null&&this.c_tm_bg==null&&this.c_dt_en==null&&this.c_tm_en==null){
					stDateTimePlan = new CscCalendar(this.getString("c_dt_bg"));
					stDateTimePlan.setCSCTime(Double.valueOf(this.getString("c_tm_bg")));
					
					endDateTimePlan = new CscCalendar(this.getString("c_dt_en"));
					endDateTimePlan.setCSCTime(Double.valueOf(this.getString("c_tm_en")));	
				}else{
					stDateTimePlan = new CscCalendar(this.c_dt_bg);
					stDateTimePlan.setCSCTime(Double.valueOf(this.c_tm_bg));
					
					endDateTimePlan = new CscCalendar(this.c_dt_en);
					endDateTimePlan.setCSCTime(Double.valueOf(this.c_tm_en));	
				}//end if
				
				while(resultSet.next()){
					CscCalendar stDateTimeOT = new CscCalendar(resultSet.getString("dt_bg"));
					stDateTimeOT.setCSCTime(Double.valueOf(resultSet.getString("tm_bg")));
					CscCalendar endDateTimeOT = new CscCalendar(resultSet.getString("dt_en"));
					endDateTimeOT.setCSCTime(Double.valueOf(resultSet.getString("tm_en")));
					if(stDateTimeOT.afterEqualsDateTime(stDateTimePlan) && endDateTimeOT.beforeEqualsDateTime(endDateTimePlan)){
						strReturn= resultSet.getString("tm_bg");
						break;
					}//end if 
				}//end while
				
			}else if(fieldName.equalsIgnoreCase("ot_timeout")){
				resultSet = stmt.executeQuery(this.getSQLQueryAdjDateTime(employeeid, new CscCalendar(dateid).getYYYYMMDD(), doctype, docno));
				
				CscCalendar stDateTimePlan =null;
				CscCalendar endDateTimePlan=null;
				if(this.c_dt_bg==null&&this.c_tm_bg==null&&this.c_dt_en==null&&this.c_tm_en==null){
					stDateTimePlan = new CscCalendar(this.getString("c_dt_bg"));
					stDateTimePlan.setCSCTime(Double.valueOf(this.getString("c_tm_bg")));
					
					endDateTimePlan = new CscCalendar(this.getString("c_dt_en"));
					endDateTimePlan.setCSCTime(Double.valueOf(this.getString("c_tm_en")));	
				}else{
					stDateTimePlan = new CscCalendar(this.c_dt_bg);
					stDateTimePlan.setCSCTime(Double.valueOf(this.c_tm_bg));
					
					endDateTimePlan = new CscCalendar(this.c_dt_en);
					endDateTimePlan.setCSCTime(Double.valueOf(this.c_tm_en));	
				}//end if
				while(resultSet.next()){
					CscCalendar stDateTimeOT = new CscCalendar(resultSet.getString("dt_bg"));
					stDateTimeOT.setCSCTime(Double.valueOf(resultSet.getString("tm_bg")));
					CscCalendar endDateTimeOT = new CscCalendar(resultSet.getString("dt_en"));
					endDateTimeOT.setCSCTime(Double.valueOf(resultSet.getString("tm_en")));
					if(stDateTimeOT.afterEqualsDateTime(stDateTimePlan) && endDateTimeOT.beforeEqualsDateTime(endDateTimePlan)){
						strReturn= resultSet.getString("tm_en");
						break;
					}//end if 
				}//end while
			}//end if 
			
			
		}catch(Exception ex){
			System.out.print(">>>>>Error on Vw_time_trans.retrieveData()"+ex.getStackTrace())	;
		}finally{
			try{		
				resultSet.close();
				if(stmt!=null){
					stmt.close();
				}
				conn.close();
			}catch(SQLException ex){
				ex.printStackTrace();
			}
		}//end try
		return strReturn;
	}//end method retrieveData
	
	private String getSQLQueryAdjDateTime(String employeeid,String dateid,String doctype,String docno){
		String SQLQuery ="";
		SQLQuery = "SELECT employeeid,docdate,docid,doctype " +
		",dt_bg,tm_bg,dt_en,tm_en " +
		" FROM tadjtime0 " +
		" WHERE employeeid ='"+employeeid+"' and docdate = '"+dateid+
		"' and doctype='"+doctype+"'" +" and docid ='"+docno+"' " +
		" ORDER BY employeeid,docdate,docid,doctype " +
		" ,dt_bg,tm_bg,dt_en,tm_en";
		
		return SQLQuery;
	}//end method getSQLQueryAdjDateTime
	
	private String getSQLQuery(String employeeid,String dateid){
		String SQLQuery ="";
		String whereClause=" and f0.employeeid='"+employeeid+"'"
		+" and f1.forget_date='"+dateid+"'";
		
		SQLQuery = "SELECT f0.employeeid,f0.fscardid "+
		" ,f1.forget_date,f1.line_no,f1.remark,mr.reasonchangeid"+
		" FROM  tforgetcard0 f0,tforgetcard1 f1 left outer join mreasonchange mr on("+
		" (mr.tdesc is not null and mr.tdesc<>'' and f1.remark like mr.tdesc+'%') " +
		" OR(mr.edesc is not null and mr.edesc<>'' and f1.remark like mr.edesc+'%')" +
		")"+
		" WHERE  f1.fscardid=f0.fscardid "+ whereClause +
		" ORDER BY f1.forget_date,f1.line_no ASC";
		
		return SQLQuery;
	}//end method getSQLQuery
	
	/**
	 * Author : Nuiss
	 * Date : 23/02/2253
	 * Logic :  dtbTimeTrans  
	 * @param employeeid
	 * @param yearOfData
	 * @param monthOfData
	 * @return DataTable dtbTimeTrans
	 */
	public DataTable getDataTimeTrans(String employeeid, int yearOfData,int monthOfData) throws SQLException{
		DataTable dtbTimeTrans = null;
		ResultSet resultSet = null;
		ResultSetMetaData rsMtd = null;
		conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userProFile.get("dbname"));
		stmt = conn.createStatement();
		resultSet = stmt.executeQuery("SELECT * FROM vw_time_trans "
				+" WHERE employeeid ='"+employeeid+"'"
				+" and yearid ="+yearOfData
				+" and monthid ="+monthOfData
				+" ORDER BY dateid");
		rsMtd = resultSet.getMetaData();
		String[] colName = new String[rsMtd.getColumnCount()];
		String[] colType = new String[rsMtd.getColumnCount()];
		for(int colIndex=1;colIndex<=colName.length;colIndex++){
			colName[colIndex-1] = rsMtd.getColumnName(colIndex);
			colType[colIndex-1] = rsMtd.getColumnTypeName(colIndex);
		}//end for
		
		dtbTimeTrans = new DataTable(colName,colType);
		int row =0;
		while(resultSet.next()){
			row++;
			dtbTimeTrans.insertRow(1);
			for(int col=1;col<=colName.length;col++){
				dtbTimeTrans.setItem(row, colName[col-1], resultSet.getObject(colName[col-1]));
			}//end for 
		}//end while
		
		resultSet.close();
		stmt.close();
		conn.close();
		
		return dtbTimeTrans;
	}//end method getDataTimeTrans
	
	public void setUserProfile(UProfile userProFile){
		this.userProFile =userProFile;
	}//end method setUserProfile
	
}//end class Vw_time_trans
