package com.csc.library.dwr;

import com.csc.library.utilities.FindingOrganizationChart;
import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;

import javax.servlet.http.HttpServletRequest;

import org.directwebremoting.WebContext;
import org.directwebremoting.WebContextFactory;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.UProfile;

public class DWR_base {
	
	UProfile up;
	MyHashMap hmTime = new MyHashMap(); // description ͧҧ÷ӧҹ
	
	public void setUProfile(){		
		WebContext ctx = WebContextFactory.get();
		HttpServletRequest req = ctx.getHttpServletRequest();		
		this.up	=(UProfile) req.getSession().getAttribute("userprofile");		
	}
	
	public String getHeaderFrame() {
		String data = "";
		data += "<TABLE WIDTH='95%' BORDER='0' ALIGN='center' CELLPADDING='0' CELLSPACING='0'>";
		data += "<TR>";
		data += "	<TD WIDTH='5' HEIGHT='5'><IMG SRC='../IMAGES/MYNOTE/C-T-L.gif' WIDTH='5' HEIGHT='5'></TD>";
		data += "	<TD HEIGHT='5'><IMG SRC='../IMAGES/MYNOTE/T.gif' WIDTH='100%' HEIGHT='5'></TD>";
		data += "<TD WIDTH='5' HEIGHT='5'><IMG SRC='../IMAGES/MYNOTE/C-T-R.gif' WIDTH='5' HEIGHT='5'></TD>";
		data += "</TR>";
		data += "<TR>";
		data += "<TD WIDTH='5' BACKGROUND='../IMAGES/MYNOTE/L2.gif'><FONT COLOR='#FFFFFF'></FONT></TD>";
		data += "<TD VALIGN='middle'>";
		data += "<FONT FACE='MS Sans Serif' SIZE='1' COLOR='#FFFFFF'>";
		return data;
	}
	
	public String getBelowFrame() {
		String data = "";
		data += "	</FONT>";
		data += "</TD>";
		data += "<TD WIDTH='5' BACKGROUND='../IMAGES/MYNOTE/R2.gif'><FONT COLOR='#FFFFFF'></FONT></TD>";
		data += "</TR>";
		data += "<TR>";
		data += "<TD WIDTH='5' HEIGHT='5'><IMG SRC='../IMAGES/MYNOTE/C-B-L.gif' WIDTH='5' HEIGHT='5'></TD>";
		data += "<TD HEIGHT='5'><IMG SRC='../IMAGES/MYNOTE/B.gif' WIDTH='100%' HEIGHT='5'></TD>";
		data += "<TD WIDTH='5' HEIGHT='5'><IMG SRC='../IMAGES/MYNOTE/C-B-R.gif' WIDTH='5' HEIGHT='5'></TD>";
		data += "</TR>";
		data += "</TABLE>";
		return data;
	}
	
	public DbInquiry getInquiry(String tablename,String column,String filter,String orderby, UProfile up){
		DbInquiry inq = null;
		inq = new InitialInquiry(up).getDbInquiry();
		try {
			inq.initMyTable(tablename,filter,orderby);
			inq.setColumn(column);
			inq.refresh();			
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}		
		return inq;
	}
	
	/*
	 * ӡҤҷҨҡ˹Ҩ (array) 
	 * 繤ҧ  error  
	 * ҼԴԡ return ҧ͡
	 */
	public String chkEmptyData(String[] str, int index) {
		try {
			return str[index];
		} catch (Exception e) {
			MyLog.error(this, e);
			MyLog.debug(this, " ERROR :::: "+index);
			return "";
		}
	}
	
	/*
	 * ӡô֧ tdesc, edesc ͧҧ÷ӧҹ
	 * 红ŧ HashMap ͹
	 * ͧ search  ҡաô֧ŷ¤
	 */
	public String getTimeDesc(String timeCode) {
		String result="";
		if (this.hmTime.containsKey(timeCode)) {
			result = this.hmTime.getString(timeCode);
		} else {
			try {
				DbInquiry inq = this.getInquiry("Mtime0","time0id, tdesc, edesc, companyid", "time0id='"+timeCode+"'", "", this.up);
				if (inq.next()) {
					this.hmTime.put(timeCode, inq.getString("tdesc"));
					result = inq.getString("tdesc");
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
				return "";
			}
		}
		return result;
	}
	
	/*
	 * ӡäҪ;ѡҹ
	 */
	public String getEmployeeName(String empCode) {
		String empName = "";
		try {
			DbInquiry inq = this.getInquiry("Memployee","employeeid, emp_prefix, fname, lname, efname, elname, companyid", 
					"employeeid='"+empCode+"'", "", this.up);
			if (inq.next()) {
				empName = inq.getString("fullname");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return empName;
	}
	
	/*
	 * ӡô֧Ţ١ͧ͡
	 */
	public String getDWRSubordinate(String empid){
	    this.setUProfile();
	    String subordinate = "";
	    if(!empid.equals("")){
	        FindingOrganizationChart foc=new FindingOrganizationChart(this.up);
	        subordinate = foc.getSubOrdinateAll(empid);
	    }
	    return subordinate;
	}
}
