package com.csc.library.dwr;

import java.sql.Statement;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;

public class RestoreAnnualLeave extends DWR_base{
	String sql ;
	
	public boolean restore(String ref){
		try {
			setUProfile();
			initSQL(ref);
			restoreVacation();
		}catch(Exception e){
			MyLog.error(this,e);
			return false ;
		}
		return true ;
	}
	
	public void initSQL(String refid){
		String RESTORE_PROD = "RESTORE_VACATION";
		try {
			InitialEnvironment inv = new InitialEnvironment(this.up.getDbName());
			String dbType = inv.getValue("datasource-dbtype");
			
			MyLog.debug("!! restore vacation with referenceid : " + refid);
			if (dbType.equals("ORACLE")){ // for oracle
				sql = "CALL " + RESTORE_PROD + "('" + refid + "')";
			} else { // for SQLServer
				sql = "EXEC " + RESTORE_PROD + " '" + refid + "'" ;		
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void restoreVacation(){
		MyLog.debug("!! restore command : " + sql);
		execSQL(sql);
	}
	
	/**  EXECUTE SQL  */
    public void execSQL(String _SQL) {
		CscConnection conn = null;
		Statement stmt = null;
		try {
			if(_SQL != null && !_SQL.equals("")){
				conn = (CscConnection) StaticProperties.myConnection.getConnection(this.up.get("dbname"));
				stmt = conn.createStatement();
				
				MyLog.debug("!! execute sql restore vacation !! : " + _SQL);
				stmt.executeUpdate(_SQL);
			}else{
				MyLog.debug("!! SQL is null or empty !!");
			}
        } catch (Exception e) {
        	MyLog.error("!! Error : can't exec this SQL [" + _SQL + "] !!" ,e);           
        } finally {
        	try {
	        	if(stmt != null) stmt.close();
	        	if(conn != null) conn.close();
        	} catch(Exception e){
        		MyLog.error("!! Error : Can't close statement or connection !!",e);
        	}
        }
    }

}
