package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.Iterator;
import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;

public class Show_working_dwr extends DWR_base {

	public Show_working_dwr() { }
		
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String empCode = this.chkEmptyData(str, 0);
		String startDate = this.chkEmptyData(str, 1);
		String endDate = this.chkEmptyData(str, 2);
		
		CscCalendar cs1 = new CscCalendar(startDate);
		CscCalendar cs2 = new CscCalendar(endDate);

		DecimalFormat df = new DecimalFormat("0.00");
		
		try {			
			data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";		
			data += "<tr bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
                data += "<td colspan='6' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Working Information&nbsp;:&nbsp;"+empCode
				+"&nbsp;:&nbsp;"+this.getEmployeeName(empCode)+"&nbsp;:&nbsp;</strong></td>";
            }else{
                data += "<td colspan='6' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;š÷ӧҹ&nbsp;:&nbsp;"+empCode
                +"&nbsp;:&nbsp;"+this.getEmployeeName(empCode)+"&nbsp;:&nbsp;</strong></td>";
            }
			//Working Information = š÷ӧҹ
			data += "</tr>";
			data += "<tr align='center' bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
    			data += "<td class='txt_normal' width='15%'><strong>Date&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='15%'><strong>Time Code&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='40%'><strong>Description&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='10%'><strong>Day Type&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='10%'><strong>Time In&nbsp;</strong></td>";			
    			data += "<td class='txt_normal' width='10%'><strong>Time Out&nbsp;</strong></td>";		
            }else{
                data += "<td class='txt_normal' width='15%'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='15%'><strong>ʡ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='40%'><strong>´&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='10%'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='10%'><strong>ѹٴ&nbsp;</strong></td>";           
                data += "<td class='txt_normal' width='10%'><strong>ѹٴ͡&nbsp;</strong></td>";                      
            }
			data += "</tr>";						
			
			DbInquiry inqEmp = new InitialInquiry(this.up).getDbInquiry();
			inqEmp.initMyTable("Memployee", "employeeid='"+empCode+"'", "");
			inqEmp.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level, workarea," +
			"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid, status, startdate, resigndate");			
			inqEmp.refresh();
			while (inqEmp.next()) {
				DbRecord empRec = inqEmp.getCurrentDbRecord();
				Mtime0 timeRec = this.getTimeRecord(empRec.getString("time0"));		
				timeRec.setEmpRec(empRec);
				WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(cs1	.getTimestamp()), new CscCalendar(cs2.getTimestamp()));
				MyLog.debug(this, "Working Shift of :> "+empRec.getString("employeeid"));
				MyLog.debug(this, ws.getUprofile() , ws.toString());
				MyLog.debug(this, ws.getUprofile(), ws.keySet().toString());
				MyLog.debug(this, ws.getUprofile(),  "----------------------------------------------------------------------------");
								
				ws.setUProfile(up);
				ws.setEmployeeid(empRec.getString("employeeid"));
				ws.adjust();
				MyLog.debug(this, ws.getUprofile(), "<<< ADJUST >>>");
				MyLog.debug(this, ws.getUprofile(), ws.toString());
				for (Iterator IT = ws.keySet().iterator(); IT.hasNext(); ) {
					String key = (String) IT.next();
					DayShift dShift = (DayShift) ws.get(key);
					for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext(); ) {
						String key1 = (String) IT1.next();
						Shift sh = (Shift) dShift.get(key1);
						data += "<tr align='center'>";
						data += "<td class='desc'>"+sh.getShiftDate().getDDMMYYYY()+"</td>";
						data += "<td class='desc'>"+sh.getResultTimeCode()+"</td>";
						data += "<td class='desc'>"+this.getTimeDesc(sh.getResultTimeCode())+"</td>";
						data += "<td class='desc'>"+sh.getEventGroup()+"</td>";			
						data += "<td class='desc'>"+df.format(sh.getResult_c_dt_in().getCSCTime())+"</td>";				
						data += "<td class='desc'>"+df.format(sh.getResult_c_dt_out().getCSCTime())+"</td>";									
						data += "</tr>";
					}
				}				
			}						
			data += "</table>";
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}		
		data += this.getBelowFrame();
		return data;
	}
	
	public Mtime0 getTimeRecord(String id) {
		Mtime0 rec = null;
		try {
			DbInquiry inq = new InitialInquiry(this.up).getDbInquiry();
			inq.initMyTable("Mtime0", "time0id='" + id + "'", "");
			inq.setColumn("*");
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				rec = (Mtime0) inq.getCurrentDbRecord();				
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}		
		return rec;
	}
}
