package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

import java.text.DecimalFormat;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tabsent_m_date;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Tabsent_m_date_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");

	public Tabsent_m_date_dwr() { }

	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String lv_type = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String endDate = this.chkEmptyData(str, 3);
		
		try {
			Tabsent_m_date rec = (Tabsent_m_date) new InitialRecord(up).getDbRecord("TABSENT_M_DATE");
			rec.set("ABSENTID","0");			 
			rec.set("EMPLOYEEID", emp);
			rec.set("TYPE_ABSENT", lv_type);
			rec.set("START_DATE", startDate);
			rec.set("END_DATE", endDate);
			rec.set("COMPANYID", this.up.get("companyid"));
			MyTreeMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
			
			
			String lv_desc="";
			String time_desc = "";
			DbInquiry inqEvent = this.getInquiry("Meventgrp", "*", "eventgrpid='"+lv_type+"'", "", this.up);
			if (inqEvent.next()) {
				lv_desc = inqEvent.getString("tdesc");
			}
			
			data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0' >";			
			data += "<tr bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Leave Request Information&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td colspan='2' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Ũӹǹѹ&nbsp;:&nbsp;</strong></td>";
            }
			//Leave Request Information = Ũӹǹѹ
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='title2'><strong>Leave Type&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td class='title2'><strong>&nbsp;:&nbsp;</strong></td>";                
            }
			//Leave Type = 
			data += "<td class='desc'>"+lv_type+" : "+lv_desc+"</td>";
			data += "</tr>";
			
			data += "<tr>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='title2'><strong>Leave_Date&nbsp;:&nbsp;</strong></td>";
            } else {
                data += "<td class='title2'><strong>ǧѹ&nbsp;:&nbsp;</strong></td>";
            }
			//Leave Date = ǧѹ 
			data += "<td class='desc'>"+startDate+" - "+endDate+"</td>";
			data += "</tr>";
			
			/*data += "<tr>";
			data += "<td></td>";
			data += "<td>"+hm.size()+"</td>";
			data += "</tr>";*/
			
			data += "</table>";
			
			data += "</font>";
			
			data += "<table cellspacing='1' cellpadding='1' width='100%' align='center' border='0'>";		
			data += "<tr align='center' bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='txt_normal'><strong>Date&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Day&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Working_Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Leave_Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Leave_Total&nbsp;</strong></td>";
            } else {
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ҷӧҹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>. &nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
            }
			data += "</tr>";
									
			int hm_size = hm.size();
			int i=1;
			while (i<=hm_size) {
				MyHashMap hmData = (MyHashMap) hm.get(String.valueOf(i));
					
				DbInquiry inqTimet = this.getInquiry("Mtime0", "*", "time0id='"+hmData.getString("TIME0ID")+"'", "", this.up);
				if (inqTimet.next()) {
					time_desc = inqTimet.getString("tdesc");
				}
				
				data += "<tr align='center'>";
				CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
				data += "<td class='desc'>"+cs.getDDMMYYYY()+"</td>";
				data += "<td class='desc'>"+cs.getDOWTHI()+"</td>";
				data += "<td class='desc'>"+hmData.getString("TIME0ID")+" : "+time_desc+"</td>";
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+" - "+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";				
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("LV")))+"</td>";		
				data += "</tr>";
				i++;
			}					
			data += "</table>";	
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}			
		data += this.getBelowFrame();
		return data;
	}	
}
