package com.csc.library.dwr;

import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Mtime0;
import com.csc.library.databean.Tchangeshift_nstda;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Tchangeshift_nstda_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");
	
	public Tchangeshift_nstda_dwr() { }
	
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String startDate = this.chkEmptyData(str, 1);
		String endDate = this.chkEmptyData(str, 2);
		String oldShift = this.chkEmptyData(str, 3);
		String newShift = this.chkEmptyData(str, 4);
		
		try {
			Tchangeshift_nstda rec = (Tchangeshift_nstda) new InitialRecord(up).getDbRecord("TCHANGESHIFT_NSTDA");
			rec.set("TCHSHIFTID","0");			 
			rec.set("EMPLOYEEID", emp);
			rec.set("START_DATE", startDate);
			rec.set("END_DATE", endDate);
			rec.set("OLD_SHIFT",  oldShift);
			rec.set("NEW_SHIFT",  newShift);
			rec.set("COMPANYID", this.up.get("companyid"));
			MyHashMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
								
			for (int j=1;j<=hm.size(); j++) {
				MyHashMap hmShow =null;
				String header = "";
				if (j==1) {
					hmShow = (MyHashMap) hm.get("HMSUB");
                    if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                        header = "Old Working Information";
                    }else{
                        header = "š÷ӧҹ";
                    }
				} else {
					hmShow = (MyHashMap) hm.get("HMADD");
                    if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {                
                        header = "New Working Information";
                    }else{
                        header = "š÷ӧҹ";
                    }
				}				
				
				data += "<table cellspacing='1' cellpadding='0' width='95%' align='center' border='0'>";		
				data += "<tr bgcolor='#0099CC'>";
				data += "<td colspan='5' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;"+header+"&nbsp;:&nbsp;</strong></td>";
				//Old Working Information = š÷ӧҹ
				//New Working Information = š÷ӧҹ
				data += "</tr>";
				data += "<tr align='center' bgcolor='#0099CC'>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {                
    				data += "<td class='txt_normal' width='15%'><strong>Date&nbsp;</strong></td>";
    				data += "<td class='txt_normal' width='15%'><strong>Time Code&nbsp;</strong></td>";
    				data += "<td class='txt_normal' width='50%'><strong>Description&nbsp;</strong></td>";
    				data += "<td class='txt_normal' width='10%'><strong>Time In&nbsp;</strong></td>";			
    				data += "<td class='txt_normal' width='10%'><strong>Time Out&nbsp;</strong></td>";
                }else{
                    data += "<td class='txt_normal' width='15%'><strong>ѹ&nbsp;</strong></td>";
                    data += "<td class='txt_normal' width='15%'><strong>ʡ&nbsp;</strong></td>";
                    data += "<td class='txt_normal' width='50%'><strong>´&nbsp;</strong></td>";
                    data += "<td class='txt_normal' width='10%'><strong>ٴ&nbsp;</strong></td>";           
                    data += "<td class='txt_normal' width='10%'><strong>ٴ͡&nbsp;</strong></td>";
                }
				data += "</tr>";
												
				int i=1; 
				while (i<=hmShow.size()) {
					MyHashMap hmData = (MyHashMap) hmShow.get(String.valueOf(i));
						
					data += "<tr align='center'>";
					CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
					data += "<td class='desc'>"+cs.getDDMMYYYY()+"</td>";
					data += "<td class='desc'>"+hmData.getString("TIME0ID")+"</td>";
					data += "<td class='desc'>"+this.getTimeDesc(hmData.getString("TIME0ID"))+"</td>";
					data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";				
					data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";		
					data += "</tr>";
					i++;
				}
				data += "<tr>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
    				data += "<td class='desc' align='right'>Total&nbsp;:&nbsp;</td>";
                    data += "<td class='desc' align='center'>"+hmShow.size()+"&nbsp;</td>";
    				data += "<td class='desc'>Day</td>";
                    data += "<td class='desc'>&nbsp;</td>";
                    data += "<td class='desc'>&nbsp;</td>";
                }else{
                    data += "<td class='desc' align='right'>&nbsp;:&nbsp;</td>";
                    data += "<td class='desc' algin='center'>"+hmShow.size()+"&nbsp;</td>";
                    data += "<td class='desc'>ѹ</td>";
                    data += "<td class='desc'>&nbsp;</td>";
                    data += "<td class='desc'>&nbsp;</td>";               
                }
                data += "</tr>";
				data += "</table>";

			}		
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		data += this.getBelowFrame();
		return data;
	}
	
	public String getDWRDataService(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String startDate = this.chkEmptyData(str, 1);
		String endDate = this.chkEmptyData(str, 2);
		String oldShift = this.chkEmptyData(str, 3);
		String newShift = this.chkEmptyData(str, 4);
		
		try {
			Tchangeshift_nstda rec = (Tchangeshift_nstda) new InitialRecord(up).getDbRecord("TCHANGESHIFT_NSTDA");
			rec.set("TCHSHIFTID","0");			 
			rec.set("EMPLOYEEID", emp);
			rec.set("START_DATE", startDate);
			rec.set("END_DATE", endDate);
			rec.set("OLD_SHIFT",  oldShift);
			rec.set("NEW_SHIFT",  newShift);
			rec.set("COMPANYID", this.up.get("companyid"));
			MyHashMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
								
			for (int j=1;j<=hm.size(); j++) {
				MyHashMap hmShow =null;
				String header = "";
				if (j==1) {
					hmShow = (MyHashMap) hm.get("HMSUB");
                    if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                        header = "Old Working Information";
                    }else{
                        header = "š÷ӧҹ";
                    }
				} else {
					hmShow = (MyHashMap) hm.get("HMADD");
                    if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {                
                        header = "New Working Information";
                    }else{
                        header = "š÷ӧҹ";
                    }
				}				
				
				data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";		
				data += "<tr>";
				data += "<td colspan='5' align='center' class='row-title'>"+header+"</td>";
				//Old Working Information = š÷ӧҹ
				//New Working Information = š÷ӧҹ
				data += "</tr>";
				data += "<tr align='center'>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {                
    				data += "<td class='row-header' width='15%'>Date</td>";
    				data += "<td class='row-header' width='15%'>Time Code</td>";
    				data += "<td class='row-header' width='50%'>Description</td>";
    				data += "<td class='row-header' width='10%'>Time In</td>";			
    				data += "<td class='row-header' width='10%'>Time Out</td>";
                }else{
                    data += "<td class='row-header' width='15%'><strong>ѹ</td>";
                    data += "<td class='row-header' width='15%'><strong>ʡ</td>";
                    data += "<td class='row-header' width='50%'><strong>´</td>";
                    data += "<td class='row-header' width='10%'><strong>ٴ</td>";           
                    data += "<td class='row-header' width='10%'><strong>ٴ͡</td>";
                }
				data += "</tr>";
												
				int i=1; 
				while (i<=hmShow.size()) {
					MyHashMap hmData = (MyHashMap) hmShow.get(String.valueOf(i));
						
					data += "<tr align='center'>";
					CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
					data += "<td class='row-data'>"+cs.getDDMMYYYY()+"</td>";
					data += "<td class='row-data'>"+hmData.getString("TIME0ID")+"</td>";
					data += "<td class='row-data'>"+this.getTimeDesc(hmData.getString("TIME0ID"))+"</td>";
					data += "<td class='row-data'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";				
					data += "<td class='row-data'>"+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";		
					data += "</tr>";
					i++;
				}
				data += "<tr>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
    				data += "<td class='row-data' align='right'>Total&nbsp;:&nbsp;</td>";
                    data += "<td class='row-data' colspan='4'>&nbsp;"+hmShow.size()+"&nbsp;Day</td>";
                }else{
                    data += "<td class='row-data' align='right'>&nbsp;:&nbsp;</td>";
                    data += "<td class='row-data' colspan='4'>&nbsp;"+hmShow.size()+"&nbsp;ѹ</td>";
                }
                data += "</tr>";
				data += "</table>";

			}		
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		data += this.getBelowFrame();
		return data;
	}
	
	public String getListShift(String[] str){
        this.setUProfile();
        String shiftList = "";
        String empCode = this.chkEmptyData(str, 0);
        String start_date = this.chkEmptyData(str, 1);
        String end_date = this.chkEmptyData(str, 2);
        try {
            Tchangeshift_nstda rec = (Tchangeshift_nstda) new InitialRecord(up).getDbRecord("TCHANGESHIFT_NSTDA");
            rec.set("TCHSHIFTID","0");           
            rec.set("EMPLOYEEID", empCode);
            rec.set("START_DATE", start_date);
            rec.set("END_DATE", end_date);
            rec.set("COMPANYID", this.up.get("companyid"));
            
            shiftList =  rec.getListShift(empCode, start_date, end_date);
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return shiftList;
    }
	
	public boolean isHoliday(String[] str){
        this.setUProfile();
        boolean result = false;
        String empCode = this.chkEmptyData(str, 0);
        String date = this.chkEmptyData(str, 1);
        try {
            Tchangeshift_nstda rec = (Tchangeshift_nstda) new InitialRecord(up).getDbRecord("TCHANGESHIFT_NSTDA");
            rec.set("TCHSHIFTID","0");           
            rec.set("EMPLOYEEID", empCode);
            rec.set("START_DATE", date);
            rec.set("END_DATE", date);
            rec.set("COMPANYID", this.up.get("companyid"));
            
            result =  rec.chkIsHoliday(empCode, date);
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return result;
	}

    public String getListShiftAll(String[] str){
        this.setUProfile();
        String shiftList = "";
        String empCode = this.chkEmptyData(str, 0);
        String start_date = this.chkEmptyData(str, 1);
        String end_date = this.chkEmptyData(str, 2);
        try {
            Tchangeshift_nstda rec = (Tchangeshift_nstda) new InitialRecord(up).getDbRecord("TCHANGESHIFT_NSTDA");
            rec.set("TCHSHIFTID","0");           
            rec.set("EMPLOYEEID", empCode);
            rec.set("START_DATE", start_date);
            rec.set("END_DATE", end_date);
            rec.set("COMPANYID", this.up.get("companyid"));
            
            shiftList =  rec.getListShiftAll(empCode, start_date, end_date);
        } catch (Exception e) {
            MyLog.error(this, e);
        }
        return shiftList;
    }

}
