package com.csc.library.dwr;

import java.text.DecimalFormat;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Texchangeshift_nstda;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

public class Texchangeshift_nstda_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");

	public Texchangeshift_nstda_dwr() { }
	
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp_exchange = this.chkEmptyData(str, 0);
		String emp_receive = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String endDate = this.chkEmptyData(str, 3);
		
		try {
			Texchangeshift_nstda rec = (Texchangeshift_nstda) new InitialRecord(up).getDbRecord("TEXCHANGESHIFT_NSTDA");
			rec.set("TEXSHIFTID","0");			 
			rec.set("EMP_EXCHANGE", emp_exchange);	
			rec.set("EMP_RECEIVE", emp_receive);	
			rec.set("START_DATE", startDate);
			rec.set("END_DATE", endDate);
			rec.set("COMPANYID", this.up.get("companyid"));
			MyHashMap hm = rec.getDWRData();
			//MyLog.debug(this, "===="+hm);
						
			for (int j=1;j<=2; j++) {
				MyHashMap hmShow =null;
				String empFullName = "";
				if (j==1) {
					hmShow = (MyHashMap) hm.get("HM_EXCHANGE_ADD");		
					empFullName = emp_exchange+" - "+this.getEmployeeName(emp_exchange); 
				} else {
					hmShow = (MyHashMap) hm.get("HM_RECEIVE_ADD");
					empFullName = emp_receive+" - "+this.getEmployeeName(emp_receive); 
				}				
				data += "<input type='hidden' name='day_emp"+j+"' value='"+hmShow.size()+"'>";
				data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";		
				data += "<tr bgcolor='#0099cc'>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
    				data += "<td colspan='5' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Working Information&nbsp;"+empFullName+"&nbsp;:&nbsp;</strong></td>";
    				//Working Information = š÷ӧҹ
    				data += "</tr>";
    				data += "<tr align='center' bgcolor='#0099cc'>";
    				data += "<td class='txt_normal' width='15%'><strong>Date&nbsp;</strong></td>";
    				data += "<td class='txt_normal' width='15%'><strong>Time Code&nbsp;</strong></td>";
    				data += "<td class='txt_normal' width='50%'><strong>Description&nbsp;</strong></td>";
    				data += "<td class='txt_normal' width='10%'><strong>Time In&nbsp;</strong></td>";			
    				data += "<td class='txt_normal' width='10%'><strong>Time Out&nbsp;</strong></td>";
                }else{
                    data += "<td colspan='5' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;š÷ӧҹ&nbsp;"+empFullName+"&nbsp;:&nbsp;</strong></td>";
                    //Working Information = š÷ӧҹ
                    data += "</tr>";
                    data += "<tr align='center' bgcolor='#0099cc'>";
                    data += "<td class='txt_normal' width='15%'><strong>ѹ&nbsp;</strong></td>";
                    data += "<td class='txt_normal' width='15%'><strong>ʡ&nbsp;</strong></td>";
                    data += "<td class='txt_normal' width='50%'><strong>´&nbsp;</strong></td>";
                    data += "<td class='txt_normal' width='10%'><strong>ٴ&nbsp;</strong></td>";           
                    data += "<td class='txt_normal' width='10%'><strong>ٴ͡&nbsp;</strong></td>";
                }
				data += "</tr>";
												
				int i=1; 
				while (i<=hmShow.size()) {
					MyHashMap hmData = (MyHashMap) hmShow.get(String.valueOf(i));
						
					data += "<tr align='center'>";
					CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
					data += "<td class='desc'>"+cs.getDDMMYYYY()+"<INPUT TYPE='hidden' NAME='__dateexc"+i+"_emp"+j+"' VALUE="+cs.getDDMMYY()+"></td>";
					data += "<td class='desc'>"+hmData.getString("TIME0ID")+"<INPUT TYPE='hidden' NAME='__time0idexc"+i+"_emp"+j+"' VALUE="+hmData.getString("TIME0ID")+"></td>";
					data += "<td class='desc'>"+this.getTimeDesc(hmData.getString("TIME0ID"))+"</td>";
					data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";				
					data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";		
					data += "</tr>";
					i++;
				}		
				data += "<tr>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                    data += "<td class='desc' align='right'>Total&nbsp;:&nbsp;</td>";
                    data += "<td class='desc' align='center'>"+hmShow.size()+"&nbsp;</td>";
                    data += "<td class='desc'>Day</td>";
                    data += "<td class='desc'>&nbsp;</td>";
                    data += "<td class='desc'>&nbsp;</td>";
                }else{
                    data += "<td class='desc' align='right'>&nbsp;:&nbsp;</td>";
                    data += "<td class='desc' algin='center'>"+hmShow.size()+"&nbsp;</td>";
                    data += "<td class='desc'>ѹ</td>";
                    data += "<td class='desc'>&nbsp;</td>";
                    data += "<td class='desc'>&nbsp;</td>";               
                }
				data += "</tr>";
				data += "</table>";	
			}			
		} catch (Exception e) {
			//MyLog.error(this, e);		
		}
		data += this.getBelowFrame();
		return data;
	}
		
	public String getDWRDataService(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp_exchange = this.chkEmptyData(str, 0);
		String emp_receive = this.chkEmptyData(str, 1);
		String startDate = this.chkEmptyData(str, 2);
		String endDate = this.chkEmptyData(str, 3);
		
		try {
			Texchangeshift_nstda rec = (Texchangeshift_nstda) new InitialRecord(up).getDbRecord("TEXCHANGESHIFT_NSTDA");
			rec.set("TEXSHIFTID","0");			 
			rec.set("EMP_EXCHANGE", emp_exchange);	
			rec.set("EMP_RECEIVE", emp_receive);	
			rec.set("START_DATE", startDate);
			rec.set("END_DATE", endDate);
			rec.set("COMPANYID", this.up.get("companyid"));
			MyHashMap hm = rec.getDWRData();
			//MyLog.debug(this, "===="+hm);
						
			for (int j=1;j<=2; j++) {
				MyHashMap hmShow =null;
				String empFullName = "";
				if (j==1) {
					hmShow = (MyHashMap) hm.get("HM_EXCHANGE_ADD");		
					empFullName = emp_exchange+" - "+this.getEmployeeName(emp_exchange); 
				} else {
					hmShow = (MyHashMap) hm.get("HM_RECEIVE_ADD");
					empFullName = emp_receive+" - "+this.getEmployeeName(emp_receive); 
				}				
				data += "<input type='hidden' name='day_emp"+j+"' value='"+hmShow.size()+"'>";
				data += "<table cellspacing='1' cellpadding='0' width='100%' align='center' border='0'>";		
				data += "<tr>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {         
    				data += "<td colspan='5' align='center' class='row-title'>Working Information&nbsp;"+empFullName+"</td>";
    				//Working Information = š÷ӧҹ
    				data += "</tr>";
    				data += "<tr align='center'>";
    				data += "<td class='row-header' width='15%'><strong>Date&nbsp;</strong></td>";
    				data += "<td class='row-header' width='15%'><strong>Time Code&nbsp;</strong></td>";
    				data += "<td class='row-header' width='50%'><strong>Description&nbsp;</strong></td>";
    				data += "<td class='row-header' width='10%'><strong>Time In&nbsp;</strong></td>";			
    				data += "<td class='row-header' width='10%'><strong>Time Out&nbsp;</strong></td>";
                }else{
                    data += "<td colspan='5' align='center' class='row-title'>š÷ӧҹ&nbsp;"+empFullName+"</td>";
                    //Working Information = š÷ӧҹ
                    data += "</tr>";
                    data += "<tr align='center'>";
                    data += "<td class='row-header' width='15%'><strong>ѹ&nbsp;</strong></td>";
                    data += "<td class='row-header' width='15%'><strong>ʡ&nbsp;</strong></td>";
                    data += "<td class='row-header' width='50%'><strong>´&nbsp;</strong></td>";
                    data += "<td class='row-header' width='10%'><strong>ٴ&nbsp;</strong></td>";           
                    data += "<td class='row-header' width='10%'><strong>ٴ͡&nbsp;</strong></td>";
                }
				data += "</tr>";
												
				int i=1; 
				while (i<=hmShow.size()) {
					MyHashMap hmData = (MyHashMap) hmShow.get(String.valueOf(i));
						
					data += "<tr align='center'>";
					CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
					data += "<td class='row-data'>"+cs.getDDMMYYYY()+"<INPUT TYPE='hidden' NAME='__dateexc"+i+"_emp"+j+"' VALUE="+cs.getDDMMYY()+"></td>";
					data += "<td class='row-data'>"+hmData.getString("TIME0ID")+"<INPUT TYPE='hidden' NAME='__time0idexc"+i+"_emp"+j+"' VALUE="+hmData.getString("TIME0ID")+"></td>";
					data += "<td class='row-data'>"+this.getTimeDesc(hmData.getString("TIME0ID"))+"</td>";
					data += "<td class='row-data'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";				
					data += "<td class='row-data'>"+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";		
					data += "</tr>";
					i++;
				}		
				data += "<tr>";
                if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                	data += "<td class='row-data' align='right'>Total&nbsp;:&nbsp;</td>";
                    data += "<td class='row-data' colspan='4'>&nbsp;"+hmShow.size()+"&nbsp;Day</td>";
                }else{
                    data += "<td class='row-data' align='right'>&nbsp;:&nbsp;</td>";
                    data += "<td class='row-data' colspan='4'>&nbsp;"+hmShow.size()+"&nbsp;ѹ</td>";
                }
				data += "</tr>";
				data += "</table>";	
			}			
		} catch (Exception e) {
			//MyLog.error(this, e);		
		}
		data += this.getBelowFrame();
		return data;
	}
}
