package com.csc.library.dwr;

import java.rmi.RemoteException;
import java.text.DecimalFormat;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tot;
import com.csc.library.databean.Tot0_liteon;
import com.csc.library.databean.Tot1_liteon;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

public class Tot_liteon_dwr extends DWR_base{

    private DbTable dbTot1_liteon;
    private float limitOTWeek=0;
    DecimalFormat df =new DecimalFormat("#0.00");

    public Tot_liteon_dwr() {}
    
    public void writeUProfile(UProfile up) {
        this.up = up;
    }
    
    public String getDWRData(String[] str) {
        if (this.up == null) {
            this.setUProfile();
        } 
        String data = "";
        String[] empList ;
        String[] value;
        
        this.setLimitOTWeek(Float.parseFloat(this.chkEmptyData(str, 0)));
        CscCalendar startDate = new CscCalendar(this.chkEmptyData(str, 1));
        CscCalendar endDate = new CscCalendar(this.chkEmptyData(str, 2));
        String startTime = this.chkEmptyData(str, 3);
        String endTime = this.chkEmptyData(str, 4);
        String cc = this.chkEmptyData(str, 5);
        String emp = this.chkEmptyData(str, 6);
        empList = emp.split(",");
        
        try {
            Tot0_liteon rec = (Tot0_liteon) new InitialRecord(up).getDbRecord("TOT0_LITEON");
            rec.set("OTID","0");             
            rec.set("COMPANYID", this.up.get("companyid")); 
            //rec.set("SHIFT", shift);
            rec.set("START_DATE", startDate.getYYYYMMDD());
            rec.set("START_TIME", startTime);
            rec.set("END_DATE", endDate.getYYYYMMDD());
            rec.set("END_TIME",  endTime);
            rec.set("COSTCENTER", cc);
            
           DbTable dt = new InitialTable(up).getDbTable("TOT1_LITEON");
            
            for(int i = 1; i<empList.length; i++){
                value = empList[i].split("@");
                DbRecord recTot1 = dt.getNewRecord();
                recTot1.set(dt.getMinorKey(), value[0]);
                recTot1.set("EMPLOYEEID", value[1]);
                //recTot1.set("OT_WORKAREA", value[2]);
                dt.putNewRecord(recTot1);
            }
            rec.putChild(dt);
            
            MyTreeMap hm = (MyTreeMap) rec.getDWRData();
            MyLog.debug(this, "===="+hm);

            
            Iterator it = hm.keySet().iterator();
            while(it.hasNext()){
                String key = (String) it.next();
                MyHashMap hmEmp = (MyHashMap) hm.get(key);
                data += "#"+hmEmp.getString("EMPLOYEEID")+"$"+this.calcOT(hmEmp.getString("EMPLOYEEID"), hmEmp.getFloat("LV"), startDate, endDate);
            }
            
        } catch (Exception e) {
            MyLog.error(this, e);
        }       
        
        return data;
    }
    
    private String calcOT(String empCode, float lv, CscCalendar startdate, CscCalendar enddate){
        String acOtAndOtTotal ="";
        CscTime otTotal = new CscTime();
        CscTime sumAcOT = new CscTime();
        CscTime newLv = new CscTime();
        
        CscCalendar c1 = new CscCalendar(startdate.getYYYYMMDD());
        CscCalendar c2 = new CscCalendar(enddate.getYYYYMMDD());
        c1.decDate(c1.getDOW());
        c2.incDate(7-c2.getDOW());
        
        try {
            DbInquiry inqTime = new InitialInquiry(up).getDbInquiry();
            inqTime.setSchemaName(up.getSchemaName());
            inqTime.initMyTable("Ttime_current1", "", "");
            inqTime.setFilter("employeeid = '"+empCode+"' and dateid between '"+c1.getYYYYMMDD()+"' and '"+c2.getYYYYMMDD()+"'");
            inqTime.setColumn("employeeid,companyid,dateid,ac_ot");
            inqTime.refresh();
            while(inqTime.next()){
                DbRecord rec = inqTime.getCurrentDbRecord();
                sumAcOT.add(rec.getFloat("AC_OT"));
            }
            
            DbInquiry inqHis = new InitialInquiry(up).getDbInquiry();
            inqHis.setSchemaName(up.getSchemaName());
            inqHis.initMyTable("Ttime_history1", "", "");
            inqHis.setFilter("employeeid = '"+empCode+"' and dateid between '"+c1.getYYYYMMDD()+"' and '"+c2.getYYYYMMDD()+"'");
            inqHis.setColumn("employeeid,companyid,dateid,ac_ot");
            inqHis.refresh();
            while(inqHis.next()){
                DbRecord rec = inqHis.getCurrentDbRecord();
                sumAcOT.add(rec.getFloat("AC_OT"));
            }
            
            otTotal.add(sumAcOT);
            otTotal.add(lv);
            acOtAndOtTotal += df.format(sumAcOT.getFloat())+"$";
            if(otTotal.getFloat() <= this.getLimitOTWeek()){
                acOtAndOtTotal += df.format(otTotal.getFloat())+"$"+df.format(lv);
            }else{
                newLv.add(this.getLimitOTWeek());
                newLv.sub(otTotal.getFloat());
                if(newLv.getFloat() >= 0){
                    acOtAndOtTotal += df.format(this.getLimitOTWeek())+"$"+df.format(newLv);
                }else{
                    acOtAndOtTotal += df.format(this.getLimitOTWeek())+"$0";
                }
            }
            MyLog.debug(this, "OT VALUE >>> "+acOtAndOtTotal);

        } catch (Exception e) {
            MyLog.error(this, e);
        }
        
        return acOtAndOtTotal;
    }

    public float getLimitOTWeek() {
        return limitOTWeek;
    }

    public void setLimitOTWeek(float limitOTWeek) {
        this.limitOTWeek = limitOTWeek;
    }
    
}
