package com.csc.library.dwr;

import java.text.DecimalFormat;
import java.util.Vector;

import bsh.Interpreter;

import com.csc.library.databean.Ttime_current1;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.DateProperties;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class ValidateVacationCode extends DWR_base {

	DbRecord emp ;
	
	public String validateCode(String code){
		try {
			String result = ""; 
			String condition = "";
			String com_formula = "";
			String new_vacation1 = "00:00:00";	
			
			String ENDOFYEAR = "ENDOFYEAR";
			String STARTOFYEAR = "STARTOFYEAR";

			DbRecord empdb = getEmpDb(this.up.get("employeeid"));
			DecimalFormat df = new DecimalFormat("00");
			CscCalendar today = new CscCalendar();
			CscCalendar empstart = new CscCalendar(empdb.getString("startdate"));
			DateProperties now = new DateProperties(today.getYYYYMMDD(), "-");
			Vector vMainFormula = new Vector();
			
			CscCalendar datestofyear = new CscCalendar("31-12-" + today.getYear());
			
			Interpreter in = new Interpreter();
			in.set("ENDOFYEAR", ENDOFYEAR);
			in.set("STARTOFYEAR", STARTOFYEAR);
			in.set("workstart",now);	/* ѹҹ */
			in.set("workage",now);		/* اҹ ( ͹ ѹ)*/
			in.set("yearofwork", now.year + 1);	/* ӹǹշӧҹ */
			in.set("dayofwork", today.countDay(today));	/* ӹǹѹӧҹ */
			in.set("today", now);				/* ѹѨغѹ */
			in.set("result","");
			in.set("comresult",0d);
			in.set("dayofyear", datestofyear.getDayOfYear());
			in.set("emp", empdb);
			in.set("todaydate", today);	/* ѹѨغѹ CscCalendar */
			in.set("util", getTcur1Object());	/* ҧ ttime_current1 ҹ getRounding method */

			/* ѹ鹧ҹͧѡҹ */
			empstart.setCscCalendar(Integer.toString(today.getYear())+"-"+empstart.getMM()+"-"+empstart.getDD());
			in.set("empstartdate", empstart.getDayOfYear());
			
			in.eval("result = " + code);	/* complie code */	
		}catch(Exception e){
			String err = (e.toString().length() > 50)?e.toString().substring(0,50):e.toString();
			return err + "\r\r Source : \r" + code;
		}
		return "";
	}
	
	private DbRecord getEmpDb(String empid){
		try {
			if(this.emp == null || !this.emp.getString("employeeid").equals(empid)){
				this.emp = new InitialRecord(this.up).getDbRecord("Memployee");
				emp.setParam("rsc_skip","true");
				emp.setColumn("*");
				emp.set("employeeid", empid);
				emp.set("companyid", (String) this.up.get("companyid"));
				emp.search();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return this.emp;
	}
	
	private Ttime_current1 getTcur1Object(){
		Ttime_current1 t1 = null;
		try {
			t1 = (Ttime_current1) new InitialRecord(this.up).getDbRecord("ttime_current1");
			t1.setColumn("*");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return t1 ;
	}
}
