package com.csc.library.dwr;

import java.util.Iterator;

import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

public class WorkingShift_dwr extends DWR_base {
	Mtime0 dbmtime0 ;
	
	public String getActualShift(String emp, String start, String end){
		WorkingShift ws = null;
		String time0 = "";
		try {
			this.setUProfile();
			
			DbRecord dbemp = new InitialRecord(this.up).getDbRecord("Memployee");
			dbemp.setParam("rsc_skip","true");
			dbemp.setColumn("*");
			dbemp.set("employeeid", emp);
			dbemp.set("companyid", (String)this.up.get("companyid"));
			if(dbemp.search() == 1){
				dbmtime0 = (Mtime0) new InitialRecord(this.up).getDbRecord("Mtime0");
				dbmtime0.setColumn("*");
				dbmtime0.set("time0id", dbemp.getString("time0"));
				dbmtime0.set("companyid", (String)this.up.get("companyid"));
				
				if(dbmtime0.search() == 1){
					CscCalendar st = new CscCalendar(start);
					CscCalendar en = new CscCalendar(start);
					
					dbmtime0.setEmpRec(dbemp);
					ws = dbmtime0.genWorkingShift(st, en, "true");
					ws.setUProfile(this.up);
					ws.meargeWithShiftTrans(dbemp, st, en);
									
					if(!ws.isEmpty()){
						Iterator it = (Iterator) ws.keySet().iterator();
						while(it.hasNext()){
							DayShift df = (DayShift) ws.get((String)it.next()) ;
							Iterator it1 = (Iterator) df.keySet().iterator();
							while(it1.hasNext()){
								Shift sh = (Shift) df.get((String)it1.next()) ;
								time0 = getShifDetail(sh.getTimeCode());
							}
						}
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return time0;
	}
	
	private String getShifDetail(String tm0){
		String rtn = "";
		try {
			if(!this.dbmtime0.getString("time0id").equals(tm0)){
				dbmtime0 = (Mtime0) new InitialRecord(this.up).getDbRecord("Mtime0");
				dbmtime0.setColumn("*");
				dbmtime0.set("time0id", tm0);
				dbmtime0.set("companyid", (String)this.up.get("companyid"));
				if(dbmtime0.search() != 1){
					MyLog.error("!! Time0id not found, details will be blank for : " + tm0);
				}
			}
			
			rtn = this.dbmtime0.getString("time0id") + ":" + this.dbmtime0.getString("tdesc") + ":" + this.dbmtime0.getString("edesc");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return rtn ;
	}
	
	public String[] getDayShift(String emp, String start, String end){
		WorkingShift ws = null;
		String shlist[] = null;
		              
		try {
			this.setUProfile();
			
			DbRecord dbemp = new InitialRecord(this.up).getDbRecord("Memployee");
			dbemp.setParam("rsc_skip","true");
			dbemp.setColumn("*");
			dbemp.set("employeeid", emp);
			dbemp.set("companyid", (String)this.up.get("companyid"));
			if(dbemp.search() == 1){
				dbmtime0 = (Mtime0) new InitialRecord(this.up).getDbRecord("Mtime0");
				dbmtime0.setColumn("*");
				dbmtime0.set("time0id", dbemp.getString("time0"));
				dbmtime0.set("companyid", (String)this.up.get("companyid"));
				
				if(dbmtime0.search() == 1){
					CscCalendar st = new CscCalendar(start);
					CscCalendar en = new CscCalendar(start);
					
					dbmtime0.setEmpRec(dbemp);
					ws = dbmtime0.genWorkingShift(st, en, "true");
					ws.setUProfile(this.up);
					ws.setEmployeeid(emp);
					ws.setEmprec(dbemp);
					
					ws.meargeWithShiftTrans(dbemp, st, en);
					ws.adjust();
									
					if(!ws.isEmpty()){
						Iterator it = (Iterator) ws.keySet().iterator();
						while(it.hasNext()){
							DayShift df = (DayShift) ws.get((String)it.next()) ;
							Iterator it1 = (Iterator) df.keySet().iterator();
							
							shlist = new String[df.size()];
							int idx = 0;
							StringBuffer sbsh = new StringBuffer();
							
							while(it1.hasNext()){
								Shift sh = (Shift) df.get((String)it1.next()) ;
								
								sbsh.append(sh.getTimeCode()).append("#");
								sbsh.append(sh.getEventGroup()).append("#");
								sbsh.append(sh.get_c_dt_in().getDDMMYYYY()).append("#");
								sbsh.append(sh.get_c_dt_in().getCSCTime()).append("#");
								sbsh.append(sh.get_c_dt_out().getDDMMYYYY()).append("#");
								sbsh.append(sh.get_c_dt_out().getCSCTime());
								
								shlist[idx] = sbsh.toString();
								idx++;
							}
						}
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return shlist;
	}

}
