package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import org.jdom.Element;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Memployee_ta;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.CreateChangeShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

/* ʹ˹ҷ֧ٴѵâ еǨͺٴѵ ҡçѺҧ㹡¹ ҧ¹ */
public class AutoChgShift extends ProcessTimeBase {
	private MyHashMap hm = null;
	private int DupPeriod = 0;
	
	private String getStartDate(){
		try {
			if(this.data.containsKey("startDate")){
				return (String) this.data.get("startDate");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return (new CscCalendar()).getYYYYMMDD();
	}
	
	private String getEndDate(){
		try {
			if(this.data.containsKey("endDate")){
				return (String) this.data.get("endDate");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return (new CscCalendar()).getYYYYMMDD();
	}
	
	private String getExtendEndDate(){
		try {
			if(this.data.containsKey("endDate")){
				CscCalendar end = new CscCalendar((String) this.data.get("endDate"));
				end.incDate(); /* ǡ 1 ѹ ͵֧ͧٴͧ͡ѹѴ 㹡óշ繡Тѹ */
				return end.getYYYYMMDD();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return (new CscCalendar()).getYYYYMMDD();
	}
	
	private String getEmpStart(){
		try {
			if(this.data.containsKey("empStart")){
				return (String) this.data.get("empStart");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return (new CscCalendar()).getYYYYMMDD();
	}
	
	private String getEmpEnd(){
		try {
			if(this.data.containsKey("empEnd")){
				return (String) this.data.get("empEnd");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return (new CscCalendar()).getYYYYMMDD();
	}
	
	private String getFilter(){
		String filter = "";
		try {
			/* ֧ٴѵõѹҡ˹Ҩ ͡ա 1 ѹ͵ͧٴͧ͡ѹѴ仴 㹡óաТѹ */
			filter = "select t.employeeid,t.companyid,t.swipedate,t.swipetime,t.swipetype,t.source,t.runno";
			filter += " from ttimetemp t left join memployee m on t.EMPLOYEEID = m.EMPLOYEEID";			
			filter += " where m.status in ('A','B','S','V','W') and t.swipedate between '" + getStartDate() + "' and '" + getExtendEndDate() + "' ";
			
			String con = this.getParamValue("RAWFILTER");
			if(!con.equals("")){
				con = con.replace("employeeid", "t.employeeid");
				con = con.replace("bu1","m.bu1");
				con = con.replace("bu2","m.bu2");
				con = con.replace("bu3","m.bu3");
				con = con.replace("bu4","m.bu4");
				con = con.replace("bu5","m.bu5");				
				
				con = con.replace("salatype","m.salatype");
				filter += " and " + con ;
			}
			
			filter += " order by t.employeeid,t.swipedate,t.swipetime";
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return filter;
	}
	
	public HashMap getInputData(){
		return this.data;
	}
	
	public void setInputData(HashMap data){
		this.data = data;
	}
	
	/* ֧ٴѵõ͹䢨ҡ˹Ҩ */
	public Vector getProcessList() {
		Vector v = new Vector();
    	CscConnection conn = null;
   	   	Statement stmt = null;
        ResultSet rs = null;
        
		try {
			this.setParamData();
	        this.chkParamQueue();	

			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(getFilter());			
			
			String empIdx = "";
			HashMap hData = new HashMap();
			Vector vSwipetime = new Vector();
			
			System.out.print("SQL search data [ChgAsentToChangeShift] : " + getFilter());
			while(rs.next()){
				/* ѹش¢ͧǧ֧ٴѵ ͧ੾ٴ͡ҹ 礡ٴͧ͡ѹ͹˹ ٴҴ жѹж١¹ѵѵ仴 㹡óբͷѹеԴѹ ͷըŧж١¹͹ */
				if(rs.getString("swipedate").equals(getExtendEndDate()) && (rs.getString("swipetype").equals("00") || rs.getString("swipetype").equals("0"))){	
					continue;
				}
				
				if(empIdx.equals("")) {
					/* ѡҹá ˹ */
					empIdx = rs.getString("employeeid");
					hData.put("SWIPEDATA", vSwipetime);
				}
				
				if(!empIdx.equals(rs.getString("employeeid"))){
					v.add(hData);
					
					/* ѡҹ  */
					empIdx = rs.getString("employeeid");
					hData = new HashMap();
					vSwipetime = new Vector();
					hData.put("SWIPEDATA", vSwipetime);
				}
				
				hData.put("EMPLOYEEID", empIdx);
				hData.put("COMPANYID", rs.getString("companyid"));
				
				vSwipetime = (Vector) hData.get("SWIPEDATA");
				
				HashMap hSwipetime = new HashMap();
				
				hSwipetime.put("SWIPEDATE", rs.getString("swipedate"));
				hSwipetime.put("SWIPETIME", rs.getString("swipetime"));
				hSwipetime.put("SWIPETYPE", rs.getString("swipetype"));
				hSwipetime.put("SOURCE", rs.getString("source"));
				hSwipetime.put("RUNNO", rs.getString("runno"));
				
				vSwipetime.add(hSwipetime);
				
				hData.put("SWIPEDATA", vSwipetime);
			}
			v.add(hData);
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		
		System.out.print("Data list size [ChgAbsentToChangShift] : " + v.size());
		return v;
	 }
	
	public Vector getDataList(){
		try {
			if(!this.data.containsKey("isDirectCall")){
				return this.getProcessList();	/* 觨ҡ csc_quque ,method getProcessList ж١¡ͧѵѵ */
			}else{
				return this.processList;		/* 觨ҡµç ¡ getProcessList ͧ */
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return null;
	}
	
	
	public void process(){
		try {
			initConfig();
			Vector data = getDataList();
			if(data.size() > 0) {
				for(int i=0; i < data.size(); i++){	/* ǹٻ֧ҷӧҹ */
					try {
						HashMap time = (HashMap) data.get(i);
						MyLog.debug("Process line : " + i + " [data : " + time + "]");
						changeShift(time);
					}catch(Exception e){
						MyLog.error(this,e);
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void initConfig(){
		try {
			this.DupPeriod = Integer.parseInt((String) StaticConfig.getConfigCompany(this.upf, "TADUPP"));
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void changeShift(HashMap emp) {
		try {
			Vector vSwipetime = (Vector) emp.get("SWIPEDATA");
			if(vSwipetime != null){
				CscCalendar hisKey = null;
				boolean isDupOnPeriod = false ;
				for(int ii=0; ii < vSwipetime.size(); ii++){
					HashMap hSwipeData = (HashMap) vSwipetime.get(ii);
					
					/* 㹡óշ˹кҧẺѵѵ ʶҹТͧ AUTO_GEN_SHIFT == 1 (֧Ҩҡ MConfig) ͧἹ÷ӧҹҧ ԧѺٴѵ ͧҧ¹ */
			    	if(((String)hSwipeData.get("SWIPETYPE")).equals("0")){ /* ੾Тٴѵٴҹ (swipetype = 0) еͧҨҡ˹Ҩ TAU177, TAU177_HR */
			    		System.out.print("!!! swipetype is 0 !!!!");
						/* ҧҧٴѵá͹˹ 㹪ǧѹͧӫ */
						if(hisKey == null){
							try {
								hisKey = new CscCalendar((String)hSwipeData.get("SWIPEDATE"));
								hisKey.setCSCTime(Float.parseFloat((String)hSwipeData.get("SWIPETIME")));
							}catch(Exception e){
								MyLog.error(this,e);
							}
						}else{
							CscCalendar cur = new CscCalendar((String)hSwipeData.get("SWIPEDATE"));
							cur.setCSCTime(Float.parseFloat((String)hSwipeData.get("SWIPETIME")));
							
							if(cur.subForHour(hisKey) <= DupPeriod){	/* ѹͧ */
								isDupOnPeriod = true ;
							}else{
								isDupOnPeriod = false;
							}
						}
						
			    		if(isValidRunno(emp, hSwipeData) && !isDupOnPeriod){
				    		CreateChangeShift genShift = new CreateChangeShift(getTimeRecord(emp, hSwipeData));
					        genShift.setFixDoc((String)hSwipeData.get("RUNNO"));
					        genShift.setNextOut(getNextOut(ii, vSwipetime));	/* ٴ͡駶Ѵ */
					        genShift.createChangeShift();
			    		}
			    	}else{
			    		System.out.print("!!! swipetype is not 0 ,process changeshift will not be activate !!!!");
			    	}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
    private void chkParamQueue() {
		if (this.getParamValue("startDate").equalsIgnoreCase("today") && this.getParamValue("endDate").equalsIgnoreCase("today")) {
			//ѹѨغѹ 駤
			CscCalendar c1 = new CscCalendar();
			this.data.put("startDate", c1.getYYYYMMDD());
			this.data.put("endDate", c1.getYYYYMMDD());
			this.hmParam.put("startDate", c1.getYYYYMMDD());
			this.hmParam.put("endDate", c1.getYYYYMMDD());
		}else if (this.getParamValue("startDate").indexOf("last")>-1 && this.getParamValue("endDate").equalsIgnoreCase("today")) {
			//ѹ͹ѧ , ѹش  ѹѨغѹ
			CscCalendar stDate = new CscCalendar();
			String strStDate = this.getParamValue("startDate");
			strStDate = strStDate.substring(4, strStDate.length());
			CscCalendar tmpStDate = new CscCalendar();
			tmpStDate.decDate(Integer.parseInt(strStDate));			
			CscCalendar endDate = new CscCalendar();
			this.data.put("startDate", tmpStDate.getYYYYMMDD());
			this.data.put("endDate", endDate.getYYYYMMDD());
			this.hmParam.put("startDate", tmpStDate.getYYYYMMDD());
			this.hmParam.put("endDate", endDate.getYYYYMMDD());
		} else if (this.getParamValue("startDate").indexOf("last")>-1 && this.getParamValue("endDate").indexOf("last")>-1) {
			//͹ѧ 駤
			String s1 = this.getParamValue("startDate");
			String s2 = this.getParamValue("endDate");
			s1 = s1.substring(4, s1.length());
			s2 = s2.substring(4, s2.length());
			CscCalendar c1 = new CscCalendar();
			c1.decDate(Integer.parseInt(s1));
			CscCalendar c2 = new CscCalendar();
			c2.decDate(Integer.parseInt(s2));
			this.data.put("startDate", c1.getYYYYMMDD());
			this.data.put("endDate", c2.getYYYYMMDD());
			this.hmParam.put("startDate", c1.getYYYYMMDD());
			this.hmParam.put("endDate", c2.getYYYYMMDD());
		}
	}
    
    private boolean isValidRunno(HashMap hmEmp, HashMap hmSwipeData){
    	try {
        	if(((String)hmSwipeData.get("RUNNO")).equals("0")){
        		MyLog.error(" !! Error insert ttimetemp with runno is 0 !! [" + ((String)hmEmp.get("EMPLOYEEID")) 
        				+ ":" + ((String)hmSwipeData.get("SWIPEDATE")) + ":" + ((String)hmSwipeData.get("SWIPETIME")) + "]");
        		return false ;
        	}
    	}catch(Exception e){
    		MyLog.error(this,e);
    		return false ;
    	}
    	return true ;
    }
    
    private DbRecord getTimeRecord(HashMap hmEmp, HashMap hmSwipe){
    	DbRecord db = null;
    	try {
    		db = new InitialRecord(this.upf).getDbRecord("Ttimetemp");
    		db.setUProfile(this.upf);
    		db.set("employeeid", (String)hmEmp.get("EMPLOYEEID"));
    		db.set("companyid", (String)hmEmp.get("COMPANYID"));
    		db.set("swipedate", (String)hmSwipe.get("SWIPEDATE"));
    		db.set("swipetime", (String)hmSwipe.get("SWIPETIME"));
    		db.set("swipetype", (String)hmSwipe.get("SWIPETYPE"));
    		db.set("source", (String)hmSwipe.get("SOURCE"));
    		db.set("runno", (String)hmSwipe.get("RUNNO"));
    		
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return db ;
    }
    
    private CscCalendar getNextOut(int idx, Vector vc){
    	CscCalendar cs = new CscCalendar() ;
    	try {
    		for(int i = idx+1; i < vc.size() ; i++){
    			HashMap hm = (HashMap)vc.get(i);
    			if(((String)hm.get("SWIPETYPE")).equals("1")){
    				cs = new CscCalendar((String)hm.get("SWIPEDATE"));
    				cs.setCSCTime(Float.parseFloat((String)hm.get("SWIPETIME")));
    				break;
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return cs ;
    }
}
