package com.csc.library.process;

import bsh.EvalError;
import bsh.Interpreter;

import java.sql.ResultSet; 
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Ttime_current1;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;

import com.csc.library.timeattendance.DateProperties;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
import com.csc.library.utility.DHMConvert;
import com.csc.library.utility.NUtils;

public class CalculateVacation_New extends ProcessTimeBase {
	
	private String MAIN = "0";	/* ٵѡ  */
	private String SUB  = "1";	/* ٵ  */
	private String V0  	= "2";	/* ٵ¡ʹ  */

	HashMap hmHeader = new HashMap(); 		/* ´ٵäӹǳԷԾѡ͹ */
	HashMap hmMainFormular = new HashMap(); /* ´ٵäӹǳԷԾѡ͹ ٵѡ */
	HashMap hmSubFormular = new HashMap(); 	/* ´ٵäӹǳԷԾѡ͹ ٵͧ */
	HashMap hmV0Formular = new HashMap(); 	/* ´ٵäӹǳԷԾѡ͹ ٵ¡ʹ */
	
	DbRecord emp ;
	HashMap empProp ; /* ´ѡҹ */
	boolean isSave = true ;
	
	/* ˹¡÷ͧ觤ӹǳ ԷҾѡ͹ */
	public Vector getProcessList() {
		
		CscConnection conn = null;
   	   	Statement stmt =null;
        ResultSet rs = null;
        
		this.data.put("maxlist","100"); /*  Thread öżžѡҹ٧ش 100 ҹ */
        Vector v = new Vector();
        try {
            this.setParamData();
            
            //Ҩӹǹ  ͧӡûż շ褹 ͹ǹٻżŷФ
        	if (this.hmParam.containsKey("filterProcess")) { /* Ңŷ input  null ʴԴ error  ش÷ӧҹ */
        		
        		conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
    			stmt = conn.createStatement();
    			rs = stmt.executeQuery(getQuery());

    			while (rs.next()) {
    				HashMap empProp = new HashMap();
    				empProp.put("employeeid", rs.getString("employeeid"));	/* ʾѡҹ */
    				empProp.put("startdate", rs.getString("startdate"));	/* ѹҷӧҹ */
    				empProp.put("workage", rs.getString("age"));			/* اҹѺҡѹҧҹ (memployee.startdate) */
    				empProp.put("vacationcode", rs.getString("vacationcode")); /* ʤӹǳԷ  */	
    				empProp.put("vacation0", (rs.getString("vacation0")!=null&&!rs.getString("vacation0").equals(""))?rs.getString("vacation0"):"00:00:00"); 	/* Է¡ ()  */	
    				empProp.put("vacation1", (rs.getString("vacation1")!=null&&!rs.getString("vacation1").equals(""))?rs.getString("vacation1"):"00:00:00"); 	/* ԷԷջѨغѹ (ͧ)  */	
    				empProp.put("hour_d", rs.getString("hour_d")); 			/* . ӧҹѹ ִҡ ١Ѻ memployee.time0  */
    				empProp.put("issue", new CscCalendar().getTimestamp());	/* ˹ʼѾäӹǳ 繵Ǻ͡觤ӹǳ */
	                v.addElement(empProp);
	            }
            }else{
            	this.setFullMessage("Error : condition for query employee is null, process will be terminated !!");
            }
            
        } catch (Exception e) {
        	MyLog.error("!! Error in TransferTimeProcess.getProcessList() !!");            
        }finally{
			try {
				if(rs != null) 	{ rs.close(); }
				if(stmt!=null)	{ stmt.close(); }
				if(conn!=null) 	{ conn.close(); }
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}//end try
        return v;
	}
	
	public void setParamData() {
		try {
			this.hmParam.put("filterProcess", this.getProcessCondition());
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void setParamData(String field,String value){
		try {
			if(this.hmParam == null) this.hmParam = new HashMap(); 
			if(this.data == null) this.data = new HashMap();
			
			this.data.put(field, value);
			this.hmParam.put(field, value);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/*˹ param ö process  (١ѹҡ csc_quque)*/
	private void setDefaultParam(){
		try {
			this.hmParam.put("filterProcess", "");
			this.hmParam.put("isQuqueProcess", "true");
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
    /* 觻żŨҡ˹Ҩ Ҩҡ quque */
	private Vector getEmpList(){ 
		if(this.processList == null){ 	/* Ҩҡ quque  Method getProcessList ֧žѡҹһż ֧ͧ¡ͧ*/
			MyLog.error("!! CalculateVaction_New is from CSC_QUQUE !!");
			this.setDefaultParam();		/* դ param  С˹ default ¡˹֧ʾѡҹء*/
			return this.getProcessList(); 
		} 
		return this.processList;
	}
	
	/* ҧ query ֧žѡҹ͹䢷Ҩҡ˹Ҩ ͨҡ param  csc_quque */
	private String getQuery(){
		String sql = "";
		try {
			InitialEnvironment inv = new InitialEnvironment(upf.getDbName());
			String dbType = inv.getValue("datasource-dbtype");
			//CscCalendar today = new CscCalendar();
			
			if (dbType.equals("ORACLE")){ // for oracle
				sql = "select concat(concat(concat(concat(trunc( months_between( to_date('"+ this.getCalculateDate() +"','YYYY-MM-DD'), to_date(startdate,'YYYY-MM-DD') ) /12 ),':'),mod( trunc( months_between( to_date('"+ this.getCalculateDate() +"','YYYY-MM-DD'), to_date(startdate,'YYYY-MM-DD') ) ), 12 ))"
						+ ",':'),to_date('"+ this.getCalculateDate() +"','YYYY-MM-DD') - add_months(to_date(startdate,'YYYY-MM-DD'),trunc( months_between( to_date('"+ this.getCalculateDate() +"','YYYY-MM-DD'), to_date(startdate,'YYYY-MM-DD') ) )))"
						+ " age,memployee.employeeid,memployee.vacation0,memployee.vacation1,memployee.vacationcode,memployee.startdate,t.hour_d"
						+ " from memployee left join mtime0 t on memployee.time0 = t.time0id"
						+ " where memployee.status in ('A','B','S','V','W') ";
						
			} else { // for SQLServer
				sql = "SELECT MEMPLOYEE.VACATIONCODE,MEMPLOYEE.VACATION0,MEMPLOYEE.VACATION1,dbo.timespan(dbo.toDate(MEMPLOYEE.STARTDATE,'YMD'),'" + this.getCalculateDate() + "','date') as AGE,"
						+ "MEMPLOYEE.EMPLOYEEID,MEMPLOYEE.STARTDATE,T.HOUR_D FROM MEMPLOYEE LEFT JOIN MTIME0 T ON MEMPLOYEE.TIME0 = T.TIME0ID "
						+ "WHERE MEMPLOYEE.STATUS IN ('A','B','S','V','W') ";
						
			}
			
			if(this.hmParam.containsKey("filterProcess") && ((String)this.hmParam.get("filterProcess")).length() > 0 ){
				sql += " AND " + (String) this.hmParam.get("filterProcess");
			}
			
			sql += " ORDER BY MEMPLOYEE.EMPLOYEEID ";	/* set order by */
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sql;
	}
	
	private String getHashData(HashMap data, String fieldname){
		try {
			return (String)data.get(fieldname);
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	public void process() throws Exception {
		Vector vEmp = getEmpList();	/* ֧ʾѡҹͧӹǳ ԷҾѡ͹ */
		
		backupVacation();	/* backup */
		
		for(int i=0; i < vEmp.size(); i++){
			HashMap empProp = (HashMap) vEmp.get(i);
			
			calVacationFormula(empProp);
		}
	}
	
	/* ֧ٵáäӹǳԷҾѡ͹ */
	private void setVacationFormula(String code){
		
		CscConnection conn = null;
   	   	Statement stmt = null;
        ResultSet rs = null;
        
        Vector vMainFormula = new Vector();		/* ٵâͧѡ */
		Vector vSubFormula = new Vector();		/* ٵâͧ */
		Vector v0Formula = new Vector();		/* ٵâͧ¡ʹ */
	
		Vector vReturn = new Vector();
        
        try {
        	if(!hmHeader.containsKey(code)){	/* ѧŴٵù Ŵ */
        		
        		/* query ٵèҡҧ mvacation0  mvacation1 */
        		StringBuffer formula = new StringBuffer();
        		formula.append("SELECT m0.VACATIONID,m0.ISCREATE_V0,m0.VACATION_LAST,m0.FIXRATE_V0,m0.FIXOVERFLOW_V0,m0.V1_STDATE,m0.V1_ENDDATE,");
        		formula.append(" m1.VACATIONID,m1.LINE_NO,m1.COM_PRIVILEGE,m1.CONDITION,m1.PRVLGCASE,m1.COM_FORMULA ");
        		formula.append(" FROM MVACATION0 m0 left join MVACATION1 m1 on m0.VACATIONID = m1.VACATIONID ");
        		formula.append(" WHERE m0.VACATIONID = '").append(code).append("'");
        		formula.append(" ORDER BY M1.LINE_NO");
        	
	            conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
	    		stmt = conn.createStatement();
	    		rs = stmt.executeQuery(formula.toString());
	
	    		int index = 0; 	/* index ѺѺ */
	    		while (rs.next()) {
	    			/* 红 header ͧٵ */
	    			if(index == 0) {  
	    				HashMap hmVacation0 = new HashMap();
	    				hmVacation0.put("ISCREATE_V0", rs.getString("ISCREATE_V0"));
	    				hmVacation0.put("FIXRATE_V0", rs.getString("FIXRATE_V0"));
	    				hmVacation0.put("FIXOVERFLOW_V0", rs.getString("FIXOVERFLOW_V0"));
	    				hmVacation0.put("V1_STDATE", rs.getString("V1_STDATE"));
	    				hmVacation0.put("V1_ENDDATE", rs.getString("V1_ENDDATE"));
		    			
		    			hmHeader.put(code, hmVacation0);
	    			}
	    			
	    			HashMap hm = new HashMap();
	    			hm.put("VACATIONID", (rs.getString("VACATIONID")!=null)?rs.getString("VACATIONID"):"");
	    			hm.put("LINE_NO", (rs.getString("LINE_NO")!=null)?rs.getString("LINE_NO"):"0");
	    			hm.put("PRVLGCASE", (rs.getString("PRVLGCASE")!=null)?rs.getString("PRVLGCASE"):"");
	    			hm.put("CONDITION", (rs.getString("CONDITION")!=null)?rs.getString("CONDITION"):"");
	    			hm.put("COM_FORMULA", (rs.getString("COM_FORMULA")!=null)?rs.getString("COM_FORMULA"):"");
	    			hm.put("COM_PRIVILEGE", (rs.getString("COM_PRIVILEGE")!=null)?rs.getString("COM_PRIVILEGE"):"00:00:00");
	    			
	    			if(rs.getString("PRVLGCASE").equals(MAIN)){ vMainFormula.add(hm); }	/* ٵâͧѡ */
	    			if(rs.getString("PRVLGCASE").equals(SUB)){ vSubFormula.add(hm); }	/* ٵâͧ */
	    			if(rs.getString("PRVLGCASE").equals(V0)){ v0Formula.add(hm); }		/* ٵâͧ¡ʹ */
	    			
	    			index++;
		        }
	    		
	    		hmMainFormular.put(code, vMainFormula);
	    		hmSubFormular.put(code, vSubFormula);
	    		hmV0Formular.put(code, v0Formula);
        	} 

        } catch (Exception e) {
        	MyLog.error("!! Error in setVacationFormula() !!",e);            
        }finally{
			try {
				if(rs != null) 	{ rs.close(); }
				if(stmt!=null)	{ stmt.close(); }
				if(conn!=null) 	{ conn.close(); }
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	
	private void calVacationFormula(HashMap empProp){
		HashMap empResult = new HashMap();
		DateProperties empStartDate ;
		DateProperties empWorkAge ;
		CscCalendar now = new CscCalendar();
		try {
			empStartDate = new DateProperties(getHashData(empProp,"startdate"),"-");
			empWorkAge = new DateProperties(getHashData(empProp,"workage"),":");
			empWorkAge.setDayOfWork(now.countDay((String) empProp.get("startdate")));
			
			setVacationFormula(getHashData(empProp,"vacationcode")); /* ֧ٵ Vector  */
			
			calMainFormula(empStartDate,empWorkAge,empResult,empProp);
			calSubFormula(empStartDate,empWorkAge,empResult,empProp);
			
			/* ӹǳʹ¡ */
			if(isCalculateV0()){			/* 礡͹˹ҨӹǳԷ¡  */
				calVacation0(empProp);		/* ӹǳʹ¡Ẻ */
				calV0Formula(empStartDate,empWorkAge,empResult,empProp);	/* ҡٵʹ¡ ӹǳѺʹ¡ */
			}else{
				empProp.put("new_vacation0", getHashData(empProp,"vacation0"));
			}
			
			//chkBorrowVac(empProp);		/* ѡԷԷ١㹻ա͹˹ */
			updateEmpVacation(empProp);	/* ѾഷԷҾѡ͹ 㹷¹ memployee */
			//backupEmpVacation(empProp);	/* 繻ѵԡäӹǳ */
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ѾഷԷҾѡ͹ 㹷¹ memployee */
	private void updateEmpVacation(HashMap empProp){
		CscConnection conn = null;
   	   	Statement stmt = null;
   	   	boolean autoCommit = true;
   	   	CscCalendar today = new CscCalendar();
   	 
		try {
			if(isSave){
				conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
				autoCommit = conn.getAutoCommit();
				conn.setAutoCommit(false);
				conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);
	
				stmt = conn.createStatement();
				stmt.execute("update memployee set vacation0 = '" + getHashData(empProp,"new_vacation0") 
						+ "' ,vacation1 = '" + getHashData(empProp,"new_vacation1") 
						+ "' ,edit_date = '" + today.getYYYYMMDD() 
						+ "' ,edit_time = '" + today.getHHMMSS() 
						+ "' where employeeid = '" + getHashData(empProp,"employeeid") + "'");
				
				conn.commit();
			}
			
		} catch (Exception e) {
            MyLog.error(this, e);           
        } finally {
    		try{
    			if(stmt != null) stmt.close();
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in executeQuery!!",e);
    		}
        }
	}
	
	/* 繻ѵԡäӹǳ */
	private void backupEmpVacation(HashMap empProp){
		try {
			DbRecord db = new InitialRecord(this.upf).getDbRecord("empvacation_history");
			db.setColumn("*");
			db.set("employeeid", getHashData(empProp,"employeeid"));
			db.set("issue", getHashData(empProp,"issue"));
			db.set("vacation0", getHashData(empProp,"vacation0"));
			db.set("vacation1", getHashData(empProp,"vacation1"));
			db.set("new_vacation0", getHashData(empProp,"new_vacation0"));
			db.set("old_vacation1", getHashData(empProp,"new_vacation1"));
			db.save();
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ˹ѹ觤ӹǳ Ҷ١觨ҡ quque ѹѨغѹ Ҩҡ˹ҨͨѺҨҡ field caldate */
	private String getCalculateDate(){
		CscCalendar caldate = new CscCalendar();
		try {
			if(this.data.containsKey("caldate")){	/* Ҩҡ˹Ҩ ˹ҡѺѹ˹ ѹѨغѹ */
				caldate.setCalendar((String)this.data.get("caldate"));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return caldate.getYYYYMMDD();
	}
	
	private Ttime_current1 getTcur1Object(){
		Ttime_current1 t1 = null;
		try {
			t1 = (Ttime_current1) new InitialRecord(this.upf).getDbRecord("ttime_current1");
			t1.setColumn("*");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return t1 ;
	}
	
	/* ӹǳԷҾѡ͹ ٵõѡ (ҷкѹ֡ŧ vacation1 ¨źͧ) */
	private void calMainFormula(DateProperties empWorkStart, DateProperties empWorkAge, HashMap empResult, HashMap empProp){
		try {
			String result = ""; 
			String condition = "";
			String com_formula = "";
			String new_vacation1 = "00:00:00";	
			
			String ENDOFYEAR = "ENDOFYEAR";
			String STARTOFYEAR = "STARTOFYEAR";

			DbRecord empdb = getEmpDb((String) empProp.get("employeeid"));
			DecimalFormat df = new DecimalFormat("00");
			CscCalendar today = new CscCalendar(getCalculateDate());
			CscCalendar empstart = new CscCalendar(empdb.getString("startdate"));
			DateProperties now = new DateProperties(today.getYYYYMMDD(), "-");
			Vector vMainFormula = (Vector)hmMainFormular.get(getHashData(empProp,"vacationcode"));
			
			CscCalendar datestofyear = new CscCalendar("31-12-" + today.getYear());
			
			Interpreter in = new Interpreter();
			in.set("ENDOFYEAR", ENDOFYEAR);
			in.set("STARTOFYEAR", STARTOFYEAR);
			in.set("workstart",empWorkStart);	/* ѹҹ */
			in.set("workage",empWorkAge);		/* اҹ ( ͹ ѹ)*/
			in.set("yearofwork", (today.getYear() - empWorkStart.year) + 1);	/* ӹǹշӧҹ */
			in.set("dayofwork", today.countDay(empWorkStart.cdate));	/* ӹǹѹӧҹ */
			in.set("today", now);				/* ѹѨغѹ */
			in.set("result","");
			in.set("comresult",0d);
			in.set("dayofyear", datestofyear.getDayOfYear());
			in.set("emp", getEmpDb((String) empProp.get("employeeid")));
			in.set("todaydate", today);	/* ѹѨغѹ CscCalendar */
			in.set("util", getTcur1Object());	/* ҧ ttime_current1 ҹ getRounding method */
			
			/* ѹ鹧ҹͧѡҹ */
			empstart.setCscCalendar(Integer.toString(today.getYear())+"-"+empstart.getMM()+"-"+empstart.getDD());
			in.set("empstartdate", empstart.getDayOfYear());
			
			for(int i=0; i < vMainFormula.size(); i++){
				HashMap formula = (HashMap)vMainFormula.get(i);
			
				condition = (String) formula.get("CONDITION");
				if(condition != null && !condition.equals("")){
					in.eval("result = " + condition);	/* ˹ٵ÷ͧ compile */
				
					result = String.valueOf(in.get("result"));	/* ֧Ѿѧ÷ compile ٵ */
					
					if(result.equalsIgnoreCase("TRUE")){		/* ͹ٵ繨ԧ ˹ԷҾѡ͹Ѻ  */
						if(((String) formula.get("COM_FORMULA")).equals("")){	/* ٵäӹǳӹǹԷ Ҥ com_privilege  */
							new_vacation1 =  (String) formula.get("COM_PRIVILEGE");
						}else{	/* ˹ٵäӹǳԷԷ  compile ٵ Ҥ */
							try {
								com_formula = (String) formula.get("COM_FORMULA");
								in.eval("comresult = " + com_formula);
								new_vacation1 = String.valueOf(in.get("comresult"));
								/* ŧ 00:00:00 */
								if(new_vacation1.indexOf(":") > -1){
									/* 餧ٵ ٻẺ DD:HH:MM  */
								}else if(new_vacation1.indexOf(".") > -1){
									String tmp[] = new_vacation1.split("\\.");
									new_vacation1 = df.format(Double.parseDouble(tmp[0])) + ":" + df.format(Double.parseDouble(tmp[1])) + ":00"; 
								}else{
									new_vacation1 = df.format(Double.parseDouble(new_vacation1)) + ":00:00"; 
								}
							}catch(Exception e){
								MyLog.error("!! Formula error : " + com_formula);
								MyLog.error(this,e);
								new_vacation1 = "00:00:00";
							}
						}
					}
				}
			}
			
			/* ѹ֡ԷԾѡ͹  */
			empProp.put("new_vacation1",new_vacation1);
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳԷҾѡ͹ ٵõͧ (Фҷ vacation1) */
	private void calSubFormula(DateProperties empWorkStart, DateProperties empWorkAge, HashMap empResult, HashMap empProp){
		try {
			String result = ""; 
			DbRecord empdb = getEmpDb((String) empProp.get("employeeid"));
			CscCalendar today = new CscCalendar(getCalculateDate());
			DateProperties now = new DateProperties(getCalculateDate(), "-");
			CscCalendar datestofyear = new CscCalendar("31-12-" + today.getYear());
			CscCalendar empstart = new CscCalendar(empdb.getString("startdate"));

			Vector vSubFormula = (Vector)hmSubFormular.get(getHashData(empProp,"vacationcode"));
			
			Interpreter in = new Interpreter();
			in.set("workstart",empWorkStart);	/* ˹ҵ÷ٵ */
			in.set("workage",empWorkAge);		/* اҹ ( ͹ ѹ)*/
			in.set("yearofwork", (today.getYear() - empWorkStart.year) + 1);	/* ӹǹշӧҹ */
			in.set("today", now);				/* ѹѨغѹ */
			in.set("result","");
			in.set("emp", getEmpDb((String) empProp.get("employeeid")));
			in.set("dayofyear", datestofyear.getDayOfYear());	/* ӹǹѹ㹻չ  */
			in.set("todaydate", today);	/* ѹѨغѹ CscCalendar */
			in.set("util", getTcur1Object());	/* ҧ ttime_current1 ҹ getRounding method */
			
			/* ѹ鹧ҹͧѡҹ */
			empstart.setCscCalendar(Integer.toString(today.getYear())+"-"+empstart.getMM()+"-"+empstart.getDD());
			in.set("empstartdate", empstart.getDayOfYear());

			
			for(int i=0; i < vSubFormula.size(); i++){
				HashMap formula = (HashMap)vSubFormula.get(i);
				in.eval("result = " + (String) formula.get("CONDITION"));	/* ˹ٵ÷ͧ compile */
				
				result = String.valueOf(in.get("result"));	/* ֧Ѿѧ÷ compile ٵ */
				
				if(result.equalsIgnoreCase("TRUE")){		/* ͹ٵ繨ԧ ˹ԷҾѡ͹Ѻ  */
					/* ǡѺʹ ͧҡٵû */
					if(empProp.containsKey("new_vacation1")){	/* ʹ */
						empProp.put("new_vacation1", addLeaveHour((String) formula.get("COM_PRIVILEGE"),(String) empProp.get("new_vacation1")));
					}else{	/* ѧʹ vacation1 */
						empProp.put("new_vacation1", (String) formula.get("COM_PRIVILEGE"));
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳԷҾѡ͹ ٵʹ¡ (ҷ价Ѻ vacation0) */
	private void calV0Formula(DateProperties empWorkStart, DateProperties empWorkAge, HashMap empResult, HashMap empProp){
		try {
			String result = ""; 
			String com_formula = "";
			String new_vacation0 = "00:00:00";
			
			CheckNull chk = new CheckNull();
			DecimalFormat df = new DecimalFormat("00");
			
			DbRecord empdb = getEmpDb((String) empProp.get("employeeid"));
			CscCalendar today = new CscCalendar(getCalculateDate());
			CscCalendar empstart = new CscCalendar(empdb.getString("startdate"));
			DateProperties now = new DateProperties(getCalculateDate(), "-");
			Vector v0Formula = (Vector)hmV0Formular.get(getHashData(empProp,"vacationcode"));
			
			CscCalendar datestofyear = new CscCalendar("31-12-" + today.getYear());
			DHMConvert dhm = new DHMConvert();
			
			Interpreter in = new Interpreter();
			in.set("workstart",empWorkStart);	/* ˹ҵ÷ٵ */
			in.set("workage",empWorkAge);		/* اҹ ( ͹ ѹ)*/
			in.set("yearofwork", (today.getYear() - empWorkStart.year) + 1);	/* ӹǹշӧҹ */
			in.set("today", now);				/* ѹѨغѹ */
			in.set("result","");
			in.set("emp", getEmpDb((String) empProp.get("employeeid")));
			in.set("daysofyear", datestofyear.getDayOfYear());
			in.set("todaydate", today);	/* ѹѨغѹ CscCalendar */
			in.set("util", getTcur1Object());	/* ҧ ttime_current1 ҹ getRounding method */
			in.set("hour_s", Double.parseDouble(getHashData(empProp,"hour_d"))); /* . ӧҹѹ */
			in.set("DHMConv", dhm); 
			in.set("oldv0", (String) empProp.get("vacation0"));	/* ʹ¡ҡ͹ӹǳ */
			in.set("oldv1", (String) empProp.get("vacation1"));	/* ԷԻչ͹ӹǳ */
			in.set("newv0", chk.chkNullString((String) empProp.get("new_vacation0")));	/* ʹ¡ѧӹǳ */
			in.set("newv1", chk.chkNullString((String) empProp.get("new_vacation1")));	/* ԷԻչѧӹǳ */
			
			/* ѹ鹧ҹͧѡҹ */
			empstart.setCscCalendar(Integer.toString(today.getYear())+"-"+empstart.getMM()+"-"+empstart.getDD());
			in.set("empstartdate", empstart.getDayOfYear());
			
			for(int i=0; i < v0Formula.size(); i++){
				HashMap formula = (HashMap)v0Formula.get(i);
				in.eval("result = " + (String) formula.get("CONDITION"));	/* ˹ٵ÷ͧ compile */
				
				result = String.valueOf(in.get("result"));	/* ֧Ѿѧ÷ compile ٵ */
				
				if(result.equalsIgnoreCase("TRUE")){		/* ͹ٵ繨ԧ ˹ԷҾѡ͹Ѻ  */
					if(((String) formula.get("COM_FORMULA")).equals("")){	/* ٵäӹǳӹǹԷ Ҥ com_privilege  */
						/* ǡѺʹ ͧҡٵû */
						if(empProp.containsKey("new_vacation0")){	/* ʹ */
							empProp.put("new_vacation0", (String) formula.get("COM_PRIVILEGE"));
						}else{	/* ѧʹ vacation1 */
							empProp.put("new_vacation0", (String) formula.get("COM_PRIVILEGE"));
						}
					}else{	/* ˹ٵäӹǳԷԷ  compile ٵ Ҥ */
						try {
							com_formula = (String) formula.get("COM_FORMULA");
							in.eval("comresult = " + com_formula);
							new_vacation0 = String.valueOf(in.get("comresult"));
							
							if(new_vacation0.indexOf(":") > -1){
								// on DD:HH:MM format
							}else{
								/* ŧ 00:00:00 */
								if(new_vacation0.indexOf(".") > -1){
									String tmp[] = new_vacation0.split("\\.");
									new_vacation0 = df.format(Double.parseDouble(tmp[0])) + ":" + df.format(Double.parseDouble(tmp[1])) + ":00"; 
								}else{
									new_vacation0 = df.format(Double.parseDouble(new_vacation0)) + ":00:00"; 
								}
							}
							
							empProp.put("new_vacation0", new_vacation0);
						}catch(Exception e){
							MyLog.error("!! Formula error : " + com_formula);
							MyLog.error(this,e);
							new_vacation0 = "00:00:00";
						}
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* 繵÷Ѻ äӹǳԷҾѡ͹١зҧǴէҳ 
	 * ͤӹǳʹ¡Ҩ١Ѿഷ жʹҨҡա͹ Ҥӹǳաзʹ¡١ͧ */
	private boolean isCalculateV0(){
		try {
			if(this.data.containsKey("isCalculateV0")){
				return Boolean.parseBoolean((String) this.data.get("isCalculateV0"));
			}
		}catch(Exception e){
			MyLog.error(this,e);
			return false;
		}
		return false;
	}
	
	/* ʹԷԡ  10:00:00 ǡ 04:04:00  14:04:00 */
	private String addLeaveHour(String vac0,String vac1){
		String result = "00:00:00";
		String v0[],v1[];
		String day,month,year;
		DecimalFormat df = new DecimalFormat("00");
		try {
			v0 = vac0.split(":");
			v1 = vac1.split(":");
			
			year = Integer.toString(Integer.parseInt(v0[0]) + Integer.parseInt(v1[0]));
			month = Integer.toString(Integer.parseInt(v0[1]) + Integer.parseInt(v1[1]));
			day = Integer.toString(Integer.parseInt(v0[2]) + Integer.parseInt(v1[2]));
			
			result = df.format(Integer.parseInt(year)) + ":" + df.format(Integer.parseInt(month)) + ":" + df.format(Integer.parseInt(day));
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	/* Ѻ ѹ . ҷ ١ͧ . ѹ */
	private String leaveDateFormat(String vac0,String hour_d){
		String leave[] ;
		int minuteLeave = 0;
		int minuteHour = 0;
		int MINUTE = 60;
		int day = 0;
		int hour = 0;
		int min = 0;
		CscTime hd = new CscTime();
		DecimalFormat df = new DecimalFormat("00");
		try {
			leave = vac0.split(":");
			/* Ѻ繰ҹҷա͹*/
			minuteLeave += (Integer.parseInt(leave[0]) * Integer.parseInt(hour_d)) * MINUTE;
			minuteLeave += Integer.parseInt(leave[1]) * MINUTE;
			minuteLeave += Integer.parseInt(leave[2]);
			
			/* Ѻ. ӧҹѹ 繰ҹҷ */
			minuteHour = (hour_d.indexOf(".")>-1)?(Integer.parseInt(hour_d.substring(0,hour_d.indexOf(".")))*MINUTE)+Integer.parseInt(hour_d.substring(hour_d.indexOf(".")+1))
					:Integer.parseInt(hour_d)*MINUTE;
			
			/* Ҩӹǹѹ */
			day = minuteLeave / minuteHour;
			minuteLeave -= day * minuteHour;
			
			/* Ҩӹǹ . */
			hour = minuteLeave / MINUTE;
			minuteLeave -= hour * MINUTE;
			
			/* Ҩӹǹ ҷ */
			min = minuteLeave;
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return df.format(day) + ":" + df.format(hour) + ":" + df.format(min);
	}
	
	/* ӹǳԷ¡ */
	private void calVacation0(HashMap empProp){
		DHMConvert dhm = new DHMConvert();
		try {
			int used = dhm.timeToMin(getVacUsed(getHashData(empProp, "employeeid")));	/* Ҿѡ͹ Ѿ . ҷ  */
			int oldV0 = dhm.DHMToMin(convToValidDHM(getHashData(empProp,"vacation0")), getHashData(empProp,"hour_d"));
			int oldV1 = dhm.DHMToMin(convToValidDHM(getHashData(empProp,"vacation1")), getHashData(empProp,"hour_d"));
			
			if(used >= (oldV0 + oldV1)){	/* ʹҡҡѺԷ ʴա¡ʹ ФҨ 0 */
				empProp.put("new_vacation0", "00:00:00");
				//setBorrowValue(empProp, used - (oldV0 + oldV1));
			}else{
				HashMap vProp = (HashMap)hmHeader.get(getHashData(empProp,"vacationcode"));	/* ֧Ҩӹǹѹö¡ʹԹ */
				String fxover = (String)vProp.get("FIXOVERFLOW_V0");
				fxover = (Integer.parseInt(fxover) > 9)?fxover:(fxover.length()>1)?fxover:"0"+fxover;
				int fixOver = dhm.DHMToMin(fxover+":00:00",getHashData(empProp,"hour_d"));	/* ʹ¡Թѹ ˹ѹ  */
				
				String remain = "00:00:00";
				if((oldV0 + oldV1) - used > fixOver){	/* ʹҡ ӹǹѹö¡ʹ ¡ʹҡѺӹǹѹö¡ */
					 remain = dhm.MinToDHM(fixOver , Double.parseDouble(getHashData(empProp,"hour_d")));
				}else{
					remain = dhm.MinToDHM((oldV0 + oldV1) - used , Double.parseDouble(getHashData(empProp,"hour_d")));
				}
				
				empProp.put("new_vacation0", remain);
				//setBorrowValue(empProp, 0);
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ʹ  */
	private float getVacUsed(String employeeid){
		
		CscConnection conn = null;
   	   	Statement stmt = null;
        ResultSet rs = null;
        
		CscTime csUsed = new CscTime();

		try{
			CscCalendar stDate = new CscCalendar((getParamData("startDate")!=null||getParamData("startDate").length()>0)?getParamData("startDate"):new CscCalendar().getYYYYMMDD());
			CscCalendar enDate = new CscCalendar((getParamData("endDate")!=null||getParamData("endDate").length()>0)?getParamData("endDate"):new CscCalendar().getYYYYMMDD());
			
			/* ҧ query ֧ʹҾѡ͹㹪ǧշ˹ҡ˹Ҩ */
			StringBuffer sqlQuery = new StringBuffer();
			sqlQuery.append("SELECT tlv.employeeid,tlv.hour_s,tlv.m_lv ");
			sqlQuery.append(" FROM tleave_summary tlv ");
			sqlQuery.append(" WHERE tlv.lv_type = (select mev.eventgrpid from meventgrp mev where mev.daytype='7') ");
			sqlQuery.append(" and tlv.doctype='A' ");
			sqlQuery.append(" and tlv.employeeid ='").append(employeeid).append("' ");
			sqlQuery.append(" and tlv.lv_bg_date >= '").append(stDate.getYYYYMMDD()).append("' ");
			sqlQuery.append(" and tlv.lv_bg_date <= '").append(enDate.getYYYYMMDD()).append("'") ;
			
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sqlQuery.toString());
			
			String m_lv = "0.0";
			float hour_s = 0.0f;
			
			while (rs.next()) {
				m_lv = rs.getString("m_lv");
				csUsed.add(Double.parseDouble(m_lv));
			}
			
		}catch(Exception ex){
			MyLog.error(this,ex);
		}finally{
			try {
				if(rs != null ) { rs.close(); }
				if(stmt != null){ stmt.close(); }
				if(conn != null) { conn.close(); }
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
		return csUsed.getFloat();
	}
	
	/* input 2:4:00 need to be converted to 02:04:00 */
	private String convToValidDHM(String date){
		try {
			if(date.indexOf(":") > -1){
				String items[] = date.split(":");
				if(items.length == 3){
					String dd = (items[0].length() == 1)?"0"+items[0]:items[0];
					String hh = (items[1].length() == 1)?"0"+items[1]:items[1];
					String mm = (items[2].length() == 1)?"0"+items[2]:items[2];
					return dd + ":" + hh + ":" + mm;
				}else{
					MyLog.error("!! vacation0 or vacation1 format is invalid " + date);
				}
			}else{
				MyLog.error("!! vacation0 or vacation1 format is invalid " + date);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "00:00:00";
	}
	
	private DbRecord getEmpDb(String empid){
		try {
			if(this.emp == null || !this.emp.getString("employeeid").equals(empid)){
				this.emp = new InitialRecord(this.upf).getDbRecord("Memployee");
				emp.setParam("rsc_skip","true");
				emp.setColumn("*");
				emp.set("employeeid", empid);
				emp.set("companyid", (String) this.upf.get("companyid"));
				emp.search();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return this.emp;
	}
	
	/* ʹԷԾѡ͹Դź ͹ѡѺԷԷնѴ  */
	private void setBorrowValue(HashMap empProp, int val){
		try {
			DHMConvert dhm = new DHMConvert();
			DbRecord db = new InitialRecord(this.upf).getDbRecord("MEMPL_BORROWVAC");
			db.setColumn("*");
			db.set("employeeid", getHashData(empProp,"employeeid"));
			db.set("companyid", getHashData(empProp,"companyid"));
			db.set("amount", dhm.MinToDHM(val , Double.parseDouble(getHashData(empProp,"hour_d"))));
			db.save();
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ѡʹ仨ҡա͹˹ */
	private void chkBorrowVac(HashMap empProp){
		try {
			DHMConvert dhm = new DHMConvert();
			DbRecord db = new InitialRecord(this.upf).getDbRecord("MEMPL_BORROWVAC");
			db.setColumn("*");
			db.set("employeeid", getHashData(empProp,"employeeid"));
			db.set("companyid", getHashData(empProp,"companyid"));
			if(db.search() == 1){
				String hour_d = getHashData(empProp,"hour_d");
				int v1 = dhm.DHMToMin(getHashData(empProp,"new_vacation1"), hour_d);
				int brr = dhm.DHMToMin(db.getString("amount"), hour_d);
				if(brr >= v1){
					empProp.put("new_vacation1", "00:00:00");
				}else{
					empProp.put("new_vacation1", dhm.MinToDHM(v1-brr, Double.parseDouble(hour_d)));
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void backupVacation(){
		try {
			/* էҳ */
			CscCalendar cscLeaveStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1001"));
			CscCalendar stDate = new CscCalendar((getParamData("startDate")!=null||getParamData("startDate").length()>0)?getParamData("startDate"):cscLeaveStart.getYYYYMMDD());
			
			if(isCalculateV0()){
				CscCalendar now = new CscCalendar();
				
				StringBuffer sql = new StringBuffer();
				sql.append("insert into vacation_his(employeeid,companyid,referenceid,yearid,vacation0,vacation1,edit_date,edit_time,create_date,create_time)");
				sql.append(" select employeeid,'").append(this.upf.getCompanyid()).append("',");
				sql.append(now.getTime()).append(",");
				sql.append(stDate.getYear()).append(",vacation0,vacation1,");
				sql.append("'").append(now.getYYYYMMDD()).append("'");
				sql.append(",'").append(now.getHHMMSS()).append("'"); 
				sql.append(",'").append(now.getYYYYMMDD()).append("'");
				sql.append(",'").append(now.getHHMMSS()).append("'");
				sql.append(" from MEMPLOYEE ");
				//sql.append("where STATUS not in ('X','Y','Z')");
	
				execSQL(sql.toString());
				MyLog.debug("!! backup vacation0 !!" + sql);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/**  EXECUTE SQL  */
    public void execSQL(String _SQL) {
		CscConnection conn = null;
		Statement stmt = null;
		try {
			if(_SQL != null && !_SQL.equals("")){
				conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
				stmt = conn.createStatement();
				
				MyLog.debug("!! execute sql back up vacation !! : " + _SQL);
				stmt.executeUpdate(_SQL);
			}else{
				MyLog.debug("!! SQL is null or empty !!");
			}
        } catch (Exception e) {
        	MyLog.error("!! Error : can't exec this SQL [" + _SQL + "] !!" ,e);           
        } finally {
        	try {
	        	if(stmt != null) stmt.close();
	        	if(conn != null) conn.close();
        	} catch(Exception e){
        		MyLog.error("!! Error : Can't close statement or connection !!",e);
        	}
        }
    }
    
    /* ԴͧҧӹǳԷԾѡ͹ǧ˹ ¡ method  ·ͧ¡ method process Ͷ١¡ж١ŧ cscqueue*/
	public void calVirtualVacation1(){
		try {
			Vector vEmp = this.getProcessList();	/* ֧ʾѡҹͧӹǳ ԷҾѡ͹ */
			
			empProp = (HashMap) vEmp.get(0);
			calVacationFormula(empProp);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public String getDataFromEmpProp(String field){
		try {
			if(empProp != null && empProp.containsKey(field)){
				return (String) empProp.get(field);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}

	public void isSave(boolean stat){
		this.isSave = stat ;
	}
}
