package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CountAge;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.UProfile;
import com.csc.library.utilities.MyTreeMap;

/*
 * ѺӹǳԷҾѡ͹ͧѡҹ 
 * Ңѹӡ觻ż ѡҹԷҾѡ͹ѹ 
 */
public class CalulateEmpVacation extends ProcessTimeBase {
	
	FormulaString util = new FormulaString();
	DecimalFormat df = new DecimalFormat("0.0");
	protected CscCalendar cscDate = null;
	protected MyTreeMap hmVacation = null;
	protected DbInquiry inqVacation = null;
	protected MyHashMap hmVacation0 = null;
	protected DbInquiry inqVacation0 = null;
	protected MyHashMap hmTime = null;	
	protected DbInquiry inqTime = null;
	protected DbInquiry inqLeave = null;
	protected DbRecord recEmpVacation = null;
	protected String vCode = "";
	DbInquiry inqEmp = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");			
			inq.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level," +
				"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid," + 
				"status, startdate, resigndate, workarea, emp_type");	
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		//v.addElement("All");
		return v;
	}
	
	public void process() throws Exception {
		long start=System.currentTimeMillis();		
		this.setParamData();
		this.cscDate = new CscCalendar(this.getParamValue("startDate")); //ѹӡûż
		//this.cscDate = new CscCalendar("01-07-2008");
		this.vCode = this.getVacationCode(); //ӡä code 繡Ҿѡ͹  code 
		//Vector vt = this.getProcessList();
		Vector vt = this.processList;
		String errorResult = "";
		String errorProcess = "";
		
		if (this.recEmpVacation == null) {
			this.recEmpVacation = new InitialRecord(this.upf).getDbRecord("MEMPL_VACATION");
			this.recEmpVacation.setColumn("*");
		}
		
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
		//for (int i=0;i<vt.size();i++) {
			String id = (String) vt.elementAt(i);
			try {
				this.recEmpVacation.clearField();
				
				if (this.inqEmp == null) {
					this.inqEmp = new InitialInquiry(this.upf).getDbInquiry();
					this.inqEmp.setParam(this.data);
					this.inqEmp.setSchemaName(this.upf.getSchemaName());
					this.inqEmp.initMyTable("MEMPLOYEE","","");
					this.inqEmp.setColumn("employeeid, companyid, status, emp_type, startdate, firsthiredate, " +
					"vacationcode, vacation0, vacation1, time0");
				}
				this.inqEmp.setFilter("employeeid='"+(String) vt.elementAt(i)+"'");
				this.inqEmp.refresh();
				if (this.inqEmp.next()) {
	        		DbRecord empRec = this.inqEmp.getCurrentDbRecord().cloneRecord(true);
	        			              
	        		MyLog.debug("-----------> employeeid=" + empRec.getString("employeeid"));
	        		MyLog.debug("-----------> vacation0=" + empRec.getString("vacation0"));
	        		MyLog.debug("-----------> vacation1=" + empRec.getString("vacation1"));
	        		MyLog.debug("-----------> startdate=" + empRec.getString("startdate"));
	        		MyLog.debug("-----------> firsthiredate=" + empRec.getString("firsthiredate"));
	        		
	        		MyHashMap hm = this.getVacation(empRec); //ӡûż ԷҾѡ͹
	        		if (!hm.isEmpty()) {
	        			if (hm.containsKey("vacation0")) {
	        				empRec.set("vacation0", hm.getString("vacation0"));
	        			} else { 
	        				empRec.set("vacation0", "00:00:00"); 
	        			}
	        			if (hm.containsKey("vacation1")) {
	        				empRec.set("vacation1", hm.getString("vacation1"));
	        			} else empRec.set("vacation1", "00:00:00"); 
	        			MyLog.debug("-----------> Result : "+empRec.getString("employeeid"));
	        			MyLog.debug("-----------> New vacation0=" + empRec.getString("vacation0"));
		        		MyLog.debug("-----------> New vacation1=" + empRec.getString("vacation1"));		
		        		MyLog.debug("-----------> Save Emp ..... ");
	        			empRec.save();
	        		} else {
	        			MyLog.debug("-----------> Result : "+empRec.getString("employeeid"));
	        			MyLog.debug("-----------> Not Save Emp ..... ");
	        		}
				}
        	} catch (Exception e) {
        		MyLog.error(this, e);     
        		errorProcess += id+",";
        	}
        	this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		}
		this.setMessage("Successful of CalulateEmpVacation : "+vt.size());
		this.setFullMessage("Successful of CalulateEmpVacation : "+vt.size()+"\n"+				
				"Error Process : "+errorProcess);	
		long end=System.currentTimeMillis();
		MyLog.debug(this, "Process >>> End Process :>>> time  : "+(end-start)/10000 + "Total Process="+vt.size());
	}
	
	/*
	 * ӡäӹǳاҹͧѡҹФ
	 * ѹҹͧѡҹ ѹӡûż
	 */
	protected double getEmpWorkAge(CscCalendar c1, CscCalendar c2) {
		double result = 0;
		try {
			CountAge count = new CountAge(this.getUProfile().get("lang"));
	        String tmp = count.getCountAges(c1, c2, false) ;
	        StringTokenizer str = new StringTokenizer(tmp, ":");
	        String y = str.nextToken();
	        String m = str.nextToken();
	        if (m.length()==1) m="0"+m;
	        String d = str.nextToken();
	        result = Double.parseDouble(y+"."+m);
		} catch (Exception e) {
			MyLog.error(this, e);    
		}
        return result;
	}
	
	/*
	 *  . ӧҹ/ѹ ҧ÷ӧҹ
	 */
	protected void chkHMTime(String code) {
		try {
			if (this.hmTime == null) {
				this.hmTime = new MyHashMap();
			} 
			
			if (!this.hmTime.containsKey(code)) {
				if (this.inqTime == null) {
					this.inqTime = new InitialInquiry(this.upf).getDbInquiry();
					this.inqTime.initMyTable("MTIME0","","");
					this.inqTime.setColumn("time0id, companyid, hour_d");
				}
				this.inqTime.setFilter("time0id='"+code+"'");
				this.inqTime.refresh();
				if (this.inqTime.next()) {
					this.hmTime.put(code, inqTime.getString("hour_d"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	/*
	 * ֧ .÷ӧҹѹͧѡҹ
	 */
	protected double getHourWork(String code) {
		double result = 0;
		if (this.hmTime==null || !this.hmTime.containsKey(code)) {
			this.chkHMTime(code);
		}		
		if (this.hmTime.containsKey(code)) {
			result = Double.parseDouble(this.hmTime.getString(code));
		}
		return result;
	}
	
	/*
	 *  HashMap ѹش¢ͧԷѡ͹
	 *  HashMap ѧ ѧӡŴ
	 */
	protected void chkDateLastVacation(String code) {
		try {
			if (this.hmVacation0 == null) {
				this.hmVacation0 = new MyHashMap();
			} 
			
			if (!this.hmVacation0.containsKey(code)) {
				if (this.inqVacation0 == null) {
					this.inqVacation0 = new InitialInquiry(this.upf).getDbInquiry();
					this.inqVacation0.initMyTable("MVACATION0","","");
					this.inqVacation0.setColumn("*");
				}
				this.inqVacation0.setFilter("vacationid='"+code+"'");
				this.inqVacation0.refresh();
				while (this.inqVacation0.next()) {
					CscCalendar c = new CscCalendar(this.inqVacation0.getString("vacation_last"));
					this.hmVacation0.put(code, c.getDDMMYYYY());
				}
			}
			
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	/*
	 *  HashMap 纨ӹǹѹѡ͹è اҹ դ
	 * ѧӡŴ
	 */
	protected void chkHMVacation(String code) {
		try {
			if (this.hmVacation == null) {
				this.hmVacation = new MyTreeMap();
			} 
			
			if (!this.hmVacation.containsKey(code)) {
				MyTreeMap tr = new MyTreeMap();				
				String key = "";
				if (this.inqVacation == null) {
					this.inqVacation = new InitialInquiry(this.upf).getDbInquiry();
					this.inqVacation.initMyTable("MVACATION1","","");
					this.inqVacation.setColumn("*");
				}
				this.inqVacation.setFilter("vacationid='"+code+"'");
				this.inqVacation.refresh();
				while (this.inqVacation.next()) {
					MyHashMap hmDetail = new MyHashMap();
					StringTokenizer str = new StringTokenizer(this.inqVacation.getCurrentDbRecord().getFieldList(), ",");
					while (str.hasMoreTokens()) {
						key = str.nextToken();
						hmDetail.put(key, this.inqVacation.getString(key));						
					}
					tr.put(Integer.valueOf(this.inqVacation.getString("line_no")), hmDetail);
				}
				
				if (!tr.isEmpty()) {
					this.hmVacation.put(code, tr);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	/*
	 * ֧ѹش·ԷԡҹԷԾѡ͹¡
	 */
	protected String getLastDayVacation(String code) {
		String result = "";
		if (this.hmVacation0==null || !this.hmVacation0.containsKey(code)) {
			this.chkDateLastVacation(code);			
		}
		
		if (this.hmVacation0.containsKey(code)) {
			return this.hmVacation0.getString(code);
		}
		return result;
	}
		
	/*
	 * ֧ҨӹǹԷԾѡ͹ͺ˹ اҹ 
	 */
	protected String getComVacation(double empWorkAge, String code) {
		String result = "00:00:00";
		MyHashMap hm = null;
		if (this.hmVacation==null || !this.hmVacation.containsKey(code)) {
			this.chkHMVacation(code);
		}
		
		if (this.hmVacation.containsKey(code)) {
			MyTreeMap tr = (MyTreeMap) this.hmVacation.get(code);
			Iterator it = tr.keySet().iterator();
			while (it.hasNext()) {
				Integer key = (Integer) it.next();
				hm = (MyHashMap) tr.get(key);
				double bg = Double.parseDouble(hm.getString("workage_bg"));
				double en = Double.parseDouble(hm.getString("workage_en"));
				if (empWorkAge >= bg && empWorkAge <= en) {
					return hm.getString("com_privilege");				
				}
			}		
		}		
		return result;
	}	
	
	/*
	 * ֧ҨӹǹԷԾѡ͹¡ҷ اҹ 
	 */
	protected String getLastVacation(double empWorkAge, String code) {
		String result = "00:00:00";
		MyHashMap hm = null;
		
		if (this.hmVacation==null || !this.hmVacation.containsKey(code)) {
			this.chkHMVacation(code);
		}
		
		if (this.hmVacation.containsKey(code)) {
			MyTreeMap tr = (MyTreeMap) this.hmVacation.get(code);
			Iterator it = tr.keySet().iterator();
			while (it.hasNext()) {
				Integer key = (Integer) it.next();
				hm = (MyHashMap) tr.get(key);
				double bg = Double.parseDouble(hm.getString("workage_bg"));
				double en = Double.parseDouble(hm.getString("workage_en"));
				if (empWorkAge >= bg && empWorkAge <= en) {
					return hm.getString("last_privilege");				
				}
			}		
		}
		return result;
	}	
		
	/*
	 * ӡûżԷҾѡ͹ͧѡҹ	 
	 */
	protected MyHashMap getVacation(DbRecord empRec) {
		MyHashMap  hm = new MyHashMap();			
		try {
			double hourWork = this.getHourWork(empRec.getString("time0")); //.ӧҹѹ
			String vacationCode = empRec.getString("vacationcode"); //ʵҧԷҾѡ͹
			double workAge = this.getEmpWorkAge(empRec.getCscCalendar("startdate"), this.cscDate); //اҹ
						
			String com_privilege = this.getComVacation(workAge, vacationCode); //Է	
			String last_privilege = this.getLastVacation(workAge, vacationCode);			
			hm.put("vacation1", com_privilege);
			
			/*
			 * ͹ش·ԷҾѡ͹ͧʹҾա͹㹻շǡ͹
			 * ͨӹǳʹ 㹪ͧԷ¡ҢͧջѨغѹ
			 */
			//CscCalendar cscVacationStart = new CscCalendar("2009-01-01");
			//CscCalendar cscVacationEnd = new CscCalendar("2009-01-06");
			CscCalendar cscVacationStart = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1003"));
			CscCalendar cscVacationEnd = new CscCalendar((String) StaticConfig.getConfigCompany(this.upf, "TA1004"));
			if (this.cscDate.getMM().equals(cscVacationEnd.getMM())) {
				int m0 = this.util.DhmToM(empRec.getString("vacation0"), hourWork); //ʹ¡
				int m1 = this.util.DhmToM(empRec.getString("vacation1"), hourWork); //ԷԷ͹
				int m_total = m0+m1;
				int use = 0;
				CscTime ct = this.getLeaveUsed(empRec.getString("employeeid"), cscVacationStart, cscVacationEnd, this.vCode);
				use = (ct.getHour()*60)+ct.getMinute();
				
				String vacation_remain = "00:00:00";
				if (use<m_total) {
					int max_last = this.util.DhmToM(last_privilege, hourWork);
					if (max_last <= (m_total-use)) {
						vacation_remain = this.util.MTODhm(max_last, hourWork);
					} else {
						vacation_remain = this.util.MTODhm(m_total-use, hourWork);
					}
				} else vacation_remain = "00:00:00";				
				hm.put("vacation0", vacation_remain);				
				
				this.recEmpVacation.clearField();
				this.recEmpVacation.set("EMPLOYEEID", empRec.getString("employeeid"));
				this.recEmpVacation.set("YEARID", this.cscDate.getYear());
				this.recEmpVacation.set("LAST_V0", empRec.getString("vacation0"));
				this.recEmpVacation.set("LAST_V1", empRec.getString("vacation1"));
				this.recEmpVacation.set("LAST_TOTAL",  this.util.MTODhm(m_total, hourWork));
				this.recEmpVacation.set("LAST_REMAIN",  vacation_remain);
				this.recEmpVacation.set("PRIVILEGE_EMP",  last_privilege);
				this.recEmpVacation.set("PRIVILEGE_COM",  com_privilege);
				this.recEmpVacation.set("VACATION0", vacation_remain);
				this.recEmpVacation.set("VACATION1", com_privilege);
				int v0 = this.util.DhmToM(vacation_remain, hourWork); //ʹ¡
				int v1 = this.util.DhmToM(com_privilege, hourWork); //ԷԷ
				this.recEmpVacation.set("VACATION_TOTAL",  this.util.MTODhm(v0+v1, hourWork));
				this.recEmpVacation.save();
			} else {
				hm.put("vacation0", empRec.getString("vacation0"));
			}
			
			/*
			 *͹شҹԷԾѡ͹¡ 
			 *÷ Ҷ֧ԷԾѡ͹¡ѧ 
			 *ѧ֧ ԷԾѡ͹ҡѺҾѡ͹
			 */
			String lastDay = this.getLastDayVacation(vacationCode);
			if (!lastDay.equals("")) {
				CscCalendar c = new CscCalendar(lastDay);				
				if (this.cscDate.getMM().equals(c.getMM()) && this.cscDate.getYear()==c.getYear()) {	
					//CscCalendar cscVacationStart = new CscCalendar("2007-01-01");
					
					CscTime ct = this.getLeaveUsed(empRec.getString("employeeid"), cscVacationStart, c, this.vCode);
					int use = (ct.getHour()*60)+ct.getMinute(); //ʹ仨֧ѹѴʹ
					
					int m0 = this.util.DhmToM(empRec.getString("vacation0"), hourWork); //ʹ¡
					if (use<m0) {
						String vacation0 = this.util.MTODhm(use, hourWork);
						hm.put("vacation0", vacation0);
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return hm;
	}	
	
	/*
	 * ӡäӹǳաҾѡ͹ 㹪ǧҷ˹
	 * ¨ return ѺٻͧŢҹ 60 ==> HH.SS
	 * */
	protected CscTime getLeaveUsed(String employeeid, CscCalendar cscVacationStart, CscCalendar cscVacationEnd, String code) {
		CscTime ct = new CscTime(0);
		try {				
			String filter = "employeeid='"+employeeid+"' and lv_type='"+code+"' and " +
				"(dateid between '"+cscVacationStart.getYYYYMMDD() +"' and '"+cscVacationEnd.getYYYYMMDD()+"')";
			if (this.inqLeave == null) {
				this.inqLeave = new InitialInquiry(this.upf).getDbInquiry();
				this.inqLeave.initMyTable("TLEAVE_SUMMARY","","");
				this.inqLeave.setColumn("*");
			}
			this.inqLeave.setFilter(filter);
			this.inqLeave.refresh();
			while (this.inqLeave.next()) {
				DbRecord rec = this.inqLeave.getCurrentDbRecord();
				/*
				 * ӡ sum šҾѡ͹
				 *  ҡ . Թ .ӧҹѹ 
				 * ǡ .ӧҹѹ ᷹ 
				 */
				if ((rec.getFloat("m_lv") > rec.getFloat("hour_s")) && (rec.getFloat("hour_s")>0)) {
					ct.add(rec.getFloat("hour_s"));
				} else {
					ct.add(rec.getFloat("m_lv"));
				}//end if 
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return ct;
	}
	
	/**
	 * ӡä code 繡Ҿѡ͹  code 
	 * ջͧѹ  7
	 * 
	 */
	protected String getVacationCode() {
		String code="";
		try {
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Meventgrp", "daytype='7'", "");			
			inq.setColumn("eventgrpid, companyid");	
			inq.refresh();
			if (inq.next()) {
				code = inq.getString("eventgrpid");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return code;
	}
}
