package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Memployee;
import com.csc.library.databean.Mtime0;
import com.csc.library.databean.Ttime_current;
import com.csc.library.databean.Ttime_current1;
import com.csc.library.service.ServiceTimeWorking;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;
import com.csc.library.utility.DiffTime;

public class DocRetroactive extends MyProcess{
/**
 * Author : Nuiss
 * Date : 05/02/2551
 * Logic : ÁÕàÍ¡ÊÒÃÂéÍ¹ËÅÑ§ãËé ·Ó¡ÒÃ»ÃÐÁÇÅ¼ÅàÅÂ
 * Example : ÊÃéÒ§àÍ¡ÊÒÃ Å§àÇÅÒÃÙ´ºÑµÃÂéÍ¹ËÅÑ§ 
 * 				ÇÑ¹¹Õé 05/02/2551 áµèÅ§àÇÅÒÃÙ´ºÑµÃÂéÍ¹ËÅÑ§ãËé
 * 				ÇÑ¹·Õè 01/02/2552 «Öè§µéÍ§·Ó¡ÒÃ»ÃÐÁÇÅ¼ÅÂéÍ¹ËÅÑ§
 * 				à¾×èÍÊÃéÒ§ Data ãËé Table Ttime_current1 
 */
	private CscConnection conn = null;
	private Statement stmt =null;
	private TransferTimeProcess transTimeCls  = new TransferTimeProcess();
	DbRecord empRec = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		v.add("processDocRetroactive");
		return v;
	 }//end method getProcessList
	 
	public void process() throws Exception {
		chkParamQueue();
		this.retrieveData(this.upf);
	}//end method process
	
	private void chkParamQueue() {
		try {
			/* start date */
			CscCalendar c1 = new CscCalendar();
			
			if(this.data.containsKey("startDate")){
				if(((String)this.data.get("startDate")).equals("today")){
					this.data.put("startDate", c1.getDDMMYYYY());
				}else if(((String)this.data.get("startDate")).indexOf("last") > -1){
					CscCalendar c2 = new CscCalendar();
					try{
						String st = (String)this.data.get("startDate");
						int i = Integer.parseInt(st.substring(st.length()-1, st.length()));
						c2.decDate(i);
					}catch(Exception e){
						MyLog.error(this,e);
					}
					
					this.data.put("startDate", c2.getDDMMYYYY());
				}
			}else{
				this.data.put("startDate", c1.getDDMMYYYY());
			}
			
			/* end date */
			if(this.data.containsKey("endDate")){
				if(((String)this.data.get("endDate")).equals("today")){
					this.data.put("endDate", c1.getDDMMYYYY());
				}else if(((String)this.data.get("endDate")).indexOf("last") > -1){
					CscCalendar c3 = new CscCalendar();
					try{
						String st = (String)this.data.get("endDate");
						int j = Integer.parseInt(st.substring(st.length()-1, st.length()));
						c3.decDate(j);
					}catch(Exception e){
						MyLog.error(this,e);
					}
					
					this.data.put("start_date", c3.getDDMMYYYY());
				}
			}else{
				this.data.put("start_date", c1.getDDMMYYYY());
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}

	public void retrieveData(UProfile upf){ 		
 		if(upf==null){
			upf = this.getUProfile();
		}//end if 
		ResultSet resultSet = null;

	 	try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(upf.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(this.getSQLQuery());

			while (resultSet.next()){
				String employeeId =resultSet.getString("empid");
				//»ÃÐÁÇÅ¼Å Time µÒÁ employee áÅÐ retroDate

				 if (this.empRec == null) {
		        	this.empRec = new InitialRecord(this.upf).getDbRecord("MEMPLOYEE");
		        	this.empRec.setColumn("*");
			    }//end if 
				 
				this.empRec.clearField();
	        	this.empRec.set("employeeid", employeeId);
	        	this.empRec.set("companyid", (String) upf.get("comcode"));
	        	this.empRec.search();
	        	transTimeCls.setUProfile(upf);
	        	
            	CscCalendar retroDate = new CscCalendar(resultSet.getString("retroDate"));        
 	        	//-------------------------------- Start FlexTime NSTDA --------------------------//
    			String isCalFlexTime = "";
    			try {
    				isCalFlexTime = (String) StaticConfig.getConfigCompany(this.upf, "ta1012");
    			} catch (Exception e) {
    				MyLog.error("ERROR !!! Find Config TA1012 not found : is use for calculate flex time NSTDA");
    			}
    			
    			MyTreeMap tr = new MyTreeMap();
    			if (isCalFlexTime.equals("1")) {
	                ServiceTimeWorking st = new ServiceTimeWorking(this.upf);
					tr = st.getSwipeData(this.empRec.getString("employeeid"), retroDate, retroDate, "");
					this.alive("Process TransferTimeProvess Load Swipecard.... ");
    			}    			
    			//-------------------------------- End FlexTime NSTDA --------------------------//

 				Mtime0 timeRec = transTimeCls.getTimeRecord(this.empRec.getString("time0"));
	            if (timeRec != null) {
	                timeRec.setEmpRec(this.empRec);
	                timeRec.setEmpSwipeTime(tr);
	                	            						
	                WorkingShift wstmp = timeRec.genWorkingShift(new CscCalendar(retroDate.getTimestamp()), new CscCalendar(retroDate.getTimestamp()), "true");	//ÃÇÁÇÑ¹ËÂØ´
	                this.alive("Process TransferTimeProvess Load WorkimgShift Temp.... ");
	                WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(retroDate.getTimestamp()), new CscCalendar(retroDate.getTimestamp())); //äÁèÃÇÁÇÑ¹ËÂØ´
	                this.alive("Process TransferTimeProvess Load WorkingShift.... ");
	                this.upf.set("empRecord", employeeId);
	                
                	transTimeCls.calOT = new CalOT(this.upf);
                	Ttime_current t = new Ttime_current();
                	Ttime_current1 t1 = new Ttime_current1();
                	transTimeCls.calOT.initValue((Memployee) this.empRec, (Ttime_current1) t1, (Mtime0) timeRec, new HashMap(), new HashMap(), (Ttime_current) t, new DiffTime(), StaticProperties.messagePools);
                	if (timeRec.getString("STICKTM").equals("D")) {
                		transTimeCls.hmSwipeCard = transTimeCls.getTimetemp(employeeId, retroDate.getYYYYMMDD(),  retroDate.getYYYYMMDD());
                	}//end if 
                	
                	transTimeCls.hmParam.put("startDate",retroDate.getYYYYMMDD());
                	transTimeCls.hmParam.put("endDate",retroDate.getYYYYMMDD());
                	transTimeCls.cs1 = retroDate;
                	transTimeCls.cs2 = retroDate;
                	
    	        	// ----- Load data for process in MCONFIG ----- //
                	transTimeCls.flag_ot = "0"; //ãªé¡ÒÃãËéâÍ·ÕáººäÁè¡ÃÍ¡àÍ§ËÃ×ÍäÁè
            		try {			
            			transTimeCls.flag_ot = (String) StaticConfig.getConfigCompany(this.upf, "ta1008");
            		} catch (Exception e) {	
            			MyLog.debug("Can't get ConfigCompany TA1008");
            		}
            		
            		transTimeCls.flag_cost = "0"; //ãªé¡ÒÃãËéÂ×Á¾¹Ñ¡§Ò¹ áÅéÇà»ÅÕèÂ¹ costcenter ËÃ×ÍäÁè
            		try {			
            			transTimeCls.flag_cost = (String) StaticConfig.getConfigCompany(this.upf, "ta1009");
            		} catch (Exception e) {		
            			MyLog.debug("Can't get ConfigCompany TA1009");
            		}
            		
            		transTimeCls.flag_buslate = "0"; //ãªé¡ÒÃãËéµÃÇ¨ÊÍº¡ÒÃÁÒÊÒÂ¢Í§ ¾¹§ ã¹¡Ã³ÕÃ¶ÃÑºÊè§ÁÒÊÒÂ
            		try {			
            			transTimeCls.flag_buslate = (String) StaticConfig.getConfigCompany(this.upf, "ta1010");
            		} catch (Exception e) {
            			MyLog.debug("Can't get ConfigCompany TA1010");
            		}
            		
            		transTimeCls.flag_unused = "0"; //ãªé¡ÒÃãËéµÃÇ¨ÊÍº¤èÒã¹ UNUSED
            		try {			
            			transTimeCls.flag_unused = (String) StaticConfig.getConfigCompany(this.upf, "ta1011");
            		} catch (Exception e) {
            			MyLog.debug("Can't get ConfigCompany TA1011");
            		}
               		
        			transTimeCls.hmCostcenter = new MyHashMap();//transTimeCls.loadDayChangeCostcenter(employeeId);                
 	        		transTimeCls.hmOTAdjust = transTimeCls.loadOTAdjust(employeeId); 	
  	        		transTimeCls.hmBusLate = new MyHashMap();//transTimeCls.loadBusLate(employeeId);
 	        		transTimeCls.hmUnused = new MyHashMap();//transTimeCls.loadUnused(employeeId);
 	           		transTimeCls.hashOT = transTimeCls.loadOTFormula();
 	           	 
    	        	
                	transTimeCls.transferTimeProcess(ws, wstmp, this.empRec, timeRec);
                	
                	System.out.print("DocRetroactive Process Completed..."
                			+"\nretroDate is "+retroDate.getYYYYMMDD()
                			+"\nemployeeId is :"+employeeId);
	            }//end if
			}//end while
			
		}catch(Exception ex){
			System.out.print(">>>>>Error on DocRetroactive.retrieveData()"+ex.getStackTrace())	;
		}finally{
			try {
				resultSet.close();
				if(stmt!=null){
					stmt.close();
				}		
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}//end try
	}//end method retrieveData
	
	private String getSQLQuery(){
		/**
		 * ttimetemp.source='5' at HONDA = äÁèä´éÁÒ¨Ò¡à¤Ã×èÍ§ÃÙ´ºÑµÃ
		 * ttimetemp.source='5' at KKB = äÁèä´éÁÒ¨Ò¡à¤Ã×èÍ§ÃÙ´ºÑµÃ
		 * ttimetemp.source='L' at NSTDA = ãº»®ÔºÑµÔ§Ò¹¹Í¡Ê¶Ò¹·Õè
		 * ttimetemp.source='0' at NSTDA = ãºÅ×ÁÅ§àÇÅÒ
		 */
		String SQLQuery ="";
		//for test whereClause is: 2009-01-13
		//for use whereClause is: Now
		String whereClause = (String) this.data.get("startDate"); 
		SQLQuery= "SELECT tadjtime0.edit_date,tadjtime0.employeeid as empid,tadjtime0.dt_bg as retroDate "+
			" FROM tadjtime0  "+
			" WHERE tadjtime0.edit_date >='"+whereClause+"' "+ 
			" and tadjtime0.dt_bg < tadjtime0.edit_date "+
			" and tadjtime0.doctype in ('A') "+
			" and tadjtime0.updtype not in ('T','D') "+
			" UNION ALL   "+
			" SELECT ttimetemp.edit_date,ttimetemp.employeeid as empid,ttimetemp.swipedate as retroDate "+
			" FROM ttimetemp  "+
			" WHERE ttimetemp.edit_date >='"+whereClause+"' "+
			" and ttimetemp.source in ('5','L','0') "+
			" GROUP BY ttimetemp.edit_date,ttimetemp.employeeid,ttimetemp.swipedate "+
			" ORDER BY edit_date,empid,retroDate";
		return SQLQuery;
	}//end method getSQLQuery
	
}//end class DocRetroactive
