package com.csc.library.process;

import java.io.File;
import java.util.HashMap;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
 
import org.omg.PortableInterceptor.SYSTEM_EXCEPTION;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.csc.library.database.StaticConfig;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class GenTCurData extends MyProcess{
	DbInquiry mainInquiry = null;
	
	DocumentBuilderFactory docFactory = null;
	DocumentBuilder docBuilder = null;
	Document doc = null;
	Element rootElement = null;
	
	/* Ѻ */
	String COLUMNS[] = {"DATEID","C_DT_BG","C_TM_BG","C_DT_EN","C_TM_EN","M_DT_BG","M_TM_BG","M_DT_EN","M_TM_EN"
			,"EVENTGRP","DOCTYPE","DOCNO","TIME0ID","OLDTIME0","M_LV","LT","AC_OT","AP_OT","OT1","SEQUENCE","HOUR_S"
			,"OT2","OT3","OT5","WARN00","WARN01","WARN02","WARN03","WARN04","WARN05","WARN06","WARN07","WARN08"
			,"WARN09","WARN10","WARN11","WARN12","WARN13","WARN14","WARN15"};
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			if(isActiveDate()) {		/* ֧ѹͧż */
			
				initDataSource(this);	// ˹͹䢡ô֧Ũҡҧ
				
				mainInquiry.refresh();
				HashMap hEmp = new HashMap();
				Vector vDate = new Vector();
				String idx = "";
				StringBuffer key = null;
				
				while (mainInquiry.next()) {
					DbRecord db = mainInquiry.getCurrentDbRecord().cloneRecord(false);
					
					if(idx.equals("")){	/* ͺá */
						idx = db.getString("employeeid");
						hEmp = setHeaderInfo(hEmp,db);	/* ˹ͧ */
						
						vDate.add(cloneTcurData(db));	/* ´÷ӧҹѹ   */
						hEmp.put("data", vDate);		/* 红ѹ */
					}else if(db.getString("employeeid").equals(idx)){	/* ʾѡҹǡѺá촡͹˹ */
						vDate.add(cloneTcurData(db));
						hEmp.put("data", vDate);		/* 红ѹ */
					}else{	/* ͺá ʾѡҹçѺá촡͹˹ */
						v.add(hEmp);				/* 红žѡҹ á촡͹˹ */
	
						/* ҧžѡҹ */
						idx = db.getString("employeeid");
						hEmp = new HashMap();
						hEmp = setHeaderInfo(hEmp,db);	/* ˹ͧ */
						vDate = new Vector();
						
						vDate.add(cloneTcurData(db));	/* ´÷ӧҹѹ   */
						hEmp.put("data", vDate);		/* 红ѹ */
					}
				}
				v.add(hEmp);						/* 红žѡҹ áش */
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return v;
	}
	
	/* copy  DbRecord ŧ HashMap ᷹ */
	private HashMap cloneTcurData(DbRecord db){
		HashMap hm = new HashMap();
		try {
			/* ˹ value ͡ҹ  */
			for(int j=0; j < COLUMNS.length; j++){
				hm.put(COLUMNS[j], db.getString(COLUMNS[j]));	
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return hm;
	}
	
	/* ˹ͧ */
	private HashMap setHeaderInfo(HashMap hEmp, DbRecord db){
		try {
			/* ҧͧ */
			DbRecord emp = new InitialRecord(this.upf).getDbRecord("Memployee");
			emp.setColumn("*");
			emp.setParam("rsc_skip","true");
			
			/*ҧ link ҧѡ еҧͧ */
			db.putChild(emp);	
			db.refreshChild();
			
			DbRecord branch = new InitialRecord(this.upf).getDbRecord("MBranch");
			branch.setColumn("branchid,tdesc,edesc");
			branch.set("branchid", db.getChild("Memployee").getString("branch"));
			branch.search();
			
			hEmp.put("employeeid", db.getString("employeeid"));	// ʾѡҹ
			hEmp.put("companyid", db.getChild("Memployee").getString("companyid"));
			hEmp.put("fullname", db.getChild("Memployee").getString("fullname"));
			hEmp.put("efullname", db.getChild("Memployee").getString("efullname"));
			hEmp.put("fname", db.getChild("Memployee").getString("fname"));
			hEmp.put("lname", db.getChild("Memployee").getString("lname"));
			hEmp.put("efname", db.getChild("Memployee").getString("efname"));
			hEmp.put("elname", db.getChild("Memployee").getString("elname"));
			hEmp.put("email", db.getChild("Memployee").getString("email"));
			hEmp.put("branchid", (branch != null)?db.getChild("Memployee").getString("branch"):"");
			hEmp.put("tbranch", (branch != null)?branch.getString("tdesc"):"");
			hEmp.put("ebranch", (branch != null)?branch.getString("edesc"):"");
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		
		return hEmp;
	}
	
	// ˹͹䢡ô֧Ũҡҧ
	private void initDataSource(GenTCurData genObject){
		try {
			/* ҧѡ */
			genObject.mainInquiry = new InitialInquiry(this.upf).getDbInquiry("Ttime_current1");
			genObject.mainInquiry.setParam(this.data);
			genObject.mainInquiry.setSchemaName(this.upf.getSchemaName());
			genObject.mainInquiry.setColumn("*");
			genObject.mainInquiry.setFilter(genObject.mainInquiry.getFilter() + ((genObject.mainInquiry.getFilter().length()>0)?" and ":"") + getCondition());
			genObject.mainInquiry.setOrderBy("employeeid,dateid,sequence");
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* Ҩҡ˹Ҩ */
	private boolean isManual(){
		try {
			if(this.data.containsKey("ismanual")){
				String ism = (String) this.data.get("ismanual");
				if(ism.equals("1")){
					return true;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* ѹ process ͧӧҹ */
	private boolean isActiveDate(){
		String ENDOFMONTH = "ENDOFMONTH";
		
		try {
			CheckNull chk = new CheckNull();
			String act = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TAACTIVE"));
			
			if(isManual()){
				return true;
			}else if((act != null && !act.trim().equals(""))){
				CscCalendar today = new CscCalendar();
				
				/* ͹ */
				if(act.equalsIgnoreCase(ENDOFMONTH)){
					act = Integer.toString(today.getEndDateOfMonth());
				}
				
				if(today.getDate() == Integer.parseInt(act)){
					return true;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* ѹ鹴֧ */
	private String getStartDate(){
		String st = "";
		try {
			CheckNull chk = new CheckNull();
			String std = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TASD_ST"));
			String stm = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TASM_ST"));

			CscCalendar today = new CscCalendar();
			
			if(!std.equals("")) today.decMonth(Integer.parseInt(stm));	// ѡ͹ѧ config
			if(!stm.equals("")) today.setDate(Integer.parseInt(std));	// ˹ѹ config
			
			st = today.getYYYYMMDD();
			
		}catch(Exception e){
			MyLog.error("!! Start date is null, default date will be set !!");
			MyLog.error(this,e);
		}
		return st;
	}
	
	/* ѹش֧ */
	private String getEndDate(){
		String ENDOFMONTH = "ENDOFMONTH";
		String en = "";
		try {
			CheckNull chk = new CheckNull();
			String end = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TASD_EN"));
			String enm = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TASM_EN"));
			
			CscCalendar today = new CscCalendar();
			
			if(!enm.equals("")) today.decMonth(Integer.parseInt(enm));	// ѡ͹ѧ config
			
			if(end.equals(ENDOFMONTH)){
				end = Integer.toString(today.getEndDateOfMonth());
			}
			if(!end.equals("")) today.setDate(Integer.parseInt(end));	// ˹ѹ config
			
			today.setDate(Integer.parseInt(end));
			en = today.getYYYYMMDD();
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return en;
	}
	
	/* ҧ͹䢴֧ŵǧ */
	private String getCondition(){
		String cond = "";
		try {
			cond = "dateid between '" + getStartDate() + "' and '" + getEndDate() + "'";
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return cond;
	}
	
	public void process() throws Exception {
		if(isActiveDate()) {		/* ֧ѹͧż */
			genXML();		/* ҧشŷ write ŧ xml file */
			writeFile();	/* ҧ xml ªشŷ */
		}else{
			setFullMessage("!! today is not active day ,process will not be activated !!");
		}
	}
	
	private void initXMLProp(){
		try {
			/* ҧ XML */
			docFactory = DocumentBuilderFactory.newInstance();
			docBuilder = docFactory.newDocumentBuilder();
			
			/* ҧ root eliment */
			doc = docBuilder.newDocument();
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void initRootElement(){
		initRootElement("DATA");
	}
	
	private void initRootElement(String name){
		try {
			rootElement = doc.createElement(name);
			doc.appendChild(rootElement);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void addXMLData(Element ele){
		rootElement.appendChild(ele);
	}
	
	private Vector getDataList(){
		try {
			if(this.processList != null){
				return this.processList;
			}else{
				return getProcessList();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return null;
	}
	
	private void genXML(){
		try {
			Vector v = getDataList();
			HashMap hEmp = null;
			
			initXMLProp();		/* ҧ evn Ѻҧ XML */
			initRootElement();	/* ˹ root element ͧ XML (default "DATA") */
			
			/* ֧žѡҹФ */
			//MyLog.debug("!! Number of emp to process : " + v.size());
			for(int i=0; i < v.size(); i++){
				hEmp = (HashMap) v.get(i);
				
				/* ҧ element ѡҹ˹ */
				MyLog.debug("!! process no. : " + i);
				addXMLData(createEmpElement(hEmp));	
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private Element initElementData(String name,String val){
		Element el = null;
		try {
			el = doc.createElement(name);
			el.appendChild(doc.createTextNode(val));
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return el;
	}
	
	private Element createEmpElement(HashMap hEmp){
		Element rtData = null;
		
		try {
				rtData = doc.createElement("EMPLOYEE");
		 
				rtData.appendChild(initElementData("EMPLOYEEID",(String) hEmp.get("employeeid")));	// ҧ element employeeid
				rtData.appendChild(initElementData("COMPANYID",(String) hEmp.get("companyid")));	// ҧ element companyid
				rtData.appendChild(initElementData("FULLNAME",(String) hEmp.get("fullname")));	// ҧ element fullname
				rtData.appendChild(initElementData("EFULLNAME",(String) hEmp.get("efullname")));	// ҧ element fullname
				rtData.appendChild(initElementData("FNAME",(String) hEmp.get("fname")));	// ҧ element fname
				rtData.appendChild(initElementData("LNAME",(String) hEmp.get("lname")));	// ҧ element lname
				rtData.appendChild(initElementData("EFNAME",(String) hEmp.get("efname")));	// ҧ element efname
				rtData.appendChild(initElementData("ELNAME",(String) hEmp.get("elname")));	// ҧ element elname
				rtData.appendChild(initElementData("EMAIL",(String) hEmp.get("email")));	// ҧ element email
				rtData.appendChild(initElementData("BRANCH",(String) hEmp.get("branchid")));	// ҧ element email
				rtData.appendChild(initElementData("TBRANCH",(String) hEmp.get("tbranch")));	// ҧ element email
				rtData.appendChild(initElementData("EBRANCH",(String) hEmp.get("ebranch")));	// ҧ element email
								
				Vector vDate = (Vector) hEmp.get("data");
				HashMap db = null;	/* 纤ҵҧ   COLUMNS 㹵ҧ ttime_current1 */
				for(int i=0; i < vDate.size(); i++){
					Element rtSubData = doc.createElement("DATEINFO");	/* ҧ element group ͧѹ  */
					db = (HashMap) vDate.get(i);
					
					/* ˹ value ͡ҹ  */
					for(int j=0; j < COLUMNS.length; j++){
						rtSubData.appendChild(initElementData(COLUMNS[j], (String)db.get(COLUMNS[j])));	
					}
					
					rtData.appendChild(rtSubData);
				}

		} catch (Exception e) {
			MyLog.error(this,e);
		}
		return rtData;
	}
	
	// write content into xml file
	private void writeFile(){
		try {
			String filename = this.processId + "_" + System.currentTimeMillis() + ".xml";
			String foldername = new CscCalendar().getYYYYMMDD();
			
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			DOMSource source = new DOMSource(doc);
			
			chkFolderExist();	/* ҧ folder 繪ѹ process  folder TCURXML */
			StreamResult result = new StreamResult(new File(getDefaultFolder() + foldername + "//" + filename));
	 
			MyLog.debug("!! XML will bef created under name : " + getDefaultFolder() + foldername + "//" + filename);
			transformer.transform(source, result);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* get default folder */
	private String getDefaultFolder(){
		String folder = "";
		try {
			CheckNull chk = new CheckNull();
			folder = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TAFOLDER"));
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return folder;
	}
	
	/* check folder exist */
	private void chkFolderExist(){
		try {
			File file = new File(getDefaultFolder() + new CscCalendar().getYYYYMMDD());
			boolean exists = file.exists();
			
			if (exists) {
				this.setFullMessage("!! Folder exist !!");
			}else{
				this.setFullMessage("!! Folder doesn't exist , system will create one automaticlly!!");
				if(file.mkdirs()){
					this.setFullMessage("!! Folder created successful !!");
				}else{
					this.setFullMessage("!! Error occur, folder created unsuccessful !!");
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
}
