package com.csc.library.process;

import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.MyLog;

public class GenTimeAutoByQuery extends MyProcess {
	private DataSet ds = null;
	private InitialEnvironment ev = null;
	private CheckNull chkNull = new CheckNull();
	private DbRecord rec= null;

	@Override
	public Vector getProcessList() {
		Vector vList = new Vector();
		try{
			if(vList == null || vList.size() == 0){
				String first_sql = this.chkNull.chkNullString(this.getParamData("sql_query"));
				if(ds == null){
					init();
				}
				this.ds.setSql(first_sql);
				this.ds.initConnection(this.getUProfile());
				while(this.ds.next()){
					vList.add(this.ds.getString("employeeid") + "|" + this.ds.getString("swipedate") + "|" + this.ds.getString("swipetime"));
				}
			}
		}catch(Exception e){
			MyLog.error(this, this.getUProfile(), e);
		}finally{
			if(this.ds != null)
				this.ds.closeConnection();
		}
		return vList;
	}
	
	/**
	 * <p>Ҩҡ quque  Method getProcessList ֧žѡҹһż ֧ͧ¡ͧ</p>
	 * @author P' Tong
	 * @return 
	 */
	private Vector getVlist(){
		if(this.processList == null){ 
			MyLog.debug("!! This process is from CSC_QUQUE !!");
			return this.getProcessList(); 
		}
		return this.processList;
	}
	
	@Override
	public void process() throws Exception {
		try{
			Vector vList = this.getVlist();
			
			for(int i = 0;i < vList.size() && !this.isCancle(); i++){
				String[] str = this.chkNull.chkNullString((String) vList.get(i)).split("\\|");
				if(this.rec == null){
					this.rec = new InitialRecord(this.getUProfile()).getDbRecord("Ttimetemp");
					this.rec.setColumn("*");
				}
				
				this.rec.clearField();
				
				this.rec.set("employeeid", str[0]);
				this.rec.set("swipedate", str[1]);
				this.rec.set("swipetime", str[2]);
				this.rec.set("companyid", this.getUProfile().getCompanyid());
				if(this.rec.search() == 1){
					this.rec.save();
					this.alive("Process Emp_id ::" + str[0]);
				} else {
					MyLog.debug(this, this.getUProfile(), "!!!!!!!!!! [TAWAT] : Can't find Ttimetemp record [empid : " + str[0] + "], [swipetime : " + str[1] + "], [swipetime : " + str[2] + "]");
				}
			}
		}catch(Exception e){
			MyLog.error(this, this.getUProfile(), e);
			this.setMessage("Exception:" + e);
		}
	}
	
	private void init(){
		try{
			if( this.ev  == null ){
				this.ev= new InitialEnvironment(this.getUProfile().getDbName());
			}
			if( this.ds == null ){
				this.ds = new DataSet();
				//this.ds.setClassName("GenTimeAuto");
				this.ds.setUPofile(this.getUProfile());
        		this.ds.setDbName(this.getUProfile().getDbName());
        		this.ds.setDbType(this.ev.getValue("datasource-dbtype"));
			}
		}catch(Exception e){
			MyLog.error(this , this.getUProfile() , e);
		}
	}
	
	private String getParamData(String key){
		if(this.data.containsKey(key))
			return (String) this.data.get(key);
		return "";
	}
}
