package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.TimeResult;
import com.csc.library.utilities.CscCalendar;

/*
 * NOT USED 2008/09/01
 */
public class MoveHisCurrent extends ProcessTimeBase {
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			if (!this.getParamValue("filterProcess").equals("")) {
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");
				inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, companyid, startdate, resigndate, status");
				inq.setFatchAll(true);
				inq.refresh();
				while (inq.next()) {
					v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public void process() throws Exception {		
		this.setParamData();
		CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
		cs1.decDate();
		CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
		cs2.incDate();
				
		Vector vt = this.processList;
		for (int i=0;i<vt.size();i++) {
			DbRecord empRec = new InitialRecord(this.upf).getDbRecord("MEMPLOYEE");
        	empRec.set("employeeid", (String) vt.elementAt(i));
        	empRec.set("companyid", (String) this.upf.get("companyid"));
        	empRec.search();
        	
			//MyLog.debug(this, "-----------> employeeid=" + empRec.getString("employeeid") + " ---> time0=" + empRec.getString("time0"));
			if ( this.getParamValue("cmdValue").equalsIgnoreCase("tot")) {
				this.chkTot(empRec, cs1 ,cs2);
			} else if ( this.getParamValue("cmdValue").equalsIgnoreCase("tabsentdate")) {
				this.chkTabsent(empRec, cs1, cs2);
			} else if ( this.getParamValue("cmdValue").equalsIgnoreCase("tabsent_m_date")) {
				this.chkTabsent_m_date(empRec, cs1, cs2);
			}
		}
	}
	
	private void chkTot(DbRecord empRec, CscCalendar cs1, CscCalendar cs2) {
		try {
			String filter = "employeeid='"+empRec.getString("employeeid")+"' and wf_status='9' " +
			"and (ot_date between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"') ";
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("TOT", filter, "employeeid");
			inq.setColumn("*");
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				DbRecord docRec = inq.getCurrentDbRecord();				
				Mtime0 timeRec = this.getTimeRecord(empRec.getString("time0"));		
				timeRec.setEmpRec(empRec);
				if (timeRec != null) {
					//MyLog.debug(this, "-----------> startDate=" 	+ this.getParamValue("startDate") + "  endDate=" + this.getParamValue("endDate"));
					WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(docRec.getString("ot_date")), new CscCalendar(docRec.getString("ot_date")));
					//MyLog.debug(this, ">>> WorkingShift=" + ws);
					this.upf.set("empRecord",empRec.getString("employeeid"));
					if (!ws.isEmpty()) {
						this.saveHistory_Tot(ws, empRec, docRec);
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void chkTabsent_m_date(DbRecord empRec, CscCalendar cs1, CscCalendar cs2) {
		try {
			String filter = "employeeid='"+empRec.getString("employeeid")+"' and wf_status='9' " +
				"and (start_date between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"') "+
				"and (end_date between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"') ";
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("TABSENT_M_DATE", filter, "employeeid");
			inq.setColumn("*");
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				DbRecord docRec = inq.getCurrentDbRecord();				
				Mtime0 timeRec = this.getTimeRecord(empRec.getString("time0"));
				timeRec.setEmpRec(empRec);
				if (timeRec != null) {
					//MyLog.debug(this, "-----------> startDate=" 	+ this.getParamValue("startDate") + "  endDate=" + this.getParamValue("endDate"));
					WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(docRec.getString("start_date")), new CscCalendar(docRec.getString("end_date")));
					//MyLog.debug(this, ">>> WorkingShift=" + ws);
					this.upf.set("empRecord",empRec.getString("employeeid"));
					if (!ws.isEmpty()) {
						this.saveHistory_Tabsent_m_date(ws, empRec, docRec.cloneRecord(false));
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void chkTabsent(DbRecord empRec, CscCalendar cs1, CscCalendar cs2) {
		try {
			DbInquiry inqChild = new InitialInquiry(this.upf).getDbInquiry();
			inqChild.setParam(this.data);
			inqChild.setSchemaName(this.upf.getSchemaName());
			inqChild.initMyTable("TABSENTDATE1", "", "");
			inqChild.setColumn("*");
			
			String filter = "employeeid='"+empRec.getString("employeeid")+"' and wf_status='9' " +
				"and (absent_date between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"') ";
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("TABSENTDATE0", filter, "employeeid");
			inq.setColumn("*");
			inq.setFatchAll(true);
			inq.putChild(inqChild);
			inq.refresh();
			while (inq.next()) {
				DbRecord docRec = inq.getCurrentDbRecord();				
				Mtime0 timeRec = this.getTimeRecord(empRec.getString("time0"));		
				timeRec.setEmpRec(empRec);
				if (timeRec != null) {
					//MyLog.debug(this, "-----------> startDate=" 	+ this.getParamValue("startDate") + "  endDate=" + this.getParamValue("endDate"));
					WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(docRec.getString("absent_date")), new CscCalendar(docRec.getString("absent_date")));					
					//MyLog.debug(this, ">>> WorkingShift=" + ws.toString());
					this.upf.set("empRecord",empRec.getString("employeeid"));
					if (!ws.isEmpty()) {
						DbInquiry inqAbsent = (DbInquiry) docRec.getChild("TABSENTDATE1");
						this.saveHistory_Tabsent(ws, empRec, docRec, inqAbsent);
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	private void saveHistory_Tabsent(WorkingShift ws, DbRecord empRec, DbRecord docRec, DbInquiry inqAbsent) {
		for (Iterator IT = ws.keySet().iterator(); IT.hasNext();) {
			String key = (String) IT.next();
			DayShift dShift = (DayShift) ws.get(key);
			try {
				String date="";
				int i=1, recCount=0;
				DbTable db = new InitialTable(this.upf).getDbTable("Ttime_current1"); 			
				for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {			
					String key1 = (String) IT1.next();
					TimeResult tr = (TimeResult) dShift.get(key1);
					date = tr.getResultShiftCalendar().getYYYYMMDD();
					
					inqAbsent.first();
					while (inqAbsent.next()) {	
						DbRecord absentRec = inqAbsent.getCurrentDbRecord();
						DbRecord rec = db.getNewRecord(); 
						rec.set("employeeid", empRec.getString("employeeid"));
						rec.set("companyid", empRec.getString("companyid"));
						rec.set("dateid", tr.getResultShiftCalendar().getYYYYMMDD());					
						rec.set("doctype", "A");
						rec.set("docno", docRec.getString("absentid"));
						rec.set("time0id", tr.getResultTimeCode());
						rec.set("old_time0", tr.getResultOldTimeCode());						
						rec.set("sequence", this.getStringID(i, 2));
						try {
							rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
							rec.set("c_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
						} catch (Exception e) {
							MyLog.error(this, e);
						}
						try {
							rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
							rec.set("c_tm_en", tr.getResult_c_dt_out().getCSCTime());
						} catch (Exception e) {
							MyLog.error(this, e);
						}
											
						CscCalendar csc1 = new CscCalendar(docRec.getString("absent_date"));
						csc1.setCSCTime(absentRec.getFloat("start_time"));					
						CscCalendar csc2 = new CscCalendar(docRec.getString("absent_date"));
						csc2.setCSCTime(absentRec.getFloat("end_time"));
						
						if (csc2.subForHour(csc1)>8) {
							rec.set("m_lv", 8);	
						} else rec.set("m_lv", csc2.subForHour(csc1));	
						rec.set("c_lv", tr.getResultC_LV());
						rec.set("ap_ot", tr.getResultAp_ot());
						rec.set("lv_ty", absentRec.getString("type_absent"));
						rec.set("tr_type", "A");
						rec.set("eventgrp", absentRec.getString("type_absent"));
						rec.set("ac_ot", tr.getResultAc_ot());
						
						rec.set("iswork", tr.getResultIsWork());
						rec.set("oldeventgrp", tr.getResultOldEventGroup());						
						db.putNewRecord(rec);
						recCount++;			
						i++;
					}
					//i++;
				}				
				
				if (recCount>0) {				
					DbRecord rec = new InitialRecord(this.upf).getDbRecord("Ttime_current");				
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("time0id", empRec.getString("time0")); 
					rec.set("dateid", date);				 
					rec.putChild(db); 
					rec.save();
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}
	}
	
	private void saveHistory_Tot(WorkingShift ws, DbRecord empRec, DbRecord docRec) {
		for (Iterator IT = ws.keySet().iterator(); IT.hasNext();) {
			String key = (String) IT.next();
			DayShift dShift = (DayShift) ws.get(key);
			try {
				String date="";
				int i=1, recCount=0;
				DbTable db = new InitialTable(this.upf).getDbTable("Ttime_current1"); 			
				for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {			
					String key1 = (String) IT1.next();
					TimeResult tr = (TimeResult) dShift.get(key1);
					date = tr.getResultShiftCalendar().getYYYYMMDD();
					
					DbRecord rec = db.getNewRecord(); 
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("dateid", tr.getResultShiftCalendar().getYYYYMMDD());					
					rec.set("doctype", "B");
					rec.set("docno", docRec.getString("otid"));
					rec.set("time0id", tr.getResultTimeCode());
					rec.set("old_time0", tr.getResultOldTimeCode());						
					rec.set("sequence", this.getStringID(i, 2));
					try {
						rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
						rec.set("c_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
					} catch (Exception e) {
						MyLog.error(this, e);
					}
					try {
						rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
						rec.set("c_tm_en", tr.getResult_c_dt_out().getCSCTime());
					} catch (Exception e) {
						MyLog.error(this, e);
					}
										
					CscCalendar ot1 = new CscCalendar(docRec.getString("ot_date"));
					ot1.setCSCTime(docRec.getFloat("start_time"));					
					CscCalendar ot2 = new CscCalendar(docRec.getString("ot_date"));
					ot2.setCSCTime(docRec.getFloat("end_time"));
					
					rec.set("m_dt_bg", ot1.getYYYYMMDD());
					rec.set("m_tm_bg", ot1.getCSCTime());
					rec.set("m_dt_en", ot2.getYYYYMMDD());
					rec.set("m_tm_en", ot2.getCSCTime());					
												
					rec.set("c_lv", tr.getResultC_LV());
					rec.set("ap_ot", tr.getResultAp_ot());
					rec.set("lv_ty", tr.getResultLV_Type());
					rec.set("tr_type", "O");
					rec.set("eventgrp", "O");
					rec.set("ac_ot", tr.getResultAc_ot());
					
					rec.set("iswork", tr.getResultIsWork());
					rec.set("oldeventgrp", tr.getResultOldEventGroup());						
					db.putNewRecord(rec);
					recCount++;
					i++;
				}				
				
				if (recCount>0) {				
					DbRecord rec = new InitialRecord(this.upf).getDbRecord("Ttime_current");				
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("time0id", empRec.getString("time0")); 
					rec.set("dateid", date);				 
					rec.putChild(db); 
					rec.save();
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}
	}

	private void saveHistory_Tabsent_m_date(WorkingShift ws, DbRecord empRec, DbRecord docRec) {
		for (Iterator IT = ws.keySet().iterator(); IT.hasNext();) {
			String key = (String) IT.next();
			DayShift dShift = (DayShift) ws.get(key);
			try {
				String date="";
				int i=1, recCount=0;
				DbTable db = new InitialTable(this.upf).getDbTable("Ttime_current1"); 			
				for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {			
					String key1 = (String) IT1.next();
					TimeResult tr = (TimeResult) dShift.get(key1);
					date = tr.getResultShiftCalendar().getYYYYMMDD();
					
					DbRecord rec = db.getNewRecord(); 
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("dateid", tr.getResultShiftCalendar().getYYYYMMDD());					
					rec.set("doctype", "S");
					rec.set("docno", docRec.getString("absentid"));
					rec.set("time0id", tr.getResultTimeCode());
					rec.set("old_time0", tr.getResultOldTimeCode());						
					rec.set("sequence", this.getStringID(i, 2));
					try {
						rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
						rec.set("c_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
					} catch (Exception e) {
						MyLog.error(this, e);
					}
					try {
						rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
						rec.set("c_tm_en", tr.getResult_c_dt_out().getCSCTime());
					} catch (Exception e) {
						MyLog.error(this, e);
					}
					
					try {
						if (tr.getResult_m_dt_in()!=null) {
							rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
							rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
						}
					} catch (Exception e) {
						MyLog.error(this, e);
					}	
					try {
						if (tr.getResult_m_dt_out()!=null) {
							rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
							rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
						} 
					} catch (Exception e) {
						MyLog.error(this, e);
					}
												
					rec.set("c_lv", tr.getResultC_LV());
					rec.set("ap_ot", tr.getResultAp_ot());
					rec.set("lv_ty", docRec.getString("type_absent"));
					rec.set("tr_type", "A");
					rec.set("eventgrp", docRec.getString("type_absent"));
					rec.set("m_lv", tr.getResult_c_dt_out().subForHour(tr.getResult_c_dt_in()));
					rec.set("ac_ot", tr.getResultAc_ot());		
					
					rec.set("iswork", tr.getResultIsWork());
					rec.set("oldeventgrp", tr.getResultOldEventGroup());						
					db.putNewRecord(rec);
					recCount++;
					i++;
				}				
				
				if (recCount>0) {				
					DbRecord rec = new InitialRecord(this.upf).getDbRecord("Ttime_current");				
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("time0id", empRec.getString("time0")); 
					rec.set("dateid", date);				 
					rec.putChild(db); 
					rec.save();
				}
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}
	}
}
