package com.csc.library.process;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.upload.FileInfo;

public class RetrieveSwipeTimeGPF extends MyProcess{
	
	private Connection conn ;
	
	private Vector vData = new Vector();
	
	private String driver ;
	private String url ;
	private String username ;
	private String pass ;
	private String activetime ;
	private String outputfolder ;
	private String viewname ;
	private String sourcename ;
	private String empcol ;
	private String datecol ;
	//private String timecol ;
	private String cardcol ;
	private String doorcol ;
	private String acccol ;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		v.add("default");
		return v;
	}//end method getProcessList

	
	public void process() throws Exception {
		readConConfix();
		initConnection();
		ReadSwipeTime();
		WriteSwipeTime();
	}//end method process
	
	/* init conn */
	private void initConnection(){
		try {
			Class.forName(driver);
			conn = DriverManager.getConnection(url, username, pass);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/* read connection prop from xml */
	private void readConConfix(){
		try {
			InitialEnvironment en = new InitialEnvironment("GLOBAL");
			String importPath = en.getValue((String)this.data.get("servicename") + "-dir"); //path  connection prop
			outputfolder = en.getValue("dirimport-dir"); //path ٴѵ ;
			
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
            Document doc = docBuilder.parse (new File(importPath));
            
            doc.getDocumentElement ().normalize ();
            System.out.println ("Root element of the doc is " + 
                 doc.getDocumentElement().getNodeName());
            
            NodeList listOfDatabase = doc.getElementsByTagName(doc.getDocumentElement().getNodeName());
            for(int s=0; s < listOfDatabase.getLength() ; s++){
            	Node firstDBNode = listOfDatabase.item(s);
                if(firstDBNode.getNodeType() == Node.ELEMENT_NODE){
                	Element firstDBElement = (Element)firstDBNode;
                	
                	NodeList firstNameList = firstDBElement.getElementsByTagName("DATASOURCE");
                    Element firstNameElement = (Element)firstNameList.item(0);
                	
                    driver = firstNameElement.getAttribute("driver");
                    url = firstNameElement.getAttribute("url");
                    username = firstNameElement.getAttribute("username");
                    pass = firstNameElement.getAttribute("password");
                    activetime = firstNameElement.getAttribute("activetime");
                    viewname = firstNameElement.getAttribute("viewname");
                    sourcename = firstNameElement.getAttribute("sourceswt");
                    
                    empcol = firstNameElement.getAttribute("empcol");
                    datecol = firstNameElement.getAttribute("datecol");
                    //timecol = firstNameElement.getAttribute("timecol");
                    cardcol = firstNameElement.getAttribute("cardcol");
                    doorcol = firstNameElement.getAttribute("doorcol");
                    acccol = firstNameElement.getAttribute("acccol");

                }//end of if clause
            }//end of for loop with s var


        }catch (SAXParseException err) {
	        System.out.println ("** Parsing error" + ", line " 
	             + err.getLineNumber () + ", uri " + err.getSystemId ());
	        System.out.println(" " + err.getMessage ());

        }catch (SAXException e) {
	        Exception x = e.getException ();
	        ((x == null) ? e : x).printStackTrace ();

        }catch (Exception e) {
        	e.printStackTrace ();
        }
	}
	
	/* read swipe time from SERVICECLPE (external DB) */
	private void ReadSwipeTime(){
		ResultSet rs = null;
		Statement st = null;
		try {
			if(conn != null){
				st = conn.createStatement();
				rs = st.executeQuery(getQuery());
				
				while(rs.next()){
					GPFSwipeProp swProp = new GPFSwipeProp();
					CscCalendar swtime = new CscCalendar(rs.getTimestamp(datecol));
					//CscCalendar swtime = new CscCalendar(rs.getTimestamp("GenTime"));
					/*
					swProp.setId(rs.getString("Note1"));
					swProp.setTrDate(swtime.getYYYYMMDD());
					swProp.setTrTime(swtime.getHHMMSS());
					swProp.setCardNo(rs.getString("CardNo"));
					swProp.setUnitNo(rs.getString("Door"));
					swProp.setTrCode(rs.getString("CardHolderAccountID"));*/

					swProp.setId(rs.getString(empcol));
					swProp.setTrDate(swtime.getYYYYMMDD());
					swProp.setTrTime(swtime.getHHMMSS());
					swProp.setCardNo(rs.getString(cardcol));
					swProp.setUnitNo(rs.getString(doorcol));
					swProp.setTrCode(rs.getString(acccol));

					vData.add(swProp);
				}
				
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				if(st != null) st.close();
				if(rs != null) rs.close();
				if(conn != null) conn.close();
			}catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	
	/* ѹ鹴֧ */
	private CscCalendar getStartDate(){
		CscCalendar cs = null;
		try {
			if(this.data.containsKey("fixstart")){
				String fix = (String) this.data.get("fixstart");
				if(fix.startsWith("-")){
					String tmp[] = fix.split("-");
					cs = new CscCalendar();
					cs.decDate(Integer.parseInt(tmp[1]));
				}else{
					cs = new CscCalendar(fix);
				}
			}else{
				cs = new CscCalendar();
				//cs.decDate();
			}
		}catch(Exception e){
			MyLog.error(this,e);
			cs = new CscCalendar();
			//cs.decDate();
		}
		return cs;
	}
	
	/* create query to retrieve data since yesterday at 8.31 */
	private String getQuery(){
		StringBuilder sql = new StringBuilder();
		try {
			CscCalendar cs = getStartDate();
			
			sql.append("select " + empcol + "," + datecol + "," + cardcol + "," + doorcol + "," + acccol);
			sql.append(" from ").append(viewname);
			sql.append(" where " + datecol + " > ");
			sql.append(" CONVERT(datetime, '").append(cs.getYYYYMMDD()).append(" ").append(activetime).append("', 120)");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sql.toString();
	}
	
	/* write file */
	private void WriteSwipeTime(){
		FileWriter fstream = null;
		try {
			fstream = initOutputFile();
			
			for(int i = 0; i < vData.size(); i++){
				GPFSwipeProp swProp = (GPFSwipeProp) vData.get(i);
				
				fstream.write(createTxt(swProp));
				
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			if(fstream != null)
				try {
					fstream.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}
	
	/* create msg */
	private String createTxt(GPFSwipeProp swprop){
		StringBuilder sb = new StringBuilder();
		String tab = "\t";
		try {
			sb.append(swprop.getId());
			sb.append(tab);
			sb.append(swprop.getCardNo());
			sb.append(tab);
			sb.append(swprop.getTrDate());
			sb.append(tab);
			sb.append(swprop.getTrTime());
			sb.append(tab);
			sb.append(swprop.getUnitNo());
			sb.append(tab);
			sb.append(swprop.getTrCode());
			sb.append("\r");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sb.toString();
	}
	
	private FileWriter initOutputFile(){
		try {
			String filename = new CscCalendar().getYYYYMMDD() + ".txt";
			File out = new File(outputfolder);

			// if the directory does not exist, create it
			if (!out.exists()) {
				System.out.println("creating directory: " + outputfolder);
				boolean result = out.mkdir();
				if (result) {
					System.out.println("DIR created");
				}
			}
			
			FileWriter fw = new FileWriter(outputfolder + sourcename + "_"+ filename );

			return fw;
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return null;
	}
}
