package com.csc.library.process;

import java.text.DecimalFormat;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.mail.SendMail;
import com.csc.library.report.ReportUDF;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/*
 * class 㹡 ͼԴҴҡõǨͺŧҢͧѡҹ
 * Ѻѡҹ ˹ҧҹ
 * ·ӡ觻üԴҴͧҨҡ˹Ҩ 
 *  ٴ ٴ͡  繵
 * ·ӡѺѡҹ Ѻ˹ҧҹ
 */
public class SendMailCheckTimeError extends ProcessTimeBase {
	
	DbRecord empRec = null;
	DbInquiry inqTimeError = null;
	DbInquiry inqEmp = null;
	DecimalFormat df = new DecimalFormat("00");
	
	public Vector getProcessList() {
		Vector v = new Vector();
	    try {
	    	this.setParamData();
	        if (!this.getParamValue("filterProcess").equals("")) {
	        	DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
		        inq.setParam(this.data);
		        inq.setSchemaName(this.upf.getSchemaName());
		        inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");
		        inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, "+
		         		"companyid, status, startdate, resigndate, salatype, workarea, emp_position, "+
		           		"emp_roup, branch, job");
		        inq.setFatchAll(true);
		        inq.refresh();
		        while (inq.next()) {
		        	v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
		        }
	        }
	    } catch (Exception e) {
	    	MyLog.error(this, e);           
	    }
	    return v;	   
	}
	 
	 public void process() throws Exception {
	      	this.setParamData();        
	        String error_type="";
	        String send_to="";
	        int loop = 0;
	        if (this.data.containsKey("error_type")) { // error_type ͧ error_type Ẻ˹ҧ
	        	StringTokenizer str = new StringTokenizer((String) this.data.get("error_type"),",");
	        	String error = "";
	        	while (str.hasMoreTokens()) {
	        		error = df.format(Double.parseDouble(str.nextToken())); 
	        		if (loop==0) {
	        			error_type = "(warn"+error+"<>'')";
	        		} else {
	        			error_type += " or (warn"+error+"<>'')";
	        		}
	        		loop++;
	        	}
	        	if (error_type.length()>0) {
	        		error_type = " and ("+error_type+")";
	        	}
	        } 
	        
	        if (this.data.containsKey("send_to")) { // ͧúҧ 0=ѡҹ 1=˹ҧҹ	        
	        	send_to = (String) this.data.get("send_to");
	        }
	        
	        CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
	        CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
	        Vector vt = this.processList;
	        String errorProcess = "";
	        String errorSendMail = "";
			String errorValue = "";
			String filter;
			for (int i=0;i<vt.size() && !this.isCancle();i++) {
				String id = (String) vt.elementAt(i);				
				try {
					/*
					 * ӡҢͼԴҴҡŧҷͧѡҹ͡
					 * ¹Ӣͼ״Ҵҵ ѹŧ㹵 errorValue
					 * ͹
					 */
					errorValue = "";
					if (this.inqTimeError == null) {
						this.inqTimeError = new InitialInquiry(this.upf).getDbInquiry();
						this.inqTimeError.initMyTable("TTIME_CURRENT1", "", "employeeid, dateid");
						this.inqTimeError.setColumn("*");
					}					
					filter = "employeeid='"+id+"' and (dateid between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')";
					this.inqTimeError.setFilter(filter+error_type);
					this.inqTimeError.refresh();
					while (this.inqTimeError.next()) {
						DbRecord rec = this.inqTimeError.getCurrentDbRecord();
						errorValue += this.getErrorString(rec, new CscCalendar(rec.getString("dateid")));
					}					
				} catch (Exception e ) {	}
				
				/*
				 * ҡբͼԴҴԴ йʾѡҹ seach 
				 * , , ˹ҧҹ 㹡
				 */
				if (!errorValue.equals("")) {
					if (this.inqEmp == null) {
						this.inqEmp = new InitialInquiry(this.upf).getDbInquiry();
						this.inqEmp.initMyTable("MEMPLOYEE", "", "");
						this.inqEmp.setColumn("employeeid, companyid, emp_level, email, bossid, " +
								" emp_prefix, fname, lname, efname, elname");
					}
					this.inqEmp.setFilter("employeeid='"+id+"'");
					this.inqEmp.refresh();
					this.inqEmp.next();
					DbRecord recEmp = this.inqEmp.getCurrentDbRecord(); 
					String mail_content = "";
					if (((String) this.upf.get("lang")).equalsIgnoreCase("tha")) {
						mail_content = "šüԴҴҡõǨͺš÷ӧҹ "+
							"ͧ "+recEmp.getString("employeeid")+" : "+recEmp.getString("FULLNAME")+" "+
							"ѹ "+cs1.getDDMMYYYY()+" ֧ "+cs2.getDDMMYYYY()+"<br>";
					} else {
						mail_content = "List of Abnormal from Checking Working "+
						"of  "+recEmp.getString("employeeid")+" : "+recEmp.getString("FULLNAME")+" "+
						"from "+cs1.getDDMMYYYY()+" to "+cs2.getDDMMYYYY()+"<br>";
					}
					try {
						if (send_to.indexOf("0")>-1) { //Ҿѡҹ
							SendMail sm = new SendMail("", 
							        new InitialEnvironment("GLOBAL").getValue("MAILAUTH-username"), 
							        recEmp.getString("email"),
									"", 
									"HR online : šüԴҴҡõǨͺšúѹ֡",
									mail_content+errorValue);
							sm.send();
						} else if (send_to.indexOf("1")>-1) { //˹Ңͧѡҹ
							this.inqEmp.setFilter("employeeid='"+recEmp.getString("bossid")+"'");
							this.inqEmp.refresh();
							this.inqEmp.next();
							DbRecord recBoss = this.inqEmp.getCurrentDbRecord(); 
							SendMail sm = new SendMail("", 
							        new InitialEnvironment("GLOBAL").getValue("MAILAUTH-username"), 
							        recBoss.getString("email"),
									"", 
									//"Mail Result From myHR System [Working Abnormal]",
									"HR online : šüԴҴҡõǨͺšúѹ֡",
									mail_content+errorValue);
							sm.send();
						} 
					} catch (Exception e) {
						errorSendMail += id+", ";
					}
				} else {
					errorProcess += id+", ";
				}
				
	            this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
			}
			this.setMessage("Successful of SendMailCheckTimeError : "+vt.size());
			this.setFullMessage("Successful of SendMailCheckTimeError : "+vt.size()+"\n"+
					"Not Error Abnormal : "+errorProcess+"\n"+
					"Not Send Mail : "+errorSendMail);					
	 }
	 
	 /*
	  * ʴͤüԴҴҡ process
	  */
	 private String getErrorString(DbRecord rec, CscCalendar c) {
		 String result = "";
		 try {			 
			 String errorList = (String) this.data.get("error_type");
			 String sCode = "";
			 String error = "";
			 ReportUDF UDF = new ReportUDF();			 
			 StringTokenizer str = new StringTokenizer(errorList,",");			
			 while (str.hasMoreTokens()) {
				 error = str.nextToken();
				 sCode = UDF.getSystemCode("error_type", (String) this.upf.get("lang"), error);
				 if (!rec.getString("warn"+df.format(Double.parseDouble(error))).equals("")) {
					 if (((String) this.upf.get("lang")).equalsIgnoreCase("tha")) {
						 result += "ѹ "+c.getDDMMYYYY()+" \t " + sCode+" \t" + 
							"šüԴҴ "+rec.getString("warn"+df.format(Double.parseDouble(error))) + " <br>";
					} else {
						result += "Date "+rec.getString("dateshift")+" \t " + sCode+" \t" +
							"Error Value "+rec.getString("warn"+df.format(Double.parseDouble(error))) + " <br>";
					}
				}
			 }			 
		 } catch (Exception e) {}
		 return result;
	 }
	 
}
