package com.csc.library.process;

import java.io.File;
import java.util.Vector;

import com.csc.library.database.StaticConfig;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import java.io.File;

public class SendMailCurData extends MyProcess {

	/* ֧  config */
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			if(isActiveDate()) {		/* ֧ѹͧż */
				String foldername = new CscCalendar().getYYYYMMDD();
				File folder = new File(getDefaultFolder() + foldername);
				File[] listOfFiles = folder.listFiles();

				for (int i = 0; i < listOfFiles.length; i++) {
					if (listOfFiles[i].isFile()) {
						v.add(listOfFiles[i].getName());
				    } 
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return v;
	}
	
	public void process() throws Exception {
		if(isActiveDate()) {		/* ֧ѹͧż */
			Vector v = getDataList();;
			
			for(int i=0; i < v.size(); i++){
				readFile((String)v.get(i));				/* ҹ */
			}
		}else{
			setFullMessage("!! today is not active day ,send mail process will not be activated !!");
		}
	}
	
	/* ҹ͡ҷŴ  Class MailOperator Ѵ¡ */
	private void readFile(String filename){
		try {
			String foldername = new CscCalendar().getYYYYMMDD();
			File fXmlFile = new File(getDefaultFolder() + foldername + "//" + filename);	/* ֧੾ѹѨغѹ */
			
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(fXmlFile);
			doc.getDocumentElement().normalize();
			
			NodeList nList = doc.getElementsByTagName("EMPLOYEE");
			for (int temp = 0; temp < nList.getLength(); temp++) {
				Node nNode = nList.item(temp);
				MailOperator mol = new MailOperator();	/* ǨѴ¡  */ 
				mol.init(this.upf,nNode);
				mol.sendmail();
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* Ҩҡ˹Ҩ */
	private boolean isManual(){
		try {
			if(this.data.containsKey("ismanual")){
				String ism = (String) this.data.get("ismanual");
				if(ism.equals("1")){
					return true;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* ѹ process ͧӧҹ */
	private boolean isActiveDate(){
		String ENDOFMONTH = "ENDOFMONTH";
		
		try {
			CheckNull chk = new CheckNull();
			String act = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TAACTIVE"));
			
			if(isManual()){
				return true;
			}else if(act != null && !act.trim().equals("")){
				CscCalendar today = new CscCalendar();
				
				/* ͹ */
				if(act.equalsIgnoreCase(ENDOFMONTH)){
					act = Integer.toString(today.getEndDateOfMonth());
				}
				
				if(today.getDate() == Integer.parseInt(act)){
					return true;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}
	
	/* get default folder */
	private String getDefaultFolder(){
		String folder = "";
		try {
			CheckNull chk = new CheckNull();
			folder = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TAFOLDER"));
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return folder;
	}
	
	private Vector getDataList(){
		try {
			if(this.processList != null){
				return this.processList;
			}else{
				return getProcessList();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return null;
	}

}
