package com.csc.library.process;

import java.util.HashMap;
import java.util.Iterator;

import com.csc.library.utilities.MyLog;

public class TransferTimeLog {
	private String emp = "";	/* employeeid */
	private int rect0 = 0;		/* number of ttime_current */
	private int rect1 = 0;		/* number of ttime_current1 */
	private HashMap<String,StringBuffer> datekey = new HashMap<String, StringBuffer>();		/* each date error */ 
	private StringBuffer sb = new StringBuffer(); 	/* normal error */
	
	public TransferTimeLog(String emp){
		this.emp = emp;
	}
	
	public String getEmp(){
		return this.emp;
	}
	
	public int getTCur0RowOutput(){
		return rect0 ;
	}
	
	public int getTCur1RowOutput(){
		return rect1 ;
	}
	
	public String getErrorOnDate(){
		StringBuffer sb = new StringBuffer();
		try {
			for(Iterator it = (Iterator) datekey.keySet().iterator(); it.hasNext();){
				String dkey = (String) it.next();
				StringBuffer sbt = datekey.get(dkey);
				sb.append("\r\n");
				sb.append(dkey);
				sb.append("\t").append(sbt).append("\r\n");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sb.toString();
	}
	
	public String getGlobalError(){
		return this.sb.toString();
	}
	
	public void setTimeCurNo(int no){
		this.rect0 += no; 
	}
	
	public void setTimeCur1No(int no){
		this.rect1 += no; 
	}
	
	/* global error */
	public void addError(String mode, String msg){
		addGlobalErr(mode, msg);
	}
	
	/* specific date error */
	public void addError(String mode, String dkey, String msg){
		addDateError(mode, dkey, msg);
	}
	
	public void addDateError(String mode, String dkey, String err){
		try {
			if(datekey.containsKey(dkey)){
				this.datekey.put(dkey, this.datekey.get(dkey).append("\r\n")).append("[").append(mode).append("] ").append(err);
			}else{
				this.datekey.put(dkey, new StringBuffer().append(err));
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void addGlobalErr(String mode, String err){
		try {
			this.sb.append("\r\n");
			this.sb.append("[").append(mode).append("] ");
			this.sb.append(err);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
}
