package com.csc.library.process;

import java.lang.reflect.Method;
import java.rmi.RemoteException;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import koala.dynamicjava.tree.AddExpression;

import std.library.DataTable;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Memployee;
import com.csc.library.databean.Memployee_ta;
import com.csc.library.databean.Mtime0;
import com.csc.library.databean.Ttime_current;
import com.csc.library.databean.Ttime_current1;
import com.csc.library.service.ServiceTimeWorking;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.timeattendance.BreakCheck;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.ManageAdjustChangeHoliday;
import com.csc.library.timeattendance.ManageAdjustLeave;
import com.csc.library.timeattendance.ManageAdjustOT;
import com.csc.library.timeattendance.OTBreak;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.SwipeData;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.SwipeRecord;
import com.csc.library.timeinterface.TimeResult;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utility.DiffTime;
import com.csc.library.utility.NRepairTtimeCurrent1;
import com.csc.library.utility.NTriger;

/*
 * Class Ѻ Ǩͺ, ͹š÷ӧҹͧѡҹ
 * ¨仹 ѹ֡ŧ TTIME_CURRENT, TTIME_CURRENT1
 */
public class TransferTimeProcess extends ProcessTimeBase {
	
	MyHashMap hmTime = null;
	MyHashMap hmDayTime=null;
	MyTreeMap hashOT=null;
	MyHashMap hmHoliday=null;
	MyHashMap hmSwipeCard = null; //红šٴѵ
	MyHashMap hmOTAdjust = null; //红š÷ OT Ẻͧ͡
	MyHashMap hmCostcenter = null; //͡ costcenter Ҩҡ
	MyHashMap hmBusLate = null; //红š
	MyHashMap hmUnused = null; //红šҹ UNUSED
	
	DbRecord empRec = null;
	DbInquiry inqTimeCurrent = null;
	DbInquiry inqTimeCurrent1 = null;
	DbInquiry inqSwipeTime = null;
	DbInquiry inqFormula = null;
	
	DbRecord recTCurrent = null;
	DbTable dbTCurrent1 = null;
	DbRecord recTCurrentNoWork = null;
	DbTable dbTCurrent1NoWork = null;
	DbRecord recTCurrentOT = null;
	DbTable dbTCurrent1OT = null;
	
	DbInquiry inqOTAdjust = null;
	DbInquiry inqCostcenter = null;
	DbInquiry inqBusLate = null;
	DbInquiry inqUnused = null;
	
	CscCalendar cs1 = null;
	CscCalendar cs2 = null;
	CscCalendar tempCs1 = null;
	CscCalendar tempCs2 = null;
	
	String flag_ot = "0";
	String flag_cost = "0";
	String flag_buslate = "0";
	String flag_unused = "0";
	String AUTO_GEN_SHIFT = ""; /* ʶҹ ҧἹѵѵ (0 ,1 )*/
	
	CalOT calOT = null;
	
	HashMap hmTimeRec = new HashMap();	/*  mtime0 Ѻ */

	private Vector vc = new Vector();	/* Ἱ */
	private Vector vcSwipeTime = new Vector();	/* ٴѵ */
	
	private boolean delStatus = true;
	
	Ttime_current1 buff = null ; /* chk prv & next shift */
	
	private Hashtable<String,String> hshShift = new Hashtable<String,String>();
	/**Ǩͺ Ҩҡ param
     * 㹡óչҨҡá˹ CSC_QUQUE
     * ҡ˹ startDate  endDate = today ͨлż  ѹѨغѹ
     * ҡ startDate  endDate = last1  ż͹ѧ 1 ѹ
     */	
	private Hashtable<String,String> htbEndWorkDate = new Hashtable<String,String>();
	
	private StringBuffer doEmpList = new StringBuffer();	/* ʾѡҹ觻ż  log ѧ */
	
	/* debug */
	private HashMap<String, TransferTimeLog> hmEmpProLog = new HashMap<String, TransferTimeLog>(); /* Process Emp Log */
	private String M_DEBUG = "DEBUG";
	private String M_ERROR = "ERROR";
	
	private void chkParamQueue() {
		if (this.getParamValue("startDate").equalsIgnoreCase("today") && this.getParamValue("endDate").equalsIgnoreCase("today")) {
			//ѹѨغѹ 駤
			CscCalendar c1 = new CscCalendar();
			this.data.put("startDate", c1.getDDMMYYYY());
			this.data.put("endDate", c1.getDDMMYYYY());
			this.hmParam.put("startDate", c1.getDDMMYYYY());
			this.hmParam.put("endDate", c1.getDDMMYYYY());
		}else if (this.getParamValue("startDate").indexOf("last")>-1 && this.getParamValue("endDate").equalsIgnoreCase("today")) {
			//ѹ͹ѧ , ѹش  ѹѨغѹ
			CscCalendar stDate = new CscCalendar();
			String strStDate = this.getParamValue("startDate");
			strStDate = strStDate.substring(4, strStDate.length());
			CscCalendar tmpStDate = new CscCalendar();
			tmpStDate.decDate(Integer.parseInt(strStDate));			
			CscCalendar endDate = new CscCalendar();
			this.data.put("startDate", tmpStDate.getDDMMYYYY());
			this.data.put("endDate", endDate.getDDMMYYYY());
			this.hmParam.put("startDate", tmpStDate.getDDMMYYYY());
			this.hmParam.put("endDate", endDate.getDDMMYYYY());
		} else if (this.getParamValue("startDate").indexOf("last")>-1 && this.getParamValue("endDate").indexOf("last")>-1) {
			//͹ѧ 駤
			String s1 = this.getParamValue("startDate");
			String s2 = this.getParamValue("endDate");
			s1 = s1.substring(4, s1.length());
			s2 = s2.substring(4, s2.length());
			CscCalendar c1 = new CscCalendar();
			c1.decDate(Integer.parseInt(s1));
			CscCalendar c2 = new CscCalendar();
			c2.decDate(Integer.parseInt(s2));
			this.data.put("startDate", c1.getDDMMYYYY());
			this.data.put("endDate", c2.getDDMMYYYY());
			this.hmParam.put("startDate", c1.getDDMMYYYY());
			this.hmParam.put("endDate", c2.getDDMMYYYY());
		}
	}
	
	/** ֧ʾѡҹ лԹ ͹䢨ҡ˹Ҩ **/
    public Vector getProcessList() { /* Override ҡ Class ProcessTimeBase */
    	this.data.put("maxlist","50"); /*  Thread öżžѡҹ٧ش 50 ҹ */
        Vector v = new Vector();
        try {
            this.setParamData();
            this.chkParamQueue();
            
            //Ҩӹǹ  ͧӡûż շ褹 ͹ǹٻżŷФ
            if (!this.getParamValue("filterProcess").equals("")) {
	            DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
	            inq.setParam(this.data);
	            inq.setSchemaName(this.upf.getSchemaName());

	            inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");
	            inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, companyid, status, startdate, resigndate,salary,emp_level,endworkdate");
	            inq.setFatchAll(true);
	            inq.refresh();
	            
	            while (inq.next()) {
	                v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
	                this.htbEndWorkDate.put(inq.getCurrentDbRecord().getString("employeeid"), inq.getCurrentDbRecord().getString("endworkdate"));
	            }
            }
            
        } catch (Exception e) {
        	MyLog.error("!! Error in TransferTimeProcess.getProcessList() !!");            
        }
        return v;
    }	
	
    /* 觻żŨҡ˹Ҩ Ҩҡ quque */
	private Vector getEmpList(){ 
		if(this.processList == null){ /* Ҩҡ quque  Method getProcessList ֧žѡҹһż ֧ͧ¡ͧ*/
			MyLog.debug("!! This process is from CSC_QUQUE !!");
			return this.getProcessList(); 
		} 
		return this.processList;
	}
	
	private void setDateTimeProcess(){
		/** 絤鹢ͧѹ شûż ¹ӤҷҨҡ˹Ҩ **/
        try {
			this.cs1 = new CscCalendar(this.getParamValue("startDate")); /* start process date */        
	        this.cs2 = new CscCalendar(this.getParamValue("endDate")); /* end process date */

	        this.cs1.setCSCTime(Float.parseFloat(this.getParamValue("startTime"))); /* start process time */
        	this.cs2.setCSCTime(Float.parseFloat(this.getParamValue("endTime"))); /* end prcess time */
        } catch (Exception e) {
        	try {
	        	this.cs1.setCSCTime(0.00f);
	        	this.cs2.setCSCTime(0.00f);
        	}catch (Exception ex){
        		MyLog.debug("!! start and end process date is set to be 0.00f !!");
        	}
        }
	}
	
	private void setDeleteOldDataFlag(){
        try {
        	if (!this.getParamData("delStatus").equals("")) //Ѻź Ҩҡ˹Ҩ Condition
        		this.delStatus = Boolean.valueOf(this.getParamData("delStatus"));
        } catch (Exception e) {
        	this.delStatus = true;
        }
	}
	
	private void updateUProfile(){
		/* Ǩͺҡ param յ÷˹ 
	     * ӡá˹ŧ UProfile 
	     * ҡ繡 process Ҩҡ CSC_QUQUE 
	     * ҺҧҨ UProfile
	     */
	    if (this.data.containsKey("companyid")) {
			this.upf.set("companyid", (String) this.data.get("companyid"));
		}
		if (this.data.containsKey("schemaname")) {
			this.upf.setSchemaName((String) this.data.get("schemaname"));
		}
		if (this.data.containsKey("dbname")) {
			this.upf.setDbName((String) this.data.get("dbname"));
		}
		if (this.data.containsKey("appname")) {
			this.upf.set("appname", (String) this.data.get("appname"));
		}
		if (this.data.containsKey("lang")) {
			this.upf.set("lang", (String) this.data.get("lang"));
		}
	}
	
	private void renewEmp(){ /*  empRec  null ҧ */
		try {
	        if (this.empRec == null) {
	        	this.empRec = new InitialRecord(this.upf).getDbRecord("MEMPLOYEE_TA");
	        	this.empRec.setColumn("*");
	        	this.empRec.setParam("rsc_skip","true");
	        }
		} catch (Exception e) {
			MyLog.error("!! Can't create new DbRecord for MEMPLOYEE in TransferTimeProcess.renewEmp !!");
		}
	}
	
	private void setDefaultProp(){
		try {
			this.renewEmp();
			
	        this.hmTime = new MyHashMap();
	        this.hmDayTime = new MyHashMap();
	        this.hashOT = this.loadOTFormula();
	        this.hmHoliday = new MyHashMap();
	        this.hmOTAdjust = new MyHashMap();
	        this.hmCostcenter = new MyHashMap();
	        this.hmBusLate = new MyHashMap();
	        this.hmUnused = new MyHashMap();
		} catch (Exception e) {
			MyLog.error("!! Error on setting default properties in TransferTimeProcess.setDefaultProp() !!");
		}
	}
	
	private void setFlag_OT(){
		this.flag_ot = "0"; //ͷẺͧ͡
		try {			
			this.flag_ot = (String) StaticConfig.getConfigCompany(this.upf, "ta1008");
		} catch (Exception e) {
			this.flag_ot = "";
			MyLog.debug("!! Can't get ConfigCompany TA1008 !!");
		} 
	}
	
	private void setFlag_cost(){
		this.flag_cost = "0"; //ѡҹ ¹ costcenter 
		try {			
			this.flag_cost = (String) StaticConfig.getConfigCompany(this.upf, "ta1009");
		} catch (Exception e) {
			this.flag_cost = "";
			MyLog.debug("!! Can't get ConfigCompany TA1009 !!");
		} 
	}

	private void setFlag_buslate(){
		this.flag_buslate = "0"; //Ǩͺ¢ͧ  㹡óöѺ
		try {			
			this.flag_buslate = (String) StaticConfig.getConfigCompany(this.upf, "ta1010");
		} catch (Exception e) {
			this.flag_buslate = "";
			MyLog.debug("!! Can't get ConfigCompany ta1010 !!");
		} 
	}

	private void setFlag_unused(){
		this.flag_unused = "0"; //Ǩͺ¢ͧ  㹡óöѺ
		try {			
			this.flag_unused = (String) StaticConfig.getConfigCompany(this.upf, "ta1011");
		} catch (Exception e) {
			this.flag_unused = "";
			MyLog.debug("!! Can't get ConfigCompany ta1011 !!");
		} 
	}
	
	private void setPropFromMconfig(){
        this.setFlag_OT(); //ͷẺͧ͡
        this.setFlag_cost(); //ѡҹ ¹ costcenter 
        this.setFlag_buslate(); //Ǩͺ¢ͧ  㹡óöѺ
        this.setFlag_unused(); //Ǩͺ UNUSED
	}
	
	private void getEmpData(String empid){
		try{
	    	this.empRec.clearField();
	    	this.empRec.set("employeeid", empid);
	    	this.empRec.set("companyid", (String) this.upf.get("companyid"));
	    	this.empRec.search();
		} catch (Exception e) {
			MyLog.error("!! Can't find employeeid in Table Memployee !!");
		}
	}
	
	private void setCostCenter(String emp){
		try {
	    	this.hmCostcenter.clear();
	    	if (this.flag_cost.equals("1")) {
				this.hmCostcenter = this.loadDayChangeCostcenter(emp);
			}
		} catch (Exception e) {
			MyLog.error("!! Can't load CostCenter from MConfig !!");
		}
	}
	
	private void setOTAdjust(String emp){
		try {
        	this.hmOTAdjust.clear();        	
        	if (this.flag_ot.equals("1")) {
    			this.hmOTAdjust = this.loadOTAdjust(emp);
    		}
		} catch (Exception e) {
			MyLog.error("!! Can't load OTAdjust from MConfig !!");
		}
	}
	
	private void setBusLate(String emp){
		try {
			this.hmBusLate.clear();        	
			if (this.flag_buslate.equals("1")) {
				this.hmBusLate = this.loadBusLate(emp);
			}
		} catch (Exception e) {
			MyLog.error("!! Can't load BusLate from MConfig !!");
		}
	}

	private void setUnused(String emp){
		try {
			this.hmUnused.clear();
			if (this.flag_unused.equals("1")) {
				this.hmUnused = this.loadUnused(emp);
			}
		} catch (Exception e) {
			MyLog.error("!! Can't load Unused from MConfig !!");
		}
	}
	
	private void printHeader4Debug(String emp,int i,int size){
		this.doEmpList.append(",").append(emp);
		MyLog.debug("!! TransferTimeProcess Debug : index : "+i+" of "+size+" Process "+emp+" is Startting...");
	}
	
	private void printProcessStatus(String emp,int i,int size){
		MyLog.debug("!! TransferTimeProcess Debug : index : "+i+" of "+size+" Process "+emp+" is Completed...");
	}
	
	private void printProcessFooter(String strTime,String endTime,int size,String err,String errPro){
		StringBuffer text = new StringBuffer();
		text.append("========================================================= \n");
		text.append("	Start Process at : ").append(strTime).append("\n");
		text.append("	Finish Process at : ").append(endTime).append("\n");
		text.append("	Process id is : ").append(this.processId).append("\n");
		text.append("	Employee List is : ").append(this.doEmpList.toString()).append("\n");
		text.append("	Successful of TransferTimeProcess : ").append(size).append("\n");
		text.append("	Result Error : ").append(err).append("\n");
		text.append("	Error Process : ").append(errPro).append("\n");
		text.append("========================================================= \n");
		
		MyLog.debug(text.toString());
	}
	
	public void process() throws Exception {
        CscCalendar startProcess = new CscCalendar(); /* ʴ§ҹʶҹСûԹ ͹ ͧʹ */
		StringBuffer errorResult = new StringBuffer(); /* ʴ§ҹʶҹСûԹ ͹ ͧʹ */
		StringBuffer errorProcess = new StringBuffer(); /* ʴ§ҹʶҹСûԹ ͹ ͧʹ */
		
        Vector vt = this.getEmpList(); /* ª;ѡҹ лż */   

		this.setParamData();
    	this.chkParamQueue();
    	this.setDateTimeProcess(); 		/* 絤 ͧѹ شûԹ  */
    	this.setDeleteOldDataFlag(); 	/* 絤ʶҹ ͧź */
        this.updateUProfile(); 			/* Ǩͺ С˹ Uprofile ա */
        this.setDefaultProp(); 			/* 絤Ѻõҧ  㹡ûż */
        this.setPropFromMconfig(); 		/* 礤 Ѻ͹䢺ҧҧ ¡ô֧Ҩҡ MConfig */
		
        try {
		        
	        this.tempCs1 = new CscCalendar(this.cs1.getYYYYMMDD());
			this.tempCs2 = new CscCalendar(this.cs2.getYYYYMMDD());
	
			/* 鹡ûż ¹ʾѡҹ Ф͡Ҩҡ process list */
			String id = "";
			for (int i=0;i<vt.size() && !this.isCancle();i++) {
				this.vc.clear();
				id = (String) vt.elementAt(i); /* ʾѡҹ */
				
				initEmpProcLog(id);	/* create emp process log */
	
				this.printHeader4Debug(id,i,vt.size()); /* for debugging only */
				
				try {
					this.getEmpData(id); /* ҢŢͧѡҹҡ Memployee   this.empRec */
		        	String empID = this.empRec.getString("employeeid");
		        	
		        	/* Ѻ͡  process شѹ endworkdate */
		        	//if(this.htbEndWorkDate.containsKey(empID)){
		        		CscCalendar endWorkDate = new CscCalendar(this.empRec.getString("ENDWORKDATE"));
		        		if(endWorkDate.beforeEquals(this.tempCs1)){
		        			// ѹ鹡ûż ѧ ѹӧҹѹش 
		        			continue;
		        		}else if (endWorkDate.after(this.tempCs1) && endWorkDate.beforeEquals(this.tempCs2)){
		        			// ѹ鹡ûż ͹ ѹӧҹѹش  ѹشûż ѧ ѹӧҹѹش
		        			this.cs1 = new CscCalendar(this.tempCs1.getYYYYMMDD());
		        			this.cs2 = new CscCalendar(endWorkDate.getYYYYMMDD());
		        		}else{	
		        			//
		        			this.cs1 = new CscCalendar(this.tempCs1.getYYYYMMDD());
		        			this.cs2 = new CscCalendar(this.tempCs2.getYYYYMMDD());
		        		}
		        	//}//end if 
		        	
		        	this.setCostCenter(empID); 	/* 絤 CostCenter */
		        	this.setOTAdjust(empID); 	/* 絤 OTadjust */
		        	this.setBusLate(empID); 	/* 絤 BusLate */
		        	this.setUnused(empID); 		/* 絤 Unused */
		        	
	    			/* ֧šٴѵ ǧҷż  MyTreeMap */
		        	MyTreeMap tr = new MyTreeMap(); 
	    			
		        	Mtime0 timeRec = this.getTimeRecord(this.empRec.getString("time0"));
		            if (timeRec != null) {
		                timeRec.setEmpRec(this.empRec); /* 絢žѡҹ */
		                timeRec.setEmpSwipeTime(tr); 	/* 絢šٴѵ ŧἹ */
		                
		                /** 
		                 	ѹش ҧἹ÷ӧҹ ѹ͹˹ ѹѴ
							 żѹ 10-01-2010 зӡҧἹѹ 09-01-2010 - 11-01-2010
							кҧó Тѹ
		                 **/
		                CscCalendar stGenWorkingSF = new CscCalendar(this.cs1.getTimestamp());
		                CscCalendar enGenWorkingSF = new CscCalendar(this.cs2.getTimestamp());
		                stGenWorkingSF.decDate();   
		                enGenWorkingSF.incDate();
		                
		                /** ҧἹ÷ӧҹ Ẻѹش **/
		                WorkingShift wstmp = timeRec.genWorkingShift(new CscCalendar(stGenWorkingSF.getTimestamp()), new CscCalendar(enGenWorkingSF.getTimestamp()), "true");	//ѹش
		                wstmp.setUProfile(this.upf);
		                wstmp.meargeWithShiftTrans(empRec, new CscCalendar(stGenWorkingSF.getTimestamp()), new CscCalendar(enGenWorkingSF.getTimestamp()));
		                
		                this.alive("Process TransferTimeProvess Load WorkimgShift Temp.... "); /* кѧӧҹ  kill process 駨ҡ quque */
	
		                /** ҧἹ÷ӧҹ Ẻѹش **/
		                //WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(stGenWorkingSF.getTimestamp()), new CscCalendar(enGenWorkingSF.getTimestamp())); //ѹش
		                //this.alive("Process TransferTimeProvess Load WorkingShift.... "); /* кѧӧҹ  kill process 駨ҡ quque */
		                
		                this.upf.set("empRecord", empID);
		                if (this.getParamValue("cmdValue").equalsIgnoreCase("transfer")) {
		                	this.calOT = new CalOT(this.upf);
		                	Ttime_current t = new Ttime_current();
		                	Ttime_current1 t1 = new Ttime_current1();
		                	this.calOT.initValue((Memployee_ta) this.empRec, (Ttime_current1) t1, (Mtime0) timeRec, new HashMap(), new HashMap(), (Ttime_current) t, new DiffTime(), StaticProperties.messagePools);
		                	
	                        transferTimeProcess(wstmp, wstmp, this.empRec, timeRec); /* 觤 任Թ */
	                        UpdateWithCustomData(this.empRec.getString("employeeid")
	                    		, this.cs1.getYYYYMMDD()
	                    		, this.cs2.getYYYYMMDD());	/* ѾഷѺ ttime_current 边ѡҹѺͧҡ˹ empview */
		                }
		            } else {
		            	errorResult.append(id).append(",");
		            	setEmpProcError(id, "Mtime0 not found " + this.empRec.getString("time0"));
		            }	            
				} catch (Exception e) {
					MyLog.error(this,e);
					errorProcess.append(id).append(",");
					setEmpProcError(id, e.getMessage());
				}			
				
				this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]"); /* кѧӧҹ  kill process 駨ҡ quque */
				
				this.printProcessStatus(id,i,vt.size()); /* print ʶҹТͧûż ҷʾѡҹ˹ */
	        }

        }catch(Exception e){
        	MyLog.error(this,e);
        }finally{
        	printProcessFooter(startProcess.getYYYYMMDDHHMMSS(),new CscCalendar().getYYYYMMDDHHMMSS(),vt.size()
					,errorResult.toString(),errorProcess.toString()); /* print process summary when finish */
		
        	setFullMessage("Process employee " + vt.size() + " record(s).");
		
        	setSummary();	/* process log */
        }
	}//end method process
	
	private void setSummary(){
		try {
			StringBuffer fmsg = new StringBuffer();
			fmsg.append("** Output :\n\r");
			
			for(Iterator it = hmEmpProLog.keySet().iterator(); it.hasNext(); ){
				String empkey = (String) it.next();
				
				TransferTimeLog ttl = (TransferTimeLog) hmEmpProLog.get(empkey);
				fmsg.append("\r\nid : " + ttl.getEmp());
				fmsg.append("\r\ntime_current : ").append(ttl.getTCur0RowOutput()).append(" row(s)");
				fmsg.append("\r\ntime_current1 : ").append(ttl.getTCur1RowOutput()).append(" row(s)");
				fmsg.append("\r\n");
				
				String bgerr = ttl.getGlobalError();
				String dateerr = ttl.getErrorOnDate();
				
				if(bgerr.length() > 0){
					fmsg.append(bgerr);
				}

				if(dateerr.length() > 0){
					fmsg.append(dateerr);
				}
				fmsg.append("\n\r***************************");
			}
			
			setFullMessage(fmsg.toString());
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* create emp proc log */
	private void initEmpProcLog(String emp){
		try {
			TransferTimeLog ttl = new TransferTimeLog(emp);
			this.hmEmpProLog.put(emp, ttl);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private TransferTimeLog getEmpProcLog(String emp){
		TransferTimeLog ttl = null;
		try {
			if(!hmEmpProLog.containsKey(emp)){
				initEmpProcLog(emp);
			}
			
			ttl = hmEmpProLog.get(emp);
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return ttl ;
	}
	
	/* add error */
	private void setEmpProcError(String emp, String msg){
		try {
			if(!hmEmpProLog.containsKey(emp)){
				initEmpProcLog(emp);
			}
			
			TransferTimeLog ttl = this.hmEmpProLog.get(emp);
			ttl.addError(M_DEBUG, msg);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* add error */
	private void setEmpProcOutput(String emp, int tcur1row){
		try {
			if(!hmEmpProLog.containsKey(emp)) {
				initEmpProcLog(emp);
			}
			
			TransferTimeLog ttl = this.hmEmpProLog.get(emp);
			ttl.setTimeCurNo(1);	/* increase by 1 */
			ttl.setTimeCur1No(tcur1row);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
    
    /** 觻ż ǧҷ˹ **/
    public void transferTimeProcess(WorkingShift ws, WorkingShift wstmp, DbRecord empRec, DbRecord timeRec) {
        try {
        	CscCalendar csStart = new CscCalendar(this.getParamValue("startDate"));
            csStart.decDate();
            CscCalendar csEnd = new CscCalendar(this.getParamValue("endDate"));
            csEnd.incDate();
                    	                        
            CscCalendar c1 = new CscCalendar(this.getParamValue("startDate"));
            c1.setCSCTime(0.0f);
            CscCalendar c2 = new CscCalendar(this.getParamValue("endDate"));
            c2.setCSCTime(23.59f);
            
            SwipeData SD = new SwipeData();
            SD.setUProfile(this.upf);
            Vector v = SD.loadDataToVector(empRec.getString("employeeid"), csStart, csEnd); 
            
            //Ἱ÷ӧҹͧǧҡ÷ӧҹ ( -)
        	if (!wstmp.isEmpty()) {      
        		wstmp.setUProfile(this.upf);
                wstmp.setEmployeeid(empRec.getString("employeeid"));
                wstmp.setEmpTimeCode(empRec.getString("time0"));
                wstmp.setEmprec(empRec);

                wstmp.adjust();   /* ѺἹ੾¹ š */             
                wstmp.createLink();
                
                /* ¹ѹشһѺἹ  */
                ManageAdjustChangeHoliday mac = new ManageAdjustChangeHoliday(upf);
                wstmp.adjustChangeHoliday(mac.getAdjustChangeHolidayData(wstmp, empRec),upf);
                
                /* ѺἹѺ  */
                ManageAdjustLeave mal = new ManageAdjustLeave(upf);
                //wstmp.adjustDocument(mal.getAdjustLeaveData(wstmp, empRec, timeRec, "approve not in ('W')"),upf);
                mal.getAdjustLeaveData(wstmp, empRec, timeRec, "approve not in ('W')");
                
                /* ѺἹѺâͷ */
                ManageAdjustOT mao = new ManageAdjustOT(upf);
                wstmp.adjustDocument(mao.getAdjustOTData(wstmp, empRec, timeRec),upf);
                
                wstmp.overlapChecking();	/* Ǩͺзǧѹ */
                wstmp.CheckContinueOT();	/* Ǩͺͷշ͡Ѻзӧҹ ҢͧͧҴ¡ѹ */
                wstmp.setActualEvent();		/* ˹ѹѺз ͷѹش */
                
                SwipeData SD1 = new SwipeData();
                SD1.setUProfile(this.upf);
                SD1.setSwipeTime(v);
                
                wstmp.genTimeZone();
                this.alive("Process TransferTimeProvess GenTimeZone Temp .... ");
                wstmp.setSwipeTrans(SD1);                
                wstmp.findTime(c1, c2);
                this.alive("Process TransferTimeProvess Find TimeZone Temp .... ");
                
                /* ѺٴѵẺ ó çἹ */
                wstmp.adjAutoSwipeTime();
                
                this.saveTransferTimeProcess(wstmp, wstmp, empRec, timeRec); //ӡûż кѹ֡š÷ӧҹŧҹ
            }else{
            	setEmpProcError(empRec.getString("employeeid"), "WorkingShift not found");
            }
        } catch (Exception e) {
        	MyLog.error(this, e); 
        	try {
				setEmpProcError(empRec.getString("employeeid"), e.getMessage());
			} catch (RemoteException e1) {
				e1.printStackTrace();
			}
        }
    }

    private void delOldTtimeCurrent(String emp){
        try {
        	DbRecord rec = null;
        	StringBuffer filter = new StringBuffer(); 
        	filter.append("employeeid='").append(emp).append("' and (dateid between '").append(this.tempCs1.getYYYYMMDD());
        	filter.append("' and '").append(this.tempCs2.getYYYYMMDD()).append("')");
        	
        	if (this.inqTimeCurrent == null) {
            	this.inqTimeCurrent = new InitialInquiry(this.upf).getDbInquiry();
            	this.inqTimeCurrent.initMyTable("Ttime_current", "", "employeeid");
            	this.inqTimeCurrent.setColumn("*");
            }
        	
        	this.inqTimeCurrent.setFilter(filter.toString());
        	this.inqTimeCurrent.setFetchAll(true);
        	this.inqTimeCurrent.setColumn("*");
        	this.inqTimeCurrent.refresh();
        	
        	while (this.inqTimeCurrent.next()) {
        		rec = this.inqTimeCurrent.getCurrentDbRecord().cloneRecord(true);
        		if (this.delStatus) {
             	   rec.delete();
                } else {
             	   //ѹ ttime_current 㹡Ҩкѹ֡ѹ鹷Ѻ
                    CscCalendar c = new CscCalendar(rec.getString("dateid"));
                    this.vc.add(c.getDDMMYYYY()); 
                }
        	}
        } catch (Exception e){
        	MyLog.error("!! Error on deleting old data in Ttime_current1 from TransferTimeProcess.delOldTtimeCurrent !!");
        }
    }
    
    private void delOldTtimeCurrent1(String emp){
        try {
        	StringBuffer filter = new StringBuffer();
        	filter.append("delete ttime_current1 where ");
        	filter.append("employeeid='").append(emp).append("' and (dateid between '").append(this.tempCs1.getYYYYMMDD());
        	filter.append("' and '").append(this.tempCs2.getYYYYMMDD()).append("')");
        	
        	if(!this.deleteData(filter.toString())) MyLog.debug("!! error while delete ttime_current1 !!"); 
        } catch (Exception e){
        	MyLog.error("!! Error on deleting old data in Ttime_current1 from TransferTimeProcess.delOldTtimeCurrent1 !!",e);
        }
    }
    
    /**
     	͹ż еͧźŢҴҹ ʹ͹ ͧҡҨաҧ¹ҡʶҹТҴҹ ᷹ѧ 
      	ҡź ʹҴҹФҧʹ 觷ʹԴ
    **/
    private void delOldTleaveSummary(String emp) {
    	try {
        	StringBuffer filter = new StringBuffer();
        	filter.append("delete tleave_summary where ");
        	filter.append("employeeid='").append(emp).append("' and (dateid between '").append(this.tempCs1.getYYYYMMDD());
        	filter.append("' and '").append(this.tempCs2.getYYYYMMDD()).append("')");
        	filter.append(" and (lv_type = 'J' or lv_type = 'LT')");
        	
        	if(!this.deleteData(filter.toString())) MyLog.debug("!! error while delete tleave_summary !!"); 
    	} catch(Exception e){
        	MyLog.error("!! Error on deleting old data in Tleave_summary from TransferTimeProcess.delOldTleaveSummary !!",e);
    	}
    }
    
    private boolean deleteData(String sql){
    	boolean result = false;
    	CscConnection conn = null;
    	Statement stmt = null;
    	boolean autoCommit=true;

    	try{
    		conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			autoCommit = conn.getAutoCommit();
			conn.setAutoCommit(false);
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);
			stmt = conn.createStatement();
			stmt.executeUpdate(sql);
			conn.commit();
    		result = true;    	
    	}catch(Exception e){
    		MyLog.error("!! Con't execute sql or sql error in TransferTimeProcess.deleteData !!", e);
    	}finally{
    		try{
	    		if(stmt!=null){
	    			stmt.close();
	    		}
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception ex){
    			MyLog.error("!! Error : can't close statement or connection in TransferTimeProcess.deleteDate!!",ex);
    		}
        	return result;
    	}
    }
    
    //Delete old data before save process transfer data to time_current and time_current1
    public synchronized void delOldData(String emp) {
    	this.delOldTtimeCurrent(emp);
    	this.delOldTtimeCurrent1(emp);
    	this.delOldTleaveSummary(emp);
    }

    private void updatePreviousAndNextShift(DbRecord empRec, WorkingShift wstmp, WorkingShift ws){
    	try {
    		NRepairTtimeCurrent1 nRepair = new NRepairTtimeCurrent1();
            nRepair.retrieveMHoliday1(this.upf, empRec.getString("employeeid"));
            DataTable dtbUpdate = nRepair.repair(wstmp, empRec,ws);
            
        	NTriger nTriger = new NTriger();
        	for (int ii=1;ii<=dtbUpdate.rowCount();ii++){
	        	 //set data to hshShift for find data
        		 String keys = dtbUpdate.getItem(ii,"EMPLOYEEID").toString()
				 			 			+dtbUpdate.getItem(ii,"COMPANYID").toString()
							 			+dtbUpdate.getItem(ii,"DATEID").toString()
							 			+dtbUpdate.getItem(ii,"SEQUENCE").toString();
        		 
        		 String previousShift ="";
        		 String nextShift ="";
        	   		 
        		 String employeeid = dtbUpdate.getItem(ii,"EMPLOYEEID").toString();
         		 if(ii==1){
          			//get previousShift
         			previousShift = nTriger.getShift(this.hmParam, this.upf,1,"EVENTGRP",employeeid);
         			//get nextShift
         			if(dtbUpdate.rowCount()==1){
         				nextShift = nTriger.getShift(this.hmParam, this.upf,3,"EVENTGRP",employeeid);
         			}else{
         				nextShift = nRepair.getShift(dtbUpdate, (ii+1),"EVENTGRP");
         			}//end if  
         		}else if(ii==dtbUpdate.rowCount()){
         			//get previousShift
         			previousShift = nRepair.getShift(dtbUpdate, (ii-1),"EVENTGRP");
         			//get nextShift
         			nextShift = nTriger.getShift(this.hmParam, this.upf,3,"EVENTGRP",employeeid);
         		 }else{
        			//get previousShift
         			previousShift = nRepair.getShift(dtbUpdate, (ii-1),"EVENTGRP");			 	 	
				 	//get nextShift
         			nextShift = nRepair.getShift(dtbUpdate, (ii+1),"EVENTGRP");				 
        		 }//end if  
	        	 
         		this.hshShift.put(keys, previousShift+nextShift);
        	 }//end for ii
    	} catch (Exception e) {
    		MyLog.error("!! Error in TransferTimeProcess.updatePreviouAndNextShif() !!"); 
    	}
    }

    private void getTCurrent1ForWorkindDay(){ /* ҡ͹зӡúѹ֡ Ѻѹ */
    	try {
	     	 if (this.dbTCurrent1 == null) {
	          	this.dbTCurrent1 = new InitialTable(this.upf).getDbTable("Ttime_current1");
	          	this.dbTCurrent1.setColumn("*");
	          }
	     	 this.dbTCurrent1.clear();
    	} catch(Exception e) {
    		MyLog.error("!! Error in TransferTimeProcess.getTCurrent1ForWorkindDay() !!");
    	}
    }
    
    private void getTCurrent1ForNonWorkingDay(){ /* ҡ͹зӡúѹ֡ Ѻѹ */
    	try {
			if (this.dbTCurrent1NoWork == null) {
				this.dbTCurrent1NoWork = new InitialTable(this.upf).getDbTable("Ttime_current1");
			}
			this.dbTCurrent1NoWork.clear();
    	} catch(Exception e) {
    		MyLog.error("!! Error in TransferTimeProcess.getTCurrent1ForNonWorkingDay() !!");
    	}
    }
    
    /** ӡûż кѹ֡š÷ӧҹŧ Ttime_current  Ttime_current1 **/
    private void saveTransferTimeProcess(WorkingShift ws, WorkingShift wstmp, DbRecord empRec, DbRecord timeRec) {
    	boolean overlab = false;
        float hour_s = 0; //.÷ӧҹѹ
        CscCalendar date = null;

        try {          
            MyTreeMap hmADJ = new MyTreeMap();
            TimeResult tResult = null;
            
            delOldData(empRec.getString("employeeid")); 	/* źš÷ӧҹ */
            updatePreviousAndNextShift(empRec,wstmp,ws); 	/* 絤 С͹˹ СеͨҡлѨغѹ */
        	 
        	buff = null; /*manage pre shift and next shift */
        	 
            for (Iterator<?> IT = ws.keySet().iterator(); IT.hasNext();) {    
                String key = (String) IT.next();
                DayShift dShift = (DayShift) ws.get(key);
                CscCalendar csDate = new CscCalendar(key);

                if (this.vc.contains(csDate.getDDMMYYYY())) {                	
                	continue; //ѹͧӡ save Ѻѹ ͧ save
                }

                getTCurrent1ForWorkindDay(); /* 红ŧ TTime_current1 */
                setTimeRecProp(timeRec);
                
                if (csDate.afterEquals(this.cs1) && csDate.beforeEquals(this.cs2)) { /* 㹪ǧѹͧż */

                    HashMap errorDayShiftResult = dShift.getErrorResult();
                    int i = 1, recCount = 0;
                    
                    // ----- ҹբ㹡  դѹش ----- //
                    if (dShift.isEmpty() || dShift.size()==1) {
                    	if (dShift.size()==1) {
                    		Shift sh = (Shift) dShift.get((String) dShift.firstKey());
                    		if (sh.getResultTR_Type().equals("M")) {	/* 繡ͷ ١Ѻ ͹˹  зѧй 觨жաй  ͡ѹش١ͷշѺ */
                    			if( (sh.getEventGroup().equals("H") || sh.getEventGroup().equals("I"))
                    					&& sh.getNextShift().getTR_Type().startsWith("O")
                    					&& sh.getNextShift().get_c_dt_in().afterEqualsDateTime(sh.get_c_dt_in())
                    					&& sh.getNextShift().get_c_dt_in().beforeEqualsDateTime(sh.get_c_dt_out())){
                    				sh.set_c_dt_out(new CscCalendar(sh.getNextShift().get_c_dt_in().getTime()));
                    			}
                    			
                				this.saveDayNotWorking(wstmp, empRec, key, getTimeRecProp(sh.getTimeCode()));
                				continue;

                    		} else if ((sh.getEventGroup().equals("H") || sh.getEventGroup().equals("I")) && sh.getDocNo().trim().equals("")) {
                    			this.saveDayNotWorking(wstmp, empRec, key, getTimeRecProp(sh.getTimeCode()));
                    			continue;
                    		} else if ((sh.getEventGroup().equals("H") || sh.getEventGroup().equals("I")) && sh.getDocType().trim().equals("C")) {
                    			this.saveDayNotWorking(ws, empRec, key, getTimeRecProp(sh.getTimeCode()));
                    			continue;
                    		}  
                    	} else { 
                    		this.saveDayNotWorking(wstmp, empRec, key, timeRec);
                    		continue;
                    	}
                    } else {
                    	Iterator IT1 = dShift.keySet().iterator(); 
                        TimeResult tr = (TimeResult) dShift.get(IT1.next());
                        
                        DayShift dShifttmp = (DayShift) wstmp.get(key);
                    	Iterator IT1tmp = dShifttmp.keySet().iterator();			
                		TimeResult trtmp = (TimeResult) dShifttmp.get(IT1tmp.next());
                		
                		if ((tr.getResultEventGroup().equals("H") || tr.getResultEventGroup().equals("I")) && tr.getResultDocNo().trim().equals("")) {
                			this.saveDayNotWorking(wstmp, empRec, key, timeRec);
                			
                			boolean hasOTShift = false ;
                			while(IT1tmp.hasNext()){ /* ó㹡ѹش ͷѹѴ价ѺѺѹش */
                				trtmp = (TimeResult) dShifttmp.get(IT1tmp.next());
                				if(!trtmp.getResultTR_Type().equals("M") && trtmp.getResultTR_Type().indexOf("O") > -1){
                					hasOTShift = true ;
                				}
                			}
                			
                			if(!hasOTShift) continue;
                			
                		} else if (tr.getResult_c_dt_out().before(trtmp.getResult_c_dt_in())) {
                			if (!tr.getResultTR_Type().equals("M") && tr.getResultTR_Type().indexOf("O")<=-1) {
                				this.saveDayNotWorking(wstmp, empRec, key, timeRec);
                				continue;
                			}
                		}
                    }
                    
                     //overlab = false;
                     //if (!overlab) {
                    	String docType = "";
                    	String oldDocType = "";
                    	String eventgrp = "";
                    	String chkDate = "";
                    	
                    	dShift.findHolidaySwipe(); 
                    	dShift.genProcessResult();
                      	     
                    	preProcessTrigger(ws, recTCurrent);	/* pre process trigger */
                    	
                    	for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {                    	
	                    	hour_s = 0;
	                        boolean isSave = true;
	                        String key1 = (String) IT1.next();
	                        TimeResult tr = (TimeResult) dShift.get(key1);
	                        
	                        checkOverlapPreviousShift(empRec.getString("employeeid"), (Shift)dShift.get(key1));	/* ǨͺἹѺѺС͹˹ᨧ err  log */
	
	                        HashMap errorResult = tr.getResultError();
	                        // ----- Check swipe time type ----- //
	                        int flag=9;
							//9=, 0=ٴ, 1=ٴ͡, 2=ٴͧ 
							String autoSwip=""; //0=ٴ ,1=ٴ
							if (errorResult.isEmpty()) {
								isSave=true;
							} else {						
								if (errorResult.containsKey("0") && errorResult.containsKey("1")) {
	                            	isSave = true;
	                        		flag = 2;
	                        	} else if (errorResult.containsKey("0") && !errorResult.containsKey("1")) {
	                        		isSave = true;
	                        		flag = 0;
	                        	} else if (!errorResult.containsKey("0") && errorResult.containsKey("1")) {
	                        		isSave = true;
	                        		flag = 1;
	                        	}
								if (tr.getResultPropertyShf()!=null) {
									HashMap shf = tr.getResultPropertyShf();
									autoSwip = (String) shf.get("FGTYPE");
									if (autoSwip.equals("1")) {
										isSave = true;
										flag = 9;
									}
								}
							}
							// ----- End check swipe time ----- //
	
	                        if (isSave && !tr.getResultTR_Type().equalsIgnoreCase("M")) {
	                        	
		                        //date = new CscCalendar(tr.getResultShiftCalendar().getYYYYMMDD());	/* dateid */
	                        	date = new CscCalendar((tr.getActualDate()!=null)?tr.getActualDate():tr.getResultShiftCalendar().getYYYYMMDD());	/* dateid */

	                            DbRecord rec = this.dbTCurrent1.getNewRecord();
	                            rec.setColumn("*");
	                            
	                            hmADJ.clear(); 	//㹡ͷբѹ
	                        	tResult = null; //з㹡äӹǳͷբѹ
	                            // ----- Check 㹡óͷբѹ ----- //
								if (!tr.getResultAdjustTemp().equals("")) {
									StringTokenizer str = new StringTokenizer(tr.getResultAdjustTemp(),"#");
									MyTreeMap hm;
									String adj="", adj2="";
									
									while (str.hasMoreTokens()) {
										adj = str.nextToken();					
										hm = new MyTreeMap();
										StringTokenizer str2 = new StringTokenizer(adj,",");
										
										while (str2.hasMoreTokens()) {				
											adj2 = str2.nextToken();
											hm.put(adj2.substring(0,adj2.indexOf("=")), adj2.substring(adj2.indexOf("=")+1,adj2.length()));				
										}
										hmADJ.put(adj.substring(6,16), hm);		
									}
									tResult = tr;
								}
								// ----- End check OT over day ----- //
								
	                            rec.set("employeeid", empRec.getString("employeeid"));
	                            rec.set("companyid", empRec.getString("companyid"));
	                            //rec.set("dateid", tr.getResultShiftCalendar().getYYYYMMDD());
	                            rec.set("dateid", (tr.getActualDate()!=null)?tr.getActualDate():tr.getResultShiftCalendar().getYYYYMMDD());	/* ͧѺѹԧ ͧйʴ (ҧ駷ͷբͧТѹ ǧѧ觨繤ѹѺ)  */
	                            rec.set("doctype", tr.getResultDocType());
	                            rec.set("docno", tr.getResultDocNo());
	                            rec.set("olddoctype", tr.getResultOldDocType());
	                            rec.set("olddocno", tr.getResultOldDocNo());
	                            rec.set("forget_in","0");
								rec.set("forget_out","0");
	                            if (!tr.getResultTimeCode().equalsIgnoreCase("HOLIDAY")) {
									rec.set("time0id", tr.getResultTimeCode());
								} else rec.set("time0id", empRec.getString("time0"));
	                            rec.set("old_time0", tr.getResultOldTimeCode());
	                            rec.set("sequence", this.getStringID(i, 2));
	                            //rec.set("status", tr.getResult_AppStatus());
	                            
	                            if (hmADJ.isEmpty()) {	// Check  hmADJ  OT ѹդ [ҡ timein ͧաѹ֧]					
									try {
										rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
										rec.set("c_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
									} catch (Exception e) {
										MyLog.error(this, e);
									}
									try {
										rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
										rec.set("c_tm_en", tr.getResult_c_dt_out().getCSCTime());
									} catch (Exception e) {
										MyLog.error(this, e);
									}							
									
									//Default system not include flag=0 or flag=1
									try {										
										if (tr.getResult_m_dt_in()!=null) {
											rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
											rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
										} else {
											if (tr.getResultTR_Type().indexOf("A")>-1) {
												rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
												rec.set("m_tm_bg", tr.getResult_c_dt_in().getCSCTime());
											} else if (flag==0) { //ٴ
												rec.set("m_dt_bg", tr.getResult_m_dt_out().getYYYYMMDD());
												rec.set("m_tm_bg", tr.getResult_m_dt_out().getCSCTime());	
												rec.set("forget_in","1");
												rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
												rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
											}
										}
										if (flag==2) {	//ͧ							
											rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
											rec.set("m_tm_bg", tr.getResult_c_dt_in().getCSCTime());
											//if ((tr.getResultEventGroup().equals("H") || tr.getResultEventGroup().equals("I")) && tr.getResultDocNo().trim().equals("")) {
											if (tr.getResultEventGroup().equals("H") || tr.getResultEventGroup().equals("I")){
												rec.set("m_tm_bg", 0);
											}else{
												rec.set("forget_in","1");
											}
										} 
										if (autoSwip.equals("1") && (tr.getResult_m_dt_in()==null)) {
											rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
											rec.set("m_tm_bg", tr.getResult_c_dt_in().getCSCTime());
											rec.set("forget_in","0");
										}
									} catch (Exception e) {
										MyLog.error(this, e);
										if (flag==0) { //ٴ
											rec.set("m_dt_bg", tr.getResult_m_dt_out().getYYYYMMDD());
											rec.set("m_tm_bg", tr.getResult_m_dt_out().getCSCTime());	
											rec.set("forget_in","1");
											rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
											rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
										}
									}
									
									try {										
										if (tr.getResult_m_dt_out()!=null) {
											rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
											rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
										} else {
											if (tr.getResultTR_Type().indexOf("A")>-1) {
												rec.set("m_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
												rec.set("m_tm_en", tr.getResult_c_dt_out().getCSCTime());
											} if (flag==1) { //ٴ͡
												rec.set("m_dt_en", tr.getResult_m_dt_in().getYYYYMMDD());
												rec.set("m_tm_en", tr.getResult_m_dt_in().getCSCTime());
												rec.set("forget_out","1");
												rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
												rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
											} 
										}
										if (flag==2) {
											rec.set("m_dt_en", tr.getResult_c_dt_in().getYYYYMMDD());
											rec.set("m_tm_en", tr.getResult_c_dt_in().getCSCTime());
											//if ((tr.getResultEventGroup().equals("H") || tr.getResultEventGroup().equals("I")) && tr.getResultDocNo().trim().equals("")) {
											if (tr.getResultEventGroup().equals("H") || tr.getResultEventGroup().equals("I")){
												rec.set("m_tm_en", 0);
											}else{
												rec.set("forget_out","1");
											}
										} 
										if (autoSwip.equals("1") && (tr.getResult_m_dt_out()==null)) {
											rec.set("m_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
											rec.set("m_tm_en", tr.getResult_c_dt_out().getCSCTime());
											rec.set("forget_out","0");
										}
										rec.set("ap_ot", tr.getResultAp_ot());								
									} catch (Exception e) {
										MyLog.error(this, e);
										if (flag==1) { //ٴ͡
											rec.set("m_dt_en", tr.getResult_m_dt_in().getYYYYMMDD());
											rec.set("m_tm_en", tr.getResult_m_dt_in().getCSCTime());
											rec.set("forget_out","1");
											rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
											rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
										}
									}			
									
									//  ˹ٴ - ͡ ===> 0
									if (tr.getResultTR_Type().indexOf("A")>-1 && !tr.getResultEventGroup().equals("T")) {
										rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
										rec.set("m_tm_bg", 0);
										rec.set("m_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
										rec.set("m_tm_en", 0); 
										rec.set("forget_in","");
										rec.set("forget_out","");
									}
									
									if (timeRec.getString("STICKTM").equals("D")) { 
										if (!this.hmSwipeCard.isEmpty()) {
											if (this.hmSwipeCard.get(tr.getResult_c_dt_in().getYYYYMMDD())!=null) {
												MyHashMap hm = (MyHashMap) this.hmSwipeCard.get(tr.getResult_c_dt_in().getYYYYMMDD());
												if (hm.get("1")!=null) {
													rec.set("m_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
													rec.set("m_tm_bg", hm.getString("1"));	
													rec.set("forget_in","0");
												} else rec.set("forget_in","1");
												
												if (hm.get("2")!=null) {
													rec.set("m_dt_en", tr.getResult_c_dt_in().getYYYYMMDD());
													rec.set("m_tm_en", hm.getString("2"));	
													rec.set("forget_out","0");
												} else rec.set("forget_out","1");
											} else {
												rec.set("forget_in","1");
												rec.set("forget_out","1");
											}
										} 
									}
								} else {
									MyTreeMap d = (MyTreeMap) hmADJ.get(tr.getResultShiftCalendar().getYYYYMMDD());
									
									CscCalendar cOUT = new CscCalendar(tr.getResult_c_dt_in().getYYYYMMDD());
									cOUT.setCSCTime(tr.getResult_c_dt_out().getCSCTime());
									CscCalendar scOUT = new CscCalendar((String) d.get("DT_EN"));
									scOUT.setCSCTime(Float.valueOf((String) d.get("TM_EN")).floatValue());
									
									CscCalendar smOUT = new CscCalendar((String) d.get("DT_EN"));
									smOUT.setCSCTime(Float.valueOf((String) d.get("TM_EN")).floatValue());
									
									rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());								
									rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
									rec.set("c_dt_en", scOUT.getYYYYMMDD());
									rec.set("c_tm_en", scOUT.getCSCTime());
	
									try {
										rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
										rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
										rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
										rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
									}catch(NullPointerException e){
										MyLog.error("M_DT_BG field is null or can't find any swipetime for OT on " + scOUT);
										rec.set("m_dt_bg", "");
										rec.set("m_tm_bg", "");
										rec.set("m_dt_en", "");
										rec.set("m_tm_en", "");
									}
									
									CscCalendar cIN = new CscCalendar(tr.getResult_c_dt_in().getYYYYMMDD());
									cIN.setCSCTime(tr.getResult_c_dt_in().getCSCTime());								
									rec.set("ap_ot",scOUT.subForHour(cIN));
								}
	                            rec.set("c_lv", tr.getResultC_LV());	             
	                    		rec.set("lv_ty", tr.getResultEventGroup());
	                    	    rec.set("tr_type", tr.getResultTR_Type());
	                            rec.set("ac_ot", tr.getResultAc_ot());
	                            
	                           //set time zone in 
	                            try {
	                                if (tr.getResult_Inzone_begin() != null) {
	                                    rec.set("dt_in_inzone", tr.getResult_Inzone_begin().getYYYYMMDD());
	                                    rec.set("tm_in_inzone", tr.getResult_Inzone_begin().getCSCTime());
	                                }
	                            } catch (Exception e) {
	                            	MyLog.error(this, e);
	                            }
	                            try {
	                                if (tr.getResult_Inzone_end() != null) {
	                                    rec.set("dt_out_inzone", tr.getResult_Inzone_end().getYYYYMMDD());
	                                    rec.set("tm_out_inzone", tr.getResult_Inzone_end().getCSCTime());
	                                }
	                            } catch (Exception e) {
	                            	MyLog.error(this, e);
	                            }
	                            
	                          //set time zone out 
	                            try {
	                                if (tr.getResult_Outzone_begin() != null) {
	                                    rec.set("dt_in_outzone", tr.getResult_Outzone_begin().getYYYYMMDD());
	                                    rec.set("tm_in_outzone", tr.getResult_Outzone_begin().getCSCTime());
	                                }
	                            } catch (Exception e) {
	                            	MyLog.error(this, e);
	                            }
	                            try {
	                                if (tr.getResult_Outzone_end() != null) {
	                                    rec.set("dt_out_outzone", tr.getResult_Outzone_end().getYYYYMMDD());
	                                    rec.set("tm_out_outzone", tr.getResult_Outzone_end().getCSCTime());
	                                }
	                            } catch (Exception e) {
	                            	MyLog.error(this, e);	
	                            }
	
	                            try {
	                                if (tr.getResultMidDayStop() != null) {
	                                    try {
	                                        if (tr.getResultMidDayStop().getBeginZone() != null) {
	                                            rec.set("dt_breakin", tr.getResultMidDayStop().getBeginZone().getDDMMYYYY());
	                                            rec.set("tm_breakin", tr.getResultMidDayStop().getBeginZone().getCSCTime());
	                                        }
	                                    } catch (Exception e) {
	                                    	MyLog.error(this, e);
	                                    }
	                                    try {
	                                        if (tr.getResultMidDayStop().getEndZone() != null) {
	                                            rec.set("dt_breakout", tr.getResultMidDayStop().getEndZone().getDDMMYYYY());
	                                            rec.set("tm_breakout", tr.getResultMidDayStop().getEndZone().getCSCTime());
	                                        }
	                                    } catch (Exception e) {
	                                    	MyLog.error(this, e);
	                                    }
	                                }
	                            } catch (Exception e) {
	                            	MyLog.error(this, e);
	                            }
	                            	
	                            
	                            try {
	            					rec.set("o_dt_bg", tr.getResult_o_dt_in().getYYYYMMDD());
	            					rec.set("o_dt_en", tr.getResult_o_dt_out().getYYYYMMDD());
	            				} catch (Exception e) {
	            					MyLog.error(this, e);
	            				}
	            				try {
	            					rec.set("o_tm_bg", tr.getResult_o_dt_in().getCSCTime());
	            					rec.set("o_tm_en", tr.getResult_o_dt_out().getCSCTime());
	            				} catch (Exception e) {
	            					MyLog.error(this, e);
	            				}	
	            				
	            				//ҵ ҧ÷ӧҹԧ
	            				try {
	            					rec.set("sh_dt_bg", tr.getResult_sh_dt_in().getYYYYMMDD());
	            					rec.set("sh_dt_en", tr.getResult_sh_dt_out().getYYYYMMDD());
	            				} catch (Exception e) {
	            					MyLog.error(this, e);
	            				}
	            				try {
	            					rec.set("sh_tm_bg", tr.getResult_sh_dt_in().getCSCTime());
	            					rec.set("sh_tm_en", tr.getResult_sh_dt_out().getCSCTime());
	            				} catch (Exception e) {
	            					MyLog.error(this, e);
	            				}		
	            				
	            				//͡㹡лҡѺ͡㹪ǧ break  break ᷹
	            				if (tr.getResultEventGroup().equals("T")) {
		            				CscCalendar b_com_in = new CscCalendar(rec.getString("dt_breakin"));
		            				b_com_in.setCSCTime(rec.getFloat("tm_breakin"));
		            				CscCalendar b_com_out = new CscCalendar(rec.getString("dt_breakout"));
		            				b_com_out.setCSCTime(rec.getFloat("tm_breakout"));
		            				
		            				CscCalendar c_com_in = new CscCalendar(rec.getString("o_dt_bg"));
		            				c_com_in.setCSCTime(rec.getFloat("o_tm_bg"));
		            				CscCalendar c_com_out = new CscCalendar(rec.getString("o_dt_en"));
		            				c_com_out.setCSCTime(rec.getFloat("o_tm_en"));
		            				if (c_com_out.equals(b_com_out)) {		            					
		            					rec.set("c_dt_en", b_com_in.getYYYYMMDD());
		            					rec.set("c_tm_en", b_com_in.getCSCTime());
		            					
		            					rec.set("o_dt_en", b_com_in.getYYYYMMDD());
		            					rec.set("o_tm_en", b_com_in.getCSCTime());
		            				}	          
		            				
		            				if (c_com_in.equals(b_com_in)) {
		            					rec.set("c_dt_bg", b_com_out.getYYYYMMDD());
		            					rec.set("c_tm_bg", b_com_out.getCSCTime());
		            					
		            					rec.set("o_dt_bg", b_com_out.getYYYYMMDD());
		            					rec.set("o_tm_bg", b_com_out.getCSCTime());
		            				}
	            				}       				
	            				
	                            //Check Ҿѡ
	            				try {
		                            CscCalendar c1 = new CscCalendar(rec.getString("c_dt_bg"));
		                            c1.setCSCTime(rec.getFloat("c_tm_bg"));
		                            CscCalendar c2 = new CscCalendar(rec.getString("c_dt_en"));
		                            c2.setCSCTime(rec.getFloat("c_tm_en"));
		                            CscCalendar b1 = new CscCalendar(rec.getString("dt_breakin"));
		                            b1.setCSCTime(rec.getFloat("tm_breakin"));
		                            CscCalendar b2 = new CscCalendar(rec.getString("dt_breakout"));
		                            b2.setCSCTime(rec.getFloat("tm_breakout"));
		                            if (c1.equals(b1) && c2.equals(b2))
		                            	continue;
	            				} catch (Exception e) {
	            					MyLog.debug("!! Warning : error in checking swipe-in or out on break time !! ");
	            				}
	            				
	                            rec.set("iswork", tr.getResultIsWork());
	                            rec.set("eventgrp", tr.getResultEventGroup());
	                            
	                            /* mod on 01-11-2013 Ѻ礡ó  ҷԵ ͧҡ繻 */
	                            if(tr.getResultDocType().equals("A")){
	                            	rec.set("oldeventgrp", tr.getActualEvent());
	                            }else{
	                            	rec.set("oldeventgrp", tr.getResultOldEventGroup());
	                            }
	                            
	                            rec.set("previousshift",getPreviousShiftData(key, ws, wstmp));
	                            rec.set("nextshift",getNextShiftData(key, ws, wstmp));
	                            
	                            rec.set("status",tr.getResultStatus());
	                            rec.set("source_in", tr.getResult_Sourcein());
	                            rec.set("source_out", tr.getResult_Sourceout());
	                            rec.set("ot_workarea", tr.getResult_Workarea());
	                            rec.set("ot_salatype", tr.getResult_Salatype());
	                            
	                            try{
	                            	CscCalendar cNxtShSw = tr.getResultNextShiftSwipe();
	                            	 if(cNxtShSw != null){
	 	                            	rec.set("DT_NEXT_SHIFT_SWIPE", cNxtShSw.getYYYYMMDD());
	 	                            	rec.set("TM_NEXT_SHIFT_SWIPE", cNxtShSw.getCSCTime());
	 	                            }else{
	 	                            	CscCalendar cMOut = tr.getResult_m_dt_out();
	 	                            	rec.set("DT_NEXT_SHIFT_SWIPE", cMOut.getYYYYMMDD());
	 	                            	rec.set("TM_NEXT_SHIFT_SWIPE", cMOut.getCSCTime());
	 	                            }
	                            }catch(Exception e1){
	                            	MyLog.debug("Next shift swipe is null !!");
	                            	//MyLog.error(this , this.getUProfile() , e1);
	                            }
	                            
	                            try{
	                            	CscCalendar cPrvShSw = tr.getResultPrevShiftSwipe();
	                            	 if(cPrvShSw != null){
	 	                            	rec.set("DT_PREV_SHIFT_SWIPE", cPrvShSw.getYYYYMMDD());
	 	                            	rec.set("TM_PREV_SHIFT_SWIPE", cPrvShSw.getCSCTime());
	 	                            }else{
	 	                            	CscCalendar cMIn = tr.getResult_m_dt_in();
	 	                            	rec.set("DT_PREV_SHIFT_SWIPE", cMIn.getYYYYMMDD());
	 	                            	rec.set("TM_PREV_SHIFT_SWIPE", cMIn.getCSCTime());
	 	                            }
	                            }catch(Exception e1){
	                            	MyLog.debug("Previous shift swipe is null !!");
	                            	//MyLog.error(this , this.getUProfile() , e1);
	                            }
	                           
	                            if(tr.getResultDocType().equals("O")||tr.getResultDocType().equals("B")||tr.getResultDocType().equals("OM")){
	                            	rec.set("cost_borrow","");
	                            }else{
	                            	rec.set("cost_borrow", tr.getResult_Salatype());
	                            } 
	                            
	                            rec.set("ot_type", tr.getResult_OT_type());
	                            rec.set("ot_time0", tr.getResult_OT_time0());
	                            rec.set("machine_in", tr.getResult_Machinein());
	                            rec.set("machine_out", tr.getResult_Machineout());
	                            rec.set("hour_s",tr.getResultHour_s());
	                            rec.set("docstatus", tr.getResult_DocStatus());
	                            
	                            // ----- Check swipe time in holiday or leave ----- //
	                            if (errorDayShiftResult!=null && !errorDayShiftResult.isEmpty() && errorDayShiftResult.containsKey("11")) {
	                            	if (rec.getString("tr_type").indexOf("A")>-1 || rec.getString("tr_type").indexOf("H")>-1 || rec.getString("tr_type").indexOf("I")>-1) {
	                            		String swipeHoliday = ""; //runno ͧҷٴѵѹش
	                            		String swipeHolidayTime = ""; //ҷٴѵѹش
	                            		String swipeKey = "";
	                            		if (dShift.getSwipeHoliday().size()>0) {	                            			
	                            			for (int j=0;j<dShift.getSwipeHoliday().size();j++) {
	                            				swipeKey = (String) dShift.getSwipeHoliday().elementAt(j);
	                            				
	                            				SwipeRecord SR = (SwipeRecord) dShift.getSwipeTrans().getSwipeRecord(Long.parseLong((String) dShift.getSwipeHoliday().elementAt(j)));
	                            				if (SR!=null && !SR.getSource().equals("9")) {
	                            					swipeHoliday += swipeKey + ",";
	                            					swipeHolidayTime += SR.getTime() + ",";
	                            				}
	                            			}
	                            			//ٴѵѹش ?
	                            			rec.set("warn11", swipeHolidayTime);
	                            		} 	                    
	                        		}
	                            } //աٴѵѹش
	                            
	                            // --- Set value unused ---//
	                            if (!this.hmUnused.isEmpty()) {
	                            	if (this.hmUnused.get(tr.getResult_c_dt_in().getDDMMYYYY())!=null) {
	                            		MyHashMap h = (MyHashMap) this.hmUnused.get(tr.getResult_c_dt_in().getDDMMYYYY());
	                            		rec.set("unused1", h.getString("un1_value"));
	                            		rec.set("unused2", h.getString("un2_value"));
	                            		rec.set("unused3", h.getString("un3_value"));
	                            		rec.set("unused4", h.getString("un4_value"));
	                            		rec.set("unused5", h.getString("un5_value"));
	                            		rec.set("unused6", h.getString("un6_value"));
	                            		rec.set("unused7", h.getString("un7_value"));
	                            		rec.set("unused8", h.getString("un8_value"));
	                            		rec.set("unused9", h.getString("un9_value"));
	                            		rec.set("unused10", h.getString("un10_value"));
	                            	}
	                            }
	                            
	                            // ʹٴ - ٴ͡
	                            if (timeRec.getString("STICKTM").equals("N")) { 
	                            	if (rec.getString("forget_in").equals("1") && !rec.getString("forget_out").equals("1")) { //ٴ
	                            		rec.set("m_dt_bg", rec.getString("m_dt_en"));
	                            		rec.set("m_tm_bg", rec.getString("m_tm_en"));
	                            	}	                            	
	                            	if (rec.getString("forget_out").equals("1") && !rec.getString("forget_in").equals("1")) { //ٴ͡
	                            		rec.set("m_dt_en", rec.getString("m_dt_bg"));
	                            		rec.set("m_tm_en", rec.getString("m_tm_bg"));
	                            	}	                            	
	                            	rec.set("forget_in", "0");
	                            	rec.set("forget_out", "0");
	                            }
	                            
	                            docType = tr.getResultDocType();
	                            oldDocType = tr.getResultOldDocType();
	                            eventgrp = tr.getResultEventGroup();
	                            chkDate = tr.getResultShiftCalendar().getYYYYMMDD();	                            
	                            hour_s = tr.getResultHour_s();
	                            
	                            Ttime_current1 t1 = (Ttime_current1) rec;

	                            t1.setProcLog(getEmpProcLog(t1.getString("employeeid")));	                            
	                            t1.setTimeHashMap(this.hmTime); 
	                            t1.setDayTimeHashMap(this.hmDayTime);
	                            t1.setEmpRecord(empRec);
	                            t1.setTimeRecord(timeRec);
	                            t1.setOTHashMap((MyTreeMap) this.hashOT.clone());
	                            t1.setHolidayHashMap(this.hmHoliday);
	                            t1.setCalOTProcess(this.calOT);
	                            t1.setCostcenter(this.hmCostcenter);
	                            t1.setBusLate(this.hmBusLate);
	                            t1.setUnused(this.hmUnused);
	                            
	                            /* prv & next shift for cal ot */
	        					t1.prv_shift = tr.getPreviousShift() ;
	        					t1.nex_shift = tr.getNextShift();
	        					
	                            if (i==1) {
	                            	t1.setOTAdjust(this.hmOTAdjust);	                            	
	                            } else t1.setOTAdjust(new MyHashMap());
	                            
	                            t1.FindTimeOnBreak(t1, ws.getShiftProperty(), vcSwipeTime);	/* Ѻٴѵêǧѡ§ */
	                            this.dbTCurrent1.putNewRecord(rec);
	                            recCount++;
	                            i++;
	                        }//end if 
	                        
	                    } // end for shift
	                    if (recCount > 0) {
	                    	if (this.recTCurrent == null) {
	                    		this.recTCurrent = new InitialRecord(this.upf).getDbRecord("Ttime_current");
	                    		this.recTCurrent.setColumn("*");
	                    	}
	                    	this.recTCurrent.clearField();
	                    	this.recTCurrent.set("employeeid", empRec.getString("employeeid"));
	                    	this.recTCurrent.set("companyid", empRec.getString("companyid"));
	                    	this.recTCurrent.set("time0id", empRec.getString("time0"));
	                    	this.recTCurrent.set("dateid", date.getYYYYMMDD());
	                    	this.recTCurrent.set("hour_s", hour_s);
	                    	this.recTCurrent.putChild(this.dbTCurrent1);
	                        
	                    	/* ѺӴѺäӹǳ ¡ǹäӹǳ͡Ҩҡ PreInsert ͧ Ttime_current */
	                    	Ttime_current t = (Ttime_current) this.recTCurrent;
							t.setEmpRecord(empRec);
							t.setShiftProp(ws.getShiftProperty());
							t.calulateSumDatainChild();	/* ӹǳ. ӧҹ Ҵ   */
							t.setDataRecord();	/* ˹ѹ (ӧҹ  ش) */
							
							/* ӹǳ flexible time ͹ӹǳٵͷ */
	                    	if(isFlexibleShift(timeRec) && !(this.recTCurrent.getString("EVENTGRP").equalsIgnoreCase("H") || this.recTCurrent.getString("EVENTGRP").equalsIgnoreCase("I"))){
	                    		//if(recCount > 1){	/* ҡ 1 ¡ */
	                    			calFlexibleTime(this.recTCurrent, getShiftData(this.dbTCurrent1));
	                    		//}
	                    	}
	                    	
	                    	t.ProcessOT();	/* ӹǳٵͷ */
							
							this.recTCurrent.save();
							this.setEmpProcOutput(t.getString("employeeid"), dbTCurrent1.recCount());	/* output number */
	                        
	                        if (hmADJ!=null && !hmADJ.isEmpty()) {
	                        	/**
	                        	 * check date!=null  remove key ͡ҡ hmADJ
	                        	 */
	                        	if (date!=null){
	                        		hmADJ.remove(date.getYYYYMMDD());
	                        		this.saveOTContinue(empRec, hmADJ, tResult, timeRec);
	                        	}//end if 
	                        }//end if 
	                    }//end if 
	                   
	                    postProcessTrigger(ws, recTCurrent);
                    //}
                } // end time overlab
               this.alive("Save Working EmployeeID : "+empRec.getString("employeeid")+" : "+ ((date == null)? new CscCalendar(): date.getYYYYMMDD()));
            } // end for dShift
         } catch (Exception e) {
        	MyLog.error(this, e);            
        	try {
				setEmpProcError(empRec.getString("employeeid"), e.getMessage());
			} catch (RemoteException e1) {
				e1.printStackTrace();
			}        	
        }
    }

    /* ӹǳ. ӧҹͧ Flexible */
    /* ӹǳ flexible time */
    private void calFlexibleTime(DbRecord tcur, Vector vc){
    	CscTime lv = new CscTime();
    	CscTime lt = new CscTime();
    	CscTime hour_d = new CscTime();
    	CscTime total = new CscTime();
    	CscTime hour_s = new CscTime();
    	
    	CscCalendar bkst = new CscCalendar();
    	CscCalendar bken = new CscCalendar();
    	
    	boolean isleaveOnlast = false ;
    	
    	
    	try {
    		/* sum leave , late and hour_d */
    		boolean isdeductbreak = false;
    		boolean isleave = false ;
    		int leaveidx = -1;
    		for(int i=0; i < vc.size(); i++){
    			DbRecord db = (DbRecord) vc.get(i);
      			
    			/* 纪ǧѡ§  . ӧҹѹ */
    			if(i == 0){
    				hour_s.add(db.getFloat("hour_s"));
    				bkst = new CscCalendar(db.getString("dt_breakin"));
    				bkst.setCSCTime(db.getFloat("tm_breakin"));
    				bken = new CscCalendar(db.getString("dt_breakout"));
    				bken.setCSCTime(db.getFloat("tm_breakout"));
    			}
    			
    			/* .  */
    			if(db.getString("doctype").equals("A")){
    				lv.add(db.getFloat("m_lv"));
    			}else{
    				hour_d.add(db.getFloat("hour_d"));	/* . ӧҹ */
    			}
    			
    			lt.add(db.getFloat("lt"));	/* .  */
    			
    			/*¡ش¢ͧѹ˹ʶҹ */
    			if(i == (vc.size() - 1) && db.getString("doctype").equals("A")){
    				isleaveOnlast = true;
    				
    				CscTime cst = new CscTime();
    				DbRecord pre = (DbRecord) vc.get(i-1);
    				cst.add(pre.getFloat("hour_d"));
    				cst.add(bken.subForHour(bkst));
    				
    				total.sub(pre.getFloat("hour_d")); /* ա¹ ͧѡ͡͹ ǤºǡѺ */
    				pre.set("hour_d", cst.getFloat());
    				total.add(pre.getFloat("hour_d")); /* ǡҷѺ׹ */
    			}else if(db.getString("doctype").equals("A")){
    				if(!isdeductbreak){	/* ǡѡѺ价 hourd зǵѹ óҪǧá */
						isdeductbreak = true ;
						if(i+1 <= (vc.size()-1)){
							DbRecord next = (DbRecord) vc.get(i+1);
							CscTime cst1 = new CscTime();

		    				cst1.add(next.getFloat("hour_d"));
		    				cst1.add(bken.subForHour(bkst));
		    				next.set("hour_d", cst1.getFloat());
						}
    				}
    			}
    		}
    		
    		/* ӹǳ . ӧҹ 
    		 * .ӧҹ =  + .ӧҹ */
    		total.add(hour_d);
    		total.add(lv);
    		
    		/* Ҫ. Թ觢ͧ . ӧҹѹ (Ҥѹҡ 繵ͧѡѡ§͡)  ¡ѹ (ӧҹ) */
    		/*
    		if(lv.getFloat() < (hour_s.getFloat()/2) || vc.size() == 1 ){
    			total.sub(bken.subForHour(bkst));
    		}*/
    		
    		/* 礢Ҵҹóշӧҹ¡ . ӧҹѹ */
    		if(total.getFloat() < hour_s.getFloat()){	/* ѧ¡ . ӧҹѹ ҢҴҹ ¡˹ eventgrp  J  . Ҵҹ¡ش¢ͧѹ */
    			hour_s.sub(total);
    			float absent = hour_s.getFloat();
    			
    			/* Tcurrent1 Ѻ . Ҵҹ¡ش */
    			for(int i=0; i < vc.size(); i++){
        			DbRecord db = (DbRecord) vc.get(i);
        			if( !(db.getString("eventgrp").equals("H") || db.getString("eventgrp").equals("I"))) {
        				if(!db.getString("doctype").equals("A")){
            				tcur.set("absent", absent);	/* ˹ . Ҵҹ Ttime_current  */
            				db.set("eventgrp", "J");
            				
            				/* ¡ش ͧ˹ . Ҵҹ ¡á͹ش */
                			if(isleaveOnlast){
                				if(i == vc.size()-2){ 
                    				db.set("m_lv", absent);
                    			}else{
                    				db.set("m_lv", 0);
                    			}
                			}else{
                				if(i == vc.size()-1){ /* */
                					db.set("m_lv", absent);
                    			}else{
                    				db.set("m_lv", 0);
                    			}
                			}
            			}
        			}
        			
        			
        			/* ¡ǻѺ hour_d ѡѡ */
        			if(vc.size() == 1){
        				if(total.getFloat() < 0){
        					db.set("hour_d", 0);
        				}else{
        					db.set("hour_d", hour_d.getFloat());
        					//db.set("hour_d", total.getFloat());
        				}
        			}
    			}
    		}else{ /* Ҵҹ ͧѺ . Ҵҹ 0 ء¡ ¡ */
    			/* Tcurrent */
    			tcur.set("absent", 0);
    			
    			/* Tcurrent1 Ѻ . Ҵҹ 0  */
    			for(int i=0; i < vc.size(); i++){
        			DbRecord db = (DbRecord) vc.get(i);
        			
        			/*   ѹ . ӧҹԹ . ӧҹѹ Ҵҹҧҹ ١Ѻ . Ҵҹ 红Ҵҹ͹ */
        			if(!db.getString("doctype").equals("A")){
        			//if(!db.getString("doctype").equals("A") && !(total.getFloat() >= hour_s.getFloat() && lv.getFloat() > 0)){
        				db.set("m_lv", 0);
        				if(!db.getString("eventgrp").equals("O")){
        					db.set("eventgrp" , "T");
        				}
        			}
        			
        			/* ¡ǻѺ hour_d ѡѡ */
        			if(vc.size() == 1){
        				db.set("hour_d", hour_d.getFloat());
        				//db.set("hour_d", total.getFloat());
        			}
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* ֧ѹ͡ */
    private Vector getShiftData(DbTable tcur1){
    	Vector vc = new Vector();
    	try{
    		tcur1.first();
    		while(!tcur1.eof()){
    			vc.add(tcur1.getCurrentRecordManager());
    			
    			tcur1.next();
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return vc ;
    }
    
    /* Ǩͺ繡 flexible  */
    private boolean isFlexibleShift(DbRecord db){
    	try {
    		if(db.getString("sticktm").equalsIgnoreCase("T")){
    			return true ;
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return false;
    }
    /* شӹǳ Flexibl */
    /* ********************* */
        
    public MyHashMap loadOTAdjust(String employeeid) {
    	MyHashMap hm = new MyHashMap();
    	StringBuffer filter = new StringBuffer();
        try {
	        filter.append("employeeid='").append(employeeid).append("' and ").append("(ot_date between '");
	        filter.append(this.cs1.getYYYYMMDD()).append("' and '").append(this.cs2.getYYYYMMDD()).append("')");

	        if (this.inqOTAdjust == null) {
				this.inqOTAdjust = new InitialInquiry(this.upf).getDbInquiry();
				this.inqOTAdjust.setSchemaName(this.upf.getSchemaName());
				this.inqOTAdjust.initMyTable("Totadjust1", "", "");
				this.inqOTAdjust.setColumn("*");
			}

	        this.inqOTAdjust.setFilter(filter.toString());
			this.inqOTAdjust.refresh();	
			
			while (this.inqOTAdjust.next()) {
				MyHashMap hmSub = new MyHashMap(); 
				DbRecord rec = this.inqOTAdjust.getCurrentDbRecord();
				
				hmSub.put("ot_total", rec.getDouble("ot_total"));
				hmSub.put("ot1_total", rec.getDouble("ot1_total"));
				hmSub.put("ot5_total", rec.getDouble("ot5_total"));
				hmSub.put("ot2_total", rec.getDouble("ot2_total"));
				hmSub.put("ot3_total", rec.getDouble("ot3_total"));
				
				CscCalendar cs = new CscCalendar(rec.getString("ot_date"));
				hm.put(cs.getDDMMYYYY(), hmSub);
			}
        } catch (Exception e) {
        	MyLog.error("!! Can't Load OTAdjust !!", e);
        }    	
    	return hm;
    }
    
    public MyHashMap loadDayChangeCostcenter(String employeeid) {
    	MyHashMap hm = new MyHashMap();
        try {
	        if (this.inqCostcenter == null) {
				this.inqCostcenter = new InitialInquiry(this.upf).getDbInquiry();
				this.inqCostcenter.setSchemaName(this.upf.getSchemaName());
				this.inqCostcenter.initMyTable("Tborrow_emp1", "", "");
				this.inqCostcenter.setColumn("*");
			}
	    	this.inqCostcenter.setFilter("employeeid='"+employeeid+"' and " +
	    			"(start_date >='"+this.cs1.getYYYYMMDD()+"' and end_date<='"+this.cs2.getYYYYMMDD()+"')");
			this.inqCostcenter.refresh();
			
			while (this.inqCostcenter.next()) {
				DbRecord rec = this.inqCostcenter.getCurrentDbRecord();
				
				String costCode = rec.getString("new_costcenter");
				CscCalendar c1 = new CscCalendar(rec.getString("start_date"));
				CscCalendar c2 = new CscCalendar(rec.getString("end_date"));
				while (c1.beforeEqualsDate(c2)) {					
					hm.put(c1.getDDMMYYYY(), costCode);
					c1.incDate();
				}				
			}
        } catch (Exception e) {
        	MyLog.error("Can't Load Costcenter ", e);
        }    	
    	return hm;
    }
    
    public MyHashMap loadBusLate(String employeeid) {
    	MyHashMap hm = new MyHashMap();
    	StringBuffer filter = new StringBuffer();
    	
        try {
	        filter.append("employeeid='").append(employeeid).append("' and ").append("(datelate between '");
	        filter.append(this.cs1.getYYYYMMDD()).append("' and '").append(this.cs2.getYYYYMMDD()).append("')");

	        if (this.inqBusLate == null) {
				this.inqBusLate = new InitialInquiry(this.upf).getDbInquiry();
				this.inqBusLate.setSchemaName(this.upf.getSchemaName());
				this.inqBusLate.initMyTable("Mbus_late1", "", "");
				this.inqBusLate.setColumn("*");
			}
	        
	        this.inqBusLate.setFilter(filter.toString());
			this.inqBusLate.refresh();
			
			while (this.inqBusLate.next()) {
				DbRecord rec = this.inqBusLate.getCurrentDbRecord();
				
				CscCalendar cs = new CscCalendar(rec.getString("datelate"));
				hm.put(cs.getDDMMYYYY(), rec.getString("timelate"));
			}
        } catch (Exception e) {
        	MyLog.error("Can't Load BusLate ", e);
        }    	
    	return hm;
    }
    
    public MyTreeMap loadOTFormula() {
    	MyTreeMap hFormula = new MyTreeMap();
		try {
			DbRecord rec;
			String key, field;
			StringTokenizer str;
			MyHashMap hProp;
			
			if (this.inqFormula == null) {
				this.inqFormula = new InitialInquiry(this.upf).getDbInquiry();
				this.inqFormula.setSchemaName(this.upf.getSchemaName());
				this.inqFormula.initMyTable("Otformula", "", "formulaid");
				this.inqFormula.setColumn("*");
			}
			this.inqFormula.refresh();			
			while (this.inqFormula.next()) {
				rec = this.inqFormula.getCurrentDbRecord();
				key = rec.getString("formulaid");
				hProp = new MyHashMap();
				str = new StringTokenizer(rec.getFieldList(),",");
				while (str.hasMoreTokens()) {
					field = str.nextToken();
					hProp.put(field, rec.getString(field));
				}
				hFormula.put(key, hProp);
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}	
		return hFormula;
	}
    
    public MyHashMap loadUnused(String employeeid) {
    	MyHashMap hm = new MyHashMap();
    	StringBuffer filter = new StringBuffer();
    	
    	try {
	        filter.append("employeeid='").append(employeeid).append("' and ").append("(dateid between '");
	        filter.append(this.cs1.getYYYYMMDD()).append("' and '").append(this.cs2.getYYYYMMDD()).append("')");

	        if (this.inqUnused == null) {
				this.inqUnused = new InitialInquiry(this.upf).getDbInquiry();
				this.inqUnused.setSchemaName(this.upf.getSchemaName());
				this.inqUnused.initMyTable("Mempl_unused", "", "");
				this.inqUnused.setColumn("*");
			}
	    
	        this.inqUnused.setFilter(filter.toString());
			this.inqUnused.refresh();
			
			while (this.inqUnused.next()) {
				DbRecord rec = this.inqUnused.getCurrentDbRecord();
				
				CscCalendar cs = new CscCalendar(rec.getString("dateid"));
				MyHashMap hmTemp = new MyHashMap();
				hmTemp.put("un1_value", rec.getString("un1_value"));
				hmTemp.put("un1_doctype", rec.getString("un1_doctype"));
				hmTemp.put("un1_docno", rec.getString("un1_docno"));
				
				hmTemp.put("un2_value", rec.getString("un2_value"));
				hmTemp.put("un2_doctype", rec.getString("un2_doctype"));
				hmTemp.put("un2_docno", rec.getString("un2_docno"));
				
				hmTemp.put("un3_value", rec.getString("un3_value"));
				hmTemp.put("un3_doctype", rec.getString("un3_doctype"));
				hmTemp.put("un3_docno", rec.getString("un3_docno"));
				
				hmTemp.put("un4_value", rec.getString("un4_value"));
				hmTemp.put("un4_doctype", rec.getString("un4_doctype"));
				hmTemp.put("un4_docno", rec.getString("un4_docno"));
				
				hmTemp.put("un5_value", rec.getString("un5_value"));
				hmTemp.put("un5_doctype", rec.getString("un5_doctype"));
				hmTemp.put("un5_docno", rec.getString("un5_docno"));
				
				hmTemp.put("un6_value", rec.getString("un6_value"));
				hmTemp.put("un6_doctype", rec.getString("un6_doctype"));
				hmTemp.put("un6_docno", rec.getString("un6_docno"));
				
				hmTemp.put("un7_value", rec.getString("un7_value"));
				hmTemp.put("un7_doctype", rec.getString("un7_doctype"));
				hmTemp.put("un7_docno", rec.getString("un7_docno"));
				
				hmTemp.put("un8_value", rec.getString("un8_value"));
				hmTemp.put("un8_doctype", rec.getString("un8_doctype"));
				hmTemp.put("un8_docno", rec.getString("un8_docno"));
				
				hmTemp.put("un9_value", rec.getString("un9_value"));
				hmTemp.put("un9_doctype", rec.getString("un9_doctype"));
				hmTemp.put("un9_docno", rec.getString("un9_docno"));
				
				hmTemp.put("un10_value", rec.getString("un10_value"));
				hmTemp.put("un10_doctype", rec.getString("un10_doctype"));
				hmTemp.put("un10_docno", rec.getString("un10_docno"));

				hm.put(cs.getDDMMYYYY(), hmTemp);
			}
        } catch (Exception e) {
        	MyLog.error("!! Error in TransferTimeProcess.loadUnused : Can't Load Unused !!");
        }    	
    	return hm;
    }
    
    /*
     * ѹ֡š÷ӧҹѹش
     */
    private void saveDayNotWorking(WorkingShift wstmp, DbRecord empRec, String key, DbRecord timeRec) {
    	
    	DayShift dShifttmp = (DayShift) wstmp.get(key);    	
    	dShifttmp.findHolidaySwipe();
    	dShifttmp.genProcessResult();
    	HashMap errorDayShiftResult = dShifttmp.getErrorResult();
    	
		for (Iterator IT1 = dShifttmp.keySet().iterator(); IT1.hasNext();) {			
			float hour_s=0;			
			int i=1;
			String key1 = (String) IT1.next();			
			try {
				TimeResult tr = (TimeResult) dShifttmp.get(key1);	
				
				if(tr != null){
					CscCalendar date = new CscCalendar (tr.getResultShiftCalendar().getYYYYMMDD());								
					
					this.getTCurrent1ForNonWorkingDay(); /*  ͹ѹ֡ ͧѹش ա÷ӧҹ */
					
					DbRecord rec = this.dbTCurrent1NoWork.getNewRecord();				
					rec.setColumn("*");
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("dateid", tr.getResult_c_dt_in().getYYYYMMDD());
					rec.set("docno", tr.getResultDocNo());
					rec.set("doctype", tr.getResultDocType());
					rec.set("olddoctype", tr.getResultOldDocType());
	                rec.set("olddocno", tr.getResultOldDocNo());
					rec.set("sequence", this.getStringID(i, 2));						
	
					if (!tr.getResultTimeCode().equalsIgnoreCase("HOLIDAY")) {
						rec.set("time0id", tr.getResultTimeCode());
					} else {
						rec.set("time0id", empRec.getString("time0"));											
					}
	
					rec.set("c_dt_bg", tr.getResult_c_dt_in().getYYYYMMDD());
					rec.set("c_dt_en", tr.getResult_c_dt_out().getYYYYMMDD());
					rec.set("c_tm_bg", tr.getResult_c_dt_in().getCSCTime());
					rec.set("c_tm_en", tr.getResult_c_dt_out().getCSCTime());
					
					try {
						MyLog.debug("!! day not working : " + rec.getString("dateid"));
						MyLog.debug("!! day not working swipe time : " + tr.getResult_m_dt_in());
						
						/* ѹشͧ˹ */
						rec.set("m_dt_bg", tr.getResult_c_dt_in());
						rec.set("m_tm_bg", 0);
						/*
						if (tr.getResult_m_dt_in()!= null) {
							rec.set("m_dt_bg", tr.getResult_m_dt_in().getYYYYMMDD());
							rec.set("m_tm_bg", tr.getResult_m_dt_in().getCSCTime());
						} else {
							rec.set("m_dt_bg", tr.getResult_c_dt_in());
							rec.set("m_tm_bg", 0);
						}*/
					} catch (Exception e) {
						MyLog.error("!! Error on setting [m_dt_bg,m_tm_bg,m_dt_bg,m_tm_bg] in TransferTimeProcess.saveDayNotWorking() !!");
					}
					try {	
						MyLog.debug("!! day not working : " + rec.getString("dateid"));
						MyLog.debug("!! day not working swipe time out : " + tr.getResult_m_dt_out());
						/* ѹشͧ˹ */
						rec.set("m_dt_en", tr.getResult_c_dt_in());
						rec.set("m_tm_en", 0);
						/*
						if (tr.getResult_m_dt_out()!= null) {
							rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
							rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
						} else {
							rec.set("m_dt_en", tr.getResult_c_dt_in());
							rec.set("m_tm_en", 0);
						}*/
					} catch (Exception e) {
						MyLog.error("!! Error on setting [m_dt_en,m_tm_en,m_dt_en,m_tm_en] in TransferTimeProcess.saveDayNotWorking() !!");
					}	
					
					CscCalendar breakIN = tr.getResultMidDayStop().getBeginZone();
					CscCalendar breakOUT = tr.getResultMidDayStop().getEndZone();
					
					try {
						if (tr.getResultMidDayStop()!= null){
							try {
								if (breakIN!=null) {
									rec.set("dt_breakin", breakIN.getYYYYMMDD());
									rec.set("tm_breakin", breakIN.getCSCTime());
								}		
							} catch (Exception e) {
								MyLog.error("!! Error on setting [dt_breakin,tm_breakin] in TransferTimeProcess.saveDayNotWorking() !!");
							}
							try { 										
								if (breakOUT!=null) {
									rec.set("dt_breakout", breakOUT.getYYYYMMDD());							
									rec.set("tm_breakout", breakOUT.getCSCTime());
								}
							} catch (Exception e) {
								MyLog.error("!! Error on setting [dt_breakout,tm_breakout] in TransferTimeProcess.saveDayNotWorking() !!");
							}
						} 
					} catch (Exception e) {
						MyLog.error("!! Error on setting [##_breakin,##_breakout] tr.getResultMidDayStop is null in TransferTimeProcess.saveDayNotWorking() !!");
					}
					
					rec.set("o_dt_bg", tr.getResult_o_dt_in().getYYYYMMDD());
					rec.set("o_dt_en", tr.getResult_o_dt_out().getYYYYMMDD());
					rec.set("o_tm_bg", tr.getResult_o_dt_in().getCSCTime());
					rec.set("o_tm_en", tr.getResult_o_dt_out().getCSCTime());
					rec.set("sh_dt_bg", tr.getResult_sh_dt_in().getYYYYMMDD());
					rec.set("sh_dt_en", tr.getResult_sh_dt_out().getYYYYMMDD());
					rec.set("sh_tm_bg", tr.getResult_sh_dt_in().getCSCTime());
					rec.set("sh_tm_en", tr.getResult_sh_dt_out().getCSCTime());
					rec.set("tr_type", "H0");
					rec.set("iswork", tr.getResultIsWork());
					rec.set("eventgrp", tr.getResultEventGroup());
					rec.set("oldeventgrp", tr.getResultOldEventGroup());
					
					String keyShift = empRec.getString("employeeid")
								  				+empRec.getString("companyid")
								  				+tr.getResultShiftCalendar().getYYYYMMDD()
								  				+this.getStringID(i, 2);
	
					String previousShift = "";
	                if (this.hshShift.containsKey(keyShift)) {
	                	previousShift = this.hshShift.get(keyShift).substring(0, 1);
	                }
	                String nextShift = "";
	                if (this.hshShift.containsKey(keyShift)) {
	                	nextShift = this.hshShift.get(keyShift).substring(1, 2);
	                }
	                
					rec.set("previousshift",previousShift);
					rec.set("nextshift",nextShift);
					
					rec.set("status",tr.getResultStatus());
					rec.set("source_in", tr.getResult_Sourcein());
	                rec.set("source_out", tr.getResult_Sourceout());
	                rec.set("ot_workarea", tr.getResult_Workarea());
	                rec.set("ot_salatype", tr.getResult_Salatype());
	                rec.set("cost_borrow", tr.getResult_Salatype());
	                rec.set("ot_type", tr.getResult_OT_type());
	                rec.set("ot_time0", tr.getResult_OT_time0());
	                rec.set("machine_in", tr.getResult_Machinein());
	                rec.set("machine_out", tr.getResult_Machineout());
	                rec.set("hour_s",tr.getResultHour_s());
	                rec.set("docstatus", tr.getResult_DocStatus());     
	                
	                if (errorDayShiftResult!=null && !errorDayShiftResult.isEmpty() && errorDayShiftResult.containsKey("11")) {
	                	if (rec.getString("tr_type").indexOf("A")>-1 || rec.getString("tr_type").indexOf("H")>-1 || rec.getString("tr_type").indexOf("I")>-1) {
	                		String swipeHoliday = ""; //runno ͧҷٴѵѹش
	                		String swipeHolidayTime = ""; //ҷٴѵѹش
	                		String swipeKey = "";
	                		if (dShifttmp.getSwipeHoliday().size()>0) {	                            			
	                			for (int j=0;j<dShifttmp.getSwipeHoliday().size();j++) {
	                				swipeKey = (String) dShifttmp.getSwipeHoliday().elementAt(j) ;
	                				
	                				SwipeRecord SR = (SwipeRecord) dShifttmp.getSwipeTrans().getSwipeRecord(Long.parseLong((String) dShifttmp.getSwipeHoliday().elementAt(j)));
	                				if (SR!=null && !SR.getSource().equals("9")) {
	                					swipeHoliday +=swipeKey +",";
	                					swipeHolidayTime += SR.getTime() + ",";
	                				}
	                			}
	                			rec.set("warn11", swipeHolidayTime);
	                		} 	                            		
	            		}
	                } //աٴѵѹش
	                
	                if (!this.hmUnused.isEmpty()) {
	                	if (this.hmUnused.get(tr.getResult_c_dt_in().getDDMMYYYY())!=null) {
	                		MyHashMap h = (MyHashMap) this.hmUnused.get(tr.getResult_c_dt_in().getDDMMYYYY());
	                		rec.set("unused1", h.getString("un1_value"));
	                		rec.set("unused2", h.getString("un2_value"));
	                		rec.set("unused3", h.getString("un3_value"));
	                		rec.set("unused4", h.getString("un4_value"));
	                		rec.set("unused5", h.getString("un5_value"));
	                	}
	                }
	                
					hour_s=tr.getResultHour_s();
					rec.set("loadDataTime","true");
					
					Ttime_current1 t1 = (Ttime_current1) rec;
					t1.setTimeHashMap(this.hmTime);
					t1.setDayTimeHashMap(this.hmDayTime);
					t1.setEmpRecord(empRec);
					t1.setTimeRecord(timeRec);
					t1.setOTHashMap((MyTreeMap) this.hashOT.clone());
					t1.setHolidayHashMap(this.hmHoliday);
					t1.setCalOTProcess(this.calOT);
					t1.setCostcenter(this.hmCostcenter);
					t1.setBusLate(this.hmBusLate);
					t1.setUnused(this.hmUnused);
					
					/* prv & next shift for cal ot */
					t1.prv_shift = tr.getPreviousShift() ;
					t1.nex_shift = tr.getNextShift();
					
					if (i==1) {
						t1.setOTAdjust(this.hmOTAdjust);			
	                } else { 
	                	t1.setOTAdjust(new MyHashMap());
	                }
					this.dbTCurrent1NoWork.putNewRecord(rec);
					this.hmTime = t1.getTimeHashMap();
					this.hmDayTime = t1.getDayTimeHashMap();
					this.hmHoliday = t1.getHolidayHashMap();
					            
					//Save TTIME_CURRENT
					if (this.recTCurrentNoWork == null) {
						this.recTCurrentNoWork = new InitialRecord(this.upf).getDbRecord("Ttime_current");
					}
					this.recTCurrentNoWork.clearField();
					this.recTCurrentNoWork.set("employeeid", empRec.getString("employeeid"));
					this.recTCurrentNoWork.set("companyid", empRec.getString("companyid"));
					this.recTCurrentNoWork.set("time0id", empRec.getString("time0"));
					this.recTCurrentNoWork.set("dateid", date.getYYYYMMDD());
					this.recTCurrentNoWork.set("hour_s", hour_s);
					this.recTCurrentNoWork.putChild(this.dbTCurrent1NoWork);
					Ttime_current t = (Ttime_current) this.recTCurrentNoWork;
					t.setEmpRecord(empRec);
					this.recTCurrentNoWork.save();
				} else {
					MyLog.error("!! Error TimeResult is null or doesn't have any dayShift to be process in TransferTimeProcess.saveDayNotWorking() !!");
				}
			} catch (Exception e) {
				MyLog.error("!! Error in TransferTimeProcess.saveDayNotWorking() !!");
			}
		}//end for 
    }
       
    //Save OT Continue
    private void saveOTContinue(DbRecord empRec, MyTreeMap hmADJ, TimeResult tr, DbRecord timeRec) {		
		if (hmADJ!=null && !hmADJ.isEmpty()) {
			try {
				CscCalendar breakIN = tr.getResultMidDayStop().getBeginZone();
				CscCalendar breakOUT = tr.getResultMidDayStop().getEndZone();
				for (Iterator it = hmADJ.keySet().iterator(); it.hasNext();) {
					int i=1;
					breakIN.incDate();
					breakOUT.incDate();
					
					//FOR SHIFT					
					String key = it.next().toString();
					CscCalendar csc = new CscCalendar(key);
					
					if (this.dbTCurrent1OT == null) {
						this.dbTCurrent1OT = new InitialTable(this.upf).getDbTable("Ttime_current1");
					}
					
					this.dbTCurrent1OT.clear();
					DbRecord rec = this.dbTCurrent1OT.getNewRecord();				
					rec.setColumn("*");
					rec.set("employeeid", empRec.getString("employeeid"));
					rec.set("companyid", empRec.getString("companyid"));
					rec.set("dateid", csc.getYYYYMMDD());
					rec.set("docno", tr.getResultDocNo());
					rec.set("doctype", tr.getResultDocType());
					rec.set("olddoctype", tr.getResultOldDocType());
                    rec.set("olddocno", tr.getResultOldDocNo());
					
					if (!tr.getResultTimeCode().equalsIgnoreCase("HOLIDAY")) {
						rec.set("time0id", tr.getResultTimeCode());
					} else rec.set("time0id", empRec.getString("time0"));
					rec.set("old_time0", tr.getResultOldTimeCode());						
					rec.set("sequence", this.getStringID(i, 2));
					
					MyTreeMap d = (MyTreeMap) hmADJ.get(key);
					CscCalendar cIN = new CscCalendar((String) d.get("DT_BG"));
					cIN.setCSCTime(Float.valueOf((String) d.get("TM_BG")).floatValue());
					CscCalendar cOUT = new CscCalendar((String) d.get("DT_EN"));
					cOUT.setCSCTime(Float.valueOf((String) d.get("TM_EN")).floatValue());
					
					try {
     					rec.set("o_dt_bg", tr.getResult_o_dt_in().getYYYYMMDD());
     					rec.set("o_dt_en", tr.getResult_o_dt_out().getYYYYMMDD());
     				} catch (Exception e) {
     					MyLog.error(this, e);
     				}
     				try {
     					rec.set("o_tm_bg", tr.getResult_o_dt_in().getCSCTime());
     					rec.set("o_tm_en", tr.getResult_o_dt_out().getCSCTime());
     				} catch (Exception e) {
     					MyLog.error(this, e);
     				}	
     				
     				try {
     					rec.set("sh_dt_bg", tr.getResult_sh_dt_in().getYYYYMMDD());
     					rec.set("sh_dt_en", tr.getResult_sh_dt_out().getYYYYMMDD());
     				} catch (Exception e) {
     					MyLog.error(this, e);
     				}
     				try {
     					rec.set("sh_tm_bg", tr.getResult_sh_dt_in().getCSCTime());
     					rec.set("sh_tm_en", tr.getResult_sh_dt_out().getCSCTime());
     				} catch (Exception e) {
     					MyLog.error(this, e);
     				}	
					
					rec.set("c_dt_bg", cIN.getYYYYMMDD());						
					rec.set("c_tm_bg", cIN.getCSCTime());
					rec.set("c_dt_en", cOUT.getYYYYMMDD());
					rec.set("c_tm_en",cOUT.getCSCTime());
					
					rec.set("m_dt_bg", cIN.getYYYYMMDD());
					rec.set("m_tm_bg", cIN.getCSCTime());
					if (csc.getYYYYMMDD().equalsIgnoreCase(tr.getResult_m_dt_out().getYYYYMMDD())) {
						rec.set("m_dt_en", tr.getResult_m_dt_out().getYYYYMMDD());
						rec.set("m_tm_en", tr.getResult_m_dt_out().getCSCTime());
					} else {
						rec.set("m_dt_en", cOUT.getYYYYMMDD());
						rec.set("m_tm_en", cOUT.getCSCTime());
					}
					
					rec.set("ap_ot", cOUT.subForHour(cIN));	
					rec.set("c_lv", tr.getResultC_LV());
                    rec.set("lv_ty", tr.getResultEventGroup());
                    rec.set("tr_type", tr.getResultTR_Type());
                   try {
						if (tr.getResultMidDayStop()!=null){
							try {
								if (breakIN!=null) {
									rec.set("dt_breakin", breakIN.getYYYYMMDD());
									rec.set("tm_breakin", breakIN.getCSCTime());
								}		
							} catch (Exception e) {
								MyLog.error(this, e);
							}
							try { 										
								if (breakOUT!=null) {
									rec.set("dt_breakout", breakOUT.getYYYYMMDD());							
									rec.set("tm_breakout", breakOUT.getCSCTime());
								}
							} catch (Exception e) {
								MyLog.error(this, e);
							}
						} 
					} catch (Exception e) {
						MyLog.error(this, e);
					}
					
					rec.set("iswork", tr.getResultIsWork());
                    rec.set("eventgrp", tr.getResultEventGroup());
                    rec.set("oldeventgrp", tr.getResultOldEventGroup());
                    
                    //================ Nuiss Edit Code ===================      
                    //rec.set("previousshift",tr.getResultPreviousShiftType());
                    //rec.set("nextshift",tr.getResultNextShiftType());
                    //================ Nuiss Edit Code ===================
                    
                    rec.set("status",tr.getResultStatus());
                    rec.set("source_in", tr.getResult_Sourcein());
                    rec.set("source_out", tr.getResult_Sourceout());
                    rec.set("ot_workarea", tr.getResult_Workarea());
                    rec.set("ot_salatype", tr.getResult_Salatype());
                  //=================== Nuiss Code ===============
                    /**
                     * Author : Nuiss
                     * Date : 06/07/2552
                     * Logic : update  ttime_current1.cost_borrow = tr.getResult_Salatype()
                     */
                    rec.set("cost_borrow", tr.getResult_Salatype());
                    //=================== Nuiss Code ===============
                    rec.set("ot_type", tr.getResult_OT_type());
                    rec.set("ot_time0", tr.getResult_OT_time0());
                    rec.set("machine_in", tr.getResult_Machinein());
                    rec.set("machine_out", tr.getResult_Machineout());
                    rec.set("hour_s",tr.getResultHour_s());
                    rec.set("docstatus", tr.getResult_DocStatus());
                    
                    if (!this.hmUnused.isEmpty()) {
                    	if (this.hmUnused.get(tr.getResult_c_dt_in().getDDMMYYYY())!=null) {
                    		MyHashMap h = (MyHashMap) this.hmUnused.get(tr.getResult_c_dt_in().getDDMMYYYY());
                    		rec.set("unused1", h.getString("un1_value"));
                    		rec.set("unused2", h.getString("un2_value"));
                    		rec.set("unused3", h.getString("un3_value"));
                    		rec.set("unused4", h.getString("un4_value"));
                    		rec.set("unused5", h.getString("un5_value"));
                    	}
                    }
                    
                    Ttime_current1 t1 = (Ttime_current1) rec;
                    t1.setTimeHashMap(this.hmTime);
                    t1.setDayTimeHashMap(this.hmDayTime);
                    t1.setEmpRecord(empRec);
                    t1.setTimeRecord(timeRec);
                    t1.setOTHashMap((MyTreeMap) this.hashOT.clone());
                    t1.setHolidayHashMap(this.hmHoliday);
                    t1.setCalOTProcess(this.calOT);
                    t1.setCostcenter(this.hmCostcenter);
                    t1.setUnused(this.hmUnused);
                    this.dbTCurrent1OT.putNewRecord(rec);
                    this.hmTime = t1.getTimeHashMap();
                    this.hmDayTime = t1.getDayTimeHashMap();
                    this.hmHoliday = t1.getHolidayHashMap();
                    
                    //Save TTIME_CURRENT
                    if (this.recTCurrentOT == null) {
                    
                    	this.recTCurrentOT = new InitialRecord(this.upf).getDbRecord("Ttime_current");
                    }
                    this.recTCurrentOT.clearField();
                    this.recTCurrentOT.set("employeeid", empRec.getString("employeeid"));
                    this.recTCurrentOT.set("companyid", empRec.getString("companyid"));
                    this.recTCurrentOT.set("time0id", empRec.getString("time0"));
                    this.recTCurrentOT.set("dateid", csc.getYYYYMMDD());
                    this.recTCurrentOT.putChild(this.dbTCurrent1OT);
                    Ttime_current t = (Ttime_current) this.recTCurrentOT;
					t.setEmpRecord(empRec);
					this.recTCurrentOT.save();
				}				
			} catch (Exception e) {
				MyLog.error(this, e);				
			}			
		}
	}
    
    public MyHashMap getTimetemp(String employeeid, String sDate, String eDate) {
    	MyHashMap hm = new MyHashMap();
    	try {
    		int i=0, rec=1;   		
    		MyHashMap hmDetail = new MyHashMap();	
    		String swipeDate = "";
    		StringBuffer filter = new StringBuffer();
    		filter.append("employeeid='").append(employeeid).append("' and (swipedate between '").append(sDate);
    		filter.append("' and '").append(eDate).append("')");
    		
    		if (this.inqSwipeTime == null) {
    			this.inqSwipeTime = new InitialInquiry(this.upf).getDbInquiry();
    			this.inqSwipeTime.setParam(this.data);
    			this.inqSwipeTime.setSchemaName(this.upf.getSchemaName());		
    			this.inqSwipeTime.initMyTable("Ttimetemp", "", "swipedate,swipetime");
    			this.inqSwipeTime.setColumn("swipedate,swipetime,employeeid,companyid");
    		}
    		this.inqSwipeTime.setFilter(filter.toString());
    		this.inqSwipeTime.refresh();
			while (this.inqSwipeTime.next()) {
				if (i!=0 && !swipeDate.equalsIgnoreCase(this.inqSwipeTime.getString("swipedate"))) {
					hm.put(swipeDate, hmDetail.clone());
					hmDetail.clear();
					rec=1;
				} 
				hmDetail.put(String.valueOf(rec), this.inqSwipeTime.getString("swipetime"));
				swipeDate = this.inqSwipeTime.getString("swipedate");
				rec++;
				i++;
			}
			
			if (i>0) {
				hm.put(swipeDate, hmDetail);
			}
    	} catch (Exception e) {
    		MyLog.error(this, e);    		
    	}
    	return hm;
    }

    /**
     * Author : Nuiss
     * Date : 03/06/2552
     * Logic : Trigger Fields for NSTDA only
     * 	-ttime_current1.doctype ='OTA'
     * 	-ttime_current1.docno = totapprove0.approveid
     * ա͹ѵ OT Ǩҡ ˹Ҩ §ҹ÷ӧҹǧ [TUA_NSTDA_008.jsp]
     */
    private void triggerTtime_current1(String stDate,String endDate){
    	CscConnection conn = null;
   	   	Statement stmt =null;
        ResultSet resultSet = null;
       
       String SQLQuery = "SELECT t1.employeeid,t1.companyid,t1.dateid,t1.sequence"+
				" ,t1.docno,t1.doctype"+
				" ,a0.approveid,a1.ot_date"+
				" FROM ttime_current1 t1,totapprove_nstda0 a0 ,totapprove_nstda1 a1"+
				" WHERE a0.approveid = a1.approveid"+
				" and a1.approveid in(select tot0.approveid from totapprove_nstda0 tot0 where tot0.otid > 0)"+
				" and t1.employeeid = a0.employeeid"+
				" and t1.dateid = a1.ot_date"+
				" and t1.ac_ot >0 "+
				" and t1.dateid >='"+stDate+"' "+
				" and t1.dateid <='"+endDate+"' ";

 		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(SQLQuery);
			ResultSetMetaData resultSetMtd = resultSet.getMetaData();
			int rowEffected = 0;
			while (resultSet.next()) {
				rowEffected ++;
 				String employeeid="";
 				String companyid="";
 				String dateid="";
 				String sequence="";
 				String approveid="";
 				for (int col=1;col<=resultSetMtd.getColumnCount();col++){
 					switch(col){
						case 1:
							employeeid = resultSet.getString(resultSetMtd.getColumnName(col));
							break;
						case 2:
							companyid = resultSet.getString(resultSetMtd.getColumnName(col));
							break;
						case 3:
							dateid = resultSet.getString(resultSetMtd.getColumnName(col));
							break;
						case 4:
							sequence = resultSet.getString(resultSetMtd.getColumnName(col));
							break;
						case 7:
							approveid = resultSet.getString(resultSetMtd.getColumnName(col));
							break;
						default:break;
					}//end switch 
				}//end for col
 				
				String whereClause = "EMPLOYEEID = '"+employeeid+"' " 
				+" and COMPANYID = '" +companyid+ "' "
				+" and DATEID = '"+dateid+"' ";
				
				DbInquiry inqT1 = new InitialInquiry(this.upf).getDbInquiry();		
				inqT1.initMyTable("ttime_current1", whereClause, "");
				inqT1.setColumn("EMPLOYEEID,COMPANYID,DATEID,SEQUENCE,DOCNO,DOCTYPE");
				inqT1.refresh();
				DbRecord dbRecord = inqT1.getCurrentDbRecord().cloneRecord(true);
				dbRecord.set("EMPLOYEEID",employeeid);
				dbRecord.set("COMPANYID", companyid);
				dbRecord.set("DATEID", dateid);
				dbRecord.set("SEQUENCE", sequence);
				dbRecord.set("DOCNO", approveid);
				dbRecord.set("DOCTYPE", "OTA");
				dbRecord.save();
			}//end while 
			
			System.out.print(">>>>>After Process Update OT Approve "+rowEffected +" Row Completed...")	;
		}catch(Exception ex){
			System.out.print(">>>>>Error on TransferTimeProcess.triggerTtime_current1()"+ex.getStackTrace())	;
		}finally{
			try {
				resultSet.close();
				if(stmt!=null){
					stmt.close();
				}
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}//end try
    }//end method triggerTtime_current1
    
    /*ӹǳ. ͷա ͧҡ SKI ա͹ 4 駵͹  .  ѡҡͷѹ  ᷹ */
    private void processSKIFlexTime(String emp){
    	CscConnection conn = null;
   	   	Statement stmt =null;
        ResultSet rs = null;
        
    	StringBuffer filter = new StringBuffer();
    	try {
    		CheckNull chk = new CheckNull();
    		String status = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "ISACCESS"));
    		
    		if(status.equals("Y")){	/*  site HONDA ACCESS ֧з */
    		
	    		filter.append("select t1.EMPLOYEEID,t1.DATEID,t2.doctype,t2.eventgrp,t2.m_lv,t2.C_DT_BG,t2.C_TM_BG,t2.C_DT_EN,t2.C_TM_EN,t2.M_DT_BG,t2.M_TM_BG,t2.ot_before,t2.ot_after");
	    		filter.append(",t2.M_DT_EN,t2.M_TM_EN,t2.LT,t2.AC_OT,t2.dt_breakin,t2.tm_breakin,t2.dt_breakout,t2.tm_breakout,t2.HOUR_D,t2.SEQUENCE,m0.OTSTANG,t2.hour_s");
	    		filter.append(" from TTIME_CURRENT1 t1 left join TTIME_CURRENT1 t2 on t1.EMPLOYEEID = t2.EMPLOYEEID and t1.DATEID = t2.DATEID");
	    		filter.append(" left join  mtime0 m0 on t1.time0id = m0.time0id");
	    		filter.append(" where t1.LT > 0 ");
	    		filter.append(" and t1.DATEID between '").append(this.cs1.getYYYYMMDD()).append("' and '");
	    		filter.append(cs2.getYYYYMMDD()).append("'");
	    		filter.append(" and t1.EMPLOYEEID = '").append(emp).append("'");
	    		filter.append(" order by t2.dateid,t2.sequence desc;");
	    	
	    		conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
				stmt = conn.createStatement();
				rs = stmt.executeQuery(filter.toString());
				
				int max = 4;
				int count = 0;
				
				MyHashMap ws = new MyHashMap();
				while(rs.next()){
					String date = rs.getString("dateid");
					
					HashMap hdetail = new HashMap();
					hdetail.put("employeeid", rs.getString("employeeid"));
					hdetail.put("dateid", rs.getString("dateid"));
					hdetail.put("c_dt_bg", rs.getString("c_dt_bg"));
					hdetail.put("c_tm_bg", rs.getString("c_tm_bg"));
					hdetail.put("c_dt_en", rs.getString("c_dt_en"));
					hdetail.put("c_tm_en", rs.getString("c_tm_en"));
					hdetail.put("m_dt_bg", rs.getString("m_dt_bg"));
					hdetail.put("m_tm_bg", rs.getString("m_tm_bg"));
					hdetail.put("m_dt_en", rs.getString("m_dt_en"));
					hdetail.put("m_tm_en", rs.getString("m_tm_en"));
					hdetail.put("dt_breakin", rs.getString("dt_breakin"));
					hdetail.put("tm_breakin", rs.getString("tm_breakin"));
					hdetail.put("dt_breakout", rs.getString("dt_breakout"));
					hdetail.put("tm_breakout", rs.getString("tm_breakout"));
					hdetail.put("lt", rs.getString("lt"));
					hdetail.put("ac_ot", rs.getString("ac_ot"));
					hdetail.put("hour_d", rs.getString("hour_d"));
					hdetail.put("sequence", rs.getString("sequence"));
					hdetail.put("otstang", rs.getString("otstang"));
					hdetail.put("hour_s", rs.getString("hour_s"));
					hdetail.put("doctype", rs.getString("doctype"));
					hdetail.put("eventgrp", rs.getString("eventgrp"));
					hdetail.put("m_lv", rs.getString("m_lv"));
					hdetail.put("ot_before", rs.getString("ot_before"));
					hdetail.put("ot_after", rs.getString("ot_after"));
					
					Vector v = null;
					if(ws.containsKey(date)){
						v = (Vector) ws.get(date);
						v.add(hdetail);
					}else{
						v = new Vector();
						v.add(hdetail);
					}
					ws.put(date, v);
				}
				
				for (Iterator it = ws.getKeySortIterator(); it.hasNext();) {
					String key1 = (String) it.next();			
					Vector vt = (Vector) ws.get(key1);
					
					for(int i=0; i < vt.size() ; i++){
						HashMap date_detail = (HashMap) vt.get(i);
						
						if(count >= max) return ; /* Թ 4  ش÷ӧҹ */
						
						if(Float.parseFloat((String)date_detail.get("lt")) > 0){	/* ѧԹ 4 駵͹ */
							/*  ͷáǡѹ */
							RoundingTime rt1 = new RoundingTime("LT", Float.parseFloat((String)date_detail.get("lt"))); /* Ѵ .  ͹ѡ */
							rt1.setUProfile(this.upf);
							float _lt = (float) rt1.getRounding();
							
							if(Float.parseFloat((String)date_detail.get("ac_ot")) > 0 && _lt
									<= Float.parseFloat((String)date_detail.get("ac_ot"))){	/*  ͷ ѧԹ 4 źͷյ .   0 */
								/* ͧҡ͹Ңͷժǧ 17.30  觤Ҫǧҷ鹡˹ 1  л Сͷըж١ҵ͡ѹ  ac_ot  ot_after Фӹǳ͡çѹ 
								 *  ac_ot ФԴҡ Ἱͷ ( 17.30)  ot_after ФԴҡ 17.00 (ԡҹ)  ot_after ҡҤ繨ԧ ֧Ѻ ac_ot ҡѺ
								 * ot_after Ǥٵͷѡ͡ .20 ҷ ѧ */
								float ot_after = Float.parseFloat((String)date_detail.get("ot_after"));
								float ot_before = Float.parseFloat((String)date_detail.get("ot_before"));
								float ac_ot = Float.parseFloat((String)date_detail.get("ac_ot"));
								if(ot_after > 0 && ac_ot > 0){	/*  ot_after դҡ˹ ac_ot   */
									ac_ot = ot_after;
								}
								
								CscTime tmp = new CscTime(ac_ot);
								if(tmp.getFloat() >= 2){
									tmp.sub(.20);	/* ѡ͡ .20 ҷմͧҡԨТͷ 17.20 кӡҵ͡ѹͷԴҡ 17.00 ֧繵ͧѡ͡ */
								}
								tmp.sub(_lt);	/* ѡ */
								
								updateLTandOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
										(String)date_detail.get("sequence"),0,tmp.getFloat(),(String)date_detail.get("hour_d"),"OTF");
								reCalOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
										(String)date_detail.get("sequence"));	/* ͻѺͷ ͧӹǳ wage ͧͷ (ͷ 1,5,2  3) */
								count++;
							}else if(Float.parseFloat((String)date_detail.get("ac_ot")) == 0 ){	/* ͷ .. ӧҹú 8 .  0 */
								float hour_d = getActualWorkHour(date_detail);
								if(hour_d >= Float.parseFloat((String)date_detail.get("hour_s"))){
									updateLTandOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
											(String)date_detail.get("sequence"),0,0,(String)date_detail.get("hour_s"),"OTF");
									count++;
								}else{	/*  . ӧҹ¡ ͧѹ  բҴ յͧ . ӧҹ ǡѺ .  Ǥ礡Ѻ . ӧҹѹ */
									float leave = getDataFromVector(vt,"doctype","A","m_lv"); /*  .  */
									float ot = getDataFromVector(vt,"eventgrp","O","ac_ot");	/*  ͷ ͡ */
									CscTime ct = new CscTime();
									ct.add(leave);
									ct.add(hour_d);
									/* ͷ  .ҺǡѺ . ӧҹ ººѺ . ӧҹѹ */
									if(leave > 0f && ot == 0f && ct.getFloat() >= Float.parseFloat((String)date_detail.get("hour_s"))){
										updateLTandOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
												(String)date_detail.get("sequence"),0,0,(String)date_detail.get("hour_s"),"OTF");
										count++;
									}else if(ot > 0f){ /* ͷ͡ѹ  ͧѡ  Ѻ . ͷѹ  */
										//float lt = Float.parseFloat((String)date_detail.get("lt"));
										
										if(_lt > ot){	/* .  ҡͷ ѡ .  ͷ纤 . · */
											CscTime tmp = new CscTime(_lt);
											tmp.sub(ot);
											updateLTandOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
													(String)date_detail.get("sequence"),tmp.getFloat(),0,(String)date_detail.get("hour_s"),"OTF");
											updateIsolateOT(vt, 0);	/* Ѿഷͷ 0 ФҡҤͷ  */
											count++;
										}else{	/* ¹¡ͷ Ѻ 0 纤ŧ㹤 ͷ еͧѡҡͷյ͡ á촶Ѵ价ٻҷӧҹ */
											CscTime tmp = new CscTime(ot);
											tmp.sub(_lt);
											updateLTandOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
													(String)date_detail.get("sequence"),0,0,(String)date_detail.get("hour_s"),"OTF");
											updateIsolateOT(vt, tmp.getFloat());	/* Ѿഷͷշͨҡѡ .   */
											count++;
										}
									}
								}
							}
						}
					}
				}
    		}
    	}catch(Exception ex){
			System.out.print(">>>>>Error on TransferTimeProcess.triggerTtime_current1()"+ex.getStackTrace())	;
		}finally{
			try {
				if(rs!=null) rs.close();
				if(stmt!=null) stmt.close();
				if(conn!=null) conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}
    }
    
    /*  . ӧҹҡٴѵѡ . ѡ§ */
    private float getActualWorkHour(HashMap date_detail){
    	float hour_d = 0f;
    	try {
			CscCalendar in = new CscCalendar((String)date_detail.get("m_dt_bg"));
			in.setCSCTime(Float.parseFloat((String)date_detail.get("m_tm_bg"))); /* ٴ */
			
			CscCalendar out = new CscCalendar((String)date_detail.get("m_dt_en"));
			out.setCSCTime(Float.parseFloat((String)date_detail.get("m_tm_en"))); /* ٴ͡ */
			
			CscCalendar brk_in = new CscCalendar((String)date_detail.get("dt_breakin"));
			brk_in.setCSCTime(Float.parseFloat((String)date_detail.get("tm_breakin"))); /* ѡ§ */
			
			CscCalendar brk_out = new CscCalendar((String)date_detail.get("dt_breakout"));
			brk_out.setCSCTime(Float.parseFloat((String)date_detail.get("tm_breakout"))); /* شѡ§ */
			
			/* ੾Сóշ͡դ ҹ */
			if(brk_in.afterEqualsDateTime(in) && brk_out.beforeEquals(out)){ /* ٴѵäѡ§ */
				hour_d = out.subForHour(in);	/* Դ . ӧҹҡش ٴ͡ */
				CscTime tmp = new CscTime(hour_d);
				tmp.sub(brk_out.subForHour(brk_in));
				hour_d = tmp.getFloat();
			}else if(brk_in.beforeDateTime(in) && brk_out.afterDateTime(in) && brk_out.beforeDateTime(out)){	/* ٴҪǧѡ§ ٴ͡ѧѡ§ */
				hour_d = out.subForHour(brk_out);	/* Դ . ӧҹ ҡ ԡѡ§ ٴ͡ */
			}else if(brk_out.beforeDateTime(in)){	/* ٴѵѧѡ§ Դ . ӧҹ ҡٴѵ ͡ */
				hour_d = out.subForHour(in);
			}else{	/* ͡˹ͨҡóբҧ hour_d ӹǳ */
				hour_d = Float.parseFloat((String)date_detail.get("hour_d"));
			}
			
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return hour_d;
    }
    
    /* Ѿഷͷ͡ ѧҡѡ . ѹ   */
    private void updateIsolateOT(Vector vt, float val){
    	try {
    		for(int i=0; i < vt.size() ; i++){
				HashMap date_detail = (HashMap) vt.get(i);
				if(Float.parseFloat((String)date_detail.get("ac_ot")) > 0 && ((String)date_detail.get("eventgrp")).equals("O")){
					updateLTandOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
							(String)date_detail.get("sequence"),0,val,(String)date_detail.get("hour_s"),(String)date_detail.get("otstang"));
					
					reCalOT((String)date_detail.get("dateid"),(String)date_detail.get("employeeid"),
							(String)date_detail.get("sequence"));	/* ͻѺͷ ͧӹǳ wage ͧͷ (ͷ 1,5,2  3) */
				}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* 觤ӹǳ wage ͧͷ */
    private void reCalOT(String dateid, String emp, String seq){
    	try {
    		DbRecord db = new InitialRecord(this.upf).getDbRecord("Ttime_current1");
    		db.setColumn("*");
    		db.set("employeeid", emp);
    		db.set("dateid", dateid);
    		db.set("companyid", this.upf.getComCode());
    		db.set("sequence", seq);
    		if(db.search() == 1){
    			Ttime_current1 t1 = (Ttime_current1) db;
    			t1.loadTimeData();
    			t1.processOT();
    			t1.save();
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /*  . ѹ  */
    private float getDataFromVector(Vector vt, String field, String code, String rtnfield){
    	CscTime hr = new CscTime();
    	try {
    		for(int i=0; i < vt.size() ; i++){
				HashMap detail = (HashMap) vt.get(i);
				if(((String)detail.get(field)).equals(code)){
					hr.add(Float.parseFloat((String)detail.get(rtnfield)));
				}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return hr.getFloat();
    }

    /* Ѻ .  ͷ */
    private void updateLTandOT(String dateid,String emp,String seq,float lt,float ot,String hour_d,String otstang){
    	CscConnection conn = null;
   	   	Statement stmt =null;
        
        StringBuffer update = new StringBuffer();
    	try {
    		conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = conn.createStatement();
			/* ͧѴͷ ¹ٵͷ繵ǻѴͧ */
			//RoundingTime rt = new RoundingTime(otstang, ot);
			//rt.setUProfile(this.upf);
			
			update.append("update ttime_current1 set ");
			update.append(" lt = '").append(Float.toString(lt)).append("'");
			update.append(",ac_ot = '").append(ot).append("'");
			update.append(",hour_d = ").append(hour_d);
			update.append(",unused3 = 1");	/* ѹ flextime */
			update.append(" where employeeid = '").append(emp).append("'");
			update.append(" and dateid = '").append(dateid).append("'");
			update.append(" and sequence = '").append(seq).append("'");
			
			stmt.executeUpdate(update.toString());
			
    	}catch(Exception ex){
			System.out.print(">>>>>Error on TransferTimeProcess.triggerTtime_current1()"+ex.getStackTrace())	;
		}finally{
			try {
				if(stmt!=null){
					stmt.close();
				}
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			
		}
    }

    /* ҤҨҡС͹˹  */
	private float getPreviousShiftSwipeOut(CscCalendar key, WorkingShift ws, WorkingShift wstmp){
		try {
			if(ws.containsKey(key.getYYYYMMDD())){
				DayShift ds = (DayShift) ws.get(key.getYYYYMMDD());
				
				Shift sh = (Shift) ds.get(key.getYYYYMMDDHHMMSS());
				
				if(sh != null){
					
					Shift prsh = sh.getPreviousShift();
					if(prsh != null){
						if(prsh.get_m_dt_out() != null){
							return prsh.get_m_dt_in().getCSCTime();
						}else if(prsh.get_m_dt_in() != null){
							return prsh.get_m_dt_out().getCSCTime();
						}
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0f;
	}
	
	/* ҤҨҡжѴ  */
	private float getNextShiftSwipeIn(CscCalendar key, WorkingShift ws, WorkingShift wstmp){
		try {
			if(ws.containsKey(key.getYYYYMMDD())){
				DayShift ds = (DayShift) ws.get(key.getYYYYMMDD());
				
				Shift sh = (Shift) ds.get(key.getYYYYMMDDHHMMSS());
				
				if(sh != null){
					
					Shift nxsh = sh.getNextShift();
					if(nxsh != null){
						if(nxsh.get_m_dt_out() != null){
							return nxsh.get_m_dt_out().getCSCTime();
						}else if(nxsh.get_m_dt_in() != null){
							return nxsh.get_m_dt_in().getCSCTime();
						}
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 0f;
	}	
	
	/* pre process trigger 
     * call class from Mconfig on precls
     * class must implement interface ProcessTimeTrigger 
     * */
    private void preProcessTrigger(WorkingShift ws, DbRecord tcur){
    	try {
    		CheckNull chk = new CheckNull();
    		String pre = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TAPRECLS"));
    		
    		if(!pre.equals("")){
    			
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* post process trigger 
     * call class from Mconfig on poscls
     * class must implement interface ProcessTimeTrigger 
     * */
    private void postProcessTrigger(WorkingShift ws, DbRecord tcur){
    	try {
    		CheckNull chk = new CheckNull();
    		String post = chk.chkNullString((String) StaticConfig.getConfigCompany(this.upf, "TAPOSCLS"));
    		
    		if(!post.equals("")){
    			HashMap hm = new HashMap();
    			hm.put("workshift", ws);
    			hm.put("time1", tcur);
    			
    			Object cls = Class.forName(post).newInstance();
				Class c = cls.getClass();
				Method m = c.getDeclaredMethod("process", new Class[] {HashMap.class});
				m.invoke(cls, new Object[] { hm });
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
            
    /* ҤҨҡС͹˹  */
	private String getPreviousShiftData(String key, WorkingShift ws, WorkingShift wstmp){
		try {
			Shift sh = null;
			
			CscCalendar pre = new CscCalendar(key);
			pre.decDate();
			
			if(ws.containsKey(pre.getYYYYMMDD())){
				DayShift ds = (DayShift) ws.get(pre.getYYYYMMDD());
				if(ds != null && !ds.isEmpty()){
					for (Iterator it = ds.keySet().iterator(); it.hasNext();) { 
						sh = (Shift) ds.get(it.next());
						if(!sh.getEventGroup().equals("M")){
							if(sh.getEventGroup().equals("O")){
								return sh.getActualEvent();
							}else{
								if(sh.getDocType().equals("A")){	/* С͹˹ */
									return "T";
								}else{
									return sh.getEventGroup();
								}
							}
						}
					}
				}else{	/* holiday */
					DayShift dsh = (DayShift) wstmp.get(pre.getYYYYMMDD());
					Iterator ith = dsh.keySet().iterator();
					sh = (Shift) dsh.get(ith.next());
					return sh.getEventGroup();
				}
			}else{	/* 㹪ǧż */
				if(pre.afterEqualsDate(cs1) && pre.beforeEqualsDate(cs2)){	/* ѹش 㹪ǧż  ws */
					DayShift dsh = (DayShift) wstmp.get(pre.getYYYYMMDD());
					Iterator ith = dsh.keySet().iterator();
					sh = (Shift) dsh.get(ith.next());
					return sh.getEventGroup();
				}else{	/* 㹪ǧż */
					return "";
				}
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	/* ҤҨҡС͹˹  */
	private String getNextShiftData(String key, WorkingShift ws, WorkingShift wstmp){
		try {
			Shift sh = null;
			
			CscCalendar next = new CscCalendar(key);
			next.incDate();
			
			if(ws.containsKey(next.getYYYYMMDD())){
				DayShift ds = (DayShift) ws.get(next.getYYYYMMDD());
				if(ds != null && !ds.isEmpty()){
					for (Iterator it = ds.keySet().iterator(); it.hasNext();) { 
						sh = (Shift) ds.get(it.next());
						if(!sh.getEventGroup().equals("M")){
							if(sh.getEventGroup().equals("O")){
								return sh.getActualEvent();
							}else{
								if(sh.getDocType().equals("A")){	/* жѴ */
									return "T";
								}else{
									return sh.getEventGroup();
								}
							}
						}
					}
				}else{	/* holiday */
					DayShift dsh = (DayShift) wstmp.get(next.getYYYYMMDD());
					Iterator ith = dsh.keySet().iterator();
					sh = (Shift) dsh.get(ith.next());
					return sh.getEventGroup();
				}
			}else{	
				if(next.afterEqualsDate(cs1) && next.beforeEqualsDate(cs2)){	/* ѹش 㹪ǧż  ws */
					DayShift dsh = (DayShift) wstmp.get(next.getYYYYMMDD());
					Iterator ith = dsh.keySet().iterator();
					sh = (Shift) dsh.get(ith.next());
					return sh.getEventGroup();
				}else{	/* 㹪ǧż */
					return "";
				}
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return "";
	}
	
	private void checkOverlapPreviousShift(String emp, Shift sh){
		try {
			if(!sh.getTR_Type().equals("M") && sh.getPreviousShift().get_c_dt_out().afterDateTime(sh.get_c_dt_in())){ /* зѺѹ */
				setEmpProcError(emp, "Overlap in on shift : " + sh.get_c_dt_in());
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
    /* ҧ query ֧Ţͷ ŧἹ÷ӧҹ ͹ѧ 1 ͹ */
	private String createQuery(){
		StringBuilder sb = new StringBuilder();
		try {
			sb.append("select employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, companyid, status, startdate, resigndate,salary,emp_level");
			sb.append(" from memployee ");
			sb.append(" where ").append(this.getParamValue("filterProcess"));
			sb.append(" order by employeeid");
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sb.toString();
	}
	
	private DbRecord getTimeRecProp(String time0id){
		DbRecord db = null ;
		try {
			if(hmTimeRec.containsKey(time0id)){
				db = (DbRecord) hmTimeRec.get(time0id);
			}else{
				db = new InitialRecord(this.upf).getDbRecord("Mtime0");
				db.setColumn("*");
				db.set("time0id", time0id);
				db.set("companyid", this.upf.getCompanyid());
				if(db.search()==1){
				
				}else{
					MyLog.error("Mtime0 " + time0id + " not found, transfertime process result might be incorrect !!");
				}
				hmTimeRec.put(time0id, db);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return db ;
	}
	
	private DbRecord getDefaultShift(DayShift ds){
		DbRecord db = null ;
		try {
			Shift sh = (Shift) ds.get((String) ds.firstKey());
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return db ;
	}
	
	private void setTimeRecProp(DbRecord db){
		try {
			if(!hmTimeRec.containsKey(db.getString("time0id"))){
				hmTimeRec.put(db.getString("time0id"), db);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}  

/* update ttime_current with custom data (ttime_current_custom) */
	private boolean UpdateWithCustomData(String emp, String st, String en){
		String PROC_NAME = "MERGE_TIMECURRENT_CUSTOM";
		CscConnection conn = null;
		Statement stmt = null;
		try {
			StringBuffer procedure = new StringBuffer();
			procedure.append("exec ").append(PROC_NAME).append(" '").append(emp)
				.append("','").append(st).append("','").append(en).append("'");
			
			if(procedure.length() > 0){
				conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
				stmt = conn.createStatement();
				
				MyLog.debug("!! execute sql merge with ttime_current custom !! : " + procedure.toString());
				stmt.executeUpdate(procedure.toString());
			}else{
				MyLog.debug("!! SQL is null or empty !!");
			}
		}catch(Exception e){
			MyLog.error(this,e);
			return false;
		}finally {
        	try {
	        	if(stmt != null) stmt.close();
	        	if(conn != null) conn.close();
        	} catch(Exception e){
        		MyLog.error("!! Error : Can't close statement or connection !!",e);
        	}
        }
		return true ;
	}
	
}//end class 
