package com.csc.library.service;

import java.util.HashMap;
import java.util.Iterator;

import com.csc.entity.CSC_Quque;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class GenProcessTime extends TA_Service{
	private HashMap hmProcess = null ,conProcess = null;
	private String ClassName = "TransferTimeProcess" , tName = "" , eName = "" , owner = "" , appName = "TA" , remark = "" , screenName = "";
	private int mb = 0;
	private Runtime myRunTime = null;
	private long maxMem = 0 , maxLimit = 0;
	private GenProcessQuque gpq = null;
	private CscCalendar cAll = new CscCalendar();
	
	public GenProcessTime(UProfile up){
		this.up = up;
	}
	
	public GenProcessTime(UProfile up ,String owner, String tName , String eName , String remark , String sName){
		this.setUProfile(up);
		this.setTName(tName);
		this.setEName(eName);
		this.setOwner(owner);
		this.setRemark(remark);
		this.setScreenName(sName);
		if(this.getParam() == null){
			this.setParam(new HashMap());
		}
	}
	
	public void setTName(String tName){
		this.tName = tName;
	}
	
	public void setEName(String eName){
		this.eName = eName;
	}
	
	public void setOwner(String owner){
		this.owner = owner;
	}
	
	public void setRemark(String remark){
		this.remark = remark;
	}
	
	public void setScreenName(String screenName){
		this.screenName = screenName;
	}
	
	public void setUProfile(UProfile up){
		this.up = up;
	}
	
	public UProfile getUProfile(){
		return this.up;
	}
	
	public void addToProcess(String empid , String dateid){
		try{
			this.cAll.setCscCalendar(dateid);
			if( this.chkInListProcess(empid, this.cAll.getYYYYMMDD()) ){
				MyLog.debug(this , this.getUProfile() , "Is Found List in listprocess_roster :: Empid[ "+empid+" ] Dateid[ "+dateid+" ]");
				return;//  list ͧ process ա
			}
			StringBuffer sb = null;
			if( this.hmProcess == null)
				this.hmProcess = new HashMap();
			
			if(this.hmProcess.containsKey(this.cAll.getYYYYMMDD()))
				sb = (StringBuffer)this.hmProcess.get(this.cAll.getYYYYMMDD());
			else{
				sb = new StringBuffer();
				this.hmProcess.put(this.cAll.getYYYYMMDD(), sb);
			}
			sb.append(empid+",");
			if(this.isOverLimitMem())
				this.createQuqueProcess();
			
		}catch (Exception e) {
			MyLog.error(this , this.getUProfile() , "!!!! TongZuu Exception In GenProcessTime.addToProcess :: empid [ "+empid+" ] , dateid [ "+dateid+" ]");
			MyLog.error(this , this.getUProfile() , e);
		}catch (OutOfMemoryError e) {
			this.createQuqueProcess();
		}
	}
	
	public void createQuqueProcess(){
		try{	
			if( this.up == null )
				return;
			if( this.hmProcess == null)
				return;
			if(this.conProcess == null){
				this.conProcess = new HashMap();
				this.conProcess.put("employeeid", this.getUProfile().get("employeeid").toString());
				this.conProcess.put("companyid", this.getUProfile().get("companyid").toString());
				this.conProcess.put("schemaname", this.getUProfile().getSchemaName());
				this.conProcess.put("lang", this.getUProfile().get("lang"));
				this.conProcess.put("appname", this.appName);
				this.conProcess.put("dbname", this.getUProfile().getDbName());
				this.conProcess.put("uprofile", this.getUProfile());
				this.conProcess.put("cmdValue", "transfer");
			}
			this.conProcess.putAll(this.param);
			Iterator it = this.hmProcess.keySet().iterator();
			while(it.hasNext()){
				String key = it.next().toString() , strEmp = ((StringBuffer)this.hmProcess.get(key)).toString();
				this.conProcess.put("employeeSelect", strEmp);
				this.conProcess.put("startDate", key);
				this.conProcess.put("endDate", key);
				if( this.gpq == null ){
					this.gpq = new GenProcessQuque();
				}
				this.gpq.createQuque(this.getUProfile(), this.tName, this.eName, this.ClassName , this.screenName , this.remark , "9", this.conProcess );
			}
		} catch (Exception e) {
			MyLog.error(this , this.getUProfile() ,  "!!!! TongZuu Exception In GenProcessTime.createQuqueProcess !!!");	
			MyLog.error(this , this.getUProfile() , e);		
		}finally{
			if(this.hmProcess != null)
				this.hmProcess.clear();
		}
	}
	
	public void putParam(String key , String value){
		try{
			if( this.param == null )
				this.param = new HashMap();
			this.param.put(key, value);
		}catch(Exception e){
			MyLog.error(this , this.getUProfile() , e);
		}
	}
	
	public void putParamAll(HashMap h){
		try{
			if( this.param == null )
				this.param = new HashMap();
			this.param.putAll(h);
		}catch(Exception e){
			MyLog.error(this , this.getUProfile() , e);
		}
	}
	
	private void initRuntime(){
		if(this.myRunTime == null){
			this.myRunTime = Runtime.getRuntime();
			this.mb = 1024*1024;
			this.maxMem = this.myRunTime.maxMemory() / this.mb;
			this.maxLimit = this.maxMem*100/115;
		}
	}

	private boolean isOverLimitMem(){
		this.initRuntime();
		return this.getUsedMem() > this.maxLimit;
	}
	
	private long getUsedMem(){
		this.initRuntime();
		return (this.myRunTime.totalMemory() - this.myRunTime.freeMemory()) / this.mb;
	}
	
	protected boolean chkInListProcess(String empid , String dateid){
		return false;
	}
}
