package com.csc.library.timeattendance;

import com.csc.library.timeinterface.AdjustTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.CscCalendar;

public class AdjustResult implements AdjustTime {

	private TimeZone timing; //ѹҷӡûѺا
	private String type;
	private String eventGroup; //ѹ
	private String tr_type; //ͧ  T0, O0, A0
	private String timeCode; //ʵҧҡ÷ӧҹ
	private CscCalendar adjDate; //ѹӡûѺا÷ӧҹ
	
	private String oldtimeCode; //ʵҧҡ÷ӧҹ
	private String oldeventGroup; //ѹ
	private String docNo; //Ţ͡
	private String docType; //͡
	private String updateType; //ٻẺûѺا͡ D=ź, A=, T=ӧҹ
	private String lv_ty; //
	
	private TimeZone timeBreak; //ǧҡþѡ§
	private TimeZone timeWork; //ǧҷͧӧҹ
	
	private String status;
	private String adjustTemp;
	private String workarea; //ʶҹӧҹ
	private String salatype; //ٻẺèԹ
	private String ot_type; //ͧͷ
	private String ot_time0; //ҡ÷ӧҹͧǧͷ
	private float hour_s; //.ӧҹѹ
	private String docStatus; //͡
	private String appStatus; //͡
	
	private String actual_date = "";
	
	/*
	 * ӡ clear ҵҧ 繤 default
	 * */
	public void clear() {
		this.timing = new TimeZone();
		this.type = "T";
		this.eventGroup = "T";
		this.tr_type = "T";
		this.timeCode = "";
		this.adjDate = new CscCalendar();
		
		this.oldtimeCode="";
		this.oldeventGroup="";
		this.docNo="";
		this.docType="";
		this.updateType="";
		this.lv_ty="";
		
		this.timeBreak = null;
		this.timeWork = null;
		
		this.status="";
		this.adjustTemp="";
		this.workarea = "";
		this.salatype = "";
		this.ot_type = "";
		this.ot_time0 = "";	
		this.hour_s = 0;
		this.docStatus = "";
		this.appStatus = "";
	}

	public AdjustResult() {
		super();
		this.clear();
	}
	
	/*
	 * ҧ AdjustResult  Constructor
	 */
	public AdjustResult(CscCalendar adjDate, String tr_type, String timeCode,
			String type, String eventGroup, TimeZone z, String lv_ty, String oldtimeCode, 
			String oldeventGroup, String docNo, String docType, String updateType, 
			String workarea, TimeZone tz, String salatype, String ot_type, 
			String ot_time0, String docStatus) {
		this.setTiming(z);
		this.setType(type);
		this.setTimeCode(timeCode);
		this.setEventGroup(eventGroup);
		this.set_tr_type(tr_type);
		this.setAdjDate(adjDate);
		this.setlv_ty(lv_ty);
		this.setoldtimeCode(oldtimeCode);
		this.setoldeventGroup(oldeventGroup);
		this.setdocNo(docNo);
		this.setdocType(docType);
		this.setupdateType(updateType);
		this.setWorkarea(workarea);
		this.setTimeWork(tz);
		this.setSalatype(salatype);
		this.setOT_type(ot_type);
		this.setOT_time0(ot_time0);
		this.setDocStatus(docStatus);
		//this.setAppStatus(appStatus);
	}

	/*
	 * ҧ AdjustResult  Constructor
	 */
	public AdjustResult(CscCalendar adjDate, String type, String timeCode,
			String tr_type, String eventGroup, CscCalendar dt_bg, CscCalendar dt_ed, 
			String lv_ty, String oldtimeCode, 	String oldeventGroup, String docNo, 
			String docType, String updateType, String workarea, TimeZone tz, 
			String salatype, String ot_type, String ot_time0, String docStatus, String actual_date) {
		TimeZone z = new TimeZone();
		z.setBeginZone(dt_bg);
		z.setEndZone(dt_ed);
		this.setTiming(z);
		this.setType(type);
		this.setTimeCode(timeCode);
		this.setEventGroup(eventGroup);
		this.set_tr_type(tr_type);
		this.setAdjDate(adjDate);
		this.setlv_ty(lv_ty);
		this.setoldtimeCode(oldtimeCode);
		this.setoldeventGroup(oldeventGroup);
		this.setdocNo(docNo);
		this.setdocType(docType);
		this.setupdateType(updateType);
		this.setWorkarea(workarea);
		this.setTimeWork(tz);
		this.setSalatype(salatype);
		this.setOT_type(ot_type);
		this.setOT_time0(ot_time0);
		this.setDocStatus(docStatus);
		//this.setAppStatus(appStatus);
		this.setActualDate(actual_date);
	}

	public TimeZone getTiming() {
		return this.timing;
	}

	public void setTiming(TimeZone z) {
		this.timing = z;
	}

	public String getType() {
		return this.type;
	}

	public void setType(String t) {
		this.type = t;
	}

	public String getEventGroup() {
		return this.eventGroup;
	}

	public void setEventGroup(String eg) {
		this.eventGroup = eg;
	}

	public String get_tr_type() {
		return this.tr_type;
	}

	public void set_tr_type(String t) {
		this.tr_type = t;
	}

	public String getTimeCode() {
		return this.timeCode;
	}

	public void setTimeCode(String t) {
		this.timeCode = t;
	}

	public CscCalendar get_DT_BG() {
		return this.getTiming().getBeginZone();
	}

	public CscCalendar get_DT_EN() {
		return this.getTiming().getEndZone();
	}

	public void set_DT_BG(CscCalendar d) {
		this.getTiming().setBeginZone(d);
	}

	public void set_DT_EN(CscCalendar d) {
		this.getTiming().setEndZone(d);
	}

	public CscCalendar getAdjDate() {
		return this.adjDate;
	}

	public void setAdjDate(CscCalendar d) {
		this.adjDate = d;
	}

	public String toString() {
		String s;
		s = this.getType() + " : " + this.adjDate.getDDMMYYYY() + " :> "
				+ this.getTimeCode() 
				+ "     -     " 
				+ this.getEventGroup()
				+ "     -     "
				+ this.getTiming().getBeginZone().getYYYYMMDDHHMMSS()
				+ "     -     "
				+ this.getTiming().getEndZone().getYYYYMMDDHHMMSS()
				+ "     -     "
				+ this.getType()
				+ "     -     "
				+ this.get_LV()
				+ "     -     "
				+ this.getWorkarea();
		return s;
	}

	public float get_LV() {		
		return this.get_DT_EN().subForHour(this.get_DT_BG());
	}	
	
	//Method set use in interface AdjustTime
	public void setoldtimeCode(String oldtimeCode){
		this.oldtimeCode = oldtimeCode;
	}
	public void setoldeventGroup(String oldeventGroup){
		this.oldeventGroup = oldeventGroup;		
	}
	public void setdocNo(String docNo){
		this.docNo = docNo;
	}
	public void setdocType(String docType){
		this.docType = docType;
	}
	public void setupdateType(String updateType){
		this.updateType = updateType;
	}
	public void setlv_ty(String lv_ty){
		this.lv_ty = lv_ty;
	}
	
	//Method implements interface AdjustTime
	public String getUpdateType() {
		return this.updateType;
	}
	public String getDocNo() {
		return this.docNo;
	}
	public String getDocType(){
		return this.docType;
	}
	public String getTime0(){
		return this.timeCode;
	}
	
	public String getOldTime0(){
		return this.oldtimeCode;
	}
	public String getOldEventGroup(){
		return this.oldeventGroup;
	}
	public String get_LV_TY(){
		return this.lv_ty;
	}
	
	public String get_TR_Type() {
		return this.tr_type;
	}
	
	public float get_TM_BG(){
		return this.timing.getBeginZone().getCSCTime();
	}
	public float get_TM_EN(){
		return this.timing.getEndZone().getCSCTime();
	}
	public String getString_TM_BG(){
		return String.valueOf(this.timing.getBeginZone().getCSCTime());
	}
	public String getString_TM_EN(){
		return String.valueOf(this.timing.getEndZone().getCSCTime());
	}
	
	public TimeZone getTimeBreak() {
		return this.timeBreak;
	}
	
	public void setTimeBreak(TimeZone tz) {
		this.timeBreak = tz;
	}
	
	public void setStatus(String str) {
		this.status = str;
	}
	
	public String getStatus(){
		return this.status;
	}
	
	public void setAdjustTemp(String tmp) {
		this.adjustTemp = tmp;
	}
	
	public String getAdjustTemp(){
		return this.adjustTemp;
	}
	

	public void setWorkarea(String workarea) {
		this.workarea = workarea;
	}
	
	public String getWorkarea() {
		return this.workarea;
	}
	
	public void setSalatype(String salatype) {
		this.salatype = salatype;
	}

	public String getSalatype() {
		return this.salatype;
	}
	
	public void setOT_type(String ot_type) {
		this.ot_type = ot_type;
	}

	public String getOT_type() {
		return this.ot_type;
	}
	
	public void setOT_time0(String ot_time0) {
		this.ot_time0 = ot_time0;
	}

	public String getOT_time0() {
		return this.ot_time0;
	}

	public CscCalendar getDocDate() {
		return this.adjDate;
	}
	
	public TimeZone getTimeWork() {
		return this.timeWork;
	}
	
	public void setTimeWork(TimeZone tz) {
		this.timeWork = tz;
	}
	
	public float getHour_s() {
		return this.hour_s;
	}
	
	public void setHour_s(float s) {
		this.hour_s = s;
	}
	
	public void setDocStatus(String docStatus) {
		this.docStatus = docStatus;
	}
	
	public String getDocStatus() {
		return this.docStatus;
	}

	public String getActualDate() {
		return actual_date;
	}

	public void setActualDate(String d) {
		actual_date = d ;
	}

	/*
	public void setAppStatus(String appStatus) {
		this.appStatus = appStatus;
	}
	
	public String getAppStatus() {
		return null;
	}*/
}