package com.csc.library.timeattendance;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import std.library.TimeSpan;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ManageAdjustLeave {
	
	private UProfile upf ;
	
	public ManageAdjustLeave(UProfile upf){
		this.upf = upf;
	}
	
	/* ֧š ҧشѾഷ ͹㹵ҧ Tadjtime0 */
	public Vector getAdjustLeaveData(WorkingShift ws,DbRecord empRec,DbRecord time0){
		return getAdjustLeaveData(ws,empRec,time0, "");
	}
	
	/* ֧š ҧشѾഷ ͹㹵ҧ Tadjtime0 */
	public Vector getAdjustLeaveData(WorkingShift ws,DbRecord empRec,DbRecord time0, String condition){
		Vector vUpdateData = new Vector();
		try {
			/* ҧἹͧѾഷѹ Vector */
			Vector vResultAll = new Vector();
			StringBuffer filter = new StringBuffer();
			filter.append("approve != 'W' and doctype = 'A' and employeeid = '").append(empRec.getString("employeeid"));
			filter.append("' and dateid between '").append(ws.getBeginDate().getYYYYMMDD());
			filter.append("' and '").append(ws.getEndDate().getYYYYMMDD()).append("'");
			
			if(condition.trim().length() > 0){ filter.append(" and ").append(condition); } /* ͹ */
			
			DbInquiry inqLeave = new InitialInquiry(this.upf).getDbInquiry("TLEAVE_SUMMARY");
			inqLeave.setColumn("*");
			inqLeave.setFilter(filter.toString());
			//inqLeave.setOrderBy("create_date,create_time");
			inqLeave.setOrderBy("dateid,lv_bg_date,lv_bg_time");
			inqLeave.refresh();
			
			while(inqLeave.next()){
				DbRecord leave = inqLeave.getCurrentDbRecord();
 				chkLeaveTime(ws,leave);	/* Ǩͺҷ çѺἹ÷ӧҹ */
				Vector vResult = getAdjustResult(ws,time0,leave);
				ws.adjustDocument(vResult, this.upf); /* ѴἹء ͧѺóͧ 1 ѹ ֧繵ͧѺἹʹ¹ŧ */
				//vResultAll.add(vResult);
			}
			
			/* ἹѾഷͧѹѹ vector  */
			for(int i = 0; i < vResultAll.size(); i++){
				Vector vData = (Vector)vResultAll.get(i);
				for(int j = 0; j < vData.size(); j++){
					vUpdateData.add((DbRecord)vData.get(j));
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return vUpdateData;
	}
	
	/* 
	 * Ǩͺҡ Ἱ÷ӧҹ ִ͹䢴ѧ 
	 * 1. Ңҷѹ ¹С÷ӧҹ ¹ҡҡѺἹͧѹ (ʹ)
	 * 2. Ҥѹ ( ͺ)¹С÷ӧҹ ¹ҡҡѺἹͧѹ ǧ÷ӧҹ  ͺ
	 * 3.  . ¹С÷ӧҹ ¹ ἹСûżš鹴
	 * */
	public void chkLeaveTime(WorkingShift ws,DbRecord leave){
		int FULLDAY = 0;
		int FIRSTHALF = 2;
		int SECONDHALF = 3;
		int HOUR = 1;
		try {
			CscCalendar st = leave.getCscCalendar("lv_bg_date");
			CscCalendar en = leave.getCscCalendar("lv_en_date");
			st.setCSCTime(leave.getFloat("lv_bg_time"));
			en.setCSCTime(leave.getFloat("lv_en_time"));
			
			//if(ws.containsKey(st.getYYYYMMDD())){
			String ackey = getActualDate(ws, leave);
			if(ws.containsKey(ackey)){
				DayShift ds = (DayShift) ws.get(ackey);
	            Iterator it_ds = (Iterator) ds.keySet().iterator();
	            if (it_ds.hasNext()) {
	            	Shift sh = (Shift) ds.get(it_ds.next());
	            	
	            	int format = getLeaveFormat(leave);
	            	if(format == FULLDAY){	/* ѹ */
	    				if(!sh.get_c_dt_in().equalsDateTime(st) && !sh.get_c_dt_out().equalsDateTime(en)){
	    					leave.set("lv_bg_date", sh.get_c_dt_in().getYYYYMMDD());
	    					leave.set("lv_en_date", sh.get_c_dt_out().getYYYYMMDD());
	    					leave.set("lv_bg_time", sh.get_c_dt_in().getCSCTime());
	    					leave.set("lv_en_time", sh.get_c_dt_out().getCSCTime());
	    					
	    					return ;
	    				}
	    			}else if(format ==  FIRSTHALF){	/* Ҥ */
	    				if(!sh.get_c_dt_in().equalsDateTime(st) && !sh.getMidDayStop().bg.equalsDateTime(en)){
	    					leave.set("lv_bg_date", sh.get_c_dt_in().getYYYYMMDD());
	    					leave.set("lv_en_date", sh.getMidDayStop().bg.getYYYYMMDD());
	    					leave.set("lv_bg_time", sh.get_c_dt_in().getCSCTime());
	    					leave.set("lv_en_time", sh.getMidDayStop().bg.getCSCTime());
	    					
	    					return ;
	    				}
	    			}else if(format ==  SECONDHALF){	/* Ҥ觺 */
	    				if(!sh.getMidDayStop().en.equalsDateTime(st) && !sh.get_c_dt_out().equalsDateTime(en)){
	    					leave.set("lv_bg_date", sh.getMidDayStop().en.getYYYYMMDD());
	    					leave.set("lv_en_date", sh.get_c_dt_out().getYYYYMMDD());
	    					leave.set("lv_bg_time", sh.getMidDayStop().en.getCSCTime());
	    					leave.set("lv_en_time", sh.get_c_dt_out().getCSCTime());
	    					
	    					return ;
	    				}
	    			}else if(format ==  HOUR){
	    				/* Ѻ੾͡÷Ҩҡ import (IM...)*/
	    				if(leave.getString("DOCID").startsWith("IM")){
	    					CscCalendar lst = new CscCalendar(leave.getString("LV_BG_DATE"));
	    					lst.setCSCTime(leave.getFloat("LV_BG_TIME"));
	    					CscCalendar est = new CscCalendar(leave.getString("LV_EN_DATE"));
	    					est.setCSCTime(leave.getFloat("LV_EN_TIME"));
	    					
	    					/* 㹪ǧҧҹ ѺҡѺἹ */
	    					//if(!(lst.afterEqualsDateTime(sh.get_c_dt_in()) && est.beforeEqualsDateTime(sh.get_c_dt_out()))){
	    						leave.set("lv_bg_date", sh.get_c_dt_in().getYYYYMMDD());
	    						leave.set("lv_bg_time", sh.get_c_dt_in().getCSCTime());
	    						
	    						CscCalendar een = new CscCalendar(sh.get_c_dt_in().getTime());
	    						een.incTime(leave.getFloat("m_lv"));
	    						
	    						leave.set("lv_en_date", een.getYYYYMMDD());
	    						leave.set("lv_en_time", een.getCSCTime());
	    					//}
	    				}
	    			}
	            }
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ѹ繡Шԧ ͧἹ */
	private String getActualDate(WorkingShift ws, DbRecord rec){
		CscCalendar stw = null;
		CscCalendar enw = null;
		CscCalendar acDate = null;
		try {
			acDate = rec.getCscCalendar("dateid");
			stw = rec.getCscCalendar("lv_bg_date");
			stw.setCSCTime(rec.getFloat("lv_bg_time"));
			enw = rec.getCscCalendar("lv_en_date");
			enw.setCSCTime(rec.getFloat("lv_en_time"));	
			
			/* ó 繡Тѹ 觤ѹ鹡Ѻ */
			if(enw.afterDate(stw)){
				return stw.getYYYYMMDD() ;
			}
			
			Iterator it = ws.keySet().iterator();
			while(it.hasNext()){
				DayShift ds = (DayShift) ws.get((String) it.next()) ;
				Iterator it1 = ds.keySet().iterator();
				//if(ds.getShiftDate().beforeDate(acDate)){
				//	continue;
				//}
				while(it1.hasNext()){
					Shift sh = (Shift) ds.get((String) it1.next());
					
					if(stw.afterEqualsDateTime(sh.get_c_dt_in()) && enw.beforeEqualsDateTime(sh.get_c_dt_out())){
						//return sh.getActualDate().get_c_dt_in().getYYYYMMDD();
						return (!sh.getActualDate().equals(""))?sh.getActualDate():sh.get_c_dt_in().getYYYYMMDD();
					}else if(sh.get_c_dt_in().afterEqualsDateTime(stw) && sh.get_c_dt_out().beforeEqualsDateTime(enw)){
						return sh.get_c_dt_in().getYYYYMMDD();
					}else if(stw.beforeDateTime(sh.get_c_dt_in()) && enw.afterEqualsDateTime(sh.get_c_dt_in()) && enw.beforeEqualsDateTime(sh.get_c_dt_out())){
						return sh.get_c_dt_in().getYYYYMMDD();
					}else if(stw.afterEqualsDateTime(sh.get_c_dt_in()) && stw.beforeEqualsDateTime(sh.get_c_dt_out()) && enw.afterDateTime(sh.get_c_dt_out())){
						return sh.get_c_dt_in().getYYYYMMDD();
					}
				}
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		
		/*   ѹ鹢ͧἹѺѺ */
		return stw.getYYYYMMDD();
	}
	
	/* һ (ѹ,  Ф觺)*/
	private int getLeaveFormat(DbRecord leave){
		int result = 99;
		try {
			DbRecord absent = new InitialRecord(this.upf).getDbRecord("TABSENT_NSTDA");
			absent.setColumn("absentid,companyid,leave_format");
			absent.set("absentid",leave.getString("docid"));
			absent.set("companyid",leave.getString("companyid"));
			if(absent.search()==1){
				result = absent.getInt("leave_format");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return result;
	}
	
	public Vector getAdjustResult(WorkingShift ws,DbRecord time0, DbRecord leaveProp){
		AdjustResult result = null;   
		Vector vAdjust = new Vector();	/* Ѿѧҡ gen  */
		Vector vResult = new Vector();	/* 纼Ѿ˹ DbRecord Tadjtime0 */
		
		try {
        	CscCalendar c = new CscCalendar(leaveProp.getString("lv_bg_date"));
        	
        	if (leaveProp.getString("m_lv").equals(leaveProp.getString("hour_s")) && leaveProp.getString("start_date").equals(leaveProp.getString("end_date"))) {//繡ѹ
        		TimeZone tz = new TimeZone();       
        		Iterator it = (Iterator) ws.keySet().iterator(); 
                if (it.hasNext()) {
                	if(ws.containsKey(c.getYYYYMMDD())){
	                	DayShift ds = (DayShift) ws.get(c.getYYYYMMDD());
	                    Iterator it_ds = (Iterator) ds.keySet().iterator();
	                    if (it_ds.hasNext()) {
	                    	Shift sh = (Shift) ds.get(it_ds.next());
	                    	tz.setTimeZone(sh.get_c_dt_in(), sh.get_c_dt_out()); //ѹ ͡ ŧ
	                    }
                	}
                }
                vAdjust = ws.genSubShiftTrans(tz);
        	} else {
        		vAdjust = ws.genSubShiftTrans(getDocTimeZoneTleave(leaveProp));
        	}
        	
        	/* For error checking */
        	if(vAdjust.size() == 0){
        		MyLog.error("!!! Process AdjustTime terminated here coz no data in vAdjust from genSubShiftTrans["+getDocTimeZoneTleave(leaveProp)+"]");
        	}
        	
        	Iterator it = vAdjust.iterator();    
        	
        	/* ǹٻ֧͡૵ŧ TADJTIME0 ŧ Vector */
        	while (it.hasNext()) {                   		              		
        	   result = (AdjustResult) it.next();
        	   
			   DbRecord recADJ = new InitialRecord(this.upf).getDbRecord("TadjTime0");
			   recADJ.set("COMPANYID", leaveProp.getString("companyid"));
			   recADJ.set("DOCID", leaveProp.getString("docid"));
			   recADJ.set("DOCTYPE", "A");
			   recADJ.set("APPROVE", leaveProp.getString("approve"));
			   recADJ.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
			   recADJ.set("TM_BG", result.get_DT_BG().getCSCTime());
			   recADJ.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
			   recADJ.set("TM_EN", result.get_DT_EN().getCSCTime());
			   recADJ.set("UPDTYPE", result.getType());
			   recADJ.set("DOCDATE", result.getAdjDate().getYYYYMMDD());
			   recADJ.set("EMPLOYEEID", leaveProp.getString("employeeid"));
			   recADJ.set("TIME0ID", result.getTimeCode());
			   recADJ.set("OLDTIME0ID", "");
			   recADJ.set("OLDEVENTGRP", "");
			   if (result.getType().equals("T")) {
				   recADJ.set("LV_TY", "T");
				   recADJ.set("EVENTGRP", "T");
			   } else {
				   recADJ.set("LV_TY", leaveProp.getString("lv_type"));
				   recADJ.set("EVENTGRP", leaveProp.getString("lv_type"));
			   }
			   recADJ.set("TR_TYPE", result.getEventGroup());
			   recADJ.set("STATUS", leaveProp.getString("status"));
			   recADJ.set("PRIORITY", "1");
			   recADJ.set("HOUR_S", time0.getString("hour_d"));
			   recADJ.set("WF_STATUS", leaveProp.getString("wf_status"));
			   recADJ.set("LV", this.getHourDAdjust(result.getTimeCode(), 
					   result.get_DT_BG().getYYYYMMDD(), 
					   result.get_DT_EN().getYYYYMMDD(), 
					   result.get_DT_BG().getCSCTime(), 
					   result.get_DT_EN().getCSCTime())); 
			   
			   recADJ.set("actual_date", result.getActualDate()); /* ͧѺóաТѹ Ҥѧ */
			   
			   vResult.add(recADJ);	
   		   }
        } catch (Exception e) {
        	MyLog.error(this,e);
        }
        return vResult;
	}
	
	/** ˹ҷѺ TimeZone */
    private TimeZone getDocTimeZone(DbRecord absent) {
    	TimeZone tz = new TimeZone();
    	try {
	        CscCalendar cs1 = new CscCalendar(absent.getString("start_date"));
	        CscCalendar cs2 = new CscCalendar(absent.getString("end_date"));
	        try {
	            cs1.setCSCTime(absent.getFloat("start_time"));
	            cs2.setCSCTime(absent.getFloat("end_time"));
	            if (cs2.getDDMMYYYY().equals(cs1.getDDMMYYYY()) && absent.getFloat("end_time")==0) {
	            	cs2.incDate();
	            }
	        } catch (Exception e) {
	            MyLog.error(this, e);            
	        }
	        tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
	        tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
	        MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
        return tz;
    }
    
	/** ˹ҷѺ TimeZone */
    private TimeZone getDocTimeZoneTleave(DbRecord tleave) {
    	TimeZone tz = new TimeZone();
    	try {
	        CscCalendar cs1 = new CscCalendar(tleave.getString("lv_bg_date"));
	        CscCalendar cs2 = new CscCalendar(tleave.getString("lv_en_date"));
	        try {
	            cs1.setCSCTime(tleave.getFloat("lv_bg_time"));
	            cs2.setCSCTime(tleave.getFloat("lv_en_time"));
	            if (cs2.getDDMMYYYY().equals(cs1.getDDMMYYYY()) && tleave.getFloat("lv_en_time")==0) {
	            	cs2.incDate();
	            }
	        } catch (Exception e) {
	            MyLog.error(this, e);            
	        }
	        tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
	        tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
	        MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
        return tz;
    }    
    
    /* ӹǳ .  */
    private float getHourDAdjust(String timeCode, String date1, String date2, float time1, float time2) {
        float hour = 0; 
        DbInquiry inqTime1 =  null;
        try {           
            float break_hour = 0f;
            float hour_s = 0f;
            
            CscCalendar cs1=null, cs2=null;
            CscCalendar cs = new CscCalendar(date1);
            String filter = "time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'";
            
            inqTime1 = new InitialInquiry(this.upf).getDbInquiry();
            inqTime1.initMyTable("Mtime1", filter, "");
            inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
            inqTime1.refresh();
            
            if (inqTime1.next()) {
                DbRecord rec = inqTime1.getCurrentDbRecord();                
                hour_s = rec.getFloat("hour_d");
                
                // Break Hour
                cs1 = new CscCalendar(date1);
                cs1.setCSCTime(rec.getFloat("timeout1"));
                if (rec.getFloat("timeout1")==0) {
                	cs1.incDate();
                }
                cs2 = new CscCalendar(date2);
                cs2.setCSCTime(rec.getFloat("timein2"));
                if ((rec.getFloat("timein2") < rec.getFloat("timeout1")) && date1.equals(date2)) {
                    cs2.incDate();
                }
                break_hour = cs2.subForHour(cs1);
                if (break_hour>24)
                	break_hour = break_hour-24;
                
                // Working Hour
                CscCalendar cs3 = new CscCalendar(date1);
                cs3.setCSCTime(rec.getFloat("timein1"));
                CscCalendar cs4 = new CscCalendar(date2);
                cs4.setCSCTime(rec.getFloat("timeout2"));
                if ((rec.getFloat("timeout2") < rec.getFloat("timein1")) && date1.equals(date2)) {
                    cs4.incDate();
                }
                
                TimeSpan ts = new TimeSpan();
                TimeSpan tsStDate = new TimeSpan();
                tsStDate.setSignSeperateOfDate("-");
                tsStDate.setSignSeperateOfTime(":");
                tsStDate.cnvrtToTimeSpan(cs3.getYYYYMMDD(), cs3.getHHMM());
                TimeSpan tsEndDate = new TimeSpan();
                tsEndDate.setSignSeperateOfDate("-");
                tsEndDate.setSignSeperateOfTime(":");
                tsEndDate.cnvrtToTimeSpan(cs4.getYYYYMMDD(), cs4.getHHMM());
                double hourLeave= ts.timeDiff(tsStDate, tsEndDate);
                
                if(!cs3.equalsDate(cs4)){
                	hour = (float) hourLeave;
                }else{
                	//ͧ
                	CscTime c = new CscTime(cs4.subForHour(cs3));
                    c.sub(break_hour);
                    hour = c.getFloat(); 
                }                     
            }
            
            CscCalendar c_dt_in = new CscCalendar(date1);
            c_dt_in.setCSCTime(time1);
            CscCalendar c_dt_out = new CscCalendar(date2);
            c_dt_out.setCSCTime(time2);
            float hourCom = c_dt_out.subForHour(c_dt_in);
            
            if (cs1!=null&&cs2!=null) {
                if (cs1.afterEquals(c_dt_in)&&cs2.beforeEquals(c_dt_out)) {
                    CscTime c = new CscTime(hourCom);
                    if (break_hour>0) {
                    	c.sub(break_hour);
                    }                    
                    hourCom = c.getFloat();
                }
            }       
            
            if (hourCom<hour) {
                hour=hourCom;
            }
            
        } catch (Exception e) {
            MyLog.error(this, e);
        }finally{
        	inqTime1.closeConnection();
        	
            return hour;
        }
    }
}
