package com.csc.library.timeattendance;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import std.library.TimeSpan;

import com.csc.library.database.CscConnection;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Mtime2;
import com.csc.library.databean.Tadjtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

public class ManageAdjustOT {
	
	private UProfile upf ;
	
	/* ҧἹͧѾഷѹ Vector */
	Vector vResultAll = new Vector();
	
	public ManageAdjustOT(UProfile upf){
		this.upf = upf;
	}
	
	/* ֧šâͷ ҧشѾഷ ͹㹵ҧ Tadjtime0 */
	@SuppressWarnings("deprecation")
	public Vector getAdjustOTData(WorkingShift ws,DbRecord empRec,DbRecord time0){
		Vector vUpdateData = new Vector();
		try {
			WorkingShift wstmp = new WorkingShift();
			wstmp =	ws.cloneWorkingShift();	/* clone workingshift ͵ͧѹش͡ ͹йҧͷ зѺ ws ѡżŵ */
			wstmp.removeStopShift();
			
			getAdjTOT(wstmp,empRec,time0,vResultAll);
			getAdjTOT1(wstmp,empRec,time0,vResultAll);
			getAdjTOT_M_DATE1(wstmp,empRec,time0,vResultAll);
			//getAdjTOT_M_PAYMENT1(wstmp,empRec,time0,vResultAll);
			
			Map<MyTimeZone,DbRecord> tm = new HashMap<MyTimeZone,DbRecord>();
			List<MyTimeZone> listRemove = new Vector<MyTimeZone>();
			/* ἹѾഷͧѹѹ vector  */
			for(int i = 0; i < vResultAll.size(); i++){
				Vector vData = (Vector)vResultAll.get(i);
				for(int j = 0; j < vData.size(); j++){
					DbRecord rec =(DbRecord)vData.get(j);
					CscCalendar bg = new CscCalendar();
					bg.setCscCalendar(rec.getString("DT_BG"));
					bg.setCSCTime(rec.getFloat("TM_BG"));
					
					CscCalendar en = new CscCalendar();
					en.setCscCalendar(rec.getString("DT_EN"));
					en.setCSCTime(rec.getFloat("TM_EN"));
					
					MyTimeZone newTz = new MyTimeZone(bg , en);
					boolean isPut = true;
					
					for(MyTimeZone tz : tm.keySet()){
						if( listRemove.contains(tz) ){
							continue;
						}
						boolean bgin = tz.inZone(newTz.getBeginZone()) , enin = tz.inZone(newTz.getEndZone());
						if(newTz.getBeginZone().beforeEqualsDateTime(tz.getBeginZone()) && newTz.getEndZone().afterEqualsDateTime(tz.getEndZone())){
							listRemove.add(tz);
						}else if( bgin || enin ){
							if( bgin && enin ){
								isPut = false;
								break;
							}else{
								if( bgin ){
									rec.set("DT_BG", tz.getEndZone().getYYYYMMDD());
									rec.set("TM_BG", tz.getEndZone().getCSCTime());
									newTz.getBeginZone().setCscCalendar(tz.getEndZone().getYYYYMMDD());
									newTz.getBeginZone().setCSCTime(tz.getEndZone().getCSCTime());
								}else{
									rec.set("DT_EN", tz.getBeginZone().getYYYYMMDD());
									rec.set("TM_EN", tz.getBeginZone().getCSCTime());
									newTz.getEndZone().setCscCalendar(tz.getBeginZone().getYYYYMMDD());
									newTz.getEndZone().setCSCTime(tz.getBeginZone().getCSCTime());
								}
								isPut = true;
							}
						}else {
							isPut = true;
						}
					}
					for(MyTimeZone tz : listRemove){
						tm.remove(tz);
					}
					listRemove.clear();
					if( isPut ){
						tm.put(newTz, rec);
					}
				}
			}

			/* sort by dateid */
			List<String> list = new ArrayList<String>();
			HashMap keyhm = new HashMap();
			for(MyTimeZone tz : tm.keySet()){
				Tadjtime0 tad = (Tadjtime0) tm.get(tz);
				String tzkey = tz.getBeginZone().getYYYYMMDDHHMMSS()+"#"+tz.getEndZone().getYYYYMMDDHHMMSS();
				keyhm.put(tzkey, tad);
		        list.add(tzkey);
			}
			
			Collections.sort(list);
			
			for(int i=0; i < list.size(); i++){
				//System.out.print("ot timezone ---> " + list.get(i));
				vUpdateData.add((Tadjtime0)keyhm.get(list.get(i)));
			}

		}catch(Exception e){
			MyLog.error(this,e);
		}
		return vUpdateData;
	}
	
	/* ҧ¡Ѿഷҡҧ TOT */
	private void getAdjTOT(WorkingShift ws,DbRecord empRec,DbRecord time0,Vector vResultAll){
		try {
			DbInquiry inqOT = new InitialInquiry(this.upf).getDbInquiry("TOT");
			inqOT.setColumn("*");
			inqOT.setFilter("employeeid = '"+empRec.getString("employeeid")+"' and start_date between '"+ws.getBeginDate().getYYYYMMDD()+"' and '"+ws.getEndDate().getYYYYMMDD()+"'");
			inqOT.setOrderBy("start_date");
			inqOT.refresh();
			
			while(inqOT.next()){
				Vector vResult = getAdjustResult(ws,time0,inqOT.getCurrentDbRecord(),"B");
				vResultAll.add(vResult);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ҧ¡Ѿഷҡҧ TOT1 */
	private void getAdjTOT1(WorkingShift ws,DbRecord empRec,DbRecord time0,Vector vResultAll){
		try {
			DbInquiry inqOT = new InitialInquiry(this.upf).getDbInquiry("TOT1");
			inqOT.setColumn("*");
			inqOT.setFilter("employeeid = '"+empRec.getString("employeeid")+"' and start_date between '"+ws.getBeginDate().getYYYYMMDD()+"' and '"+ws.getEndDate().getYYYYMMDD()+"'");
			inqOT.refresh();
			
			while(inqOT.next()){
				Vector vResult = getAdjustResult(ws,time0,inqOT.getCurrentDbRecord(),"O");
				vResultAll.add(vResult);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ҧ¡Ѿഷҡҧ TOT1 */
	private void getAdjTOT_M_DATE1(WorkingShift ws,DbRecord empRec,DbRecord time0,Vector vResultAll){
    	CscConnection conn = null;
   	   	Statement stmt = null;
        ResultSet rs = null;
        
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("select m0.OTID,m0.EMPLOYEEID,m1.START_DATE,m1.START_TIME,m1.END_DATE,m1.END_TIME,m1.OT_CAUSE,m1.OT_SALATYPE,m1.OT_TIME0");
			sql.append(" ,m1.OT_TYPE,m1.OT_WORKAREA,m1.SALATYPE,m1.WF_STATUS,m1.WF_REF_DOC,m1.total_time,m1.bu1,m1.bu2,m1.bu3,m1.bu4,m1.bu5,m1.branch");
			sql.append(" ,m1.emp_group,m1.emp_position,m1.workarea");
			sql.append(" from TOT_M_DATE0 m0 left join TOT_M_DATE1 m1 on m0.OTID = m1.OTID");
			sql.append(" where m0.employeeid = '").append(empRec.getString("employeeid")).append("'");
			sql.append(" and m1.start_date between '").append(ws.getBeginDate().getYYYYMMDD()).append("' and '").append(ws.getEndDate().getYYYYMMDD()).append("'");
			sql.append(" order by m1.start_date, m1.start_time");
			
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql.toString());
			
			while(rs.next()){
				DbRecord db = new InitialRecord(this.upf).getDbRecord("TOT1");
				db.set("otid", rs.getString("otid"));
				db.set("employeeid", rs.getString("employeeid"));
				db.set("start_date", rs.getString("start_date"));
				db.set("start_time", rs.getString("start_time"));
				db.set("end_date", rs.getString("end_date"));
				db.set("end_time", rs.getString("end_time"));
				db.set("total_time", rs.getString("total_time"));
				db.set("bu1", rs.getString("bu1"));
				db.set("bu2", rs.getString("bu2"));
				db.set("bu3", rs.getString("bu3"));
				db.set("bu4", rs.getString("bu4"));
				db.set("bu5", rs.getString("bu5"));
				db.set("branch", rs.getString("branch"));
				db.set("emp_group", rs.getString("emp_group"));
				db.set("emp_position", rs.getString("emp_position"));
				db.set("workarea", rs.getString("workarea"));
				db.set("salatype", rs.getString("salatype"));
				db.set("wf_status", rs.getString("wf_status"));
				db.set("wf_ref_doc", rs.getString("wf_ref_doc"));
				db.set("ot_cause", rs.getString("ot_cause"));
				db.set("ot_salatype", rs.getString("ot_salatype"));
				db.set("ot_time0", rs.getString("ot_time0"));
				
				Vector vResult = getAdjustResult(ws,time0,db,"OM");
				//System.out.print(" docdate --> " + ((DbRecord)vResult.get(0)).getString("dt_bg") + ":" + ((DbRecord)vResult.get(0)).getString("tm_bg"));
				vResultAll.add(vResult);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				if(rs!=null){rs.close();}
				if(stmt!=null){ stmt.close(); }
				if(conn!=null){conn.close();}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	
	/* ҧ¡Ѿഷҡҧ TOT1 */
	private void getAdjTOT_M_PAYMENT1(WorkingShift ws,DbRecord empRec,DbRecord time0,Vector vResultAll){
    	CscConnection conn = null;
   	   	Statement stmt = null;
        ResultSet rs = null;
        
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("select m0.otmpaymentid,m0.EMPLOYEEID,m1.START_DATE,m1.START_TIME,m1.END_DATE,m1.END_TIME,m1.OT_CAUSE,m1.OT_TIME0");
			sql.append(" ,m1.WF_STATUS,m1.WF_REF_DOC,m1.work_time,m1.bu1,m1.bu2,m1.bu3,m1.bu4,m1.bu5,m1.branch");
			sql.append(" ,m1.emp_group,m1.emp_position");
			sql.append(" from TOT_MPAYMENT0 m0 left join TOT_MPAYMENT1 m1 on m0.otmpaymentid = m1.otmpaymentid");
			sql.append(" where m0.employeeid = '").append(empRec.getString("employeeid")).append("'");
			sql.append(" and m1.start_date between '").append(ws.getBeginDate().getYYYYMMDD()).append("' and '").append(ws.getEndDate().getYYYYMMDD()).append("'");
			sql.append(" order by start_date, start_time");
			
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql.toString());
			
			while(rs.next()){
				DbRecord db = new InitialRecord(this.upf).getDbRecord("TOT1");
				db.set("otid", rs.getString("otmpaymentid"));
				db.set("employeeid", rs.getString("employeeid"));
				db.set("start_date", rs.getString("start_date"));
				db.set("start_time", rs.getString("start_time"));
				db.set("end_date", rs.getString("end_date"));
				db.set("end_time", rs.getString("end_time"));
				db.set("total_time", rs.getString("work_time"));
				db.set("bu1", rs.getString("bu1"));
				db.set("bu2", rs.getString("bu2"));
				db.set("bu3", rs.getString("bu3"));
				db.set("bu4", rs.getString("bu4"));
				db.set("bu5", rs.getString("bu5"));
				db.set("branch", rs.getString("branch"));
				db.set("emp_group", rs.getString("emp_group"));
				db.set("emp_position", rs.getString("emp_position"));
				db.set("workarea", "");
				db.set("salatype", "");
				db.set("wf_status", rs.getString("wf_status"));
				db.set("wf_ref_doc", rs.getString("wf_ref_doc"));
				db.set("ot_cause", rs.getString("ot_cause"));
				db.set("ot_salatype", "");
				db.set("ot_time0", rs.getString("ot_time0"));
				
				Vector vResult = getAdjustResult(ws,time0,db,"OM");
				vResultAll.add(vResult);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try {
				if(rs!=null){rs.close();}
				if(stmt!=null){ stmt.close(); }
				if(conn!=null){conn.close();}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	
	public Vector getAdjustResult(WorkingShift ws,DbRecord time0, DbRecord otProp,String docType){
		AdjustResult result = null;   
		Vector vAdjust = new Vector();	/* Ѿѧҡ gen  */
		Vector vResult = new Vector();	/* 纼Ѿ˹ DbRecord Tadjtime0 */
		
		try {
        	CscCalendar c = new CscCalendar(otProp.getString("start_date"));
        	
        	if (ws.chkAddShiftTrans(this.getDocTimeZone(otProp))) {
				MyLog.debug(this, "TIME NOT MATCH IN SHIFT !!!");
			} else {
				vAdjust = ws.genAddShiftTrans(this.getDocTimeZone(otProp));
			}
        	
        	/* For error checking */
        	if(vAdjust.size() == 0){
        		MyLog.error("!!! Process AdjustTime terminated here coz no data in vAdjust from genSubShiftTrans["+getDocTimeZoneTleave(otProp)+"]");
        	}
        	
        	Iterator it = vAdjust.iterator();    
        	
        	/* ǹٻ֧͡૵ŧ TADJTIME0 ŧ Vector */
        	while (it.hasNext()) {                   		              		
        		result = (AdjustResult) it.next();
        	   
        		DbRecord recADJ = new InitialRecord(this.upf).getDbRecord("TadjTime0");
        	   	recADJ.set("DOCID", otProp.getString("otid"));
				recADJ.set("DOCTYPE", docType);
				recADJ.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
				recADJ.set("TM_BG", result.get_DT_BG().getCSCTime());
				recADJ.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
				recADJ.set("TM_EN", result.get_DT_EN().getCSCTime());
				recADJ.set("UPDTYPE", result.getType());
				recADJ.set("DOCDATE", result.getAdjDate().getYYYYMMDD());
				recADJ.set("EMPLOYEEID", otProp.getString("employeeid"));
				recADJ.set("TIME0ID", (result.getTimeCode().trim().length()==0)?getActualTime0(time0,result.get_DT_BG()):result.getTimeCode());
				recADJ.set("EVENTGRP", "O");
				recADJ.set("OLDTIME0ID", "");
				recADJ.set("OLDEVENTGRP", "");
				recADJ.set("LV_TY", "");
				recADJ.set("LV", result.get_LV());
				recADJ.set("TR_TYPE", result.getEventGroup());
				recADJ.set("ADJUSTTEMP", "");
				recADJ.set("STATUS", otProp.getString("status"));	
				recADJ.set("PRIORITY", "2");	
				recADJ.set("OT_WORKAREA", otProp.getString("ot_workarea"));
				recADJ.set("OT_SALATYPE", otProp.getString("ot_salatype"));
				recADJ.set("OT_TYPE", otProp.getString("ot_type"));
				recADJ.set("OT_TIME0", otProp.getString("ot_time0"));
				
				vResult.add(recADJ);	
   		   }
        } catch (Exception e) {
        	MyLog.error(this,e);
        }
        return vResult;
	}
	
	/** ˹ҷѺ TimeZone */
    private TimeZone getDocTimeZone(DbRecord doc) {
    	TimeZone tz = new TimeZone();
    	try {
	        CscCalendar cs1 = new CscCalendar(doc.getString("start_date"));
	        CscCalendar cs2 = new CscCalendar(doc.getString("end_date"));
	        try {
	            cs1.setCSCTime(doc.getFloat("start_time"));
	            cs2.setCSCTime(doc.getFloat("end_time"));
	            if (cs2.getDDMMYYYY().equals(cs1.getDDMMYYYY()) && doc.getFloat("end_time")==0) {
	            	cs2.incDate();
	            }
	        } catch (Exception e) {
	            MyLog.error(this, e);            
	        }
	        tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
	        tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
	        MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
        return tz;
    }
    
	/** ˹ҷѺ TimeZone */
    private TimeZone getDocTimeZoneTleave(DbRecord tleave) {
    	TimeZone tz = new TimeZone();
    	try {
	        CscCalendar cs1 = new CscCalendar(tleave.getString("lv_bg_date"));
	        CscCalendar cs2 = new CscCalendar(tleave.getString("lv_en_date"));
	        try {
	            cs1.setCSCTime(tleave.getFloat("lv_bg_time"));
	            cs2.setCSCTime(tleave.getFloat("lv_en_time"));
	            if (cs2.getDDMMYYYY().equals(cs1.getDDMMYYYY()) && tleave.getFloat("lv_en_time")==0) {
	            	cs2.incDate();
	            }
	        } catch (Exception e) {
	            MyLog.error(this, e);            
	        }
	        tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
	        tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
	        MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
        return tz;
    }    
    
    /* ӹǳ .  */
    private float getHourDAdjust(String timeCode, String date1, String date2, float time1, float time2) {
        float hour = 0; 
        DbInquiry inqTime1 =  null;
        try {           
            float break_hour = 0f;
            float hour_s = 0f;
            
            CscCalendar cs1=null, cs2=null;
            CscCalendar cs = new CscCalendar(date1);
            String filter = "time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'";
            
            inqTime1 = new InitialInquiry(this.upf).getDbInquiry();
            inqTime1.initMyTable("Mtime1", filter, "");
            inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
            inqTime1.refresh();
            
            if (inqTime1.next()) {
                DbRecord rec = inqTime1.getCurrentDbRecord();                
                hour_s = rec.getFloat("hour_d");
                
                // Break Hour
                cs1 = new CscCalendar(date1);
                cs1.setCSCTime(rec.getFloat("timeout1"));
                if (rec.getFloat("timeout1")==0) {
                	cs1.incDate();
                }
                cs2 = new CscCalendar(date2);
                cs2.setCSCTime(rec.getFloat("timein2"));
                if ((rec.getFloat("timein2") < rec.getFloat("timeout1")) && date1.equals(date2)) {
                    cs2.incDate();
                }
                break_hour = cs2.subForHour(cs1);
                if (break_hour>24)
                	break_hour = break_hour-24;
                
                // Working Hour
                CscCalendar cs3 = new CscCalendar(date1);
                cs3.setCSCTime(rec.getFloat("timein1"));
                CscCalendar cs4 = new CscCalendar(date2);
                cs4.setCSCTime(rec.getFloat("timeout2"));
                if ((rec.getFloat("timeout2") < rec.getFloat("timein1")) && date1.equals(date2)) {
                    cs4.incDate();
                }
                
                TimeSpan ts = new TimeSpan();
                TimeSpan tsStDate = new TimeSpan();
                tsStDate.setSignSeperateOfDate("-");
                tsStDate.setSignSeperateOfTime(":");
                tsStDate.cnvrtToTimeSpan(cs3.getYYYYMMDD(), cs3.getHHMM());
                TimeSpan tsEndDate = new TimeSpan();
                tsEndDate.setSignSeperateOfDate("-");
                tsEndDate.setSignSeperateOfTime(":");
                tsEndDate.cnvrtToTimeSpan(cs4.getYYYYMMDD(), cs4.getHHMM());
                double hourLeave= ts.timeDiff(tsStDate, tsEndDate);
                
                if(!cs3.equalsDate(cs4)){
                	hour = (float) hourLeave;
                }else{
                	//ͧ
                	CscTime c = new CscTime(cs4.subForHour(cs3));
                    c.sub(break_hour);
                    hour = c.getFloat(); 
                }                     
            }
            
            CscCalendar c_dt_in = new CscCalendar(date1);
            c_dt_in.setCSCTime(time1);
            CscCalendar c_dt_out = new CscCalendar(date2);
            c_dt_out.setCSCTime(time2);
            float hourCom = c_dt_out.subForHour(c_dt_in);
            
            if (cs1!=null&&cs2!=null) {
                if (cs1.afterEquals(c_dt_in)&&cs2.beforeEquals(c_dt_out)) {
                    CscTime c = new CscTime(hourCom);
                    if (break_hour>0) {
                    	c.sub(break_hour);
                    }                    
                    hourCom = c.getFloat();
                }
            }       
            
            if (hourCom<hour) {
                hour=hourCom;
            }
            
        } catch (Exception e) {
            MyLog.error(this, e);
        }finally{
        	inqTime1.closeConnection();
        	
            return hour;
        }
    }
    
    /* ҡТͧѹ   */
    private String getActualTime0(DbRecord mtime0, CscCalendar cs){
    	try {
    		if(mtime0.getString("status").equals("1")){
    			DbRecord mtime2 = new InitialRecord(this.upf).getDbRecord("MTIME2");
    			mtime2.setColumn("*");
    			mtime2.set("time0id", mtime0.getString("time0id"));
    			mtime2.set("yearid", cs.getYear());
    			mtime2.set("monthid", cs.getMM());
    			if(mtime2.search() == 1){
    				return ((Mtime2)mtime2).getActualTime0(cs);
    			}
    		}else{
    			return mtime0.getString("time0id");
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return "";
    }
}

