package com.csc.library.timeattendance;

import com.csc.library.timeinterface.AdjustTime;
import com.csc.library.timeinterface.SwipeTrans;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;
import com.csc.library.database.StaticConfig;
import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.Vector;
import com.csc.library.utilities.CscTime;
/*
 * Finding Working in Holiday ӧҹ͡СѹѺҶ١ ӹǳ ¢Ҵ OT
 * ŧ Error  XML  save ŧ timecurrent  save èͧŧ
 * timetemp 駡ô֧Ŵ
 */
public class WorkingShift extends MyTreeMap {

	private CscCalendar begDate, endDate;
	SwipeTrans swipeData;
	private String errorMsg;
	private UProfile up;
	private HashMap hmTime = new HashMap();
	private Shift firstShift, lastShift;
	private HashMap ShiftList = new HashMap();
	private String shiftCode;
	private HashMap shiftProperty;
	private String employeeid;
	private CscCalendar sDate = null, eDate = null;
	private String empTimeCode = "";
	private DbRecord empRec = null;
	
	private Vector vcShiftPlan = new Vector();
	private HashMap shiftPropList = new HashMap(); /* ´ mtime0 ء¡÷١¡ */
	
	public WorkingShift() {
	}
	
	public void setEmprec(DbRecord rec){
		this.empRec = rec ;
	}
	
	public void setShiftCode(String sc) {
		this.shiftCode = sc;
	}

	public String getShiftCode() {
		return this.shiftCode;
	}

	public void setShiftProperty(HashMap h) {
		this.shiftProperty = h;
		this.shiftPropList.put((String) h.get("TIME0ID"), this.shiftProperty); /* ѹ HashMap */		
	}

	public HashMap getShiftProperty() {
		return this.shiftProperty;
	}
	
	public HashMap getShiftProperty(String time0id){
		HashMap shp = new HashMap();
		try {
			if(shiftPropList.containsKey(time0id)){
				return (HashMap) shiftPropList.get(time0id);
			}else{
				Mtime0 mt0 = (Mtime0) new InitialRecord(this.up).getDbRecord("Mtime0");
				mt0.setColumn("*");
				mt0.set("time0id", time0id);
				mt0.set("companyid", this.up.getCompanyid());
				 
				if(mt0.search() == 1){
					shp = mt0.getHashMap();
					shiftPropList.put(time0id, shp);
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return shp ;
	}

	public void setUProfile(UProfile up) {
		this.up = up;
	}

	public UProfile getUProfile() {
		return this.up;
	}
	
	public void setEmployeeid(String employeeid) {
		this.employeeid = employeeid;
	}

	public String getEmployeeid() {
		return this.employeeid;
	}
	
	public void setEmpTimeCode(String timeCode) {
		this.empTimeCode = timeCode;
	}

	public String getEmpTimeCode() {
		return this.empTimeCode;
	}

	public void setBegDate(CscCalendar begDate) {
		this.begDate = begDate;
		this.sDate = begDate;
	}

	public void setEndDate(CscCalendar endDate) {
		this.endDate = endDate;
		this.eDate = endDate;	
	}

	public void setWorkingShiftDate(CscCalendar begDate, CscCalendar endDate) {
		this.begDate = begDate;
		this.endDate = endDate;
		this.sDate = begDate;
		this.eDate = endDate;		
	}

	public void setWorkingShiftDate(CscCalendar date) {
		this.begDate = date;
		this.endDate = date;
		this.sDate = date;
		this.eDate = date;		
	}
	
	public void setSDate(CscCalendar sDate) {
		this.sDate = sDate;
	}
	
	public void setEDate(CscCalendar eDate) {
		this.eDate = eDate;
	}
	
	public void setSEDate(CscCalendar sDate, CscCalendar eDate) {
		this.sDate = sDate;
		this.eDate = eDate;
	}
	
	public CscCalendar getBeginDate(){
		return this.begDate;
	}
	
	public CscCalendar getEndDate(){
		return this.endDate;
	}

	private DbInquiry initTable(String table, String filter) {
		DbInquiry inqAdj = null;
		try {
			inqAdj = new InitialInquiry(this.up).getDbInquiry();
			inqAdj.setSchemaName(this.up.getSchemaName());
			inqAdj.initMyTable(table, "", "runno");
			inqAdj.setColumn("*");
			inqAdj.setFilter(filter);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return inqAdj;
	}
	
	/* ѺἹѺ繡 DbRecord ͧ Tadjtime0 */
	private HashMap getAdjustData(Vector vadjust) {
		HashMap hmADJ = new HashMap();
		try {
			MyTreeMap hmDetail = new MyTreeMap();
			int i=1,j=1;
			String tmp="";
			DbRecord rec = null ;
			String actualdate = "";
			for (int ii = 0; ii < vadjust.size(); ii++) {
				rec = (DbRecord) vadjust.get(ii);
				//actualdate = getActualDate(rec);
				actualdate = (rec.getString("ACTUAL_DATE").equals(""))?getActualDate(rec):rec.getString("ACTUAL_DATE");
				if (i==1) {
					tmp = actualdate;
				} else {
					if (!tmp.equals(actualdate)) {
						CscCalendar csc = new CscCalendar(tmp);
						hmADJ.put(csc.getYYYYMMDD(), hmDetail);
						hmDetail = new MyTreeMap();
						j=1;
					}
				}

				hmDetail.put(j+"", rec.cloneRecord(true));
				i++;
				j++;
				tmp = actualdate;
			}
			
			if(rec != null) {
				//CscCalendar csc = new CscCalendar(getActualDate(rec));
				String acdate = (rec.getString("ACTUAL_DATE").equals(""))?getActualDate(rec):rec.getString("ACTUAL_DATE");
				CscCalendar csc = new CscCalendar(acdate);
				if( hmADJ.containsKey(csc.getYYYYMMDD()) ){
					MyTreeMap oldTreemap = (MyTreeMap)hmADJ.get(csc.getYYYYMMDD());
					Iterator it = hmDetail.keySet().iterator();
					while(it.hasNext()){
						String key = it.next().toString();
						oldTreemap.put( Integer.toString(oldTreemap.size()+1) , (DbRecord)hmDetail.get(key) );
					}
					
				}else{
					hmADJ.put(csc.getYYYYMMDD(), hmDetail);
				}
				
			}else{
				MyLog.error("!! No data to be adjust in getAdjustData(Vector vadjust) !!");
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hmADJ;
	}
	
	/* ѹ繡Шԧ ͧἹ */
	private String getActualDate(DbRecord rec){
		CscCalendar stw = null;
		CscCalendar enw = null;
		CscCalendar acDate = null;
		try {
			if(rec.getTableName().equals("tadjtime0")){
				acDate = rec.getCscCalendar("docdate");
			}else{
				acDate = rec.getCscCalendar("dateid");
			}
			
			stw = rec.getCscCalendar("dt_bg");
			stw.setCSCTime(rec.getFloat("tm_bg"));
			enw = rec.getCscCalendar("dt_en");
			enw.setCSCTime(rec.getFloat("tm_en"));
			
			Iterator it = this.keySet().iterator();
			while(it.hasNext()){
				DayShift ds = (DayShift) this.get((String) it.next()) ;
				Iterator it1 = ds.keySet().iterator();
				//if(ds.getShiftDate().beforeDate(acDate)){
				//	continue;
				//}
				while(it1.hasNext()){
					Shift sh = (Shift) ds.get((String) it1.next());
					
					if(stw.afterEqualsDateTime(sh.get_c_dt_in()) && enw.beforeEqualsDateTime(sh.get_c_dt_out())){
						return sh.get_c_dt_in().getYYYYMMDD();
					}else if(sh.get_c_dt_in().afterEqualsDateTime(stw) && sh.get_c_dt_out().beforeEqualsDateTime(enw)){
						return sh.get_c_dt_in().getYYYYMMDD();
					}else if(stw.beforeDateTime(sh.get_c_dt_in()) && enw.afterEqualsDateTime(sh.get_c_dt_in()) && enw.beforeEqualsDateTime(sh.get_c_dt_out())){
						return sh.get_c_dt_in().getYYYYMMDD();
					}else if(stw.afterEqualsDateTime(sh.get_c_dt_in()) && stw.beforeEqualsDateTime(sh.get_c_dt_out()) && enw.afterDateTime(sh.get_c_dt_out())){
						return sh.get_c_dt_in().getYYYYMMDD();
					}
				}
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		
		/*   ѹ鹢ͧἹѺѺ */
		return stw.getYYYYMMDD();
	}
	
	/*
	 * ӡӡûѺاҡ÷ӧҹ
	 * ҡûѺاͷǢͧ
	 */
	public void adjustLeave() {
		this.adjust("(doctype<>'B' and doctype<>'O' and doctype<>'OM')");		
	}
	
	/*
	 * ӡô֧Ũҡ tadjtime0 ŧ HashMap ͹㹡
	 * Ѻاҡ÷ӧҹ 
	 */
	private HashMap getAdjustData(String condition) {
		HashMap hmADJ = new HashMap(); 
		try {
			StringBuffer filter = new StringBuffer(); 
			filter.append("(docdate between '").append(this.begDate.decDate().getYYYYMMDD()).append("' and '").append(this.endDate.incDate().getYYYYMMDD()).append("') ");
			filter.append("and employeeid='").append(this.empRec.getString("employeeid")).append("'");
			
			if (!condition.equals("") || condition.trim().length() > 0 ) filter.append(" and ").append(condition) ; 
			
			MyTreeMap hmDetail = new MyTreeMap();
			int i=1,j=1;
			String tmp="";
			DbInquiry inq = this.initTable("Tadjtime0",	filter.toString());
			inq.setColumn("*");
			inq.setOrderBy("docdate, runno");
			inq.refresh();
			while (inq.next()) {
				if (i==1) {
					tmp = inq.getString("docdate");
				} else {
					if (!tmp.equals(inq.getString("docdate"))) {
						CscCalendar csc = new CscCalendar(tmp);
						hmADJ.put(csc.getYYYYMMDD(), hmDetail);
						hmDetail = new MyTreeMap();
						j=1;
					}
				}

				hmDetail.put(j+"", (DbRecord) inq.getCurrentDbRecord().cloneRecord(true));
				i++;
				j++;
				tmp = inq.getString("docdate");
			}
			CscCalendar csc = new CscCalendar(inq.getString("docdate"));
			hmADJ.put(csc.getYYYYMMDD(), hmDetail);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hmADJ;
	}

	/*
	 * Ѻاҡ÷ӧҹ ҹҨҡ tadjtime0
	 */
	public void adjust(String condition) {
		HashMap hmADJ = this.getAdjustData(condition);
		
		CscCalendar buffDate = new CscCalendar(this.begDate.getTimestamp());
		DayShift day;
		do {
			if (this.containsKey(buffDate.getYYYYMMDD())) {
				try {
					day = (DayShift) this.get(buffDate.getYYYYMMDD());
					day.setUprofile(this.up);
					if (hmADJ.containsKey(buffDate.getYYYYMMDD())) {
						MyTreeMap tr = (MyTreeMap) hmADJ.get(buffDate.getYYYYMMDD()); 
						Iterator it = tr.keySet().iterator();
						while (it.hasNext()) {
							AdjustTime at = (AdjustTime) tr.get(it.next());
							if (this.sDate!=null && this.eDate!=null) {
								if (this.sDate.getCSCTime()!=0.0 && this.eDate.getCSCTime()!=0.0) {
									if (at.get_DT_BG().after(this.sDate) && at.get_DT_EN().before(this.eDate)) {
										day.adjust(at);
									}
								} else {
									day.adjust(at);
								}
							} else day.adjust(at);							
						}
					}
				} catch (Exception e) {
					MyLog.error(this, e);					
				}
			}
			buffDate.incDate();
		} while (!buffDate.afterDate(this.endDate));	
	}
	
	/* ûѺاἹ д֧੾Тŷ¹ šҹ */
	public void adjust() {
		this.adjust("DOCTYPE IN ('C','E','CH','D','CB')");
	}
	
	public void adjust(AdjustResult aj) {		
		DayShift day = (DayShift) this.get(aj.getAdjDate().getYYYYMMDD());
		AdjustTime at = (AdjustTime) aj;
		day.adjust(at);
	}

	/*
	 * ӡá˹šŧѺ÷ӧҹѹ
	 */
	public void setSwipeTrans(SwipeTrans trans) {
		this.swipeData = trans;
		String key;
		DayShift ds;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next();
			ds = (DayShift) this.get(key);
			ds.setSwipeTrans(this.swipeData);
		}
	}

	/*
	 * ӡô֧ propperties ҡҧ÷ӧҹ
	 * ŧ HashMap ͹㹡äӹǳ
	 */
	private HashMap loadTimeData(String time0id) {		
		HashMap hm = new HashMap();
		try {
			StringTokenizer str;
			String field;
						
			DbRecord rec = new InitialRecord(up).getDbRecord("MTIME0");
			rec.setColumn("*");
			rec.set("time0id", time0id);
			if(rec.search() == 1){
				str = new StringTokenizer(rec.getFieldList(), ",");
				while (str.hasMoreTokens()) {
					field = str.nextToken();
					hm.put(field.toUpperCase(), rec.getString(field));
				}
			}
			
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}

	/*
	 * ӡõǨͺ ʵҧ÷ӧҹ¶١Ŵѧ
	 * ѧӡŴ㹵 hmTime ͹
	 * ҡբ˹ ʵҧǡչ鹵ͧӡŴա
	 */
	private void chkTimeData(String timeCode) {
		if (!this.hmTime.containsKey(timeCode)) {
			this.hmTime.put(timeCode, this.loadTimeData(timeCode));
		}
	}

	/*
	 * ӡҧҷöٴѵС
	 * ´٨ҡ properties ӡ˹㹵ҧ÷ӧҹ/ҧ
	 *   8.00 - 17.00 ҨС˹ zone  
	 *  5.00 - 10.00
	 * ͡ 16.00 - 21.00
	 * ͹ººѺšٴѵõ
	 */
	public void genTimeZone() {
		Shift shf, buff;
		//this.createLink();
		shf = this.firstShift;
		for (; shf != null;) {	
//			shf.setPropertyShift(this.shiftProperty);
			shf.setUProfile(this.getUProfile());
			shf.genTimeZone();
			shf = shf.getNextShift();
		}
	}
	
	/*
	 * ӡººš÷ͷ
	 *  ҡաâͷյ͡ѹͧ ѹ繡
	 *  зӧҹ 8.00 - 17.00
	 * ͷ 19.00 - 21.00  21.00 - 23.30
	 * ͷ 19.00 - 23.30
	 */
	public void CheckContinueOT() {
		Shift shf, buff;
		// mix OT  join ѹҨҡѧҢҧ˹
		shf = this.lastShift;
		if (shf != null) {
			buff = shf.getPreviousShift();
			for (; buff!=null;) {	
				//if (shf.getType()=='O' && buff.getType()=='O'  && shf.getJoinTimeIn() && !shf.getEventGroup().equals("H")) {
				if (shf.getType()=='O' && buff.getType()=='O' && shf.getJoinTimeIn()) {
					this.cutLink(buff, shf);
					buff.set_c_dt_out(shf.get_c_dt_out());
					CscTime t = new CscTime(buff.getAp_ot());
					t.add(shf.getAp_ot());
					buff.setAp_ot(t.getFloat());
					buff.setJoinTimeOut(shf.getJoinTimeOut());
					buff.setOldDocType(buff.getDocType());
					buff.setOldDocNo(buff.getDocNo());
					buff.setDocType(shf.getDocType());
					buff.setDocNo(shf.getDocNo());
					shf.setTR_Type("M");
					shf.setTimeCode(buff.getTimeCode());
				}else if (shf.getType()=='O' && buff.getType()=='T' && shf.getJoinTimeIn()) {
					this.cutLink(buff, shf);
					buff.set_c_dt_out(shf.get_c_dt_out());
					CscTime t = new CscTime(buff.getAp_ot());
					t.add(shf.getAp_ot());
					buff.setAp_ot(t.getFloat());
					buff.setJoinTimeOut(shf.getJoinTimeOut());
					buff.setOldDocType(buff.getDocType());
					buff.setOldDocNo(buff.getDocNo());
					buff.setDocType(shf.getDocType());
					buff.setDocNo(shf.getDocNo());
					/* зӧҹ͵͡Ѻͷشͷ */
					buff.set_o_dt_in(shf.get_c_dt_in());
					buff.set_o_dt_out(shf.get_c_dt_out());
					
					shf.setTR_Type("M");
					shf.setTimeCode(buff.getTimeCode());
				}else if((shf.getEventGroup().equals("H") || shf.getEventGroup().equals("I")) && buff.getType()=='O' 
					&& shf.get_c_dt_in().beforeDateTime(buff.get_c_dt_out())){
					this.cutLink(buff, shf);
					shf.setOverLapTimeIn(false);
					buff.setOverLapTimeOut(false);
					//buff.set_c_dt_out(shf.get_c_dt_out());
					//CscTime t = new CscTime(buff.getAp_ot());
					//t.add(shf.getAp_ot());
					//buff.setAp_ot(t.getFloat());
					//buff.setJoinTimeOut(shf.getJoinTimeOut());
					//buff.setOldDocType(shf.getDocType());
					//buff.setOldDocNo(shf.getDocNo());
					shf.setTR_Type("M");
					//shf.setTimeCode(buff.getTimeCode());
				}else if((buff.getEventGroup().equals("H") || buff.getEventGroup().equals("I")) && shf.getType()=='O' 
					&& shf.get_c_dt_in().beforeDateTime(buff.get_c_dt_out())){
					
					//if(buff.getShiftDate().beforeDate(shf.getShiftDate())){ /* óբͷ 繡Тͧѹ͹˹ҷѹش ͧźѹش͡ ШзТͧѹش (Mod. 12-03-2015)*/
						/* ͧźѹش 繡ѹ͹˹ҡͷͧ */
					//}else{
						shf.setPreviousShift(buff.getPreviousShift());
						if(buff.getPreviousShift() == null){
							this.firstShift = shf ;
						}else{
							buff.getPreviousShift().setNextShift(shf);
						}
	
						shf.setOverLapTimeIn(false);
						buff.setOverLapTimeOut(false);
						
						buff.setTR_Type("M");
						
						/* óաѹشѹ ͷѹѴ仫觷Ѻѹش ͧѺἹѺѹ */
						if((buff.getType()=='H'||buff.getType()=='I') && shf.getType()=='O' 
							&& buff.getShiftDate().beforeDate(shf.getShiftDate())
							&& (shf.get_c_dt_in().afterEqualsDateTime(buff.get_c_dt_in()) && shf.get_c_dt_out().beforeEqualsDateTime(buff.get_c_dt_out()) 
							|| shf.get_c_dt_in().afterEqualsDateTime(buff.get_c_dt_in()) && shf.get_c_dt_out().afterEqualsDateTime(buff.get_c_dt_out()))){ /* óաѹشѹ ͷշ繢ͧѹѴѺѹ ͧѺἹѺѹ */
							buff.set_c_dt_out(new CscCalendar(shf.get_c_dt_in().getTime()));
						}
					//}
				}
				shf = buff;
				buff = shf.getPreviousShift();
			}
		}
		
		//  OT ҧѧ͹ѵ Shift
		/*DayShift ds;
		String key, key1;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			ds = (DayShift) this.get(key);
			for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
				key1 = (String) IT1.next().toString();
				shf = (Shift) ds.get(key1);
				buff = shf.getNextShift();
				if (buff!=null) {
					// ---> TEMP
					if (shf.getType()=='T' && buff.getType()=='O'  && shf.getJoinTimeOut() && (!buff.getJoinTimeOut())) {
						MyLog.debug(this, "!!! CHECK JOIN TIME !!! ");
						if (!buff.get_c_dt_out().getYYYYMMDD().equalsIgnoreCase(buff.get_c_dt_in().getYYYYMMDD()) &&
								buff.get_c_dt_out().subForHour(buff.get_c_dt_in())>=8) {
							//ͧ ѹͧ OT ҧѹ ҵҧѹҡ 8 . 
						} else {
							MyLog.debug(this, "!!! JOIN TIME !!! ");
							shf.setAp_ot(buff.getAp_ot());
							shf.setDocNo(buff.getDocNo());
							shf.setDocType(buff.getDocType());
							buff.setTR_Type("M");
							this.cutLink(shf, buff);
							shf.setJoinTimeOut(false);
						}
					}				
				}
			}
		}*/
		shf = this.firstShift;
		for (; shf != null;) {
			buff = shf.getNextShift();
			if (buff!=null) {
				
				if (shf.getType()=='T' && buff.getType()=='O'  && shf.getJoinTimeOut() /*&& (!buff.getJoinTimeOut())*/) {
					if (!buff.get_c_dt_out().getYYYYMMDD().equalsIgnoreCase(buff.get_c_dt_in().getYYYYMMDD()) &&
							buff.get_c_dt_out().subForHour(buff.get_c_dt_in())>=15.01) {
						//ͧ ѹͧ OT ҧѹ ҵҧѹҡ 8 . 
						MyLog.debug(this, "@@@ do not thing @@@");
					} else {
						shf.set_c_dt_out(buff.get_c_dt_out());
						CscTime t = new CscTime(shf.getAp_ot());
						t.add(buff.getAp_ot());
						shf.setAp_ot(t.getFloat());
						//shf.setAp_ot(buff.getAp_ot());
						shf.setOldDocNo(shf.getDocNo());
						shf.setOldDocType(shf.getDocType());
						shf.setDocNo(buff.getDocNo());
						shf.setDocType(buff.getDocType());
						shf.setStatus(buff.getStatus());
						shf.setSalatype(buff.getSalatype());
						shf.setWorkarea(buff.getWorkarea());
						shf.setOT_type(buff.getOT_type());
						shf.setOT_time0(buff.getOT_time0());
						/* зӧҹ͵͡Ѻͷشͷ */
						shf.set_o_dt_in(buff.get_c_dt_in());
						shf.set_o_dt_out(buff.get_c_dt_out());
						
						buff.setTR_Type("M");
						buff.setTimeCode(shf.getTimeCode());
						buff.setMidDayStop(shf.getMidDayStop());
						this.cutLink(shf, buff);
						shf.setJoinTimeOut(false);
					}					
				}else if(((shf.getType()=='T' && buff.getType()=='O') || ((shf.getType()=='H'||shf.getType()=='I') && buff.getType()=='O')) && inAutoSwipePeriodNextShift(shf, buff)){	/* óաͷ͡зӧҹ 㹪ǧͧ еͧѺʡͷ͹зӧҹ */
					buff.setTimeCode(shf.getTimeCode());
				}				
			}
			shf = shf.getNextShift();
		}
		//----------------------------------------------------------
				
		//  OT ҧ˹ҷ͹ѵ Shift
		shf = this.lastShift;
		if (shf != null) {
			while (shf!=null && shf.getType()=='A') {
				shf = shf.getPreviousFullShift();
			}
			
			if (shf!=null) {
				buff = shf.getPreviousShift();
				for (; buff != null;) {
					if (shf.getType()=='T' && buff.getType()=='O'  && buff.getJoinTimeOut() && (!buff.getJoinTimeIn())) {
						//shf.setAp_ot_before(buff.getAp_ot());
						//CscTime cs = new CscTime(shf.getAp_ot());
						//cs.add(buff.getAp_ot());					
						//shf.setAp_ot(cs.getFloat());
						shf.set_c_dt_in(buff.get_c_dt_in());
						CscTime t = new CscTime(shf.getAp_ot());
						t.add(buff.getAp_ot());
						shf.setAp_ot(t.getFloat());
						//shf.setAp_ot(buff.getAp_ot());
						shf.setOldDocNo(shf.getDocNo());
						shf.setOldDocType(shf.getDocType());
						shf.setDocNo(buff.getDocNo());
						shf.setDocType(buff.getDocType());
						shf.setStatus(buff.getStatus());
						shf.setSalatype(buff.getSalatype());
						shf.setWorkarea(buff.getWorkarea());
						shf.setOT_type(buff.getOT_type());
						shf.setOT_time0(buff.getOT_time0());
						shf.setJoinTimeIn(false);
						
						/* зӧҹ͵͡Ѻͷشͷ */
						shf.set_o_dt_in(buff.get_c_dt_in());
						shf.set_o_dt_out(buff.get_c_dt_out());
						
						buff.setTR_Type("M");
						buff.setTimeCode(shf.getTimeCode());
						shf.setPreviousShift(buff.getPreviousShift());
						if (buff.getPreviousShift()!=null) {
							shf.getPreviousShift().setNextShift(shf);
						}
					} else if(shf.getType()=='T' && buff.getType()=='O' && inAutoSwipePeriodPrevShift(shf, buff)){
						buff.setTimeCode(shf.getTimeCode());
					}
					shf = buff;
					buff = shf.getPreviousShift();				
				}
			}
		}
		//----------------------------------------------------------		
	}
	
	private void cutLink(Shift shf1, Shift shf2 ) {
		shf1.setNextShift(shf2.getNextShift());
		if (shf2.getNextShift()!=null) {
			shf1.getNextShift().setPreviousShift(shf1);
		}		
	}
    
    /*
     * createLink include Leave and OT shift 
     * ӡҧ§ѹͧ
     *  л աͷ
     *  NextShift ͧлԤ ͷ
     * ǹ PreviousShift ͧͷդ л
     */
    public void createFullLink() {
        DayShift ds;
        Shift sh, buff, shf;
        String key, key1;
        buff = null;
        shf = null;
        for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
            key = (String) IT.next().toString();
            ds = (DayShift) this.get(key);

            for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
                key1 = (String) IT1.next().toString();
                sh = (Shift) ds.get(key1);
                this.ShiftList.put(sh.getKey(), sh);
                this.lastShift = sh;
                if (this.firstShift == null) this.firstShift = sh;
                
                this.chkTimeData(sh.getTimeCode());
            	sh.setPropertyShift((HashMap) this.hmTime.get(sh.timeCode));
                sh.setPreviousFullShift(buff);
                if (buff != null) {
                    buff.setNextFullShift(sh);
                }
                buff = sh;	
            }
        }
    }
	
    /*
     * createLink not include Leave 
     * ӡҧ§ѹͧ зͧӧҹ
     *    ѹشҧ
     *  л աͷ
     *  NextShift ͧлԤ ͷ
     * ǹ PreviousShift ͧͷդ л
     */
	public void createLink() {
		DayShift ds;
		Shift sh, buff, shf;
		String key, key1;
		buff = null;
		shf = null;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			ds = (DayShift) this.get(key);

			for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
				key1 = (String) IT1.next().toString();
				sh = (Shift) ds.get(key1);
				this.ShiftList.put(sh.getKey(), sh);
				this.lastShift = sh;
               	this.chkTimeData(sh.getTimeCode());
               	sh.setPropertyShift((HashMap) this.hmTime.get(sh.timeCode));
				if (sh.isWorking()) {
					if (this.firstShift == null)
						this.firstShift = sh;
					sh.setPreviousShift(buff);
					if (buff != null) {
						buff.setNextShift(sh);
					}
					buff = sh;
				}
			}
		}
		this.createFullLink(); //creakLink previous&&next shift include leave+ot shift
		this.overlapChecking();
		this.CheckContinueOT();
	}

	/*
	 * ӡèѺ÷ӧҹ Ѻšٴѵâͧѡҹ
	 * ǧѹ , Тšٴѵô
	 */
	public void findTime(CscCalendar beg, CscCalendar end, SwipeTrans st) {
		this.setSwipeTrans(st);
		this.findTime(beg, end);
	}
	
	/*public void findTime2(CscCalendar beg, CscCalendar end) {
		DayShift ds;
		String key, key1;
		Shift sh;
		TimeZone tz;
		boolean first = true;
		boolean eod = false;

		if (this.swipeData!=null && this.getOverLapShift().length()<=0) {
			// Gen Virtual Swipe Transaction for Join Shift
			String timeSwing;			
			if (this.getShiftProperty().containsKey("TIMESWING")==false) {			
				timeSwing = "0";
			} else {
				timeSwing = (String) this.getShiftProperty().get("TIMESWING");
			}
			if (timeSwing.equals("0")) {
				eod = false;
				for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
					key = (String) IT.next();
					ds = (DayShift) this.get(key);					
					if (ds.shiftDate!=null) {
						if (ds.shiftDate.after(end)) {
							eod = true;
						} else {
							if (ds.shiftDate.afterEquals(beg)) {
								ds.genVirtualSwipeForJoinShift();
							}
						}
					}
				}
			}		
		
			
			MyLog.debug(this, this.getUprofile(), "==== BEFORE FIND TIME ====");
			MyLog.debug(this, this.getUprofile(), this.toString());
		}
	}*/

	/*
	 * ӡèѺ÷ӧҹ Ѻšٴѵâͧѡҹ
	 * ǧѹ
	 */
	public void findTime(CscCalendar beg, CscCalendar end) {
		DayShift ds;
		String key, key1;
		Shift sh;
		TimeZone tz;
		boolean first = true;
		boolean eod = false;

		if (this.swipeData!=null && this.getOverLapShift().length()<=0) {
			/*
			String timeSwing;			
			if (this.getShiftProperty().containsKey("TIMESWING")==false) {			
				timeSwing = "0";
			} else {
				timeSwing = (String) this.getShiftProperty().get("TIMESWING");
			}
			
			if (timeSwing.equals("0")) { 
				eod = false;
				for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
					key = (String) IT.next();
					ds = (DayShift) this.get(key);					
					if (ds.shiftDate!=null) {
						if (ds.shiftDate.after(end)) {
							eod = true;
						} else {
							if (ds.shiftDate.afterEquals(beg)) {
								ds.genVirtualSwipeForJoinShift(); 
							}
						}
					}
				}
			}	*/	
			
			// Finding First Loop			
			eod = false;
			for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
				key = (String) IT.next();
				ds = (DayShift) this.get(key);
				if (ds.shiftDate!=null) {
					if (ds.shiftDate.after(end)) {
						eod = true;
					} else {
						if (ds.shiftDate.afterEquals(beg)) {
							//ds.setSwipeTrans(this.swipeData);
							ds.findTime();
						}
					}
				}
			}
			
			String TA_IS2LOOP = "1";
			try {
				CheckNull chk = new CheckNull();
				TA_IS2LOOP = chk.chkNullString((String) StaticConfig.getConfigCompany(this.up, "TA_IS2LOOP"),"1");
			} catch (Exception e) {
				MyLog.error("!! TA_IS2LOOP find not found in table mconfig default TA_IS2LOOP=1 do loop...");
			}
			
			// Finding Second Loop
			if(!TA_IS2LOOP.equals("0")){
				this.genTimeZone();
				eod = false;
				for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
					key = (String) IT.next();
					ds = (DayShift) this.get(key);
					if (ds.shiftDate!=null) {
						if (ds.shiftDate.after(end)) {
							eod = true;
						} else {
							if (ds.shiftDate.afterEquals(beg)) {
								/* ҧٴѵ ó, ӧҹ͡еͧٴѵ  ˹ʹٴѵ */
								if (isTimeSwing() || isIgnoreInOutType()) { 
									ds.genVirtualSwipeForJoinShift(); 
								}
								ds.findTime(true);
							}
						}
					}
				}
			}//end if check TA_IS2LOOP == 1
			
			//Finding for working in Holiday or OverTime!
			eod = false;
			for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
				key = (String) IT.next();
				ds = (DayShift) this.get(key);
				if (ds.shiftDate!=null) {
					if (ds.shiftDate.after(end)) {
						eod = true;
					} else {
						if (ds.shiftDate.afterEquals(beg)) {
							for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
								key1 = (String) IT1.next().toString();
								sh = (Shift) ds.get(key1);
								if (first) {
									sh.findSwipeBeforeIn();
								}
								sh.findSwipeAfterOut();
							}
						}
					}
				}
			}
		}
		
		//Finding for working in Holiday or OverTime! [ѧش ҡ͹]
		/*eod = false;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
			key = (String) IT.next();
			ds = (DayShift) this.get(key);
			if (ds.shiftDate!=null) {
				if (ds.shiftDate.after(end)) {
					eod = true;
				} else {
					if (ds.shiftDate.afterEquals(beg)) {
						if (!ds.isHoliday()) {
							for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
								key1 = (String) IT1.next().toString();
								sh = (Shift) ds.get(key1);
								sh.genProcessResult();
							}
						}else{
							ds.findHolidaySwipe();
							ds.genProcessResult();
						}
					}
				}
			}
		}	
		
		MyLog.debug(this, this.getUprofile(), "==== ROUND 4 [IN HOLIDAY OR OVER TIME : 2] ====");
		MyLog.debug(this, this.getUprofile(), this.toString());*/
		
				
		//Finding for add time automatic
		/*
		 * ӡѵѵ㹡óշ option 㹵ҧ÷ӧҹ 
		 * ´ҪǧҷҧѹͧСйѹԹѺҷ˹ option 
		 * */
		if (this.shiftProperty.containsKey("TIMESAUTO") && !this.shiftProperty.get("TIMESAUTO").equals("")) {
			float swipesAuto = 0;
			try {
				swipesAuto = Float.parseFloat(((String) this.shiftProperty.get("TIMESAUTO")));
			} catch (Exception e) {
				MyLog.error(this, e);
				swipesAuto = 0;
			}
			if (swipesAuto > 0) {								
				eod = false;
				Vector v = new Vector();				
				for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
					key = (String) IT.next();
					ds = (DayShift) this.get(key);
					if (ds.shiftDate!=null) {
						if (ds.shiftDate.after(end)) {
							eod = true;
						} else {
							/**
							int i = 1;
							int max = ds.size();
							for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
								key1 = (String) IT1.next().toString();
								sh = (Shift) ds.get(key1);
								//System.out.println("sh -------------> "+sh.getShiftDate());
								Shift sh_previous = sh.getPreviousShift();
								Shift sh_previous_full = sh.getPreviousFullShift();
								
								Shift sh_next = sh.getNextShift();
								Shift sh_next_full = sh.getNextFullShift();
								
								//Add TimeIN && TimeOUT Auto
								if ((sh_previous_full!=null && sh_previous!=null && sh_next_full!=null && sh_next!=null) || (i<=max)) {
									float time=0, time1=0;
									if (sh_previous!=null) {
										time = sh.get_c_dt_in().subForHour(sh_previous.get_c_dt_out());
										if (sh_previous_full!=null && sh_previous_full.getTR_Type().substring(0,1).equals("A")) {
											time = sh.get_c_dt_in().subForHour(sh_previous_full.get_c_dt_out());
										}
									} 
									if (sh_next!=null) {
										time1 = sh_next.get_c_dt_in().subForHour(sh.get_c_dt_out());
									}
									if (time==0 && time1==0) {
										continue;
									}
									if ((time<=swipesAuto || time1<=swipesAuto) || sh.getTR_Type().substring(0,1).equals("A")) {
										if (sh_previous!=null && sh_next!=null && sh_previous.outRecord>0 && sh_next.inRecord>0) {
											if (!sh_previous_full.getTR_Type().substring(0,1).equals("A") && !sh_previous_full.getTR_Type().substring(0,1).equals("H") 
													&& !sh_previous_full.getTR_Type().substring(0,1).equals("I") && !sh_previous_full.getTR_Type().substring(0,1).equals("M")) {
												this.addTimeAuto(sh_previous_full);
											}
										}
										if (time<=swipesAuto && sh_previous!=null && sh.inRecord<=0 && sh_previous.outRecord>0 && sh.outRecord>0) {
											this.addTimeInAuto(sh);
										} else if (time1<=swipesAuto && sh_next!=null && sh.outRecord<=0 && sh_next.inRecord>0 && sh.inRecord>0) {
											this.addTimeOutAuto(sh);
										} else if (time>0 && sh_next!=null && sh.outRecord<=0 && sh_next.inRecord<=0 && sh.inRecord>0 && sh_next.outRecord>0) {
											this.addTimeOutAuto(sh);
											this.addTimeInAuto(sh_next);
										} else if (time1>0 && sh_previous!=null &&  sh.inRecord<=0 && sh_previous.outRecord<=0 && sh.outRecord>0 && sh_previous.inRecord>0) {
											this.addTimeInAuto(sh);
											this.addTimeOutAuto(sh_previous);
										}
									}
									//System.out.println("sh -------------> "+sh.getShiftDate()+" > "+time+" > "+time1+" == "+x);
								}														
								i++;
							}
							*/
							
							/**
							 * nuiss edit 31/10/2551 
							 * Ǩͺ ٴѵѵѵ ͹䢷˹
							 */
							boolean isSwipeIn = false ;
							boolean isSwipeOut = false ; 
							//fix initial 
							CscCalendar swipeDateTimeIn = new CscCalendar().incDate(1000);
							CscCalendar swipeDateTimeOut = new CscCalendar().decDate(1000);
							
							for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
								String keyDate  = (String) IT1.next().toString();
								Shift shDate = (Shift) ds.get(keyDate);
								
								if (shDate.inRecord> 0 ){
									//աٴ
									isSwipeIn = true ; 
									if(shDate.get_m_dt_in().before(swipeDateTimeIn)){
										swipeDateTimeIn =  shDate.get_m_dt_in() ; 
									} 
									
									//ѹ͡ٴ ա  ѹ >  swipeDateTimeOut
									//ͧѹ繡ٴ͡
									if(shDate.get_m_dt_in().after(swipeDateTimeOut)){
										isSwipeOut = true ; 
										swipeDateTimeOut =shDate.get_m_dt_in();
									}
								}//end if 
								
								if (shDate.outRecord> 0 ){
									//աٴ͡
									isSwipeOut = true ; 
									if(shDate.get_m_dt_out().after(swipeDateTimeOut)){
										swipeDateTimeOut =shDate.get_m_dt_out();
									}
									//ѹ͡ٴ͡ ա  ѹ <  swipeDateTimeIn
									//ͧѹ繡ٴ
									if(shDate.get_m_dt_out().before(swipeDateTimeIn)){
										isSwipeIn = true ; 
										swipeDateTimeIn =shDate.get_m_dt_out();
									}
								}//end if 		
							}//end for IT1
							
							//ͧաٴѵ÷-͡ ֧			
							if (isSwipeIn && isSwipeOut){
								for (Iterator IT2 = ds.keySet().iterator(); IT2.hasNext();) {
									String keyDate  = (String) IT2.next().toString();
									Shift shDate = (Shift) ds.get(keyDate);
									
									 switch (shDate.getTR_Type().charAt(0)){
										 case 'T'://
											 	 //ǧ ٴѵ ͧѵѵ  
												if (shDate.inRecord > 0 && shDate.outRecord <= 0){
													//for essilor  T Ѻ T 
													if( shDate.getNextShift() != null && shDate.getNextShift().getTR_Type().indexOf("T") > -1){
												 		continue;
												 	}
													// ٴ ٴͧ͡ ͧ 
													// ѹ͡٧شѹ ѹҡ ѹ͡ ͧеͧ  ? 
													if(swipeDateTimeOut.after(shDate.get_c_dt_out()) || swipeDateTimeOut.equals(shDate.get_c_dt_out())){
													 this.addTimeInAuto(shDate);
													 this.addTimeOutAuto(shDate);
													}
												 }else if (shDate.outRecord > 0 && shDate.inRecord <= 0){
													//for essilor  T Ѻ T 
													if( shDate.getPreviousShift() != null && shDate.getPreviousShift().getTR_Type().indexOf("T") > -1){
												 		continue;
												 	}
													 // ٴ͡ ٴҢͧ ͧ 
													// ѹҵشѹ ѹ¡ѹ  ͧеͧ  ? 
													 if(swipeDateTimeIn.before(shDate.get_c_dt_in()) || swipeDateTimeIn.equals(shDate.get_c_dt_in())){
														 this.addTimeInAuto(shDate);
														 this.addTimeOutAuto(shDate);
													}
												 }else if (shDate.inRecord > 0 && shDate.outRecord > 0){
													 // ٴ  ٴͧ͡ ͧ 
													 this.addTimeInAuto(shDate);
													 this.addTimeOutAuto(shDate);
												 }else if (shDate.inRecord <= 0 && shDate.outRecord <= 0){
													 // ٴѵ㹡Тͧͧ 
													// ѹҵشѹ ѹ¡ ѹ ͧеͧ  ?
													// ѹ͡ҡشѹ ѹҡ ѹ͡ ͧеͧ  ?
													  if((swipeDateTimeIn.before(shDate.get_c_dt_in()) || swipeDateTimeIn.equals(shDate.get_c_dt_in())) && 
														  (swipeDateTimeOut.after(shDate.get_c_dt_out()) || swipeDateTimeOut.equals(shDate.get_c_dt_out()))){
														 this.addTimeInAuto(shDate);
														 this.addTimeOutAuto(shDate);
													 } 
												 }//end if  
											 break;
										 case 'O'://ǧ
										 	 //ǧ ٴѵ ͧѵѵ  
												if (shDate.inRecord > 0 && shDate.outRecord <= 0){
													// ٴ ٴͧ͡ ͧ 
													// ѹ͡٧شѹ ѹҡ ѹ͡ ͧеͧ  ? 
													if(swipeDateTimeOut.after(shDate.get_c_dt_out()) || swipeDateTimeOut.equals(shDate.get_c_dt_out())){
														 this.addTimeInAuto(shDate);
														 this.addTimeOutAuto(shDate);
													}else if(swipeDateTimeOut.after(shDate.get_c_dt_in())){
														//ѹٴѵâ ѹҨй¡ ͧ͡ٴ  ҡ ҷͧٴ
														// = ҷ ͧ
														//͡ =  ٴ ҡش(ѹͧ繢) 
									 					SwipeVirtual SV = new SwipeVirtual(shDate.c_dt_in, shDate.getTimeinReserveCode());
														shDate.inRecord = shDate.swipeData.addRecord(SV);
														shDate.swipeData.reserve(shDate.inRecord, shDate.getTimeinReserveCode());
									 
														SwipeVirtual SV2 = new SwipeVirtual(swipeDateTimeOut, shDate.getTimeoutReserveCode());
														shDate.outRecord = shDate.swipeData.addRecord(SV2);
														shDate.swipeData.reserve(shDate.outRecord, shDate.getTimeoutReserveCode());	
													 
													}//end if 
													 
												 }else if (shDate.outRecord > 0 && shDate.inRecord <= 0){
													 // ٴ͡ ٴҢͧ ͧ 
													// ѹҵشѹ ѹ¡ѹ  ͧеͧ  ? 
													 if(swipeDateTimeIn.before(shDate.get_c_dt_in()) || swipeDateTimeIn.equals(shDate.get_c_dt_in())){
														 this.addTimeInAuto(shDate);
														 this.addTimeOutAuto(shDate);
													}
												 }else if (shDate.inRecord > 0 && shDate.outRecord > 0){
													 // ٴ  ٴͧ͡ ͧ 
													 this.addTimeInAuto(shDate);
													 this.addTimeOutAuto(shDate);
												 }else if (shDate.inRecord <= 0 && shDate.outRecord <= 0){
													 // ٴѵ㹡Тͧͧ 
													// ѹҵشѹ ѹ¡ ѹ ͧеͧ  ?
													// ѹ͡ҡشѹ ѹҡ ѹ͡ ͧеͧ  ?
													  if((swipeDateTimeIn.before(shDate.get_c_dt_in()) || swipeDateTimeIn.equals(shDate.get_c_dt_in())) && 
														  (swipeDateTimeOut.after(shDate.get_c_dt_out()) || swipeDateTimeOut.equals(shDate.get_c_dt_out()))){
														 this.addTimeInAuto(shDate);
														 this.addTimeOutAuto(shDate);
													 } 
												 }//end if  
											 break;
										 case 'A'://
											 break;
										 case 'H'://ѹش
											 break;
										 case 'I'://ѹشѡѵġ
											 break;
										default:break;
									 }//end switch 
								}//end for IT2
							}//end if 
											
						}//end if 						
					}//end if 
				} //end for IT			
			}
			
			//Finding for working in Holiday or OverTime!
			eod = false;
			for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
				key = (String) IT.next();
				ds = (DayShift) this.get(key);
				if (ds.shiftDate!=null) {
					if (ds.shiftDate.after(end)) {
						eod = true;
					} else {
						if (ds.shiftDate.afterEquals(beg)) {
							if (!ds.isHoliday()) { //ѹش еͧҡ 1 row
								for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
									key1 = (String) IT1.next().toString();
									sh = (Shift) ds.get(key1);
									sh.genProcessResult(); //ӡҧ error    ٴѵ ͷ
								}
							} else {
								ds.findHolidaySwipe();
								ds.genProcessResult(); //ӡҧ error ٴѵѹش
							}
						}
					}
				}
			}
			
			eod = false;
			for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
				key = (String) IT.next();
				ds = (DayShift) this.get(key);
				if (ds.shiftDate!=null) {
					if (ds.shiftDate.after(end)) {
						eod = true;
					} else {
						if (ds.shiftDate.afterEquals(beg)) {
							for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
								key1 = (String) IT1.next().toString();
								sh = (Shift) ds.get(key1);
								if(sh.getResult_Sourcein().equalsIgnoreCase("9")){
									if(sh.getPreviousShift().inRecord > 0){
										sh.setPrevShiftSwipe(sh.getPreviousShift().inRecord);
									}else{
										sh.setPrevShiftSwipe(sh.inRecord);
									}
								}
								if(sh.getResult_Sourceout().equalsIgnoreCase("9")){
									if(sh.getNextShift().outRecord > 0){
										sh.setNextShiftSwipe(sh.getNextShift().outRecord);
									}else{
										sh.setNextShiftSwipe(sh.outRecord);
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	private boolean isTimeSwing(){
		try {
			String timeSwing;			
			if (!this.getShiftProperty().containsKey("TIMESWING")) {			
				timeSwing = "0";
			} else {
				timeSwing = (String) this.getShiftProperty().get("TIMESWING");
			}
			if(timeSwing.equals("0")){
				return true ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false ;
	}
	
	/* ʹ㨡ٴѵ */
	private boolean isIgnoreInOutType(){
		boolean IgnoreInOut = false;
		try{
			/* èѺ (ʹ͡, ʹ㹷͡ зӤú .) */
			if(this.getShiftProperty().containsKey("STICKTM")){
				String type = (String)this.getShiftProperty().get("STICKTM");
				if(type.equalsIgnoreCase("N")){
					return true ;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false ;
	}
	
	/*
	 * ӡѵѵ
	 */
	private void addTimeAuto(Shift sh) {
		if (sh.inRecord==0) {
			SwipeVirtual SV = new SwipeVirtual(sh.c_dt_in, sh.getTimeinReserveCode());
			sh.inRecord = sh.swipeData.addRecord(SV);
			sh.swipeData.reserve(sh.inRecord, sh.getTimeinReserveCode());
		}
		if (sh.outRecord==0) {
			SwipeVirtual SV2 = new SwipeVirtual(sh.c_dt_out, sh.getTimeoutReserveCode());
			sh.outRecord = sh.swipeData.addRecord(SV2);
			sh.swipeData.reserve(sh.outRecord, sh.getTimeoutReserveCode());		
		}
	}
	
	/*
	 * ӡѵѵԪǧ
	 */
	private void addTimeInAuto(Shift sh) {
		if (sh.inRecord==0) {
			SwipeVirtual SV = new SwipeVirtual(sh.c_dt_in, sh.getTimeinReserveCode());
			sh.inRecord = sh.swipeData.addRecord(SV);
			sh.swipeData.reserve(sh.inRecord, sh.getTimeinReserveCode());
		}
	}
	
	/*
	 * ӡѵѵԪǧ͡
	 */
	private void addTimeOutAuto(Shift sh) {
		if (sh.outRecord==0) {
			SwipeVirtual SV2 = new SwipeVirtual(sh.c_dt_out, sh.getTimeoutReserveCode());
			sh.outRecord = sh.swipeData.addRecord(SV2);
			sh.swipeData.reserve(sh.outRecord, sh.getTimeoutReserveCode());		
		}
	}
	
	/*private int addTimeAuto(Shift shBegin, Shift shEnd) {
		if (shBegin!=null && shEnd!=null) {
			boolean eod = false;
			for (Iterator IT = this.keySet().iterator(); IT.hasNext() && !eod;) {
				String key = (String) IT.next();
				DayShift ds = (DayShift) this.get(key);
				if (ds.shiftDate!=null) {
					if (ds.shiftDate.afterDate(shEnd.getShiftDate())) {
						eod = true;
					} else {
						if (ds.shiftDate.afterEqualsDate(shBegin.getShiftDate())) {
							
							for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
								String key1 = (String) IT1.next().toString();
								Shift sh = (Shift) ds.get(key1);
								
								if (sh.c_dt_in.afterEquals(shBegin.c_dt_in) && sh.c_dt_in.beforeEquals(shEnd.c_dt_in)) {									
									if (sh.c_dt_in.equals(shBegin.c_dt_in) && sh.inRecord==0) {
										//this.addTimeOutAuto(sh);
										this.addTimeInAuto(sh);
										return 1;
									} 
									if (sh.c_dt_in.equals(shEnd.c_dt_in) && sh.outRecord==0) {
										//this.addTimeInAuto(sh);
										this.addTimeOutAuto(sh);
										return 2;
									} else {						
										if (sh.inRecord==0 && sh.outRecord==0) {
											this.addTimeInAuto(sh);
											this.addTimeOutAuto(sh);
											return 0;
										}
									}
								}										
							}
						}
					}
				}
			}	
		}
		return 4;
	}*/

	/*
	 * ӡõǨͺ աҷѺѹ
	 * 蹡зӧҹ 8.00 - 19.00 
	 * աзӧҹ͹˹ 23.00 - 10.00
	 * ҢͧзӧҹзѺѺͧ͡С͹˹ҹ
	 *  return false ͡  
	 */
	public boolean overlapChecking() {
		Shift shift = this.firstShift;
		boolean result = false;
		String buff;
		for (; shift != null;) {
			if (shift.getPreviousShift() != null) {
				if (shift.c_dt_in.before(shift.getPreviousShift().get_c_dt_out())) {
					result = true;
					shift.setOverLapTimeIn(true);
					shift.getPreviousShift().setOverLapTimeOut(true);		
					
					/* Ѻͷ Ѻ Ѻǧ͡ѹ᷹ (20-03-2015)*/
					if((shift.getEventGroup().equals("O") && shift.getPreviousShift().getDocType().equals("A"))
							|| (shift.getEventGroup().equals("A") && shift.getPreviousShift().getDocType().equals("O"))){
						shift.set_c_dt_in(new CscCalendar(shift.getPreviousShift().get_c_dt_out().getTime()));
						
						result = false ;
						
						/* set over to false */
						shift.setOverLapTimeIn(false);
						shift.getPreviousShift().setOverLapTimeOut(false);
						
						/* set join time in-out instead */
						shift.setJoinTimeIn(true);
						shift.getPreviousShift().setJoinTimeOut(true);
						
						MyLog.debug("!! ot overlap with leave : " + shift);
					}
				} else {
					if (isJoin(shift)) {
						shift.setJoinTimeIn(true);
						shift.getPreviousShift().setJoinTimeOut(true);
					}
				}
			}
			shift = shift.getNextShift();
		}
		/*DayShift ds;
		String key, key1;
		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			ds = (DayShift) this.get(key);
			for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
				key1 = (String) IT1.next().toString();
				shift = (Shift) ds.get(key1);
				if (shift.getPreviousShift() != null) {
					if (shift.c_dt_in.before(shift.getPreviousShift().get_c_dt_out())) {
						result = true;
						shift.setOverLapTimeIn(true);
						shift.getPreviousShift().setOverLapTimeOut(true);
					} else {
						if (isJoin(shift)) {
							shift.setJoinTimeIn(true);
							shift.getPreviousShift().setJoinTimeOut(true);
						}
					}
				}
			}
		}*/
		return result;
	}
	
	/*
	 * ӡõǨͺ
	 * 1. лԵʹ¡ͷ
	 * 2. ͷյʹ¡л
	 */
	private boolean isJoin(Shift shift) {
		boolean result = false;
		if (shift.c_dt_in.equals(shift.getPreviousShift().get_c_dt_out())) {
			result = true;
		} else {
			if ((shift.getType()=='O' && shift.getPreviousShift().getType()=='T')
					||(shift.getType()=='T' && shift.getPreviousShift().getType()=='O')) {
				float diff = shift.c_dt_in.subForHour(shift.getPreviousShift().get_c_dt_out());
				if (diff <= 1) {
					float breakOT = shift.getBreakOT();
					if (diff<=breakOT) {
						result = true;
					}
				}
			} 
		}
		return result;
	}

	public String getOverLapShift() {
		Shift shift = this.firstShift;
		String result = "";
		
		String docNoNX ="";
		String eventGrpNX ="";
		String docNoPV ="";
		String eventGrpPV ="";
		if(shift==null){
			return "";
		}else{
			if (shift.getNextShift()==null){
				docNoNX="";
				eventGrpNX ="";
			}else{
				docNoNX =shift.getNextShift().getDocNo().trim();
				eventGrpNX =shift.getNextShift().getEventGroup();
			}//end if 
			
			if (shift.getPreviousShift()==null){
				docNoPV="";
				eventGrpPV ="";
			}else{
				docNoPV =shift.getPreviousShift().getDocNo().trim();
				eventGrpPV =shift.getPreviousShift().getEventGroup();
			}//end if 
			
			for (; shift != null;) {
				if (shift.getOverLapTimeIn() || shift.getOverLapTimeOut()) {
					if(shift.overLapTimeIn || shift.overLapTimeOut){ /* case overlap working shift (event T:T) */
						if(shift.overLapTimeIn 
								&& shift.getEventGroup().equals("T") 
								&& shift.getPreviousShift().getEventGroup().equals("T")){
							/* let it's overlap */
						}else if(shift.overLapTimeOut
								&& shift.getEventGroup().equals("T")
								&& shift.getNextShift().getEventGroup().equals("T")){
							/* let it's overlap */
						}
					} else if (shift.getEventGroup().equals("O") && docNoPV.equals("") && 
							(eventGrpPV.equals("H") || eventGrpPV.equals("I"))) {
						
					} else if ((shift.getEventGroup().equals("H") || shift.getEventGroup().equals("I")) 
								&& !docNoNX.equals("") && 
								 (eventGrpNX.equals("O"))) {
					} else {
						result = result + shift.toString();
					}
				} 
				shift = shift.getNextShift();
			}
			return result;
		}//end check shift == null ?
	}

	public String getJoinShift() {
		Shift shift = this.firstShift;
		String result = "";
		for (; shift != null;) {
			if (shift.getJoinTimeIn() || shift.getJoinTimeOut()) {
				result = result + shift.toString();
				shift = shift.getNextShift();
			}
		}
		return result;
	}

	public boolean chkAddShiftTrans(TimeZone dz) {
		boolean result=false;		
		//MyLog.debug(this, this.getUprofile(), "key set");
		//MyLog.debug(this,  this.getUprofile(), this.keySet().toString());
		DayShift ds = (DayShift) this.get(dz.getBeginZone().getYYYYMMDD());
		//MyLog.debug(this, this.getUprofile(), ds.keySet().toString());
		if(ds != null){
			Iterator it = ds.keySet().iterator();
			while (it.hasNext()) {
				String key = (String) it.next();
				Shift sh = (Shift) ds.get(key);			
				if (dz.getBeginZone().after(sh.get_c_dt_in()) && 
						dz.getEndZone().before(sh.get_c_dt_out())) {
					result= true;
				}
			}		
		}
		
		return result;
	}
	
	/*
	 * ӡźз繡ѹش͡ ҡҧ÷ӧҹҧ͡
	 */
	public void removeStopShift() {
		Iterator it = this.keySet().iterator();
		List<String> list = null;		
		while (it.hasNext()) {
			if( list == null ){
				list = new Vector<String>();
			}else{
				list.clear();
			}
			DayShift ds = (DayShift) this.get((String) it.next());
			Iterator it2 = ds.keySet().iterator();
			while (it2.hasNext()) {
				String key = (String) it2.next();
				Shift sh = (Shift) ds.get(key);
				if (sh.getEventGroup().equals("H") || sh.getEventGroup().equals("I")) {
					list.add(key);
					//ds.remove(key);
				}
			}
			for(String k : list){
				ds.remove(k);
			}
		}
	}
	
	public void removeHoliday() {
		Iterator it = this.keySet().iterator();
		List<String> list = null;
		while (it.hasNext()) {
			if( list == null ){
				list = new Vector<String>();
			}else{
				list.clear();
			}
			DayShift ds = (DayShift) this.get((String) it.next());
			Iterator it2 = ds.keySet().iterator();
			while (it2.hasNext()) {
				String key = (String) it2.next();
				Shift sh = (Shift) ds.get(key);
				if (sh.getEventGroup().equals("H")) {
					//ds.remove(key);
					list.add(key);
				}
			}
			for(String k : list){
				ds.remove(k);
			}
		}
	}
		
	public Vector genAddShiftTrans(TimeZone dz) {
		Vector vt = new Vector();
		Iterator it;
		TimeZone z = new TimeZone();
		z.setBeginZone(new CscCalendar(dz.getBeginZone().getTimeInMillis()));
		z.setEndZone(new CscCalendar(dz.getEndZone().getTimeInMillis()));		
		z.getBeginZone().decDate(3);
		z.getEndZone().incDate(3);
		MyTreeMap workingTransaction;
		
		workingTransaction = this.genAllTimeTransaction(z);
		workingTransaction.put(dz.getBeginZone().getYYYYMMDDHHMMSS() + dz.getBeginZone().getYYYYMMDDHHMMSS() + "#", "");
		workingTransaction.put(dz.getEndZone().getYYYYMMDDHHMMSS() + dz.getBeginZone().getYYYYMMDDHHMMSS() + "@", "");
		
		it = workingTransaction.keySet().iterator();		
				
		boolean inWorkingTimeZone = false;
		boolean end_of_data = true;
		String prevShift, nextShift, sequence;
		String nextKey, prevKey, prevprevKey;
		String timeCode, eventGroup, tr_type;
		CscCalendar shiftDate = null;
		Shift sh=null;
		it = workingTransaction.keySet().iterator();
		prevShift = (String) it.next();

		prevKey = prevShift.substring(38);
		prevprevKey = "N";
		String inZoneKey = "-+ #+ -@ ";
		String inZoneKey3 = "-#@";
		String inZoneKey4 = "#@";
		String outZoneKey = "";
		timeCode = " ";
		eventGroup = " ";
		String otEventGroup = " ";
		tr_type = "";
		
		if (prevKey.equals("#")) inWorkingTimeZone = true;
		
		if (prevKey.equals("+")) {
			sh = (Shift) this.ShiftList.get(prevShift.substring(0, 19));
			eventGroup = sh.getEventGroup();
			timeCode = sh.getTimeCode();
			tr_type = sh.getTR_Type();
			shiftDate = new CscCalendar(sh.getShiftDate().getTimeInMillis());
		}
		
		while (end_of_data && it.hasNext()) {
			nextShift = (String) it.next();
			nextKey = nextShift.substring(38);
			sequence = prevKey + nextKey;

			if (nextKey.equals("+")) {
				sh = (Shift) this.ShiftList.get(nextShift.substring(0, 19));
				eventGroup = sh.getEventGroup();
				timeCode = sh.getTimeCode();
				tr_type = sh.getTR_Type();
				shiftDate = sh.getShiftDate();				
			}else{	/* ͹ Ѻ timecode 繪ͧҧ к˹ default ͧѹ  ͧ */
				timeCode = "";
			}
						
			if (!prevShift.substring(0, 19).equals(nextShift.substring(0, 19))) {
				if (inWorkingTimeZone) {
					if (inZoneKey.indexOf(sequence) >= 0 || inZoneKey3.indexOf(prevprevKey + sequence ) >= 0) {
							vt.add(new AdjustResult(new CscCalendar(prevShift.substring(0, 19)), "O", timeCode,	eventGroup, tr_type, 
								new CscCalendar(prevShift.substring(0, 19)), 
								new CscCalendar(nextShift.substring(0, 19)),
								sh.getLV_Type(), sh.getOldTimeCode(), sh.getOldEventGroup(),
								sh.getDocNo(), sh.getDocType(), sh.getTR_Type(), sh.getWorkarea(), new TimeZone(sh.get_sh_dt_in(), sh.get_sh_dt_out()), 
								sh.getSalatype(), sh.getOT_type(), sh.getOT_time0(), sh.getDocStatus(), sh.getActualDate()));
						
					} else {
						if (inZoneKey4.indexOf(sequence) >= 0) {
							vt.add(new AdjustResult(new CscCalendar(prevShift.substring(0, 19)), "O", otEventGroup, "O", "O", 
									new CscCalendar(prevShift.substring(0, 19)), 
									new CscCalendar(nextShift.substring(0, 19)),
									"", "", "", "","", "", "", new TimeZone(), "", "", "", "", ""));
						}
					}					
				} else {
					if (outZoneKey.indexOf(sequence) >= 0) {
						vt.add(new AdjustResult(shiftDate, "O", timeCode,	eventGroup, tr_type, 
								new CscCalendar(prevShift.substring(0, 19)), 
								new CscCalendar(nextShift.substring(0, 19)),
								sh.getLV_Type(), sh.getOldTimeCode(), sh.getOldEventGroup(),
								sh.getDocNo(), sh.getDocType(), sh.getTR_Type(), sh.getWorkarea(), new TimeZone(sh.get_sh_dt_in(), sh.get_sh_dt_out()), 
								sh.getSalatype(), sh.getOT_type(), sh.getOT_time0(), sh.getDocStatus(), sh.getActualDate())); 
					}
				}
			}
			if (nextKey.equals("#")) {
				inWorkingTimeZone = true;
			} else {
				if (nextKey.equals("@"))
					inWorkingTimeZone = false;
			}
			prevprevKey = prevKey;
			prevShift = nextShift;
			prevKey = nextKey;
		}
		return vt;
	}

	/*private float findTimeIN(MyTreeMap tm) {
		float timeIN = 0;
		float tmp = 0;
		for (Iterator IT = tm.keySet().iterator(); IT.hasNext();) {
			Float key = (Float) IT.next();
			MyTreeMap t = (MyTreeMap) tm.get(key);
			for (Iterator IT1 = t.keySet().iterator(); IT1.hasNext();) {
				String sign = (String) t.get((String) IT1.next());
				if (sign.equalsIgnoreCase("#")) {
					timeIN = key.floatValue();
				} else if (sign.equalsIgnoreCase("+")) {
					tmp = key.floatValue();
				}
			}
		}
		if (timeIN == 0)
			timeIN = tmp;
		return timeIN;
	}

	private float findTimeOUT(MyTreeMap tm) {
		float timeOUT = 0;
		for (Iterator IT = tm.keySet().iterator(); IT.hasNext();) {
			Float key = (Float) IT.next();
			MyTreeMap t = (MyTreeMap) tm.get(key);
			for (Iterator IT1 = t.keySet().iterator(); IT1.hasNext();) {
				String sign = (String) t.get((String) IT1.next());
				if (sign.equalsIgnoreCase("@")) {
					timeOUT = key.floatValue();
				}
			}
		}
		return timeOUT;
	}*/

	public MyTreeMap genWorkingTimeTransaction(TimeZone tm) {
		//Only Working Transaction
		MyTreeMap workingTransaction = new MyTreeMap();
		CscCalendar beg = new CscCalendar(tm.getBeginZone().getTimeInMillis());
		while (beg.beforeEquals(tm.getEndZone())) {
			if (this.containsKey(beg.getYYYYMMDD())) {				
				DayShift dsh = (DayShift) this.get(beg.getYYYYMMDD());
				dsh.genAllTimeTransaction(workingTransaction);
			}
			beg.incDate();
		}
		return workingTransaction;
	}

	public MyTreeMap genAllTimeTransaction(TimeZone tm) {
		//Include Absent Transaction
		MyTreeMap workingTransaction = new MyTreeMap();
		CscCalendar beg = new CscCalendar(tm.getBeginZone().getTimeInMillis());
		while (beg.beforeEquals(tm.getEndZone())) {
			DayShift dsh = (DayShift) this.get(beg.getYYYYMMDD());
			if (dsh!=null) {
				dsh.genWorkingTimeTransaction(workingTransaction);
			}
			beg.incDate();
		}
		return workingTransaction;
	}
	
	public Vector genSubShiftTrans(TimeZone dz) {
		Vector vt = new Vector();
		Vector delvt = new Vector();
		
		try {
			Iterator it;
			TimeZone z = new TimeZone();
			z.setBeginZone(new CscCalendar(dz.getBeginZone().getTimeInMillis()));
			z.setEndZone(new CscCalendar(dz.getEndZone().getTimeInMillis()));
			
			if (z.getBeginZone().equals(z.getEndZone()))
				return vt;
			z.getBeginZone().decDate();
			z.getEndZone().incDate();
			MyTreeMap workingTransaction;
			workingTransaction = this.genWorkingTimeTransaction(z);
			workingTransaction.put(dz.getBeginZone().getYYYYMMDDHHMMSS()
					+ dz.getBeginZone().getYYYYMMDDHHMMSS() + "#", "");
			workingTransaction.put(dz.getEndZone().getYYYYMMDDHHMMSS()
					+ dz.getBeginZone().getYYYYMMDDHHMMSS() + "@", "");
			it = workingTransaction.keySet().iterator();
			while (it.hasNext()) {
				String st = (String) it.next();
				MyLog.debug(st);
			}
			
			boolean inSubTimeZone = false;
			boolean end_of_data = true;
			String prevShift, nextShift, sequence;
			String nextKey, prevKey, prevprevKey;
			String timeCode, eventGroup, tr_type;
			Shift sh = null;
			CscCalendar shiftDate = null;
			it = workingTransaction.keySet().iterator();
			prevShift = (String) it.next();
			prevKey = prevShift.substring(38);
			prevprevKey = "N";
			String absentKey = "+-|+@|#-|";
			String absentKey3 = "+#@";
			String workingKey = "+#|@-";
			timeCode = " ";
			eventGroup = " ";
			tr_type = " ";
			if (prevKey.equals("#"))
				inSubTimeZone = true;
			if (prevKey.equals("+")) {
				sh = (Shift) this.ShiftList.get(prevShift.substring(0, 19));
				if(sh != null) {
					eventGroup = sh.getEventGroup();
					timeCode = sh.getTimeCode();
					tr_type = sh.getTR_Type();
					shiftDate = sh.getShiftDate();
				}else{
					eventGroup = "";
					timeCode = "";
					tr_type = "";
				}
			}
			while (end_of_data && it.hasNext()) {
				nextShift = (String) it.next();
				nextKey = nextShift.substring(38);
				sequence = prevKey + nextKey;
	
				if (inSubTimeZone)
					System.out.print("IN ZONE  :");
				//MyLog.debug(this, "sequence : " + sequence);
	
				if (nextKey.equals("+")) {
					sh = (Shift) this.ShiftList.get(nextShift.substring(0, 19));
					if(sh != null) {
						eventGroup = sh.getEventGroup();
						timeCode = sh.getTimeCode();
						tr_type = sh.getTR_Type();
						shiftDate = sh.getShiftDate();
					}else{
						eventGroup = "";
						timeCode = "";
						tr_type = "";						
					}
				}
	
				if (!prevShift.substring(0, 19).equals(nextShift.substring(0, 19))) {
	
					if (inSubTimeZone) {
						if (absentKey.indexOf(sequence) >= 0 || absentKey3.indexOf(prevprevKey + sequence) >= 0) {
							delvt.add(new AdjustResult(shiftDate, "D", timeCode, eventGroup, 
									tr_type, sh.get_c_dt_in(), sh.get_c_dt_out(),
									sh.getLV_Type(), sh.getOldTimeCode(), sh.getOldEventGroup(),
									sh.getDocNo(), sh.getDocType(), sh.getTR_Type(), sh.getWorkarea(), new TimeZone(sh.get_sh_dt_in(), sh.get_sh_dt_out()),
									sh.getSalatype(), sh.getOT_type(), sh.getOT_time0(), sh.getDocStatus(), sh.getActualDate()));
							vt.add(new AdjustResult(shiftDate, "A", timeCode, eventGroup, tr_type, 
									new CscCalendar(prevShift.substring(0, 19)), 
									new CscCalendar(nextShift.substring(0, 19)),
									sh.getLV_Type(), sh.getOldTimeCode(), sh.getOldEventGroup(),
									sh.getDocNo(), sh.getDocType(), sh.getTR_Type(), sh.getWorkarea(), new TimeZone(sh.get_sh_dt_in(), sh.get_sh_dt_out()),
									sh.getSalatype(), sh.getOT_type(), sh.getOT_time0(), sh.getDocStatus(), sh.getActualDate()));
									
						}
					} else {
						if (workingKey.indexOf(sequence) >= 0) {
							vt.add(new AdjustResult(shiftDate, "T", timeCode,	eventGroup, tr_type, 
									new CscCalendar(prevShift.substring(0, 19)), 
									new CscCalendar(nextShift.substring(0, 19)),
									sh.getLV_Type(), sh.getOldTimeCode(), sh.getOldEventGroup(),
									sh.getDocNo(), sh.getDocType(), sh.getTR_Type(), sh.getWorkarea(), new TimeZone(sh.get_sh_dt_in(), sh.get_sh_dt_out()), 
									sh.getSalatype(), sh.getOT_type(), sh.getOT_time0(), sh.getDocStatus(), sh.getActualDate()));
						}
					}
				}
	
				if (nextKey.equals("#")) {
					inSubTimeZone = true;
				} else {
					if (nextKey.equals("@"))
						inSubTimeZone = false;
				}
				prevprevKey = prevKey;
				prevShift = nextShift;
				prevKey = nextKey;
			}
			delvt.addAll(vt);
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return delvt;
	}

	public String toString() {
		String buff = "";
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String code = (String) it.next();
			DayShift dsh = (DayShift) this.get(code);
			buff = buff + dsh.toString();
		}
		return buff;
	}
	
	/** ¡ method 繷 process */
	public void prepairProcess(UProfile up, String empID, String timeID) {
		this.setUProfile(up);
		this.setEmployeeid(empID);
		this.setEmpTimeCode(timeID);
		this.adjust(); //ӡûѺا
		this.createLink(); //ҧ§ͧ
		this.genTimeZone(); //ҧҷöѺ
	}
	
	private boolean chkIsShiftChange(String start_date, String end_date) {
		boolean result = false;
		CscCalendar c1 = new CscCalendar(start_date);
		CscCalendar c2 = new CscCalendar(end_date);
		Iterator it = this.keySet().iterator();
		while (it.hasNext()) {
			String k = (String) it.next();
			DayShift ds = (DayShift) this.get(k);
			CscCalendar c = new CscCalendar(k);
			if (c.afterEqualsDate(c1) && c.beforeEqualsDate(c2)) {
				Iterator it2 = ds.keySet().iterator();
				while (it2.hasNext()) {
					String k2 = (String) it2.next();
					Shift sh = (Shift) ds.get(k2);
					if (sh.get_c_dt_in().getTime() == 7.30)
						return true;
				} 
			}
		}		
		return result;
	}
	
	/** 㹡 ѹ֡͡ǧҷ process */
	public void reSaveLeaveDocument() {
		try {
			StringBuffer filter = new StringBuffer();
			filter.append("employeeid='").append(this.employeeid).append("' ");
			filter.append("and (start_date>='").append(this.begDate.getYYYYMMDD()).append("' ");
			filter.append("and end_date<='").append(this.endDate.getYYYYMMDD()).append("')");
			DbInquiry inq = new InitialInquiry(this.up).getDbInquiry();			
			inq.setSchemaName(this.up.getSchemaName());
			inq.initMyTable("Tabsent_nstda", filter.toString(), "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) { 
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.setWFOff();
				if (this.chkIsShiftChange(rec.getString("start_date"), rec.getString("end_date"))) {
					rec.save();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	/* ѺἹ 㺢ͷ */
	public void adjustDocument(Vector vadjust, UProfile upf){
		try {
			if(this.up == null) this.up = upf; 	/*  uprofile  null  */
			
			HashMap hmADJ = this.getAdjustData(vadjust);
			
			CscCalendar buffDate = new CscCalendar(this.begDate.getTimestamp());
			DayShift day;
			do {
				if (this.containsKey(buffDate.getYYYYMMDD())) {
					try {
						day = (DayShift) this.get(buffDate.getYYYYMMDD());
						day.setUprofile(this.up);
						day.setWorkingShift(this);
						
						if (hmADJ.containsKey(buffDate.getYYYYMMDD())) {
							MyTreeMap tr = (MyTreeMap) hmADJ.get(buffDate.getYYYYMMDD()); 
							Iterator it = tr.keySet().iterator();
							while (it.hasNext()) {
								AdjustTime at = (AdjustTime) tr.get(it.next());
								if (this.sDate!=null && this.eDate!=null) {
									if (this.sDate.getCSCTime()!=0.0 && this.eDate.getCSCTime()!=0.0) {
										if (at.get_DT_BG().after(this.sDate) && at.get_DT_EN().before(this.eDate)) {
											day.adjust(at, buffDate);
										}
									} else {
										day.adjust(at, buffDate);
									}
								} else day.adjust(at, buffDate);		
								
							}
						}
					} catch (Exception e) {
						MyLog.error(this, e);					
					}
				}
				buffDate.incDate();
			} while (!buffDate.afterDate(this.endDate));
			
			adjustFullLink();

		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ѺἹ੾¹ѹش */
	public void adjustChangeHoliday(Vector vdata, UProfile upf){
		Shift sh1 = null;
		Shift sh2 = null;
		try {
			if(this.up == null) this.up = upf; 	/*  uprofile  null  */
			HashMap<Shift,String> mapCode = new HashMap<Shift,String>();			
			for(int i=0; i < vdata.size(); i++){
				DbRecord chHoliday = (DbRecord) vdata.get(i);
				mapCode.clear();
				/* ¹ѹӧҹѹش */
				if(this.containsKey(chHoliday.getCscCalendar("change_date1").getYYYYMMDD())){
					DayShift ds = (DayShift) this.get(chHoliday.getCscCalendar("change_date1").getYYYYMMDD());
					Iterator it_ds = (Iterator) ds.keySet().iterator();
                    if (it_ds.hasNext()) {
                    	sh1 = (Shift) ds.get(it_ds.next());
                    }    
				}else{
					sh1 = getShift(new CscCalendar(chHoliday.getCscCalendar("change_date1").getYYYYMMDD()));
				}
				
				if(sh1 != null){
					mapCode.put(sh1, sh1.getTimeCode());
				}
				
				/* ¹ѹشѹӧҹ */
				if(this.containsKey(chHoliday.getCscCalendar("change_date2").getYYYYMMDD())){
					DayShift ds = (DayShift) this.get(chHoliday.getCscCalendar("change_date2").getYYYYMMDD());
					if(ds!=null){	/* ѹ¹ѹش㹪ǧἹ÷ӧҹҧ  ͧԴ null exception */
						Iterator it_ds = (Iterator) ds.keySet().iterator();
	                    if (it_ds.hasNext()) {
	                    	sh2 = (Shift) ds.get(it_ds.next());
	                    } 
					}
				}else{
					sh2 = getShift(new CscCalendar(chHoliday.getCscCalendar("change_date2").getYYYYMMDD()));
				}
				
				if(sh2 != null){
					mapCode.put(sh2, sh2.getTimeCode());
				}
				
				/* ˹Ѻѹش ѹӧҹ */
				if(sh1 != null){
	            	sh1.setEventGroup("H");
	            	sh1.setDocType("CH");
	            	sh1.setDocNo(chHoliday.getString("chholidayid"));
	            	sh1.setTR_Type("H0");
	            	//sh1.setOldTimeCode(sh1.getTimeCode());
	            	//sh1.setTimeCode(mapCode.get(sh2));
				}

				if(sh2 != null){
					sh2.setEventGroup("T");
					sh2.setDocType("CH");
					sh2.setDocNo(chHoliday.getString("chholidayid"));
					sh2.setTR_Type("T0");
					//sh2.setOldTimeCode(sh2.getTimeCode());
					//sh2.setTimeCode(mapCode.get(sh1));
				}
				
				/* ¹  */
				if(isChangeShiftAuto()){	
					Shift sh1_new = null;
					Shift sh2_new = null;
					
					if(sh1 != null){
						sh2_new = sh1.clone();
					}
					
					if(sh2 != null){
						sh1_new = sh2.clone();
					}
					
					cloneShiftProp(sh1, sh1_new);		/* ͻ੾´ͧ */
					cloneShiftProp(sh2, sh2_new);		/* ͻ੾´ͧ */
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private void cloneShiftProp(Shift desc, Shift source){
		try {
			/* ˹´ͧ */
			desc.set_c_dt_in(new CscCalendar(desc.get_c_dt_in().getYYYYMMDD() + " " + source.get_c_dt_in().getHHMMSS()));
			desc.set_c_dt_out(new CscCalendar(desc.get_c_dt_out().getYYYYMMDD() + " " + source.get_c_dt_out().getHHMMSS()));
			desc.set_o_dt_in(new CscCalendar(desc.get_o_dt_in().getYYYYMMDD() + " " + source.get_o_dt_in().getHHMMSS()));
			desc.set_o_dt_out(new CscCalendar(desc.get_o_dt_out().getYYYYMMDD() + " " + source.get_o_dt_out().getHHMMSS()));
			desc.set_sh_dt_in(new CscCalendar(desc.get_sh_dt_in().getYYYYMMDD() + " " + source.get_sh_dt_in().getHHMMSS()));
			desc.set_sh_dt_out(new CscCalendar(desc.get_sh_dt_out().getYYYYMMDD() + " " + source.get_sh_dt_out().getHHMMSS()));
			
			/* Ǩͺҡ繡Тѹ ͧѺѹͧἹ */
			if(desc.get_c_dt_in().afterDateTime(desc.get_c_dt_out())){
				desc.get_c_dt_out().incDate();
			}
			if(desc.get_o_dt_in().afterDateTime(desc.get_o_dt_out())){
				desc.get_o_dt_out().incDate();
			}
			if(desc.get_sh_dt_in().afterDateTime(desc.get_sh_dt_out())){
				desc.get_sh_dt_out().incDate();
			}
			
			/* ˹ѡ§ */
			TimeZone tz = new TimeZone();
			tz.setBeginZone(new CscCalendar(desc.get_c_dt_in().getYYYYMMDD() + " " + source.getMidDayStop().getBeginZone().getHHMMSS()));
			tz.setEndZone(new CscCalendar(desc.get_c_dt_in().getYYYYMMDD() + " " + source.getMidDayStop().getEndZone().getHHMMSS()));
			
			if(tz.getBeginZone().afterDateTime(tz.getEndZone())){ /* 鹾ѡѹ شѡشѹѴ */
				tz.getEndZone().incDate();
			}
			desc.setMidDayStop(tz);

			/* ´ */
			desc.timeCode = source.timeCode;
			desc.hour_s = source.hour_s;
			desc.workarea = source.workarea ;
			desc.salatype = source.salatype;
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private Shift getShift(CscCalendar shdate){
		try {
			Mtime0 mt = (Mtime0) new InitialRecord(this.up).getDbRecord("Mtime0");
			mt.set("time0id", this.empRec.getString("time0"));
			mt.set("companyid", (String) this.up.get("companyid"));
			mt.setColumn("*");
			mt.setEmpRec(this.empRec);
			if(mt.search() == 1){
				WorkingShift wst = mt.genWorkingShift(new CscCalendar(shdate.getYYYYMMDD()), new CscCalendar(shdate.getYYYYMMDD()), "true");
				wst.setEmprec(this.empRec);
				wst.setUProfile(this.up);
				wst.adjust();   
				wst.createLink();
				
				DayShift ds = (DayShift) wst.get(shdate.getYYYYMMDD());
				Iterator it = ds.keySet().iterator();
				
				if(it.hasNext()){
					Shift sh = (Shift) ds.get((String) it.next());
					if(sh != null){
						return sh ;
					}
				}
				
			}
		}catch(Exception e){
			MyLog.error(this,e);
			MyLog.debug("!! Can not find shift on " + shdate);
		}
		return null ;
	}
	
	/* ʶҹШҡ mconfig.TACHHSH  FALSE ʴ¹ѹش¹ , TRUE ¹ѹش¹д */
	private boolean isChangeShiftAuto(){
		try {			
			String st = (String) StaticConfig.getConfigCompany(this.up, "TACHHSH");
			if(st.equals("TRUE")){
				return true;
			}else{
				return false;
			}
		} catch (Exception e) {
			MyLog.debug("!! Can't get config name TACHHSH!!");
		}
		return false;
	}
	
	/*
     * createLink include Leave and OT shift 
     * ӡҧ§ѹͧ
     *  л աͷ
     *  NextShift ͧлԤ ͷ
     * ǹ PreviousShift ͧͷդ л
     */
    public void adjustFullLink() {
        DayShift ds;
        Shift sh, buff, shf;
        String key, key1;
        buff = null;
        shf = null;
        
        this.ShiftList.clear();		/*  list ҷ ͵ͧûѺ */
        this.firstShift = null;		/*  firstShift ͵ͧûѺ  */
        
        for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
            key = (String) IT.next().toString();
            ds = (DayShift) this.get(key);

            for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
                key1 = (String) IT1.next().toString();
                sh = (Shift) ds.get(key1);
                this.ShiftList.put(sh.getKey(), sh);
                this.lastShift = sh;
                if (this.firstShift == null) this.firstShift = sh;
                
                this.chkTimeData(sh.getTimeCode());
            	sh.setPropertyShift((HashMap) this.hmTime.get(sh.timeCode));
                sh.setPreviousFullShift(buff);	/* ˹ǡ͹˹ ѺǻѨغѹ */
                sh.setPreviousShift(buff);		/* ˹ǡ͹˹ ѺǻѨغѹ */
                
                if (buff != null) {
                    buff.setNextFullShift(sh);	/* ˹ǻѨغѹ 繵ǶѴ仢ͧá */
                    buff.setNextShift(sh);		/* ˹ǻѨغѹ 繵ǶѴ仢ͧá */
                }
                buff = sh;	
            }
        }
    }
    
    /* clone workingshift */
    public WorkingShift cloneWorkingShift(){
    	String key = "";
    	String key1 = "";
    	
    	DayShift ds = null;
    	Shift cursh = null;
    	WorkingShift ws = new WorkingShift();	/* workingshift  */
    	
    	try {
    		/* ˹ҵҧ   workingshift */
    		ws.setBegDate(this.getBeginDate());
    		ws.setEDate(this.getEndDate());
    		ws.setEmployeeid(this.getEmployeeid());
    		ws.setEmpTimeCode(this.getEmpTimeCode());
    		ws.setEndDate(this.getEndDate());
    		ws.setSDate(this.sDate);
    		ws.setSEDate(this.sDate, this.eDate);
    		ws.setShiftCode(this.getShiftCode());
    		ws.setShiftProperty(this.getShiftProperty());
    		ws.setUProfile(this.up);
    		ws.ShiftList = this.ShiftList;
    		
    		for (Iterator IT = this.keySet().iterator(); IT.hasNext();) {
                key = (String) IT.next().toString();
                ds = (DayShift) this.get(key);
                
                DayShift newds = new DayShift(ds.shiftDate);	/* ҧ dayshift  */
                newds.setUprofile(this.up);
                newds.setErrorResult(ds.getErrorResult());
                newds.setSwipeHoliday(ds.getSwipeHoliday());
                newds.setSwipeTrans(ds.getSwipeTrans());

                for (Iterator IT1 = ds.keySet().iterator(); IT1.hasNext();) {
                    key1 = (String) IT1.next().toString();
                    cursh = (Shift) ds.get(key1);
                    
                    Shift sh = new Shift(cursh.shiftDate);
        			sh.set_c_dt_in(cursh.get_c_dt_in()); //˹ѹѺ
        			sh.set_c_dt_out(cursh.get_c_dt_out()); //˹ѹشѺ
        			
        			CscCalendar c = new CscCalendar(cursh.shiftDate.getYYYYMMDD());
       				c.setCSCTime(cursh.get_c_dt_in().getCSCTime());
        			sh.setShiftDate(c); //˹ѹѺ
        			sh.setTimeCode(cursh.getTimeCode()); //˹ʵҧ÷ӧҹѺ
        			sh.setOldTimeCode(cursh.getOldTimeCode()); //˹ʵҧ÷ӧҹѺ
        			sh.setEventGroup(cursh.getEventGroup()); //˹ѹѺ
        			sh.setOldEventGroup(cursh.getOldEventGroup()); //˹ѹѺ
        			sh.setDocType(cursh.getDocType()); //ӹ͡Ѻ
        			sh.setDocNo(cursh.getDocNo()); //˹Ţ͡Ѻ
        			sh.setLV_Type(cursh.getLV_Type()); //˹Ѻ
        			sh.set_o_dt_in(cursh.c_dt_in); 
        			sh.set_o_dt_out(cursh.c_dt_out);
        			sh.setTR_Type(cursh.getTR_Type());
        			sh.set_sh_dt_in(cursh.get_sh_dt_in()); //˹ѹ鹵ҧ÷ӧҹѺ
        			sh.set_sh_dt_out(cursh.get_sh_dt_out()); //˹ѹشҧ÷ӧҹѺ
        			sh.setLv(cursh.getLv()); //ҷ
        			sh.setDocStatus(cursh.getDocStatus());	
        			sh.setActualEvent(cursh.getActualEvent()); /* ˹ѹԧ  ͧ */
        			sh.setAp_ot(cursh.getLv()); //ӹǹ . ͷ
					sh.setStatus(cursh.getStatus());        			
        			sh.setMidDayStop(cursh.getMidDayStop()); //˹ǧҡþѡѺ
        			sh.setAdjustTemp(cursh.getAdjustTemp());
        			sh.setWorkarea(cursh.getWorkarea()); //˹ʶҹӧҹѺ
        			sh.setSalatype(cursh.getSalatype()); //˹ʤѺ
        			sh.setOT_type(cursh.getOT_type()); //˹ͷѺ
        			sh.setOT_time0(cursh.getOT_time0()); //˹ʵҧ÷ӧҹͷѺ
        			sh.setHour_s(cursh.getHour_s()); //˹ .ӧҹѹ Ѻ
        			sh.setHour_d(cursh.getHour_d()); //˹ . /ӧҹ/ͷ Ѻ
        			sh.setDocStatus(cursh.getDocStatus()); //˹âͧá͡͡ [4=͹ѵԨҡ WF, 6=HR ͡]
        			
        			newds.put(sh);	/*  shift ŧ */
                }
                
                ws.put(key, newds);
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	
    	return ws;
    }
    
    /* ººἹ÷ӧҹ ѺἹա¹ŧͧѡҹ */
    public void meargeWithShiftTrans(DbRecord empRec, CscCalendar st, CscCalendar en){
    	try {
    		/* time0 history */
    		initShiftTrans(empRec, st, en);
    		genWorkShiftTrans(empRec);
    		
    		/* user defind from workflow */
    		initUserShiftTrans(empRec, st, en) ; /* user defind from workflow */
    		genUserWorkShiftTrans(empRec);
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* get invole record from mempl_time0trans */
    private void initShiftTrans(DbRecord empRec, CscCalendar st, CscCalendar en){
    	try {
    		vcShiftPlan = new Vector();
    		
    		DbInquiry inqTimeTrans = new InitialInquiry(this.up).getDbInquiry("Mempl_time0trans");
    		inqTimeTrans.setColumn("*");
    		inqTimeTrans.setFilter("employeeid = '" + empRec.getString("employeeid") + "'");
    		inqTimeTrans.refresh();
    		
    		while(inqTimeTrans.next()){
    			CscCalendar csst = new CscCalendar(inqTimeTrans.getString("start_date"));
    			CscCalendar csen = new CscCalendar(inqTimeTrans.getString("end_date"));
    			
    			if((st.afterEqualsDate(csst) && en.beforeEqualsDate(csen))
    				|| (st.beforeDate(csst) && en.afterDate(csst) && en.beforeEqualsDate(csen))
    				|| (st.afterEqualsDate(csst) && st.beforeDate(csen) && en.afterDate(csen))
    				|| (st.beforeDate(csst) && en.afterDate(csen)
    				|| (csst.afterEqualsDate(st) && csen.beforeEqualsDate(en))
    				)
    			){
    				DbRecord db = inqTimeTrans.getCurrentDbRecord().cloneRecord(false);
    				/* start input gen shift after mempl_time0trans.startdate set date equals start gen */
    				if(st.afterDate(csst)){
    					db.set("start_date", st.getYYYYMMDD());
    				}
    				
    				/* end gen before mempl_time0trans.enddate set date equals end gen to prevent unnessary gen workshift period */
    				if(en.beforeDate(csen)){
    					db.set("end_date", en.getYYYYMMDD());
    				}
    				
    				vcShiftPlan.add(db);
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* get invole record from tshifttrans */
    private void initUserShiftTrans(DbRecord empRec, CscCalendar st, CscCalendar en){
    	try {
    		DbInquiry inqTimeTrans = new InitialInquiry(this.up).getDbInquiry("tshifttrans");
    		inqTimeTrans.setColumn("*");
    		inqTimeTrans.setFilter("employeeid = '" + empRec.getString("employeeid") + "'");
    		inqTimeTrans.refresh();
    		
    		while(inqTimeTrans.next()){
    			CscCalendar csst = new CscCalendar(inqTimeTrans.getString("startdate"));
    			CscCalendar csen = new CscCalendar(inqTimeTrans.getString("enddate"));
    			
    			if((st.afterEqualsDate(csst) && en.beforeEqualsDate(csen))
    				|| (st.beforeDate(csst) && en.afterDate(csst) && en.beforeEqualsDate(csen))
    				|| (st.afterEqualsDate(csst) && st.beforeDate(csen) && en.afterDate(csen))
    				|| (st.beforeDate(csst) && en.afterDate(csen))
    			){
    				DbRecord db = inqTimeTrans.getCurrentDbRecord().cloneRecord(false);
    				/* start input gen shift after tshifttrans.startdate set date equals start gen */
    				if(st.afterDate(csst)){
    					db.set("startdate", st.getYYYYMMDD());
    				}
    				
    				/* end gen before mempl_time0trans.enddate set date equals end gen to prevent unnessary gen workshift period */
    				if(en.beforeDate(csen)){
    					db.set("enddate", en.getYYYYMMDD());
    				}
    				
    				vcShiftPlan.add(db);
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* ҧἹ Ἱ÷ӧҹѺἹѨغѹҧ͹ */
    private void genWorkShiftTrans(DbRecord empRec){
    	try {
    		DbRecord time0trans = null;
    		Mtime0 mtime0 = null;
    		
    		for(int i=0; i < vcShiftPlan.size(); i++){
    			time0trans = (DbRecord) vcShiftPlan.get(i);
    			mtime0 = getTime0Record(time0trans.getString("time0id"));
    			mtime0.setEmpRec(empRec);
    			
    			WorkingShift wf = mtime0.genWorkingShift(new CscCalendar(time0trans.getString("start_date"))
    				, new CscCalendar(time0trans.getString("end_date")),"true");
    			
    			/* ἹѨغѹѹ çѺἹ transaction Ἱ transaction 价ѺἹѨغѹ */
    			if(!wf.isEmpty()){
    				for (Iterator<?> IT = wf.keySet().iterator(); IT.hasNext();) {    
    	                String key = (String) IT.next();
    	                DayShift dShift = (DayShift) wf.get(key);
    	                
    	                /* ѹçѹ */
    	                if(this.containsKey(key)){
    	                	this.put(key, dShift);
    	                }
    				}
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* user defind shift transaction (workflow) */
    private void genUserWorkShiftTrans(DbRecord empRec){
    	try {
    		DbRecord shifttrans = null;
    		Mtime0 mtime0 = null;
    		
    		for(int i=0; i < vcShiftPlan.size(); i++){
    			shifttrans = (DbRecord) vcShiftPlan.get(i);
    			String shiftlist[] = { shifttrans.getString("shift1")
    									,shifttrans.getString("shift2")
    									,shifttrans.getString("shift3")
    									} ;
    			
    			for(int j=0; j < shiftlist.length; j++){
    				if(!shiftlist[j].equals("")){
		    			mtime0 = getTime0Record(shiftlist[j]);
		    			mtime0.setEmpRec(empRec);
		    			
		    			WorkingShift wf = mtime0.genWorkingShift(new CscCalendar(shifttrans.getString("startdate"))
		    				, new CscCalendar(shifttrans.getString("enddate")),"true");
		    			
		    			/* ἹѨغѹѹ çѺἹ transaction Ἱ transaction 价ѺἹѨغѹ */
		    			if(!wf.isEmpty()){
		    				for (Iterator<?> IT = wf.keySet().iterator(); IT.hasNext();) {    
		    	                String key = (String) IT.next();
		    	                DayShift dShift = (DayShift) wf.get(key);
		    	                
		    	                /* ѹçѹ */
		    	                if(j == 0){
		    	                	this.put(key, dShift);
		    	                }else{
			    	                if(this.containsKey(key)){
			    	                	meargeDayShift(key, dShift);
			    	                }else{
			    	                	this.put(key, dShift);
			    	                }
		    	                }
		    				}
		    			}
    				}
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* mearge dayshift */
    private void meargeDayShift(String key, DayShift dshift){
    	try {
    		DayShift mainDayShift = (DayShift) this.get(key);
    		
    		Iterator it = dshift.keySet().iterator();
    		while(it.hasNext()){
    			Shift sh = (Shift) dshift.get((String) it.next());
    			mainDayShift.put(sh);
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* ֧ mtime0 */
    private Mtime0 getTime0Record(String time0){
    	try {
    		Mtime0 mtime0 = (Mtime0) new InitialRecord(this.up).getDbRecord("Mtime0");
    		mtime0.setColumn("*");
    		mtime0.set("time0id", time0);
    		if(mtime0.search() == 1){
    			return mtime0;
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return null;
    }
    
    /* ˹ʡѺͷ ʡ繪ͧҧ */
    public void setTime0ContinueOT() {
		Shift shf, buff;
		// mix OT  join ѹҨҡѧҢҧ˹
		shf = this.lastShift;
		if (shf != null) {
			buff = shf.getPreviousShift();
			for (; buff!=null;) {	
				if (shf.getType()=='O' && buff.getType()=='O'  && shf.getJoinTimeIn()) {
					shf.setTR_Type("M");
					shf.setTimeCode(buff.getTimeCode());
				} 
				shf = buff;
				buff = shf.getPreviousShift();
			}
		}
		
		
		shf = this.firstShift;
		for (; shf != null;) {
			buff = shf.getNextShift();
			if (buff!=null) {
				if (((shf.getType()=='T' && buff.getType()=='O') || ((shf.getType()=='H'||shf.getType()=='I') && buff.getType()=='O'))  && shf.getJoinTimeOut() && (!buff.getJoinTimeOut())) {
					if (!buff.get_c_dt_out().getYYYYMMDD().equalsIgnoreCase(buff.get_c_dt_in().getYYYYMMDD()) &&
							buff.get_c_dt_out().subForHour(buff.get_c_dt_in())>=15.01) {
						//ͧ ѹͧ OT ҧѹ ҵҧѹҡ 8 . 
						MyLog.debug(this, "@@@ do not thing @@@");
					} else {
						buff.setTR_Type("M");
						buff.setTimeCode(shf.getTimeCode());
					}
				}else if((shf.getType()=='H'||shf.getType()=='I') && buff.getType()=='O' 
					&& shf.getShiftDate().beforeDate(buff.getShiftDate())
					&& ((buff.get_c_dt_in().afterEqualsDateTime(shf.get_c_dt_in()) 
							&& buff.get_c_dt_in().beforeEqualsDateTime(shf.get_c_dt_out()) 
							&& buff.get_c_dt_out().beforeEqualsDateTime(shf.get_c_dt_out())) 
							|| 
							(buff.get_c_dt_in().afterEqualsDateTime(shf.get_c_dt_in()) 
								&& buff.get_c_dt_in().beforeEqualsDateTime(shf.get_c_dt_out())
								&& buff.get_c_dt_out().afterEqualsDateTime(shf.get_c_dt_out())) )){ /* óաѹشѹ ͷշ繢ͧѹѴѺѹ ͧѺἹѺѹ */
					shf.set_c_dt_out(new CscCalendar(buff.get_c_dt_in().getTime()));
				}else if(((shf.getType()=='T' && buff.getType()=='O') || ((shf.getType()=='H'||shf.getType()=='I') && buff.getType()=='O')) && inAutoSwipePeriodNextShift(shf, buff)){	/* óաͷ͡зӧҹ 㹪ǧͧ еͧѺʡͷ͹зӧҹ */
					buff.setTimeCode(shf.getTimeCode()); /* ͡Ǥ  */
				}
			}
			shf = shf.getNextShift();
		}
				
		//  OT ҧ˹ҷ͹ѵ Shift
		shf = this.lastShift;
		if (shf != null) {
			while (shf!=null && shf.getType()=='A') {
				shf = shf.getPreviousFullShift();
			}
			
			if (shf!=null) {
				buff = shf.getPreviousShift();
				for (; buff != null;) {
					if (shf.getType()=='T' && buff.getType()=='O'  && buff.getJoinTimeOut() && (!buff.getJoinTimeIn())) {
						buff.setTR_Type("M");
						buff.setTimeCode(shf.getTimeCode());
					} else if(shf.getType()=='T' && buff.getType()=='O' && inAutoSwipePeriodPrevShift(shf, buff)){
						buff.setTimeCode(shf.getTimeCode());
					}
					shf = buff;
					buff = shf.getPreviousShift();				
				}
			}
		}
		//----------------------------------------------------------		
	}

    /* óաͷ͡зӧҹ 㹪ǧͧ еͧѺʡͷ͹зӧҹ */
    private boolean inAutoSwipePeriodNextShift(Shift sh, Shift nextsh){
    	try {
    		/*
    		float asw = Float.parseFloat((String) shiftProperty.get("TIMESAUTO"));
    		if(nextsh.get_c_dt_in().subForHour(sh.get_c_dt_out()) <= asw){
    			return true ;
    		}*/
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return false ;
    }
    
    /* óաͷ͡зӧҹ 㹪ǧͧ еͧѺʡͷ͹зӧҹ */
    private boolean inAutoSwipePeriodPrevShift(Shift sh, Shift prvsh){
    	try {
    		/* ԴҹǤ */
    		/*
    		float asw = Float.parseFloat((String) shiftProperty.get("TIMESAUTO"));
    		if(sh.get_c_dt_in().subForHour(prvsh.get_c_dt_out()) <= asw){
    			return true ;
    		}*/
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return false ;
    }
        
    /* ˹ѹѺз ͷѹش */
    public void setActualEvent(){
    	try {
    		for (Iterator<?> IT = this.keySet().iterator(); IT.hasNext();) {    
                String key = (String) IT.next();
                
                DayShift dShift = (DayShift) this.get(key);
                Iterator IT1 = dShift.keySet().iterator(); 
                
                for(; IT1.hasNext() ;){
                	String key1 = (String) IT1.next();
                	Shift shf = (Shift) dShift.get(key1);
                	
                	if(shf.getEventGroup().equals("O")){
        				if(shf.getActualEvent().equals("H")){
        					shf.setEventGroup("H");
        				}else if(shf.getActualEvent().equals("I")){
        					shf.setEventGroup("I");
        				}
        			}
                }
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
    
    /* ѺٴѵẺ ó çἹ */
    public void adjAutoSwipeTime(){
    	try {
    		for (Iterator<?> IT = this.keySet().iterator(); IT.hasNext();) {    
                String key = (String) IT.next();
                
                DayShift dShift = (DayShift) this.get(key);
                Iterator IT1 = dShift.keySet().iterator(); 
                
                for(; IT1.hasNext() ;){
                	String key1 = (String) IT1.next();
                	Shift shf = (Shift) dShift.get(key1);
                	/* out previous shift */
                	if(shf.get_sourcein().equals("9")){
                		/*  çѺҡ  ͧѺçѹ*/
                		if(!shf.get_m_dt_in().equalsDateTime(shf.get_c_dt_in())){
                			String vtkey = shf.getTimeinReserveCode() ;
                			SwipeVirtual SV = new SwipeVirtual(shf.get_c_dt_in(), vtkey);
							SV.setSource("9");
							
							shf.swipeData.addRecord(SV);
							shf.inRecord = shf.swipeData.getSwipeRecord(vtkey).getRecordNo();
                		}
                		
                		/* ٴ͡С͹˹ բٴѵ ͹Ἱ͡ (Ҵҹ ԧ  ) ѺἹ᷹ */
                		Shift prvsh = shf.getPreviousFullShift() ;
                		if(prvsh != null){
                			
                			if(prvsh.get_m_dt_out() != null && prvsh.get_c_dt_out() != null 
                					&& prvsh.get_m_dt_out().beforeEqualsDateTime(prvsh.get_c_dt_out())){
	                			String vtprkey = prvsh.getTimeinReserveCode() ;
	                			SwipeVirtual SV1 = new SwipeVirtual(prvsh.get_c_dt_out(), vtprkey);
								SV1.setSource("9");
								
								prvsh.swipeData.addRecord(SV1);
								prvsh.outRecord = prvsh.swipeData.getSwipeRecord(vtprkey).getRecordNo();
                			}
                		}
        			}
                	
                	/* in next shift */
                	if(shf.get_sourceout().equals("9")){
                		/* ٴҡжѴ բٴѵ ѧἹ (Ҵҹ ԧ  ) ѺἹ᷹ */
                		Shift nxsh = shf.getPreviousFullShift() ;
                		if(nxsh != null){
                			try {
	                			if(nxsh.get_m_dt_out() != null && nxsh.get_c_dt_out() != null 
	                					&& nxsh.get_m_dt_out().beforeDateTime(nxsh.get_c_dt_out())){
		                			String vtprkey = nxsh.getTimeinReserveCode() ;
		                			SwipeVirtual SV1 = new SwipeVirtual(nxsh.get_c_dt_out(), vtprkey);
									SV1.setSource("9");
									
									nxsh.swipeData.addRecord(SV1);
									nxsh.swipeData.reserve(nxsh.inRecord, vtprkey);
	                			}
                			}catch(Exception e){
                				MyLog.error(this,e);
                			}
                		}
        			}
                }
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    }
}
    	
    	
    	
    	
    	
    	