package com.csc.library.utility;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;
import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import std.library.DataTable;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.UProfile;
 
public class DocTransactionError{
	private UProfile userProfile = null;
	private CscConnection conn = null;
	private Statement stmt =null;
	private ResultSet resultSet = null;
	private DataTable dtbDocError = null;
	
	public enum TimeDocument{
 		OT_MULTI_DAY("OM","㺢ͷѹ","TOT_M_DATE0","otid"),
		OT_MULTI_EMP("O","㺢ͷ¤","TOT0","otid"),
		OT_1EMP1DAY("B","㺢ͷѹ ","TOT","otid");
 		
 		private final String docType; 
 		private final String docTypeName; 
	    private final String tableTransaction; 
	    private final String docidFieldName; 
	    
	    TimeDocument(String docType, String docTypeName,String tableTransaction
	    		,String docidFieldName) {
	       this.docType =docType;
	       this.docTypeName =docTypeName;
	       this.tableTransaction =tableTransaction;
	       this.docidFieldName =docidFieldName;
	    }
 		
 		public String docType(){ return docType;}
 		public String docTypeName(){ return docTypeName;}
 	    public String tableTransaction(){ return tableTransaction;}
 	    public String havingClause() { return docidFieldName;}

	}//end enum DocumentType
	
	public DocTransactionError(UProfile userProfile) {
		this.userProfile = userProfile; 
	}//end setUProfile
	
    public void processRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Enumeration key = request.getParameterNames();
        HashMap param = new HashMap();
        Runtime.getRuntime().gc();
        while (key.hasMoreElements()) {
            String pName = (String) key.nextElement();
            param.put(pName, request.getParameter(pName));
            System.out.println("parameter is:"+pName+" value is : "+request.getParameter(pName));
        }
    }//end 
    
	public DataTable getTimeDocumentError(String docType){
		if(this.userProfile!=null){
			if(docType.equals("OM")){
				this.retrieveData(TimeDocument.OT_MULTI_DAY);
			}else if(docType.equals("O")){
				this.retrieveData(TimeDocument.OT_MULTI_EMP);
			}else if(docType.equals("B")){
				this.retrieveData(TimeDocument.OT_1EMP1DAY);
			}
		}
		return this.dtbDocError;
	}//end getTimeDocumentError
	
	private void retrieveData(TimeDocument timeDocument){
		try{
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.userProfile.get("dbname"));
			stmt = conn.createStatement();
			resultSet = stmt.executeQuery(this.getSQLQuery(timeDocument));
			dtbDocError = new DataTable(resultSet,true);
		}catch(Exception ex){
			ex.printStackTrace();
		}finally{		
			this.closeConnection();
		}//end try
		
	}//end retrieveData
	
	private void closeConnection(){
		try{
			if(resultSet!=null){
				resultSet.close();
			}
			if(stmt!=null){
				stmt.close();
			}	
			conn.close();
		}catch(SQLException sqlEx){
			sqlEx.printStackTrace();
		}
	}//end closeConnection
	
	private String getSQLQuery(TimeDocument timeDocument){
		StringBuffer strQuery = new StringBuffer();
		strQuery.append("SELECT '");
		strQuery.append(timeDocument.docTypeName);
		strQuery.append("' as doctypeName,'"); 
		strQuery.append(timeDocument.tableTransaction);
		strQuery.append("' as tableTransaction"); 
		strQuery.append(",adj.doctype,adj.employeeid,adj.docid,adj.docdate");
		strQuery.append(",adj.dt_bg,adj.tm_bg,adj.dt_en,adj.tm_en");
		strQuery.append(",doc.");
		strQuery.append(timeDocument.docidFieldName);
		strQuery.append(",mpf.tdesc as prefix,emp.fname,emp.lname");
		strQuery.append(" FROM tadjtime0 adj left outer join ");
		strQuery.append(timeDocument.tableTransaction);
		strQuery.append(" doc on (adj.docid=doc.");
		strQuery.append(timeDocument.docidFieldName);
		strQuery.append(")");
		strQuery.append(" left outer join memployee emp on (adj.employeeid=emp.employeeid)");
		strQuery.append(" left outer join mprefix mpf on (emp.emp_prefix=mpf.prefixid)");
		strQuery.append(" WHERE adj.doctype ='");
		strQuery.append(timeDocument.docType);
		strQuery.append("'");
		strQuery.append(" GROUP BY adj.employeeid,adj.docid,adj.docdate");
		strQuery.append(",adj.doctype,adj.dt_bg,adj.tm_bg,adj.dt_en,adj.tm_en");
		strQuery.append(",doc.");
		strQuery.append(timeDocument.docidFieldName);
		strQuery.append(",mpf.tdesc,emp.fname,emp.lname");
		strQuery.append(" HAVING (doc.");
		strQuery.append(timeDocument.docidFieldName);
		strQuery.append("='' or doc.");
		strQuery.append(timeDocument.docidFieldName);
		strQuery.append(" is null)");
		strQuery.append(" ORDER BY adj.employeeid,adj.docid,adj.docdate"); 
		strQuery.append(",adj.dt_bg,adj.tm_bg,adj.dt_en,adj.tm_en");
		return strQuery.toString();
	}//end getSQLQuery

}//end class DocTransactionError
