package com.csc.library.utility;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import com.csc.library.utilities.MyLog;

public class FileUtility {
	
	private Vector file_ext = new Vector();
	
	public FileUtility() {
		
	}
	
	public void setFileExtension(Vector v) {
		this.file_ext = v;
	}
	
	public Vector getFileExtension() {
		return this.file_ext;
	}
	
	/*
	 * ź ´٪Դͧ Vector 
	 */
	private void delete(File files) {
		String fileName = files.getName();
		if (fileName.indexOf(".")>-1) { //չʡ
			String ext = fileName.substring(fileName.lastIndexOf('.')+1);
			if (this.file_ext!=null && !this.file_ext.isEmpty()) { 
				if (this.file_ext.contains("*") || this.file_ext.contains(ext)) { //硪Դͧ *  Vector ź
					files.delete();
				}
			} else files.delete(); //кتԴͧ ź
		} else files.delete(); //չʡ ź
	}
	
	/*
	 * ź folder  ź folder 駴
	 */
	public boolean deleteDirectory(String paths) {
		boolean result= false;
		File path = new File(paths);
		if (path.exists()) {
	    	File[] files = path.listFiles();
	    	for (int i=0; i<files.length; i++) {
	    		if (files[i].isDirectory()) {
	    			deleteDirectory(files[i].toString());
	    		} else {	    			
	    			//files[i].delete();
	    			this.delete(files[i]);
	    		}
	    	}
	    	path.delete();
	    } else {
	    	MyLog.error(this, "DIRECTORY NOT FOUND : "+paths);
	    }		
		MyLog.debug(this, "DIRECTORY DELETE FINISH : "+paths);
		return result;
	}
	
	/*
	 * ź folder  ź sub folder 駴
	 *  parameter = true 
	 */
	public boolean deleteFileDirectory(String paths) {
		return deleteFileDirectory(paths, false);
	}			
	public boolean deleteFileDirectory(String paths, boolean subDir) {
		boolean result= false;
		File path = new File(paths);
		if (path.exists()) {
			File[] files = path.listFiles();
	    	for (int i=0; i<files.length; i++) {
	    		if (files[i].isDirectory() && subDir) {
	    			deleteFileDirectory(files[i].toString(), true);
	    		} if (files[i].isFile()) {	    			
	    			//files[i].delete();
	    			this.delete(files[i]);
	    		}
	    	}
		} else {
			MyLog.error(this, "DIRECTORY NOT FOUND : "+paths);
		}
		MyLog.debug(this, "DIRECTORY DELETE FINISH : "+paths);
		return result;
	}
	
	/*
	 * ź
	 */
	public boolean deleteFile(String fileName) {
		boolean result = false;
		File files = new File(fileName);
		if (files.exists()) {
			this.delete(files);
		} else {
			MyLog.error(this, "FILE NOT FOUND : "+fileName);
		}
		MyLog.debug(this, "FILE DELETE FINISH : "+fileName);
		return result;
	}
	
	/*
	 * copy  ҡ folder source ѧ folder destination
	 */
	public void copyDirectory(String srcPath, String dstPath) throws IOException {		
		this.copyDirectory(new File(srcPath), new File(dstPath));
	}	
	public void copyDirectory(File srcPath, File dstPath) throws IOException {		
		if (srcPath.isDirectory()){
			if (!dstPath.exists()){
				dstPath.mkdir();
			}

			String files[] = srcPath.list();
			for (int i = 0; i < files.length; i++) {
				copyDirectory(new File(srcPath, files[i]), new File(dstPath, files[i]));
			}
		} else {
			if (!srcPath.exists()){
				MyLog.error(this, "DIRECTORY NOT FOUND : "+srcPath.toString());				
			} else {
				InputStream in = new FileInputStream(srcPath);
				OutputStream out = new FileOutputStream(dstPath); 
				// 	Transfer bytes from in to out
				byte[] buf = new byte[1024];
				int len;
				while ((len = in.read(buf)) > 0) {
					out.write(buf, 0, len);
				}
				in.close();
				out.close();
			}
		}
		MyLog.debug(this, "DIRECTORY COPY FINISH FROM : "+srcPath.toString()+" TO : "+dstPath.toString());
	}	

	/*
	 * ҢҴͧ (MB)
	 */
	public float getFileSize(String path) {
		File files = new File(path);
		if (files.exists() && files.isFile()) {
			return this.getFileSize(files);
		} else return 0;
	}
	public float getFileSize(File files) {
		return (files.length()/1024f)/1000f;
	}
	
	/*
	 * ʴҴ folder  sub folder (MB)
	 * ҡͧâ sub folder  parameter = true Ҵ
	 */
	public float getDirSize(String paths) {
		return this.getDirSize(paths, false);
	}
	
	public float getDirSize(String paths, boolean subDir) {
		float value = 0;
		File path = new File(paths);
		if (path.exists()) {
			File[] files = path.listFiles();			
	    	for (int i=0; i<files.length; i++) {
	    		if (files[i].isDirectory() && subDir) {
	    			value += getDirSize(files[i].toString(), subDir);
	    		} if (files[i].isFile()) {    		
	    			value += this.getFileSize(files[i]);
	    		}
	    	}
		}
		return value;
	}
	
	/*
	 * ʴӹǹ folder  sub folder
	 * ҡͧâ sub folder  parameter = true Ҵ
	 */
	public int getDirCount(String paths) {
		return this.getDirCount(paths, false);
	}
	
	public int getDirCount(String paths, boolean subDir) {
		int value = 0;
		File path = new File(paths);
		if (path.exists()) {
			File[] files = path.listFiles();			
	    	for (int i=0; i<files.length; i++) {
	    		if (files[i].isDirectory() && subDir) {	
	    			value++;
	    			value += getDirCount(files[i].toString(), subDir);
	    		} else if (files[i].isDirectory()) {
	    			value++;
	    		}
	    	}
		}
		return value;
	}
	
	/*
	 * ʴӹǹ folder  sub folder 
	 * ҡͧâ sub folder  parameter = true Ҵ
	 */
	public int getDirFileCount(String paths) {
		return this.getDirFileCount(paths, false);
	}
	
	public int getDirFileCount(String paths, boolean subDir) {
		int value = 0;
		File path = new File(paths);
		if (path.exists()) {
			File[] files = path.listFiles();			
	    	for (int i=0; i<files.length; i++) {
	    		if (files[i].isDirectory() && subDir) {		    			
	    			value += getDirFileCount(files[i].toString(), subDir);
	    		} if (files[i].isFile()) {    		
	    			value++;
	    		}
	    	}
		}
		return value;
	}
	
	/*
	 * ª Folder  sub folder
	 * ҡͧâ sub folder  parameter = true Ҵ
	 *   : Ҵ (MB)	 * 
	 */
	public Vector getDirFileList(String paths) {
		return this.getDirFileList(paths, false);
	}
	
	public Vector getDirFileList(String paths, boolean subDir) {
		Vector value = new Vector();
		File path = new File(paths);
		if (path.exists()) {
			File[] files = path.listFiles();			
	    	for (int i=0; i<files.length; i++) {
	    		if (files[i].isDirectory() && subDir) {	    			
	    			Vector v = getDirFileList(files[i].toString(), subDir);
	    			for (int j=0; j<v.size(); j++) {
	    				value.add(v.elementAt(j));
	    			}
	    		} if (files[i].isFile()) {    		
	    			value.add(files[i]+" : "+this.getFileSize(files[i]));
	    		}
	    	}
		}
		return value;
	}
}
